SystemOrganization addCategory: #'Seaside-Builder'!
SystemOrganization addCategory: #'Seaside-Canvas'!
SystemOrganization addCategory: #'Seaside-Canvas-Tags'!
SystemOrganization addCategory: #'Seaside-Component'!
SystemOrganization addCategory: #'Seaside-Components-Decorations'!
SystemOrganization addCategory: #'Seaside-Components-Dialogs'!
SystemOrganization addCategory: #'Seaside-Components-Frames'!
SystemOrganization addCategory: #'Seaside-Components-Tools'!
SystemOrganization addCategory: #'Seaside-Components-Tools-Squeak'!
SystemOrganization addCategory: #'Seaside-Components-Widgets'!
SystemOrganization addCategory: #'Seaside-Configuration'!
SystemOrganization addCategory: #'Seaside-Continuations'!
SystemOrganization addCategory: #'Seaside-Document'!
SystemOrganization addCategory: #'Seaside-Document-Elements'!
SystemOrganization addCategory: #'Seaside-Examples-Store'!
SystemOrganization addCategory: #'Seaside-Examples-Store-Model'!
SystemOrganization addCategory: #'Seaside-Tests-Previous'!
SystemOrganization addCategory: #'Seaside-Tests-Canvas'!
SystemOrganization addCategory: #'Seaside-HTTP'!
SystemOrganization addCategory: #'Seaside-Libraries'!
SystemOrganization addCategory: #'Seaside-Platform'!
SystemOrganization addCategory: #'Seaside-Rendering'!
SystemOrganization addCategory: #'Seaside-RenderLoop'!
SystemOrganization addCategory: #'Seaside-RequestHandler'!
SystemOrganization addCategory: #'Seaside-Session'!
SystemOrganization addCategory: #'Seaside-StateRegistry'!
SystemOrganization addCategory: #'Seaside-Utilities'!
SystemOrganization addCategory: #'Seaside-Utilities-Squeak'!

!BlockContext methodsFor: '*seaside2-squeak' stamp: 'mb 4/24/2007 17:38'!
fixCallbackTemps
	"Fix the values of the temporary variables used in the block that are 
	ordinarily shared with the method in which the block is defined.
	
	This is needed because Squeak is a crappy Smalltalk implementation
	that does not have full blcck closures."


	| temps |
	home := home copy.
	home swapSender: nil.
	home isMethodContext
		ifTrue: [temps := self tempVarRefs.
			1
				to: home size
				do: [:i | (temps includes: i)
						ifFalse: [home tempAt: i put: nil]]]! !

!BlockContext methodsFor: '*seaside2' stamp: 'ab 2/11/2003 20:09'!
handleRequest: aRequest
	^ self value: aRequest! !

!BlockContext methodsFor: '*seaside2' stamp: 'ac 5/16/2003 16:30'!
renderOn: aRenderer
	self numArgs = 0 
		ifTrue: [self value]
		ifFalse: [self value: aRenderer]! !

!BlockContext methodsFor: '*seaside2-squeak' stamp: 'avi 9/19/2006 14:49'!
tempVarRefs
	| method scanner end tempVars byte type offset |

	home ifNil: [^false].
	tempVars _ Set new.
	method _ self method.
	"Determine end of block from long jump preceding it"
	end _ (method at: startpc-2)\\16-4*256 + (method at: startpc-1) + startpc - 1.
	scanner _ InstructionStream new method: method pc: startpc.

	[scanner pc <= end] whileTrue:
		[byte  _ scanner nextByte.
		type _ byte // 16.
		offset _ byte \\ 16.
		type = 1 ifTrue: [tempVars add: offset + 1].
		scanner nextInstruction].
	^ tempVars! !

TestCase subclass: #AmbTest
	instanceVariableNames: 'amb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!AmbTest methodsFor: 'utilities' stamp: 'ab 12/6/2002 12:20'!
pickANumber
	^ self pickANumberGreaterThan: 0! !

!AmbTest methodsFor: 'utilities' stamp: 'ab 12/6/2002 12:20'!
pickANumberGreaterThan: aNumber
	^ amb valueOf: [aNumber + 1] or: [self pickANumberGreaterThan: aNumber + 1]! !

!AmbTest methodsFor: 'running' stamp: 'ab 12/13/2002 01:15'!
setUp
	amb := Amb new! !

!AmbTest methodsFor: 'testing' stamp: 'ab 12/6/2002 02:43'!
testAllValuesAboveFive
	|x results|
	results := amb allValues:
				[x := amb oneOf: (1 to: 10).
				amb assert: (x > 5).
				x].			
	self assert: results = #(6 7 8 9 10).
! !

!AmbTest methodsFor: 'testing' stamp: 'avi 4/28/2004 11:31'!
testMaybe
	|x y z|
	x := amb maybe.
	y := amb maybe.
	z := amb maybe not.

	amb deny: x = y.
	amb deny: x = z.
	
	self assert: x.
	self deny: y.
	self deny: z.! !

!AmbTest methodsFor: 'testing' stamp: 'ab 12/6/2002 12:21'!
testPickANumber
	self assert: self pickANumber = 1.! !

!AmbTest methodsFor: 'testing' stamp: 'ab 12/6/2002 12:21'!
testPickANumberAboveFive
	|x|
	x := self pickANumber.
	amb assert: (x > 5).
	self assert: x = 6.
! !

!AmbTest methodsFor: 'testing' stamp: 'avi 4/26/2004 14:45'!
testSicpLogicProblem
	"Baker, Cooper, Fletcher, Miller, and Smith live on different floors of an apartment house that contains only five floors. Baker does not live on the top floor. Cooper does not live on the bottom floor. Fletcher does not live on either the top or the bottom floor. Miller lives on a higher floor than does Cooper. Smith does not live on a floor adjacent to Fletcher's. Fletcher does not live on a floor adjacent to Cooper's. Where does everyone live?"

"This implementation is too slow - uncomment to actually run it."
	
"	|baker cooper fletcher miller smith|
	baker := amb oneOf: (1 to: 5).
	cooper := amb oneOf: (1 to: 5).
	fletcher := amb oneOf: (1 to: 5).
	miller := amb oneOf: (1 to: 5).
	smith := amb oneOf: (1 to: 5).
	
	amb assert: (Set new add: baker; add: cooper; add: fletcher; add: miller; add: smith; size) = 5.
	
	amb deny: baker = 5.
	amb deny: cooper = 1.
	amb deny: fletcher = 5.
	amb deny: fletcher = 1.
	amb assert: miller > cooper.
	amb deny: (smith - fletcher) abs = 1.
	amb deny: (fletcher - cooper) abs = 1.
	
	self assert: baker = 3.
	self assert: cooper = 2.
	self assert: fletcher = 4.
	self assert: miller = 5.
	self assert: smith = 1.
"	! !

!AmbTest methodsFor: 'testing' stamp: 'avi 4/26/2004 14:45'!
testSicpLogicProblemFaster
	"Baker, Cooper, Fletcher, Miller, and Smith live on different floors of an apartment house that contains only five floors. Baker does not live on the top floor. Cooper does not live on the bottom floor. Fletcher does not live on either the top or the bottom floor. Miller lives on a higher floor than does Cooper. Smith does not live on a floor adjacent to Fletcher's. Fletcher does not live on a floor adjacent to Cooper's. Where does everyone live?"
	
	|baker cooper fletcher miller smith|
	fletcher := amb oneOf: (1 to: 5).
	amb deny: fletcher = 5.
	amb deny: fletcher = 1.

	smith := amb oneOf: (1 to: 5).
	amb deny: (smith - fletcher) abs = 1.

	cooper := amb oneOf: (1 to: 5).
	amb deny: cooper = 1.
	amb deny: (fletcher - cooper) abs = 1.

	miller := amb oneOf: (1 to: 5).
	amb assert: miller > cooper.

	baker := amb oneOf: (1 to: 5).
	amb deny: baker = 5.
	
	amb assert: (Set new add: baker; add: cooper; add: fletcher; add: miller; add: smith; size) = 5.
	self assert: baker = 3.
	self assert: cooper = 2.
	self assert: fletcher = 4.
	self assert: miller = 5.
	self assert: smith = 1.! !

!AmbTest methodsFor: 'testing' stamp: 'ab 12/6/2002 02:27'!
testSolveAnEquation
	|x y|
	x := amb oneOf: (1 to: 10).
	y := amb oneOf: (1 to: 10).
	amb assert: (y * x) = 42.
	self assert: x = 6.
	self assert: y = 7.
! !

TestCase subclass: #ContinuationTest
	instanceVariableNames: 'tmp tmp2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!ContinuationTest methodsFor: 'utilities' stamp: 'ab 6/15/2003 19:23'!
callcc: aBlock
	^ Continuation currentDo: aBlock! !

!ContinuationTest methodsFor: 'tests' stamp: 'lr 1/5/2007 17:26'!
testBlockEscape
	| x |
	tmp := 0.
	x := [ tmp := tmp + 1. tmp2 value ].
	self callcc: [ :cc | tmp2 := cc. x value ].
	tmp2 := [ ].
	x value.
	self assert: tmp = 2! !

!ContinuationTest methodsFor: 'tests' stamp: 'lr 1/5/2007 17:27'!
testBlockTemps
	| y |
	#(1 2 3) do: [ :i |
		| x |
		x := i.
		tmp ifNil: [ tmp2 := (self callcc: [ :cc | tmp := cc. [ :q ] ]) ].
		tmp2 value: x.
		x := 17 ].
	y := (self callcc: [ :cc | tmp value: cc. 42 ]).
	self assert: y = 1! !

!ContinuationTest methodsFor: 'tests' stamp: 'lr 1/5/2007 17:27'!
testBlockVars
	| continuation |
	tmp := 0.
	tmp := (self callcc: [ :cc | continuation := cc. 0 ]) + tmp.
	tmp2 
		ifNotNil: [ tmp2 value ]
		ifNil: [
			#(1 2 3) do: [ :i |
				self callcc: [ :cc | tmp2 := cc. continuation value: i ] ] ].
	self assert: tmp = 6! !

!ContinuationTest methodsFor: 'tests' stamp: 'lr 1/5/2007 17:28'!
testComprehension
	"What should this print out?
	
	| yin yang |
	yin := [ :x | Transcript cr. x ] value: Continuation current.
	yang := [ :x | Transcript nextPut: $*. x ] value: Continuation current.
	yin value: yang"! !

!ContinuationTest methodsFor: 'tests' stamp: 'lr 1/5/2007 18:24'!
testInvokeMultiple
	| assoc |
	assoc := self callcc: [ :cc | cc -> 0 ].
	assoc value: assoc value + 1.
	self assert: assoc value ~= 5.
	assoc value = 4
		ifFalse: [ assoc key invoke: [ assoc ] ]! !

!ContinuationTest methodsFor: 'tests' stamp: 'mb 2/6/2007 18:20'!
testInvokeSimple
	| x continuation |
	x := self callcc: [ :cc | continuation := cc. false ].
	x ifFalse: [ continuation invoke: [ true & true ] ]. "Must have a least one message send in this block for VW"
	self assert: x! !

!ContinuationTest methodsFor: 'tests' stamp: 'lr 1/5/2007 17:27'!
testMethodTemps
	| i continuation |
	i := 0.
	i := i + (self callcc: [:cc | continuation := cc. 1]).
	self assert: i ~= 3.
	i = 2 ifFalse: [ continuation value: 2 ]! !

!ContinuationTest methodsFor: 'tests' stamp: 'lr 1/5/2007 18:22'!
testReentrant
	| assoc |
	assoc := self callcc: [ :cc | cc -> 0 ].
	assoc value: assoc value + 1.
	self assert: assoc value ~= 5.
	assoc value = 4
		ifFalse: [ assoc key value: assoc ]! !

!ContinuationTest methodsFor: 'tests' stamp: 'lr 1/5/2007 17:28'!
testSimpleCallCC
	| x continuation |
	x := self callcc: [ :cc | continuation := cc. false ].
	x ifFalse: [ continuation value: true ].
	self assert: x! !

!ContinuationTest methodsFor: 'tests' stamp: 'lr 1/5/2007 17:28'!
testSimplestCallCC
	| x |
	x := self callcc: [ :cc | cc value: true ].
	self assert: x! !

TestCase subclass: #WAConfigurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAConfigurationTest methodsFor: 'tests' stamp: 'mb 4/23/2006 15:15'!
testLinearization
	"from http://www.webcom.com/haahr/dylan/linearization-oopsla96.html"
	| root boat dayBoat wheelBoat engineLess pedalWheelBoat smallMultihull smallCatamaran pedalo |
	root := WAUserConfiguration new.
	boat := WAUserConfiguration new addAncestor: root; yourself.
	dayBoat := WAUserConfiguration new addAncestor: boat; yourself.
	wheelBoat := WAUserConfiguration new addAncestor: boat; yourself.
	engineLess := WAUserConfiguration new addAncestor: dayBoat; yourself.
	pedalWheelBoat := WAUserConfiguration new addAncestor: engineLess; addAncestor: wheelBoat; yourself.
	smallMultihull := WAUserConfiguration new addAncestor: dayBoat; yourself.
	smallCatamaran := WAUserConfiguration new addAncestor: smallMultihull; yourself.
	pedalo := WAUserConfiguration new addAncestor: pedalWheelBoat; addAncestor: smallCatamaran; yourself.

	self assert: pedalWheelBoat allAncestors = (Array with: engineLess with: dayBoat with: wheelBoat with: boat with: root).
	self assert: smallCatamaran allAncestors = (Array with: smallMultihull with: dayBoat with: boat with: root).
	self assert: pedalo allAncestors = ((Array with: pedalWheelBoat with: engineLess with: smallCatamaran with: smallMultihull), (Array with: dayBoat with: wheelBoat with: boat with: root)).! !

TestCase subclass: #WADispatcherTest
	instanceVariableNames: 'defaultDispatcher alternateDispatcher shortDispatcher baseName alternateName lastUpdate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WADispatcherTest methodsFor: 'private' stamp: 'mb 4/23/2007 14:21'!
dispatcher: aDispatcher hasSameEntryPointsAs: anotherDispatcher
	"VW does not have Set >> #=
	OMFG!! SRSLY? wtf...?"

	| aSet anotherSet |
	aSet := aDispatcher entryPoints keys.
	anotherSet := anotherDispatcher entryPoints keys.
	aSet == anotherSet ifTrue: [^ true].	"stop recursion"
	(aSet class == anotherSet class) ifFalse: [^ false].
	aSet size = anotherSet size ifFalse: [^ false].
	aSet do: [:each | (anotherSet includes: each) ifFalse: [^ false]].
	^ true! !

!WADispatcherTest methodsFor: 'running' stamp: 'mb 2/19/2007 19:47'!
setUp
	baseName := SeasidePlatformSupport isSqueak
				ifTrue: ['seaside']
				ifFalse: ['seaside/go'].
	alternateName := 'seaside/stream'.
	defaultDispatcher := WADispatcher default.
	alternateDispatcher := defaultDispatcher copy setName: alternateName.
	shortDispatcher := defaultDispatcher copy setName: ''.
	defaultDispatcher addDependent: self.	! !

!WADispatcherTest methodsFor: 'running' stamp: 'mb 2/17/2007 23:49'!
tearDown
	defaultDispatcher removeDependent: self.! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/17/2007 23:31'!
testAlternateCloning
	| originalHandler |
	self deny: alternateDispatcher == defaultDispatcher.
	self
		assert: (self dispatcher: alternateDispatcher hasSameEntryPointsAs: defaultDispatcher).
	alternateDispatcher entryPoints
		do: [:handler | 
			originalHandler := defaultDispatcher entryPointAt: handler name.
			self assert: handler class == originalHandler class.
			self deny: handler == originalHandler.
			handler isDispatcher
				ifTrue: [self
						assert: (self dispatcher: handler hasSameEntryPointsAs: originalHandler)]]! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/17/2007 01:33'!
testAlternateConfig
	| app originalApp |
	app := alternateDispatcher entryPointAt: 'config'.
	originalApp := defaultDispatcher entryPointAt: 'config'.
	self assert: app class == WAApplication.	
	self assert: app isApplication.
	self deny: app isDispatcher.
	self deny: app parent isNil.
	self assert: app name = 'config'.
	self assert: app basePath = ('/' , alternateDispatcher name , '/config').
	
	self deny: app == originalApp.
	self assert: app name = originalApp name.
	self assert: app parent == alternateDispatcher.
	self assert: originalApp parent == defaultDispatcher.


! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/18/2007 01:36'!
testAlternateCounterDirect
	| app originalApp |
	app := alternateDispatcher entryPointAt: 'examples/counter'.
	originalApp := defaultDispatcher entryPointAt: 'examples/counter'.
	self assert: app name = 'counter'.
	self assert: app parent name = 'examples'.
	self assert: app basePath = ('/' , alternateDispatcher name , '/examples/counter').
	
	self deny: app == originalApp.
	self assert: app name = originalApp name.
	self deny: app parent == originalApp parent.
	self assert: app parent name = originalApp parent name.
	
	self deny: app parent parent == originalApp parent parent.
	self deny: app parent parent name = originalApp parent parent name.
	self assert: app parent parent == alternateDispatcher.
	self assert: originalApp parent parent == defaultDispatcher.
	
! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/17/2007 08:06'!
testAlternateFiles
	| app originalApp |
	app := alternateDispatcher entryPointAt: 'files'.
	originalApp := defaultDispatcher entryPointAt: 'files'.
	self assert: app class == WAFileHandler.	
	self deny: app isApplication.
	self deny: app isDispatcher.
	self deny: app parent isNil.
	self assert: app name = 'files'.
	self assert: app basePath = ('/' , alternateDispatcher name , '/files').
	
	self deny: app == originalApp.
	self deny: app libraries == originalApp libraries.
	self assert: app name = originalApp name.
	self assert: app parent == alternateDispatcher.
	self assert: originalApp parent == defaultDispatcher.
! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/17/2007 23:12'!
testAlternateRoot
	| app |
	app := alternateDispatcher.
	self assert: app class == WADispatcher.	
	self deny: app isApplication.
	self assert: app isDispatcher.
	self assert: app isRoot.
	self assert: app parent isNil.
	self assert: app name = alternateName.
	

! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/17/2007 01:34'!
testAlternateTests
	| app originalApp |
	app := alternateDispatcher entryPointAt: 'tests'.
	originalApp := defaultDispatcher entryPointAt: 'tests'.
	self assert: app class == WADispatcher.	
	self deny: app isApplication.
	self assert: app isDispatcher.
	self deny: app isRoot.
	self deny: app parent isNil.
	self assert: app name = 'tests'.
	self assert: app basePath = ('/' , alternateDispatcher name , '/tests').
	
	self deny: app == originalApp.
	self assert: app name = originalApp name.
	self assert: app parent == alternateDispatcher.
	self assert: originalApp parent == defaultDispatcher.
	
	

! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/15/2007 09:55'!
testDefaultConfig
	| app |
	app := defaultDispatcher entryPointAt: 'config'.
	self assert: app class == WAApplication.	
	self assert: app isApplication.
	self deny: app isDispatcher.
	self deny: app parent isNil.
	self assert: app name = 'config'.
	self assert: app basePath = ('/' , baseName , '/config').
	

! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/15/2007 10:56'!
testDefaultCounterDirect
	| app |
	app := defaultDispatcher entryPointAt: 'examples/counter'.
	self assert: app class == WAApplication.	
	self assert: app isApplication.
	self deny: app isDispatcher.
	self deny: app parent isNil.
	self assert: app name = 'counter'.
	self assert: app parent name = 'examples'.
	self assert: app basePath = ('/' , baseName , '/examples/counter').
	

! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/15/2007 10:56'!
testDefaultCounterNavigate
	| app |
	app := defaultDispatcher entryPointAt: 'examples'.
	self assert: app class == WADispatcher.	
	self assert: app isDispatcher.
	self deny: app isRoot.
	self deny: app isApplication.
	self deny: app parent isNil.
	self assert: app name = 'examples'.
	self assert: app basePath = ('/' , baseName , '/examples').
	app := app entryPointAt: 'counter'.
	self assert: app class == WAApplication.	
	self assert: app isApplication.
	self deny: app isDispatcher.
	self deny: app parent isNil.
	self assert: app name = 'counter'.
	self assert: app parent name = 'examples'.
	self assert: app basePath = ('/' , baseName , '/examples/counter').
	

! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/15/2007 09:55'!
testDefaultFiles
	| app |
	app := defaultDispatcher entryPointAt: 'files'.
	self assert: app class == WAFileHandler.	
	self deny: app isDispatcher.
	self deny: app isApplication.
	self deny: app parent isNil.
	self assert: app name = 'files'.
	self assert: app basePath = ('/' , baseName , '/files').
	

! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/17/2007 01:13'!
testDefaultRoot
	| app |
	app := defaultDispatcher.
	self assert: app == WADispatcher default.
	self assert: app class == WADispatcher.
	self assert: app isDispatcher.
	self assert: app isRoot.
	self deny: app isApplication.
	self assert: app parent isNil.
	self assert: app name = baseName.
	self assert: app basePath = ('/' , baseName).
! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/15/2007 09:56'!
testDefaultTests
	| app |
	app := defaultDispatcher entryPointAt: 'tests'.
	self assert: app class == WADispatcher.	
	self assert: app isDispatcher.
	self deny: app isRoot.
	self deny: app isApplication.
	self deny: app parent isNil.
	self assert: app name = 'tests'.
	self assert: app basePath = ('/' , baseName , '/tests').
	

! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/17/2007 23:49'!
testRootDispatcher
	| app |
	app := defaultDispatcher entryPointAt: 'examples/counter'.
	self deny: app isRoot.
	self deny: app parent isRoot.
	self assert: app parent parent isRoot.
	self assert: app rootDispatcher == defaultDispatcher! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/18/2007 00:05'!
testRootDispatcherChange
	| app before old |
	before := defaultDispatcher version.
	app := defaultDispatcher entryPointAt: 'examples/counter'.
	old := app preferenceAt: #sessionExpirySeconds.	
	app preferenceAt: #sessionExpirySeconds put: old.
	self deny: defaultDispatcher version = before.
	before := defaultDispatcher version.
	app := defaultDispatcher entryPointAt: 'examples/counter'.
	app addLibrary: Object.
	app removeLibrary: Object.
	self deny: defaultDispatcher version = before.
	before := defaultDispatcher version.
	app := defaultDispatcher defaultName: defaultDispatcher defaultName.
	self deny: defaultDispatcher version = before.! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/17/2007 23:50'!
testRootDispatcherDependency
	| app old |
	lastUpdate := nil.
	app := defaultDispatcher entryPointAt: 'examples/counter'.
	old := app preferenceAt: #sessionExpirySeconds.	
	app preferenceAt: #sessionExpirySeconds put: old.
	self deny: lastUpdate isNil.
	self assert: lastUpdate class == TimeStamp.
	defaultDispatcher removeDependent: self.! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mb 2/18/2007 01:34'!
testShortTests
	| app |
	app := shortDispatcher entryPointAt: 'tests'.
	self assert: shortDispatcher basePath = ''.
	self assert: app basePath = ('/tests').

! !

!WADispatcherTest methodsFor: 'changing' stamp: 'mb 2/17/2007 23:48'!
update: anAspectSymbol
	lastUpdate := defaultDispatcher lastUpdate! !

TestCase subclass: #WAFileLibraryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAFileLibraryTest methodsFor: 'utilities' stamp: 'pmm 2/16/2007 16:20'!
assertFile: aString contentType: aMimeType handler: aHandler symbol: aSymbol library: aLibrary
	| request response |
	request := WARequest
		method: 'GET'
		url: '/seaside/files/', aLibrary name ,'/', aString
		headers: Dictionary new
		fields: Dictionary new
		cookies: Dictionary new.
	response := aHandler handleRequest: request.
	self assert: response status = '200'.
	self assert: response contentType = aMimeType.
	self assert: response stream contents = (aLibrary perform: aSymbol).! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 4/21/2006 22:57'!
testAsFileName
	| library |
	library := WAFileLibraryDemo new.
	self assert: (library asFilename: #mainJs) = 'main.js'! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 4/21/2006 22:57'!
testAsSelector
	| library |
	library := WAFileLibraryDemo new.
	self assert: (library asSelector: 'main.css') = #mainCss.
	self assert: (library asSelector: 'main.js') = #mainJs! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 12/20/2006 12:19'!
testAsSelectorCapitalized
	| library |
	library := WAFileLibraryDemo new.
	self assert: (library asSelector: 'COMMENTS.TXT') = #COMMENTSTxt.
	self assert: (library asFilename: #COMMENTSTxt) = 'COMMENTS.txt'.! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'mb 12/22/2006 15:13'!
testAsSelectorFunky
	| library |
	library := WAFileLibraryDemo new.
	self assert: (library asSelector: '1_2$3-4/5()6!!7   8.9.test 1 2 3 me 4 5 6 .txt') = #test123me456Txt.
! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'mb 12/22/2006 15:14'!
testAsSelectorLeadingDigits
	| library |
	library := WAFileLibraryDemo new.
	self assert: (library asSelector: '1readme.txt') = #readmeTxt.
	self assert: (library asSelector: '123456789readme.txt') = #readmeTxt.
	self assert: (library asSelector: '123456789readme89.txt') = #readme89Txt.
! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 5/2/2006 19:48'!
testCompileByteArray
	| library data file first second |
	library := WAFileLibraryDemo new.
	self deny: (library class selectors includes: #demoJpeg).
	data := (1 to: 255) asByteArray.
	file := WAFile new
		contentType: 'image/jpeg';
		contents: data;
		fileName: 'demo.jpeg';
		yourself.
	library addFile: file.
	self assert: (library class selectors includes: #demoJpeg).
	first := library perform: #demoJpeg.
	self assert: first = data.
	second := library perform: #demoJpeg.
	self assert: first == second.
	library removeFile: file fileName.
	self deny: (library class selectors includes: #demoJpeg).
	
! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 5/2/2006 19:50'!
testCompileString
	| library data file first second |
	library := WAFileLibraryDemo new.
	self deny: (library class selectors includes: #demoTxt).
	data := 'this is a string'.
	file := WAFile new
		contentType: 'text/plain';
		contents: data;
		fileName: 'demo.txt';
		yourself.
	library addFile: file.
	self assert: (library class selectors includes: #demoTxt).
	first := library perform: #demoTxt.
	self assert: first = data.
	second := library perform: #demoTxt.
	self assert: first == second.
	library removeFile: file fileName.
	self deny: (library class selectors includes: #demoTxt).
	
! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 4/23/2006 19:40'!
testFileLibraryDemo
	| actual expected |
	actual := WAFileLibraryDemo new filenames.
	expected := #('main.css' 'main.jpg').
	self assert: actual size = expected size.
	expected do: [ :each |
		self assert: (actual includes: each) ]! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'mb 5/1/2007 14:12'!
testFilenames
	| expected actual |
	expected := #(#netStyleCss #libraryEditorCss #floppyGif #topJpg).
	actual := WADispatcherFiles new fileSelectors.
	"VW does not implement #= in Sets"
	self assert: actual size = expected size.
	expected do: [:each | self assert: (expected includes: each)].
! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 2/16/2007 15:51'!
testKalseyTabs
	| handler |
	handler := WAFileHandler new.
	self
		assertFile: 'kalseyTabs.css'
		contentType: 'text/css'
		handler: handler
		symbol: #kalseyTabs
		library: WAStandardStyles new! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 2/16/2007 15:52'!
testKalseyTabsCascade
	| handler |
	handler := WAFileHandler new.
	self
		assertFile: 'kalseyTabs.css'
		contentType: 'text/css'
		handler: handler
		symbol: #kalseyTabs
		library: WAStandardStyles new! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 2/16/2007 15:52'!
testLiveUpdate
	| handler |
	handler := WAFileHandler new.
	self
		assertFile: 'misc.js'
		contentType: 'text/javascript'
		handler: handler
		symbol: #misc
		library: WAStandardScripts new! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 2/16/2007 15:52'!
testMainCss
	| handler |
	handler := WAFileHandler new.
	self
		assertFile: 'main.css'
		contentType: 'text/css'
		handler: handler
		symbol: #mainCss
		library: WAFileLibraryDemo new! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 2/16/2007 15:53'!
testMainCssCascade
	| handler |
	handler := WAFileHandler new.
	self
		assertFile: 'main.css'
		contentType: 'text/css'
		handler: handler
		symbol: #mainCss
		library: WAFileLibraryDemo new! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 2/16/2007 15:53'!
testMainJpg
	| handler library request response contents |
	handler := WAFileHandler new.
	library := WAFileLibraryDemo new.
	request := WARequest
		method: 'GET'
		url: '/i/dont/care/WAFileLibraryDemo/main.jpg'
		headers: Dictionary new
		fields: Dictionary new
		cookies: Dictionary new.
	response := handler handleRequest: request.
	self assert: response status = '200'.
	self assert: response contentType = 'image/jpeg'.
	contents := response stream binary; contents.
	self assert: contents asByteArray = (library perform: #mainJpg)! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 2/16/2007 16:25'!
testMainJs
	| handler request response |
	handler := WAFileHandler new.
	request := WARequest
		method: 'GET'
		url: '/i/dont/care/main.js'
		headers: Dictionary new
		fields: Dictionary new
		cookies: Dictionary new.
	response := handler handleRequest: request.
	self assert: response status = '404'.! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 12/20/2006 12:17'!
testStandardScripts
	| actual expected |
	actual := WAStandardScripts new filenames.
	expected := #('shortcuts.js' 'misc.js' 'externalAnchors.js').
	self assert: actual size = expected size.
	expected do: [ :each |
		self assert: (actual includes: each) ]! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 4/23/2006 19:39'!
testStandardStyles
	| actual expected |
	actual := WAStandardStyles new filenames.
	expected := #('basics.css' 'kalseyTabs.css' 'sourceStyle.css').
	self assert: actual size = expected size.
	expected do: [ :each |
		self assert: (actual includes: each) ]! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'mb 2/18/2007 10:40'!
testUrlOf
	self assert: (WAStandardFiles urlOf: #seasideJpg) asString = 
		( '/'
		, SeasidePlatformSupport defaultDispatcherName 
		, '/files/WAStandardFiles/seaside.jpg' )! !

TestCase subclass: #WAProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAProxyTest methodsFor: 'testing' stamp: 'mb 1/5/2006 13:57'!
test
	| ad p |
	ad := WAStoreAddress new.
	ad street: 'Parkway'.
	p := WAModelProxy on: ad.
	self assert: p street = ad street.
	self assert: ad city isNil.
	self assert: p city = ad city.
	p city: 'NYC'.
	self assert: p city = 'NYC'.
	self assert: ad city isNil.
	p commit.
	self assert: ad city = 'NYC'.	! !

TestCase subclass: #WARenderCanvasTestCase
	instanceVariableNames: 'html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WARenderCanvasTestCase commentStamp: 'mb 3/28/2007 14:07' prior: 0!
This class is intended to be used as an abstract superclass for unit tests.

See subclasses for examples of unit tests.
!

WARenderCanvasTestCase subclass: #WARenderCanvasCompoundTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WARenderCanvasCompoundTests methodsFor: 'testing' stamp: 'mb 3/29/2007 10:05'!
testDateInput
	| divElement formElement element |
	html
		div: [WACanvasDateTimeTest basicNew renderDateTimeOn: html].
	divElement := html xmlContents elements first.
	formElement := divElement elements at: 2.
	element := formElement elementsExcludingContent at: 2.
	self assert: element name asString = 'select'.
	self assert: (element attributeAt: 'id')
			= 'date-input'.
	element := formElement elementsExcludingContent at: 3.
	self assert: element name asString = 'input'.
	self assert: (element attributeAt: 'type')
			= 'text'.
	self assert: (element attributeAt: 'class')
			= 'text'.
	self assert: (element attributeAt: 'id')
			= 'date-input-day'.
	self assert: (element attributeAt: 'max')
			= '31'.
	self assert: (element attributeAt: 'maxlength')
			= '2'.
	self assert: (element attributeAt: 'size')
			= '2'.
	element := formElement elementsExcludingContent at: 4.
	self assert: element name asString = 'input'.
	self assert: (element attributeAt: 'type')
			= 'text'.
	self assert: (element attributeAt: 'class')
			= 'text'.
	self assert: (element attributeAt: 'id')
			= 'date-input-year'.
	self assert: (element attributeAt: 'maxlength')
			= '4'.
	self assert: (element attributeAt: 'size')
			= '4'! !

!WARenderCanvasCompoundTests methodsFor: 'testing' stamp: 'mb 3/29/2007 10:04'!
testTimeInput
	| divElement formElement element |
	html
		div: [WACanvasDateTimeTest basicNew renderDateTimeOn: html].
	divElement := html xmlContents elements first.
	formElement := divElement elements at: 2.
	element := formElement elementsExcludingContent at: 6.
	self assert: element name asString = 'input'.
	self assert: (element attributeAt: 'type')
			= 'text'.
	self assert: (element attributeAt: 'class')
			= 'text'.
	self assert: (element attributeAt: 'id')
			= 'time-input'.
	self assert: (element attributeAt: 'maxlength')
			= '2'.
	self assert: (element attributeAt: 'size')
			= '2'.
	element := formElement elementsExcludingContent at: 7.
	self assert: element name asString = 'input'.
	self assert: (element attributeAt: 'type')
			= 'text'.
	self assert: (element attributeAt: 'class')
			= 'text'.
	self assert: (element attributeAt: 'id')
			= 'time-input-mins'.
	self assert: (element attributeAt: 'max')
			= '59'.
	self assert: (element attributeAt: 'maxlength')
			= '2'.
	self assert: (element attributeAt: 'size')
			= '2'.
	element := formElement elementsExcludingContent at: 8.
	self assert: element name asString = 'input'.
	self assert: (element attributeAt: 'type')
			= 'text'.
	self assert: (element attributeAt: 'class')
			= 'text'.
	self assert: (element attributeAt: 'id')
			= 'time-input-secs'.
	self assert: (element attributeAt: 'max')
			= '59'.
	self assert: (element attributeAt: 'maxlength')
			= '2'.
	self assert: (element attributeAt: 'size')
			= '2'! !

!WARenderCanvasTestCase methodsFor: 'constants' stamp: 'mb 3/28/2007 13:59'!
defaultActionElements
	^'<div>'
		, '<input name="1" class="submit" style="position: absolute; top: -100em" type="submit" value="Default" />'
			, '<input name="2" class="text" style="position: absolute; top: -100em" type="text" value="" />'
				,'</div>'
! !

!WARenderCanvasTestCase methodsFor: 'constants' stamp: 'mb 3/28/2007 14:00'!
hiddenFormElements
	^'<div>'
		, '<input type="hidden" name="_s" value="s" class="hidden" />'
			, '<input type="hidden" name="_k" value="k" class="hidden" />'
				, '</div>'
! !

!WARenderCanvasTestCase methodsFor: 'set-up' stamp: 'mb 3/28/2007 13:57'!
setUp
	html := WARenderCanvasForTest new.
	html context actionUrl
		addToPath: 'testUrl'; 
		addParameter: '_s' value: 's';
		addParameter: '_k' value: 'k'! !

WARenderCanvasTestCase subclass: #WARenderCanvasTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WARenderCanvasTests methodsFor: 'constants' stamp: 'mb 3/29/2007 10:29'!
callbackUrlParameters
	| parameters aString |
	parameters := #('_k=k&amp;' '_s=s&amp;' ).
	"Order is not predictable, depending on Smalltalk dialect,
	Try our best possible guess"
	aString := html contents.
	^ (aString indexOfSubCollection: parameters first startingAt: 1)
			< (aString indexOfSubCollection: parameters last startingAt: 1)
		ifTrue: [parameters first , parameters last]
		ifFalse: [parameters last , parameters first]! !

!WARenderCanvasTests methodsFor: 'testing' stamp: 'mb 2/21/2007 12:12'!
testAnchor
	html anchor with: 'foo'.
	self assert: html contents = '<a>foo</a>'! !

!WARenderCanvasTests methodsFor: 'testing' stamp: 'mb 3/29/2007 10:21'!
testAnchorWithCallback
	html anchor
		callback: [];
		 with: 'foo'.		
	self assert: html contents = ('<a href="?' , self callbackUrlParameters , '1">foo</a>').
	html anchor
		callback: [];
		 with: 'bar'.
	self assert: html contents = ('<a href="?' , self callbackUrlParameters , '1">foo</a>' , '<a href="?' , self callbackUrlParameters , '2">bar</a>')! !

!WARenderCanvasTests methodsFor: 'testing' stamp: 'mb 2/21/2007 13:06'!
testBreak
	html break.
	self assert: html contents = '<br />'
! !

!WARenderCanvasTests methodsFor: 'testing' stamp: 'mb 2/21/2007 13:08'!
testDiv
	html div: 'foo'.
	self assert: html contents = '<div>foo</div>'.
	html reset.
	html div with: 'bar'.
	self assert: html contents = '<div>bar</div>'! !

!WARenderCanvasTests methodsFor: 'testing' stamp: 'mb 2/21/2007 12:13'!
testDivAndSpan
	html div with: 'foo'.
	self assert: html contents = '<div>foo</div>'.
	html span with: 'bar'.
	self assert: html contents = '<div>foo</div><span>bar</span>'! !

!WARenderCanvasTests methodsFor: 'testing' stamp: 'mb 2/21/2007 12:21'!
testDivWithClass
	html div class: #bar; with: 'foo'.
	self assert: html contents = '<div class="bar">foo</div>'! !

!WARenderCanvasTests methodsFor: 'testing' stamp: 'mb 2/21/2007 12:53'!
testDivWithClassAndId
	html div class: #foo; id: #bar; with: 'zork'.
	self assert: (html contents isSameXmlAs: '<div class="foo" id="bar">zork</div>').! !

!WARenderCanvasTests methodsFor: 'testing' stamp: 'mb 2/21/2007 14:37'!
testForm
	html form with: 'foo'.
	self assert: (html contents isSameXmlAs:'<form action="" method="post">foo' 
			, self hiddenFormElements
			, '</form>')
! !

!WARenderCanvasTests methodsFor: 'testing' stamp: 'mb 2/21/2007 14:37'!
testFormAndButton
	html form with: [html submitButton text: 'foo'].
	self assert: (html contents isSameXmlAs: '<form method="post" action="">' 
			, '<input type="submit" value="foo" class="submit" />'
			, self hiddenFormElements
			, '</form>')
! !

!WARenderCanvasTests methodsFor: 'testing' stamp: 'mb 2/21/2007 14:37'!
testFormAndButtonWithCallback
	html form with: 
			[(html submitButton)
				callback: [];
				text: 'foo'].
	self assert: (html contents isSameXmlAs: '<form method="post" action="">' 
			, '<input name="1" value="foo" type="submit" class="submit" />'
			, self hiddenFormElements
			, '</form>')
			! !

!WARenderCanvasTests methodsFor: 'testing' stamp: 'mb 2/21/2007 14:37'!
testFormAndTextInput
	html form with: [html textInput id: #foo; value: 'bar'].
	self assert: (html contents isSameXmlAs: '<form action="" method="post">'
			, '<input type="text" class="text" value="bar" id="foo" />'
			, self hiddenFormElements
			, '</form>')
			! !

!WARenderCanvasTests methodsFor: 'testing' stamp: 'mb 2/21/2007 14:38'!
testFormAndTextInputWithCallback
	html form with: [html textInput id: #foo; callback: [:v | ]; value: 'bar'].
	self assert: (html contents isSameXmlAs: '<form action="" method="post">'
			, '<input name="1" class="text" id="foo" type="text" value="bar" />'
			, self hiddenFormElements
			, '</form>')! !

!WARenderCanvasTests methodsFor: 'testing' stamp: 'mb 3/28/2007 13:46'!
testFormWithDefaultAction
	html form
		defaultAction: [];
		 with: 'foo'.
	self
		assert: (html contents isSameXmlAs: '<form action="" method="post">' , self defaultActionElements , 'foo' , self hiddenFormElements , '</form>')! !

!WARenderCanvasTests methodsFor: 'testing' stamp: 'mb 2/21/2007 13:04'!
testImage
	html image url:'foo'; altText: 'bar'; title:'zork'.
	self assert: (html contents isSameXmlAs: '<img src="foo" alt="bar" title="zork" />')
! !

!WARenderCanvasTests methodsFor: 'testing' stamp: 'mb 2/21/2007 13:22'!
testSpace
	html space.
	self assert: html contents = '&#160;'.
	html reset.
	html space: 3.
	self assert: html contents = '&#160;&#160;&#160;'
! !

TestCase subclass: #WAStateRegistryTest
	instanceVariableNames: 'registry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-StateRegistry'!

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:22'!
assertSnapshot: x isIdenticalTo: y
	! !

!WAStateRegistryTest methodsFor: 'running' stamp: 'ab 2/18/2003 18:16'!
setUp
	registry := WAStateRegistry new! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:22'!
snapshot: x isIdenticalTo: y
	^ ((IdentitySet withAll: x values) includesAllOf: y values).! !

!WAStateRegistryTest methodsFor: 'tests' stamp: 'ab 2/18/2003 20:23'!
testConsecutiveSnapshots
	|a snap1 snap2 snap3 |
	a := ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 := registry snapshot.
	snap2 := registry snapshot.
	self assert: (self snapshot: snap1 isIdenticalTo: snap2).
	a contents: 2.
	snap3 := registry snapshot.
	self deny: (self snapshot: snap3 isIdenticalTo: snap2).
	! !

!WAStateRegistryTest methodsFor: 'tests' stamp: 'mb 2/7/2007 10:15'!
testGarbageCollection
	| a |
	a := ValueHolder new contents: 1.
	registry registerObject: a.
	registry snapshot.
	Smalltalk garbageCollect.
	self assert: registry size = 1.
	a := nil.
	Smalltalk garbageCollect.

	SeasidePlatformSupport isSqueak ifTrue:
		["This used to test the contrary, but it is changed now since the
		default implementation doesn't use weak dictionaries anymore."
		self deny: registry isEmpty]
	ifFalse:
		[self assert: registry isEmpty]
! !

!WAStateRegistryTest methodsFor: 'tests' stamp: 'ab 2/18/2003 20:24'!
testNoChangeAfterRestore
	| a snap1 snap2 snap3 |
	a := ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 := registry snapshot.
	a contents: 2.
	snap2 := registry snapshot.
	self deny: (self snapshot: snap1 isIdenticalTo: snap2).
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.
	snap3 := registry snapshot.
	self assert: (self snapshot: snap1 isIdenticalTo: snap3).! !

!WAStateRegistryTest methodsFor: 'tests' stamp: 'ab 2/18/2003 18:17'!
testRevert
	|a snap1|
	a := ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 := registry snapshot.
	a contents: 2.
	self assert: a contents = 2.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1	! !

!WAStateRegistryTest methodsFor: 'tests' stamp: 'ab 2/18/2003 18:22'!
testRevertTwice
	|a snap1|
	a := ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 := registry snapshot.
	a contents: 2.
	self assert: a contents = 2.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.
	a contents: 3.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.! !

TestCase subclass: #WAValueTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAValueTest commentStamp: '<historical>' prior: 0!
To test the refactorings from Yar Hwee Boon [hboon@motionobj.com]!

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:01'!
originalValue: anOriginalValue input: anInputObject expectedOutput: anExpectedOutputObject 
	| answer |
	(WAHtmlRenderer new
		fromStringConverterBlockFor: anOriginalValue
		callback: [:v | answer := v])
		value: anInputObject.
	self assert: answer = anExpectedOutputObject! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:01'!
testFloat
	self
		originalValue: 12.34
		input: '92.6'
		expectedOutput: 92.6! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:02'!
testFractionWithFloat
	self
		originalValue: 1 / 3
		input: '3.4'
		expectedOutput: 3.4! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:02'!
testFractionWithFraction
	self
		originalValue: 1 / 3
		input: '2/5'
		expectedOutput: 2! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:02'!
testFractionWithInteger
	self
		originalValue: 1 / 3
		input: '2'
		expectedOutput: 2! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:02'!
testFractionWithOriginalValue
	| value |
	"The #deny: check is to ensure value is stringent enough. For example 1/3 is not a suitable value."
	value := 1 /33.
	self deny: value asFloat asString asNumber = value.
	self
		originalValue: value
		input: value asFloat asString
		expectedOutput: value! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:02'!
testInteger
	self
		originalValue: 123
		input: '987'
		expectedOutput: 987! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:03'!
testNilWithEmptyString
	self
		originalValue: nil
		input: ''
		expectedOutput: nil! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:03'!
testNilWithNonEmptyString
	self
		originalValue: nil
		input: '123'
		expectedOutput: '123'! !

!WAValueTest methodsFor: 'testing' stamp: 'mb 11/4/2005 14:03'!
testObject
	self
		originalValue: Object new
		input: '2.3'
		expectedOutput: '2.3'! !

!Symbol methodsFor: '*seaside2-squeak' stamp: 'mb 5/29/2006 19:12'!
asMutator
	"Needed when using Seaside on older versions of Squeak,
	method not exported to vw"
	^ (self copyWith: $:) asSymbol.! !

!HttpRequest methodsFor: '*seaside2-squeak-override' stamp: 'dc 11/5/2006 21:45'!
parseCookies: aString 
	"PRIVATE: Parse a string in the format:  
	Cookie: NAME1=OPAQUE_STRING1; NAME2=OPAQUE_STRING2 ..."

	| dict |
	dict := Dictionary new.
	(aString findTokens: ';') do: 
			[:pairStr | 
			| pair |
			pair := pairStr findTokens: '='.
			pair size > 0 
				ifTrue: 
					[| key value |
					key := pair first withBlanksTrimmed asSymbol.
					value := pair size > 1 
						ifTrue:
							[pair second withBlanksTrimmed]
						ifFalse:
							[nil].
					dict at: key put: value]
				ifFalse: 
					["self log: 'Cookie invalid pair format: ''' , pairStr , ''''"

					]].
	^dict! !

!Number methodsFor: '*seaside2' stamp: 'mb 3/23/2006 07:34'!
convertSeasideString: aString
	^ aString asNumber! !

!Number methodsFor: '*seaside2' stamp: 'mb 5/20/2006 10:01'!
em
	^ self printString , 'em'! !

!Number methodsFor: '*seaside2' stamp: 'mb 5/20/2006 10:01'!
px
	^ self printString , 'px'! !

!Dictionary methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:48'!
inspectorFields
	^ self! !

!Dictionary methodsFor: '*seaside2' stamp: 'lr 2/16/2007 15:11'!
valuesCollect: aBlock
	| result |
	result := self species new: self size.
	self keysAndValuesDo: [ :key :value |
		result at: key put: (aBlock value: value) ].
	^ result! !

!UndefinedObject methodsFor: '*seaside2' stamp: 'mb 11/27/2005 10:20'!
asSeasideString
	^ ''
! !

!UndefinedObject methodsFor: '*seaside2' stamp: 'mb 3/23/2006 07:36'!
convertSeasideString: aString
	^ aString = '' ifTrue: [nil] ifFalse: [aString]
! !

!UndefinedObject methodsFor: '*seaside2' stamp: 'ab 11/11/2002 12:06'!
renderOn: html
! !

!JPEGReadWriter2 methodsFor: '*seaside2-squeak-override' stamp: 'mb 6/12/2006 13:58'!
nextPutImage: aForm quality: quality progressiveJPEG: progressiveFlag
	"Encode the given Form on my stream with the given settings. Quality goes from 0 (low) to 100 (high), where -1 means default. If progressiveFlag is true, encode as a progressive JPEG."

	| sourceForm jpegCompressStruct jpegErrorMgr2Struct buffer byteCount |
	aForm unhibernate.
	"odd width images of depth 16 give problems; avoid them."
	sourceForm _ (aForm depth = 32) | (aForm width even & (aForm depth = 16))
		ifTrue: [aForm]
		ifFalse: [aForm asFormOfDepth: 32].
	jpegCompressStruct _ ByteArray new: self primJPEGCompressStructSize.
	jpegErrorMgr2Struct _ ByteArray new: self primJPEGErrorMgr2StructSize.
	buffer _ ByteArray new: sourceForm width * sourceForm height + 1024.
	byteCount _ self primJPEGWriteImage: jpegCompressStruct 
		onByteArray: buffer
		form: sourceForm
		quality: quality
		progressiveJPEG: progressiveFlag
		errorMgr: jpegErrorMgr2Struct.
	byteCount = 0 ifTrue: [self error: 'buffer too small for compressed data'].
	stream next: byteCount putAll: buffer startingAt: 1.
	self close.
! !

Notification subclass: #WADeprecatedApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WADeprecatedApi commentStamp: '<historical>' prior: 0!
WADeprecatedApi is a notification that gets signaled if someone used a deprecated Seaside method.

see #deprecatedApi!

Notification subclass: #WADynamicVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WADynamicVariable commentStamp: '<historical>' prior: 0!
A WADynamicVariable is a variable that is visible only in the stackframes outgoing from this one.

Example:

WADynamicVariable
	use: 'Seaside'
	during: [ self compilcatedCalculation ]
	
Whenever
WADynamicVariable value
gets evaluated somewhere inside [ self compilcatedCalculation ] or a method invoked directly or indirectly by it, its value will be 'Seaside'. If no #use:during: handler is around the current stack frame, then the value will be the return value of #defaultValue.

Do not use WADynamicVariable directly, instead create a subclass for each variable you want to use.!

WADynamicVariable subclass: #WACurrentSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WACurrentSession commentStamp: '<historical>' prior: 0!
A WACurrentSession is the dynamic variable for the current Seaside session. See superclass comment for what a dynamic variable is.!

!WADynamicVariable class methodsFor: 'defaults' stamp: 'avi 3/29/2004 14:12'!
defaultValue
	^ nil! !

!WADynamicVariable class methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 14:13'!
use: anObject during: aBlock
	^ aBlock
		on: self
		do: [:n | n resume: anObject]! !

!WADynamicVariable class methodsFor: 'evaluating' stamp: 'avi 4/27/2004 14:25'!
value
	^ self raiseSignal! !

!WADynamicVariable methodsFor: 'defaults' stamp: 'avi 3/29/2004 14:12'!
defaultAction
	self resume: self class defaultValue! !

Notification subclass: #WAPageExpired
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

Notification subclass: #WARenderNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

Notification subclass: #WAValidationNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAValidationNotification commentStamp: 'cds 7/25/2005 10:17' prior: 0!
I am signaled to indicate that a validation has occurred.  See: Object>>validationError:, WAComponent>>validateWith: and WAValidationDecoration.!

!PositionableStream methodsFor: '*seaside2-squeak' stamp: 'mb 6/2/2006 10:47'!
asMIMEDocument
	^self asMIMEDocumentType: 'text/plain'! !

!PositionableStream methodsFor: '*seaside2-squeak' stamp: 'mb 6/2/2006 10:54'!
asMIMEDocumentType: mimeType
	^MIMELocalFileDocument contentType: mimeType contentStream:  self! !

!PositionableStream methodsFor: '*seaside2-squeak' stamp: 'ab 7/11/2003 00:10'!
upToAndSkipThroughAll: aCollection
	^ self upToAll: aCollection! !

!Collection methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:47'!
inspectorFields
	|i|
	i _ 0.
	^ self asArray collect: [:each | i _ i + 1. i -> each]! !

!Collection methodsFor: '*seaside2' stamp: 'lr 3/8/2006 08:43'!
renderOn: html
	self do: [ :each | each renderOn: html ]! !

!ByteArray methodsFor: '*seaside2' stamp: 'mb 6/2/2006 10:46'!
asMIMEDocument
	^self asMIMEDocumentType: 'application/octet-stream'! !

!ByteArray methodsFor: '*seaside2' stamp: 'mb 6/2/2006 10:53'!
asMIMEDocumentType: mimeType
	^SeasidePlatformSupport mimeDocumentClass contentType: mimeType content: self! !

!ByteArray methodsFor: '*seaside2' stamp: 'mb 9/22/2006 12:17'!
renderOn: aRenderer
	aRenderer text: self! !

ByteArray variableByteSubclass: #WAExternalID
	instanceVariableNames: ''
	classVariableNames: 'Generator GeneratorMutex'
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAExternalID commentStamp: '<historical>' prior: 0!
I am a session or conticuation key.!

!WAExternalID class methodsFor: 'defaults' stamp: 'ab 5/28/2003 23:34'!
defaultSize
	^ 8! !

!WAExternalID class methodsFor: 'instance creation' stamp: 'pmm 10/2/2006 21:31'!
fromString: aString
	| id |
	id := self new: aString size.
	aString withIndexDo: [ :each :index |
		id at: index put: each asInteger].
	^ id
! !

!WAExternalID class methodsFor: 'class initialization' stamp: 'mb 11/27/2005 17:19'!
initialize
	"WAExternalID initialize"

	GeneratorMutex := Semaphore forMutualExclusion.
	SeasidePlatformSupport addToStartUpList: self.
	self startUp.! !

!WAExternalID class methodsFor: 'instance creation' stamp: 'ab 5/28/2003 23:53'!
new
	^ self new: self defaultSize! !

!WAExternalID class methodsFor: 'instance creation' stamp: 'pmm 11/2/2005 23:19'!
new: aNumber
	^ (self basicNew: aNumber) initialize! !

!WAExternalID class methodsFor: 'class initialization' stamp: 'al 6/29/2005 09:08'!
startUp
	Generator := Random new.! !

!WAExternalID methodsFor: 'private' stamp: 'lr 5/3/2006 09:40'!
initialize
	GeneratorMutex critical:
		[1 to: self size do: [:i | self at: i put: ((($a to: $z), ($A to: $Z)) atRandom: Generator) asInteger]]! !

!WAExternalID methodsFor: 'private' stamp: 'ab 5/29/2003 00:00'!
printOn: stream
	self do: [:i | stream nextPut: (Character value: i)]! !

!Color methodsFor: '*seaside2' stamp: 'avi 4/29/2004 13:06'!
asHTMLColor
	^ '#', self hex! !

!Color methodsFor: '*seaside2' stamp: 'mb 5/13/2006 07:45'!
hex
	| aStream |
	aStream _ (String new: 6) writeStream. 
	aStream nextPutAll: (((self red * 255) asInteger printStringBase: 16)
		padded: #left to: 2 with: $0).
	aStream nextPutAll: (((self green * 255) asInteger printStringBase: 16)
		padded: #left to: 2 with: $0).
	aStream nextPutAll: (((self blue * 255) asInteger printStringBase: 16)
		padded: #left to: 2 with: $0).
	^ aStream contents
! !

!String methodsFor: '*seaside2' stamp: 'avi 3/16/2004 16:33'!
asCapitalizedPhrase
	|read words currentWord capitalizedWord|
	(self noneSatisfy: [:ea | ea isLowercase] ) ifTrue: [^ self].
	words _ WriteStream on: String new.
	read _ ReadStream on: self.
	[read atEnd] whileFalse:
		[currentWord _ WriteStream on: String new.
		currentWord nextPut: read next.
		[|x| x _ read peek. x isNil or: [x isUppercase]] whileFalse:
			[currentWord nextPut: read next].
		capitalizedWord _ currentWord contents capitalized.
			(#(Of In At A Or To By) includes: capitalizedWord)
				ifTrue: [capitalizedWord _ capitalizedWord asLowercase].
		words nextPutAll: capitalizedWord.
		words nextPutAll: ' '].
	words skip: -1.
	^ words contents ! !

!String methodsFor: '*seaside2' stamp: 'mb 6/2/2006 10:47'!
asMIMEDocument 
	^self asMIMEDocumentType: 'text/plain'! !

!String methodsFor: '*seaside2' stamp: 'mb 6/2/2006 10:54'!
asMIMEDocumentType: mimeType
	^SeasidePlatformSupport mimeDocumentClass contentType: mimeType content: self! !

!String methodsFor: '*seaside2' stamp: 'mb 3/29/2007 08:15'!
isSameXmlAs: anotherString 
	"
	Make sure you enclose your strings in some container
	(a div element for instance) to ensure xml well-formedness
	thus avoiding parse errors
	"
	| selfXml anotherXml |
	selfXml := SeasidePlatformSupport parseDocumentFrom: self readStream.
	anotherXml := SeasidePlatformSupport parseDocumentFrom: anotherString readStream.
	^ selfXml printString = anotherXml printString! !

!String methodsFor: '*seaside2' stamp: 'ab 3/29/2003 00:15'!
prettyPrintHtmlOn: aStream indentLevel: aNumber
	aStream nextPutAll: self! !

!String methodsFor: '*seaside2' stamp: 'ab 1/11/2003 12:46'!
printHtmlOn: aStream
	aStream nextPutAll: self! !

!String methodsFor: '*seaside2' stamp: 'lr 6/13/2006 16:06'!
renderOn: aRenderer
	aRenderer text: self! !

!String methodsFor: '*seaside2' stamp: 'jf 2/18/2004 15:21'!
renderOn: html indentLevel: level
	html text: self! !

!String methodsFor: '*seaside2-squeak' stamp: 'mb 3/23/2006 11:46'!
trimBlanks
	^self withBlanksTrimmed! !

!MessageSend methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:40'!
evaluateWithArguments: anArray
	^ self valueWithArguments: anArray! !

!MessageSend methodsFor: '*seaside2' stamp: 'mb 4/24/2007 17:35'!
fixCallbackTemps
	"for polymorphism with BlockContext >> #fixCallbackTemps"


! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 3/5/2003 18:30'!
numArgs
	^ selector numArgs! !

!MessageSend methodsFor: '*seaside2' stamp: 'lr 8/4/2006 09:18'!
renderOn: html
	self value: html! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 7/10/2003 11:40'!
value: anObject
	^ self evaluateWithArguments: (Array with: anObject)! !

!MIMEDocument methodsFor: '*seaside2-squeak' stamp: 'pmm 4/18/2006 20:09'!
asMIMEDocument
	^self! !

!MIMEDocument methodsFor: '*seaside2-squeak' stamp: 'mb 6/2/2006 10:44'!
asMIMEDocumentType: mimeType
	^self! !

!Behavior methodsFor: '*seaside2-squeak' stamp: 'mb 3/13/2007 15:15'!
fullName
	"For VW compatibility"
	^ self name! !

!Stream methodsFor: '*seaside2-squeak' stamp: 'avi 8/31/2003 15:48'!
closed
	^false! !

Object subclass: #Amb
	instanceVariableNames: 'failureContinuation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!Amb class methodsFor: 'instance creation' stamp: 'lr 5/3/2006 09:24'!
new
	^ self basicNew initialize! !

!Amb methodsFor: 'evaluation' stamp: 'ab 6/15/2003 19:23'!
allValues: aBlock
	|kPrev results|
	kPrev := failureContinuation.
	results := OrderedCollection new.
	(Continuation currentDo:
		[:kRetry |
		failureContinuation := [:v | kRetry value: false].
		results add: aBlock value.
		kRetry value: true])
			ifTrue: [self fail].
	failureContinuation := kPrev.
	^ results asArray	 ! !

!Amb methodsFor: 'error handling' stamp: 'ab 12/6/2002 02:11'!
assert: aBoolean
	aBoolean ifFalse: [self fail]! !

!Amb methodsFor: 'error handling' stamp: 'ab 12/6/2002 02:12'!
deny: aBoolean
	self assert: aBoolean not! !

!Amb methodsFor: 'error handling' stamp: 'ab 12/6/2002 02:15'!
fail
	^ failureContinuation value: nil! !

!Amb methodsFor: 'initialize-release' stamp: 'avi 4/27/2004 14:28'!
initialize
	failureContinuation := [:v | self error: 'Amb tree exhausted'].! !

!Amb methodsFor: 'evaluation' stamp: 'ab 5/29/2003 22:29'!
maybe
	^ self oneOf: (Array with: true with: false)! !

!Amb methodsFor: 'evaluation' stamp: 'ab 12/6/2002 02:09'!
oneOf: aCollection
	^ self valueOfOneOf: (aCollection collect: [:ea | [ea] fixTemps])! !

!Amb methodsFor: 'evaluation' stamp: 'ab 5/29/2003 22:30'!
valueOf: blockOne or: blockTwo
	^ self valueOfOneOf: (Array with: blockOne with: blockTwo)! !

!Amb methodsFor: 'evaluation' stamp: 'ab 5/29/2003 22:30'!
valueOf: blockOne or: blockTwo or: blockThree
	^ self valueOfOneOf: (Array with: blockOne with: blockTwo with: blockThree)! !

!Amb methodsFor: 'evaluation' stamp: 'ab 6/15/2003 19:23'!
valueOfOneOf: blockCollection
	|kPrev|
	kPrev := failureContinuation.
	^ Continuation currentDo:
		[:kEntry |
		blockCollection do:
			[:ea |
			Continuation currentDo:
				[:kNext |
				failureContinuation :=
					[:v | failureContinuation := kPrev. kNext value: v] fixTemps.
				kEntry value: ea value]].
		kPrev value: nil]
			 ! !

Object subclass: #Continuation
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

Continuation subclass: #AnswerContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
current
	^ self fromContext: thisContext sender! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
currentDo: aBlock
	^ aBlock value: (self fromContext: thisContext sender)! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
fromContext: aStack
	^self new initializeFromContext: aStack! !

!Continuation methodsFor: 'private' stamp: 'avi 4/24/2004 12:39'!
initializeFromContext: aContext
	| valueStream context |
	valueStream := WriteStream on: (Array new: 20).
	context := aContext.
	[context notNil] whileTrue:
		[valueStream nextPut: context.
		1 to: context class instSize do: [:i | valueStream nextPut: (context instVarAt: i)].
		1 to: context localSize do: [:i | valueStream nextPut: (context localAt: i)].
		context := context sender].
	values := valueStream contents! !

!Continuation methodsFor: 'evaluating' stamp: 'lr 2/6/2007 17:19'!
invoke: aBlock
	"Invoke the continuation and evaluates aBlock within the captured execution context."
	
	| activation | 
	aBlock fixTemps.
	self terminate: thisContext.
	self restoreValues.
	activation := aBlock asContext.
	activation swapSender: values first.
	thisContext swapSender: activation! !

!Continuation methodsFor: 'accessing' stamp: 'ab 6/15/2003 19:18'!
numArgs
	^ 1! !

!Continuation methodsFor: 'private' stamp: 'avi 4/24/2004 12:39'!
restoreValues
	| valueStream context |
	valueStream := values readStream.
	[valueStream atEnd] whileFalse:
		[context := valueStream next.
		1 to: context class instSize do: [:i | context instVarAt: i put: valueStream next].
		1 to: context localSize do: [:i | context localAt: i put: valueStream next]]! !

!Continuation methodsFor: 'private' stamp: 'ab 6/15/2003 19:13'!
terminate: aContext
	| context |
	context := aContext.
	[context notNil] whileTrue: [context := context swapSender: nil]
! !

!Continuation methodsFor: 'evaluating' stamp: 'ab 6/15/2003 19:13'!
value
	self value: nil! !

!Continuation methodsFor: 'evaluating' stamp: 'lr 1/5/2007 18:35'!
value: anObject
	"Invoke the continuation and answer anObject as return value."
	
	self terminate: thisContext.
	self restoreValues.
	thisContext swapSender: values first.
	^ anObject! !

!Continuation methodsFor: 'evaluating' stamp: 'lr 1/5/2007 16:02'!
valueWithArguments: anArray
	anArray size = 1 
		ifFalse: [ ^ self error: 'continuations can only be resumed with one argument' ].
	self value: anArray first! !

Continuation subclass: #EscapeContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

Continuation subclass: #ResponseContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!Object methodsFor: '*seaside2' stamp: 'mb 3/16/2006 10:32'!
asSeasideString
	^ self displayString
! !

!Object methodsFor: '*seaside2-squeak' stamp: 'lr 10/28/2006 13:05'!
beMutable! !

!Object methodsFor: '*seaside2' stamp: 'mb 3/23/2006 07:32'!
convertSeasideString: aString
	^ aString
! !

!Object methodsFor: '*seaside2' stamp: 'mb 10/13/2006 00:19'!
deprecatedApi
	WADeprecatedApi raiseSignal: thisContext sender displayString! !

!Object methodsFor: '*seaside2-squeak' stamp: 'lr 7/12/2005 17:01'!
displayString
	^ self asString! !

!Object methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:47'!
inspectorFields
	|members|
	members _ self class allInstVarNames
					collect: [:ivar | ivar -> (self instVarNamed: ivar)].
						
	self class isVariable ifTrue:
		[members _ members, ((1 to: self size) collect: [:i | i -> (self at: i)])].
	^ members! !

!Object methodsFor: '*seaside2' stamp: 'avi 9/1/2004 21:20'!
isIdenticalToSnapshot: anObject
	1 to: self class instSize do:
		[:i | (anObject instVarAt: i) == (self instVarAt: i) ifFalse: [^ false]].
	self class isVariable ifTrue:
		[1 to: self size do: [:i | (anObject at: i) == (self at: i) ifFalse: [^ false]]].
	^ true! !

!Object methodsFor: '*seaside2' stamp: 'avi 3/14/2005 15:19'!
labelForSelector: aSymbol
	^ aSymbol asCapitalizedPhrase! !

!Object methodsFor: '*seaside2' stamp: 'mb 4/23/2007 14:20'!
renderOn: aRenderer
	"Override this method to customize how objects (not components) are rendered when passed as an argument to #render:. The default is the return value of #displayString.
	Just remember that you can not use #callback:, #on:of:, or #call:"


	aRenderer text: self! !

!Object methodsFor: '*seaside2' stamp: 'avi 9/1/2004 21:19'!
restoreFromSnapshot: anObject
	1 to: self class instSize do: [:i | self instVarAt: i put: (anObject instVarAt: i)].
	self class isVariable ifTrue: [1 to: self size do: [:i | self at: i put: (anObject at: i)]].
! !

!Object methodsFor: '*seaside2' stamp: 'avi 9/1/2004 21:20'!
snapshotCopy
	^ self shallowCopy! !

!Object methodsFor: '*seaside2' stamp: 'mb 3/23/2006 17:53'!
validationError: message
	^WAValidationNotification raiseSignal: message
! !

Object subclass: #SeasidePlatformSupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!SeasidePlatformSupport class methodsFor: 'startup' stamp: 'mb 11/27/2005 10:16'!
addToStartUpList: anObject
	Smalltalk addToStartUpList: anObject.! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 4/24/2006 22:51'!
asMethodReturningByteArray: aByteArrayOrString named: aSymbol
	| optimze |
	optimze := Preferences
		valueOfFlag: #compileUseNewCompiler
		ifAbsent: [ false ].
	^optimze
		ifTrue: [ self asMethodReturningByteArrayLiteral: aByteArrayOrString named: aSymbol ]
		ifFalse: [ self asMethodReturningByteArrayWithCache: aByteArrayOrString named: aSymbol ]! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 4/24/2006 22:45'!
asMethodReturningByteArrayLiteral: aByteArrayOrString named: aSymbol
	^String streamContents: [ :stream |
		stream nextPutAll: aSymbol; cr.
		stream tab; nextPutAll: '^ #['.
		aByteArrayOrString asByteArray
			do: [ :each | each printOn: stream ]
			separatedBy: [ stream space ].
		stream nextPutAll: ']' ]! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'mb 10/17/2006 19:15'!
asMethodReturningByteArrayWithCache: aByteArrayOrString named: aSymbol
	^String streamContents: [ :stream |
		stream nextPutAll: aSymbol; cr.
		stream tab; nextPutAll: '| xxxCache |'; cr.
		stream tab; nextPutAll: 'xxxCache := #(nil) beMutable.'; cr.
		stream tab; nextPutAll: '(xxxCache at: 1) isNil ifTrue: ['; cr.
		stream tab; tab; nextPutAll: 'xxxCache at: 1 put: #('.
		aByteArrayOrString asByteArray
			do: [ :each | each printOn: stream ]
			separatedBy: [ stream space ].
		stream nextPutAll: ') asByteArray ].'; cr.
		stream tab; nextPutAll: '^ xxxCache at: 1'. ]! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 9/18/2003 16:43'!
base64Decode: aString
	^ (Base64MimeConverter mimeDecodeToChars: aString readStream) contents
		! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 4/21/2006 23:39'!
compile: aString into: aClass classified: aSymbol
	aClass compile: aString classified: aSymbol! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 10/5/2006 18:32'!
contentsOfFile: aString binary: aBoolean
	| stream |
	stream := aBoolean
		ifTrue: [ (FileDirectory default oldFileNamed: aString)
			binary;
			yourself ]
		ifFalse: [ (CrLfFileStream oldFileNamed: aString)
			ascii;
			yourself ].
	^[ stream contents ] ensure: [ stream close ]! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 10/5/2006 19:23'!
convertToSmalltalkNewlines: aString
	"yes this is stupid, inefficent code but hey, it's Squeak!!"
	^(aString
		copyReplaceAll: (String with: Character cr with: Character lf)
		with: (String with: Character cr))
			copyReplaceAll: (String with: Character lf)
			with: (String with: Character cr)! !

!SeasidePlatformSupport class methodsFor: 'dispatchers' stamp: 'mb 2/17/2007 08:19'!
defaultDispatcherName
	^'seaside'! !

!SeasidePlatformSupport class methodsFor: 'email' stamp: 'avi 3/11/2004 13:13'!
deliverMailFrom: fromAddress to: recipientList text: messageText
	SMTPClient
		deliverMailFrom: fromAddress
		to: recipientList
		text: messageText
		usingServer: self smtpServer! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 11:40'!
ensureAuthorInitials: aBlock
	Utilities authorInitialsPerSe isEmpty
		ifTrue: [Utilities setAuthorInitials: aBlock value].
! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 6/5/2006 21:29'!
filesIn: aPathString
	| directory |
	directory := FileDirectory on: aPathString.
	^directory fileNames collect: [ :each |
		directory fullNameFor: each ]! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'pmm 9/12/2006 19:24'!
getDocumentWithUrl: url
	"(WAUrl new
		hostname: 'www.google.com'; 
		addToPath: 'search';
		addParameter: 'hl' value: 'fr';
		addParameter: 'q' value: 'Seaside';
		addParameter: 'lr' value: '';
		yourself) getDocument"
	^ HTTPSocket httpGetDocument: url urlString args: url parametersForHttpSocket! !

!SeasidePlatformSupport class methodsFor: 'testing' stamp: 'avi 1/1/2005 15:05'!
isProxy: anObject
	^ (anObject class allSuperclasses includes: Object) not! !

!SeasidePlatformSupport class methodsFor: 'testing' stamp: 'mb 2/7/2007 10:12'!
isSqueak
	^true! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 6/5/2006 21:32'!
localNameOf: aFilename
	^(FileDirectory on: aFilename) localName! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'pmm 9/12/2006 17:47'!
methodsOf: anAuthorString
	"self methodsOf: 'avi'"
	| methods |
	methods := ((Seaside2Info named: 'Seaside') methods select: [ :each |
			(each timeStamp copyUpTo: Character space) = anAuthorString ]).
	MessageSet
		openMessageList: methods
		name: methods size displayString , ' methods of ', anAuthorString! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:04'!
mimeDocumentClass
	^ MIMEDocument ! !

!SeasidePlatformSupport class methodsFor: 'factory' stamp: 'pmm 9/12/2006 19:23'!
mimeDocumentOfType: type from: aFilename
	"WACachedDocument clearCache.
	(WACachedDocument fileName: 'SqueakDebug.log') asMIMEDocument.
	(WACachedDocument fileName: 'SqueakDebug.log') asMIMEDocument."


	| content mimeType |
	mimeType := type ifNil: [
		self mimeDocumentClass guessTypeFromExtension: (FileDirectory extensionFor: aFilename) ].
	content := (StandardFileStream readOnlyFileNamed: aFilename) contentsOfEntireFile.
	^self mimeDocumentClass
		contentType: mimeType 
		content: content.
! !

!SeasidePlatformSupport class methodsFor: 'exceptions' stamp: 'mb 1/13/2006 09:54'!
openDebuggerOn: anError
	| process |
	process := Processor activeProcess.
	WorldState addDeferredUIMessage:
		[process 
			debug: anError signalerContext
			title: anError description
			full: true].
	process suspend! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'mb 3/29/2007 08:16'!
parseDocumentFrom: aStream 
	^ XMLDOMParser parseDocumentFrom: aStream! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 11:18'!
profileSendsDuring: aBlock
	Processor activeProcess priority: 20.
	Smalltalk garbageCollectMost.	
	^ String streamContents: 
			[:stream | 
			(MessageTally new)
				spyEvery: 1
				on: [aBlock value. Smalltalk garbageCollectMost];
				report: stream]! !

!SeasidePlatformSupport class methodsFor: 'factory' stamp: 'avi 4/27/2004 14:25'!
readWriteStream
	^ RWBinaryOrTextStream on: String new! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 4/21/2006 23:56'!
removeSelector: aSymbol from: aClass
	aClass removeSelectorSilently: aSymbol! !

!SeasidePlatformSupport class methodsFor: 'requests' stamp: 'mb 5/30/2006 12:30'!
request: aString
	^FillInTheBlank request: aString! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'pmm 9/12/2006 19:23'!
seasideBanner
	"This is a copy of http://www.netstyle.ch/include/seaside/pics/top.jpg"
	"| mimeDoc |
	mimeDoc := 'http://www.netstyle.ch/include/seaside/pics/top.jpg' asUrl retrieveContents.
	Clipboard clipboardText: 
		(Base64MimeConverter mimeEncode: mimeDoc content readStream) contents"
	^self base64Decode:
'/9j/4AAQSkZJRgABAQAAAQABAAD/2wBDAAgGBgcGBQgHBwcJCQgKDBQNDAsLDBkSEw8UHRof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'! !

!SeasidePlatformSupport class methodsFor: 'email' stamp: 'avi 3/11/2004 13:10'!
smtpServer
	^ MailSender smtpServer! !

!SeasidePlatformSupport class methodsFor: 'accessing' stamp: 'mb 10/12/2006 20:14'!
versionString
	^SeasideVWInfo new versionString! !

!SeasidePlatformSupport class methodsFor: 'vm statistics' stamp: 'tonyg 1/3/2006 10:40'!
vmStatisticsReportString
	^ SmalltalkImage current vmStatisticsReportString ! !

!SeasidePlatformSupport class methodsFor: 'exceptions' stamp: 'mb 3/23/2006 08:12'!
walkbackStringsFor: anError
	^(anError signalerContext sender stackOfSize: 20) 
		collect: [:ctx | ctx printString].
! !

!SeasidePlatformSupport class methodsFor: 'factory' stamp: 'pmm 9/12/2006 17:34'!
weakDictionaryOfSize: aNumber
	^IdentityDictionary new: aNumber! !

Object subclass: #WAAbstractHtmlBuilder
	instanceVariableNames: 'attributeBuffer'
	classVariableNames: 'HtmlCharacters'
	poolDictionaries: ''
	category: 'Seaside-Builder'!

!WAAbstractHtmlBuilder commentStamp: '<historical>' prior: 0!
I am abstract class providing methods to build xhtml.  My most commonly used subclass is WAHtmlRenderer.!

!WAAbstractHtmlBuilder class methodsFor: 'encoding' stamp: 'lr 6/14/2006 08:00'!
encode: anObject
	^ String streamContents: [ :stream | self encode: anObject to: stream ]! !

!WAAbstractHtmlBuilder class methodsFor: 'encoding' stamp: 'lr 6/14/2006 08:00'!
encode: anObject to: aStream
	| charOrString |
	anObject displayString do: [:char |
		charOrString := HtmlCharacters 
			at: char asInteger + 1 
			ifAbsent: [ char asCharacter ].
		charOrString isString
			ifTrue: [ aStream nextPutAll: charOrString ]
			ifFalse: [ aStream nextPut: charOrString ] ]! !

!WAAbstractHtmlBuilder class methodsFor: 'initialization' stamp: 'avi 6/25/2004 20:46'!
initialize
	"WAHtmlBuilder initialize"
	HtmlCharacters := Array new: 256.
	
	0 to: 255 do: [:ea | HtmlCharacters at: ea + 1 put: ea asCharacter].
	
	#($" 'quot' $< 'lt' $& 'amp' $> 'gt') pairsDo:
		[:c :s | HtmlCharacters at: (c asInteger + 1) put: ('&',s,';') ]
	! !

!WAAbstractHtmlBuilder class methodsFor: 'instance creation' stamp: 'lr 11/16/2006 15:34'!
new
	self deprecatedApi.
	^ super new! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 2/19/2004 01:08'!
acronym: titleString do: aBlock
	self attributes at: 'title' put: titleString.
	self tag: 'acronym' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/1/2004 20:49'!
anchorWithMailto: emailString
	self anchorWithUrl: 'mailto:', emailString do: emailString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/1/2004 20:50'!
anchorWithMailto: emailString subject: subjectString
	self anchorWithUrl: 'mailto:', emailString, '?subject=', subjectString do: emailString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:38'!
anchorWithName: aString
	self attributes at: 'name' put: aString.
	self tag: #a! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 5/3/2005 08:50'!
anchorWithPopupUrl: urlString extent: aPoint do: anObject
	self 
		anchorWithPopupUrl: urlString 
		name: ''
		extent: aPoint 
		toggles: #(menubar resizable scrollbars) 
		do: anObject
! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: 'ac 12/10/2004 17:20'!
anchorWithPopupUrl: urlString extent: aPoint text: aString
	self 
		anchorWithPopupUrl: urlString 
		extent: aPoint 
		do: aString! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: 'ac 12/23/2004 04:42'!
anchorWithPopupUrl: urlString name: nameString extent: aPoint toggles: aCollection do: anObject
	self attributes
		at: 'onClick' 
		put: (self popupStringWithUrl: urlString name: nameString extent: aPoint toggles: aCollection), '; return false'.
	
	self anchorWithUrl: urlString do: anObject. ! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:38'!
anchorWithUrl: urlString do: aBlock
	self attributes at: 'href' put: urlString.
	self tag: 'a' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:37'!
anchorWithUrl: urlString title: titleString do: aBlock
	self attributes at: 'title' put: titleString.
	self anchorWithUrl: urlString do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'mb 3/28/2007 12:35'!
attributeAt: aString
	^self attributes at: aString! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 4/24/2004 13:05'!
attributeAt: aString put: anObject
	self attributes at: aString put: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'mb 3/28/2007 12:35'!
attributes
	^ attributeBuffer ifNil: [attributeBuffer := WAHtmlAttributes new]! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 1/11/2003 12:44'!
attributes: aCollection
	aCollection associationsDo: [:x | self attributeAt: x key put: x value]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:02'!
bold: aBlock
	self tag: 'b' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:02'!
break
	self tag: 'br'! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'ab 7/3/2003 14:56'!
buttonForUrl: urlString withText: labelString
	self buttonForUrl: urlString withText: labelString data: #()
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'mbany 4/14/2005 12:22'!
buttonForUrl: urlString withText: labelString data: assocCollection
	self formWithMethod: 'GET' action: urlString do:
		[assocCollection do: 
			[:each | self
				inputWithType: 'hidden'
				named: each key displayString
				value: each value].
		self submitButtonWithText: labelString]
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'mb 11/27/2005 10:22'!
buttonWithType: typeString named: nameString value: valueString do: aBlock
	nameString ifNotNil:
		[self attributes
			at: 'name' put: nameString;
			at: 'id' ifAbsentPut: [nameString]].
	valueString ifNotNil: [self attributes value: valueString displayString].
		
	self attributes type: typeString.
	
	self tag: 'button' do: aBlock.
! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:44'!
closeTag: aString
	self document closeTag: aString ! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/12/2003 21:04'!
cssClass: aString
	self attributeAt: 'class' put: aString! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/12/2003 21:04'!
cssId: aString
	self attributeAt: 'id' put: aString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
div: aBlock
	self tag: 'div' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:33'!
divClass: aString with: anObject
	self cssClass: aString; div: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:33'!
divNamed: aString with: anObject
	self cssId: aString; div: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:45'!
document
	self subclassResponsibility ! !

!WAAbstractHtmlBuilder methodsFor: 'dnu' stamp: 'ab 5/24/2003 00:41'!
doesNotUnderstand: aMessage
	| argCount |
	argCount := aMessage arguments size.
	argCount = 0 ifTrue: [^ self tag: aMessage selector].
	argCount = 1 ifTrue: [^ self tag: aMessage selector allButLast do: aMessage argument].
	^ super doesNotUnderstand: aMessage
! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'rbb 6/13/2003 00:07'!
emphasis: aBlock
	self tag: 'em' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'mbany 4/14/2005 12:21'!
encodeCharacter: aCharacter
	self html: ('&#', aCharacter asInteger displayString, ';').  ! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'jf 2/18/2004 15:02'!
encodeText: anObject
	"deprecated"
	self text: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'mb 2/9/2006 14:23'!
ensureCssClass: aString
	self attributes at: 'class' ifAbsentPut: [aString]! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'mb 2/9/2006 14:21'!
ensureCssId: aString
	self attributes at: 'id' ifAbsentPut: [aString]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 2/9/2006 17:39'!
fieldset: aBlock
	self tag: 'fieldset' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'mb 2/9/2006 17:42'!
fieldsetWithLegend: aString do: aBlock
	self fieldset: [
		self legend: aString.
		aBlock value.
	]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:16'!
formWithAction: actionUrl do: aBlock
	self formWithMethod: 'post' action: actionUrl do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:38'!
formWithMethod: methodString action: actionUrl do: aBlock
	self attributes
		 at: 'method' put: methodString;
		 at: 'action' put: actionUrl.
	self tag: 'form' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
heading: aString
	self heading: aString level: 1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mbany 4/14/2005 12:20'!
heading: anObject level: aNumber
	self tag: 'h', aNumber displayString do: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
horizontalRule
	self tag: 'hr'! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'jf 2/18/2004 15:01'!
html: aString
	self document text: aString.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:21'!
image: urlString
	self image: urlString altText: ''! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 2/9/2006 18:02'!
image: urlString altText: altString
	self attributeAt: 'alt' put: altString.
	self attributeAt: 'src' put: urlString.	
	self tag: #img.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:39'!
image: urlString height: height
	self attributes at: 'height' put: height.
	self image: urlString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:39'!
image: urlString height: height altText: altString
	self attributes at: 'height' put: height.
	self image: urlString altText: altString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:39'!
image: urlString width: width
	self attributes at: 'width' put: width.
	self image: urlString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:39'!
image: urlString width: width altText: altString
	self attributes at: 'width' put: width.
	self image: urlString altText: altString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:40'!
image: urlString width: width height: height
	self attributes
		 at: 'width' put: width;
		 at: 'height' put: height.
	self image: urlString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 8/3/2006 08:40'!
image: urlString width: width height: height altText: altString
	self attributes
		 at: 'width' put: width;
		 at: 'height' put: height.
	self image: urlString altText: altString! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:26'!
inputWithType: type
	self inputWithType: type named: nil
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:25'!
inputWithType: type named: name	
	self inputWithType: type named: name value: nil.
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'lr 5/10/2005 16:15'!
inputWithType: type named: name value: value
	name ifNotNil: [self attributes at: 'name' put: name].
	value ifNotNil: [self attributes value: value displayString].
		
	self attributes type: type; addClass: type.
	
	self tag: 'input'.
! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'rbb 6/11/2003 17:01'!
italic: aBlock
	self tag: 'i' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 2/9/2006 17:41'!
label: aBlock
	self tag: 'label' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 2/9/2006 17:42'!
labelFor: idString do: aBlock
	self attributes at: 'for' put: idString.
	self label: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'lr 8/3/2006 13:16'!
layoutTable: aBlock
	self attributes
		at: 'border'put: 0;
		at: 'cellspacing' put: 0;
		at: 'cellpadding' put: 0.
	self table: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'lr 8/3/2006 13:15'!
layoutTableOfWidth: width do: aBlock
	self attributes at: 'width' put: width.
	self layoutTable: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 2/9/2006 17:41'!
legend: aBlock
	self tag: 'legend' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
list: aCollection
	self list: aCollection do: [:x | self text: x]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/15/2004 16:24'!
list: aCollection do: aBlock
	self unorderedList:
		[aCollection do:
			[:item |
			self listItem: [aBlock value: item]]]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 11/24/2003 11:54'!
listItem: aBlock
	self tag: #li do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:51'!
openTag: aString
	self document openTag: aString attributes: self attributes.
	attributeBuffer := nil.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 7/26/2004 12:51'!
orderedList: aBlock
	self tag: 'ol' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 7/26/2004 12:52'!
orderedList: aCollection do: aBlock
	self orderedList:
		[aCollection do:
			[:item |
			self listItem: [aBlock value: item]]]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
paragraph
	self tag: 'p'! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
paragraph: aBlock
	self tag: 'p' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: 'mbany 4/14/2005 12:24'!
popupStringWithUrl: urlString name: nameString extent: aPoint toggles: aCollection
	^ String streamContents:
		[:stream |
		stream 
			nextPutAll: 'window.open(';
			nextPut: $';
			nextPutAll: urlString;
			nextPut: $';
			nextPut: $,;
			nextPut: $';
			nextPutAll: nameString;
			nextPut: $';
			nextPut:$,;
			nextPut: $';
			nextPutAll: 'width=';
			nextPutAll: aPoint x displayString;
			nextPutAll: ',height=';
			nextPutAll: aPoint y displayString;
			nextPut: $,;
			nextPutAll: (self toggleStringFor: aCollection);
			nextPut: $';
			nextPutAll: ')']! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/16/2003 00:24'!
preformatted: anObject
	self tag: 'pre' do: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'ac 5/16/2003 16:11'!
render: anObject
	anObject renderOn: self! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 7/2/2004 14:21'!
script: aString
	self tag: 'script' do: [self html: aString]! !

!WAAbstractHtmlBuilder methodsFor: 'head' stamp: 'lr 8/3/2006 13:16'!
scriptWithUrl: urlString
	self attributes
		at: 'type' put: 'text/javascript';
		at: 'src' put: urlString.
	self tag: 'script'! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 10/31/2006 16:11'!
space
	self html: self spaceEntity! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 2/19/2004 18:20'!
space: aNumber
	aNumber timesRepeat: [self space]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 11/4/2006 10:23'!
spaceEntity
	"To be subclassed as needed"
	^'&nbsp;'! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 5/30/2003 00:29'!
spacerRow
	self tableRowWith: [self space]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
span: aBlock
	self tag: 'span' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'mb 2/9/2006 14:23'!
spanClass: aString with: anObject
	self cssClass: aString; span: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:35'!
spanNamed: aString with: anObject
	self cssId: aString; span: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mb 2/9/2006 17:41'!
strong: aBlock
	self tag: 'strong' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ac 11/26/2004 16:55'!
style: aString
	self attributeAt: 'style' put: aString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
submitButton
	self inputWithType: 'submit'
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'lr 8/3/2006 13:16'!
submitButtonWithText: aString
	self attributes at: 'value' put: aString.
	self inputWithType: 'submit'
! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:04'!
table: aBlock
	self tag: 'table' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableData: aBlock
	self tag: 'td' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'avi 2/19/2004 18:11'!
tableData: aBlock span: aNumber
	aNumber > 0 ifTrue:
		[self attributes at: 'colspan' put: aNumber.
		self tableData: aBlock]
! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableHeading: aBlock
	self tag: 'th' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/16/2003 00:26'!
tableHeadings: aCollection
	self tableRow: [aCollection do: [:ea | self tableHeading: ea]]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRow: aBlock
	self tag: 'tr' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: aBlock
	self tableRow: [ self tableData: aBlock ]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'avi 2/19/2004 18:10'!
tableRowWith: aBlock span: aNumber
	self tableRow: [ self tableData: aBlock span: aNumber]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: aBlock with: anotherBlock
	self tableRow: [ self tableData: aBlock; tableData: anotherBlock]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: x with: y with: z
	self tableRow: [ self tableData: x; tableData: y; tableData: z]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'mb 2/9/2006 14:39'!
tableRowWithLabel: anObject column: aBlock
	self tableRow:
		[self 
			cssClass: 'label';
			tableData: anObject;
			tableData: aBlock]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'mb 2/9/2006 14:39'!
tableRowWithLabel: anObject column: aBlock column: anotherBlock
	self tableRow:
		[self 
			cssClass: 'label';
			tableData: anObject;
			tableData: aBlock; 
			tableData: anotherBlock]! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:40'!
tag: aString
	self openTag: aString.
	self closeTag: aString.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:40'!
tag: aString do: anObject
	self openTag: aString.
	self render: anObject.
	self closeTag: aString.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 4/24/2004 13:03'!
text: anObject
	self html: (self class encode: anObject)! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'mb 1/19/2006 18:02'!
textAreaNamed: name value: value
	name ifNotNil: [self attributes at: 'name' put: name].
	self attributes
		at: 'rows' ifAbsentPut: [3];
		at: 'cols' ifAbsentPut: [25].
	self tag: 'textarea' do: value.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'mb 2/9/2006 17:50'!
textWithCRs: anObject
	"Replace all CRs with breaks"
	| aStream |
	aStream := anObject displayString readStream.
	[aStream atEnd] whileFalse:
		[self text: (aStream upTo: Character cr).
		aStream atEnd ifFalse: [self break]].	! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'mb 3/16/2006 15:51'!
textWithLFs: anObject
	"Replace all LFs with breaks"
	| aStream |
	aStream := anObject displayString readStream.
	[aStream atEnd] whileFalse:
		[self text: (aStream upTo: Character lf).
		aStream atEnd ifFalse: [self break]].	
! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: 'pmm 11/2/2005 23:52'!
toggleStringFor: aCollection
	^ String streamContents:
		[:stream |
		aCollection 
			do: [:ea |
				stream
					nextPutAll: ea displayString;
					nextPutAll: '=yes']
			separatedBy: [stream nextPutAll: ',']]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
underline: aBlock
	self tag: 'u' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/15/2004 16:23'!
unorderedList: aBlock
	self tag: 'ul' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'mb 3/16/2006 15:50'!
withLineBreaks: aString
	| stream |
	stream := aString readStream.
	[stream atEnd] whileFalse:
		[self text: stream nextLine.
		stream atEnd ifFalse: [self break]]
! !

WAAbstractHtmlBuilder subclass: #WAHtmlBuilder
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Builder'!

!WAHtmlBuilder class methodsFor: 'instance creation' stamp: 'avi 2/18/2004 19:46'!
on: aDocument
	^ self new document: aDocument! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'avi 2/18/2004 19:46'!
document
	^ document! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'avi 2/18/2004 19:46'!
document: aDocument
	document := aDocument! !

WAAbstractHtmlBuilder subclass: #WAHtmlRenderer
	instanceVariableNames: 'context callbacks shortcutBuffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Builder'!

!WAHtmlRenderer commentStamp: '<historical>' prior: 0!
I am passed to the method #renderContentOn: of components unless #rendererClass has been redefined. On top of the basic XHTML construction methods inherited from WAAbstractHtmlBuilder, I provide an interface to attach event handlers to anchors and to form-elements.

To render any kind of squeak object call the message #render: It will do a double dispatch and call #renderOn: on this object.  For example:

	html render: 'Some text'.
	html render: 123.					" will print the child "
	html render: nil. 					" will do nothing "
	html render: #( 'a' 'b' 'c' ).			" will print every element "	
	html render: businessObject.			" will print the #displayString of your object "
	html render: childComponent.		" will render the child component "
	
This kind of double dispatch can be used with any xhtml-generating method:

	html divNamed: 'child' with: childComponent.
	html bold: #( 1 'First' ).!

!WAHtmlRenderer class methodsFor: 'instance creation' stamp: 'avi 3/22/2004 12:20'!
context: aRenderingContext callbacks: aCallbackStore
	^ self basicNew initializeWithContext: aRenderingContext callbacks: aCallbackStore! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/8/2006 12:09'!
addShortcut: aString
	| id |
	id := self ensureId.
	shortcutBuffer isNil ifTrue:
		[shortcutBuffer := Dictionary new].
	shortcutBuffer at: aString put: id.! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 14:24'!
anchorOn: aSymbol of: anObject
	self
		ensureCssId: aSymbol;
		anchorWithAction: (MessageSend receiver: anObject selector: aSymbol)
		text: (self labelForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'pmm 6/7/2005 15:34'!
anchorWithAction: actionBlock do: linkBlock	
	self openAnchorWithAction: actionBlock.
	self render: linkBlock.
	self closeTag: 'a'.

! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ac 3/23/2006 18:15'!
anchorWithAction: aBlock fileName: fileName text: doBlock
	self 
		anchorWithUrl: 
			(self actionUrl,  '/', fileName, '?',
				(self callbacks registerActionCallback: aBlock))
		do: doBlock! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 4/8/2003 14:26'!
anchorWithAction: actionBlock form: aForm
	self anchorWithAction: actionBlock do: [self imageWithForm: aForm.]
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 2/7/2004 02:09'!
anchorWithAction: actionBlock image: aForm
	self anchorWithAction: actionBlock do: [self imageWithForm: aForm.]
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 1/23/2004 01:31'!
anchorWithAction: actionBlock text: aString
	self anchorWithAction: actionBlock do: aString! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/9/2006 11:11'!
anchorWithAction: actionBlock text: aString submitFormNamed: formName
	| key |
	key := self context nextKey.
	#submitFormTriggeringCallback.
	self attributes at: 'onClick'
			put: 'submitFormTriggeringCallback('
				, formName asString printString 
				, ', ' 
				, key displayString printString 
				, ' , "href" ); return false;'.
	self anchorWithAction: actionBlock text: aString
	
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'lr 6/8/2005 09:44'!
anchorWithCallback: actionBlock do: linkBlock
	self anchorWithUrl: (self urlForIdempotentAction: actionBlock) do: linkBlock! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/20/2003 18:43'!
anchorWithDocument: anObject mimeType: mimeType fileName: fileName text: aString
	self openAnchorWithDocument: anObject mimeType: mimeType fileName: fileName.
	self text: aString.
	self closeTag: 'a'.! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/3/2003 12:25'!
anchorWithDocument: anObject mimeType: mimeType text: aString
	self anchorWithDocument: anObject mimeType: mimeType fileName: nil text: aString! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 1/11/2003 13:28'!
anchorWithDocument: anObject text: aString
	self anchorWithDocument: anObject mimeType: nil text: aString! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'ac 12/10/2004 17:15'!
anchorWithPopupAction: aBlock extent: aPoint do: anObject
	self
		anchorWithPopupUrl: (self urlForAction: aBlock)
		extent: aPoint
		do: anObject! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'ac 12/10/2004 17:20'!
anchorWithPopupAction: aBlock extent: aPoint text: aString
	self
		anchorWithPopupAction: aBlock 
		extent: aPoint 
		do: aString! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'ac 12/10/2004 17:17'!
anchorWithPopupAction: aBlock name: nameString extent: aPoint toggles: aCollection do: anObject
	self
		anchorWithPopupUrl: (self urlForAction: aBlock)
		name: nameString 
		extent: aPoint
		toggles: aCollection
		do: anObject! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'avi 6/8/2004 00:40'!
anchorWithScript: aString do: linkBlock
	self attributes at: 'onClick' put: aString.
	self anchorWithUrl: '#' do: linkBlock! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/8/2006 14:19'!
autofocus: aBlock
	| elementId |
	elementId := self ensureId.
	aBlock value.
	#setFocus.
	self script: 'setFocus(', elementId asString printString, ')'! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/8/2006 14:19'!
autofocus: aBlock withCursorAt: cursorPosition
	| elementId aStream |
	cursorPosition isNil ifTrue: [^self autofocus: aBlock].
	elementId := self ensureId.
	aBlock value.
	aStream := (String new: 30) writeStream.
	#setCursor.
	aStream
		nextPutAll: 'setCursor(';
		nextPutAll: elementId asString printString.
	cursorPosition isNumber ifTrue:
		[aStream nextPutAll: ',' , cursorPosition asString].
	"Cursor will go at end of field value, if position is not a number"
	aStream nextPut: $).
	self script: aStream contents
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 14:24'!
booleanMenuOn: aSymbol of: anObject
	self
		ensureCssId: aSymbol;
		booleanMenuWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 2/12/2003 17:21'!
booleanMenuWithValue: aBoolean callback: callbackBlock
	self booleanMenuWithValue: aBoolean callback: callbackBlock labels: #(Yes No)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 5/6/2003 18:37'!
booleanMenuWithValue: aBoolean callback: callbackBlock labels: labelArray
	self
		selectFromList: (Array with: true with: false)
		selected: aBoolean
		callback: callbackBlock
		labels: [:b | b ifTrue: [labelArray first] ifFalse: [labelArray second]]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
callbackForSelector: aSymbol of: anObject
	^ MessageSend receiver: anObject selector: (aSymbol copyWith: $:) asSymbol! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 3/22/2004 12:29'!
callbacks
	^ callbacks! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 6/7/2004 22:50'!
cancelButtonWithAction: aBlock
	self attributes value: 'Cancel'.
	self inputWithType: 'submit' named: (self callbacks registerCancelActionCallback: aBlock)
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 14:24'!
checkboxOn: aSymbol of: anObject
	self
		ensureCssId: aSymbol;
		checkboxWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 3/8/2006 17:07'!
checkboxWithValue: aBoolean callback: callbackBlock
   | value originalAttributes originalShortcuts |
   value := ValueHolder new.
   originalAttributes := attributeBuffer.
   attributeBuffer := nil.
   originalShortcuts := shortcutBuffer.
   shortcutBuffer := nil.
   self
       hiddenInputWithCallback: [:v |  value contents: false].
   attributeBuffer := originalAttributes.
   shortcutBuffer := originalShortcuts.
   self attributeAt: 'checked' put: aBoolean.
   self
       valueInputOfType: 'checkbox'
       value: 'true'
       callback: [:v |  value contents: true].
   callbackBlock fixTemps.
   self
       hiddenInputWithCallback: [:v |  callbackBlock value: value contents]
! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/9/2006 11:10'!
checkboxWithValue: aBoolean callback: callbackBlock submitFormNamed: formName 
	#submitForm.
	self attributes at: 'onClick'
			put: 'submitForm('
				, formName asString printString 
				, '); return false;'.
	self checkboxWithValue: aBoolean callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 7/5/2004 11:57'!
close! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/8/2006 12:16'!
closeTag: aString
	super closeTag: aString.
	self installShortcuts.! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:47'!
context
	^ context! !

!WAHtmlRenderer methodsFor: 'compound' stamp: 'avi 9/19/2006 14:30'!
dateInputWithValue: aDate callback: aBlock
	| values |
	aBlock fixCallbackTemps.
	
	values := Array new: 3.
	self
		selectFromList: (1 to: 12)
		selected: aDate monthIndex 
		callback: [ :month | values at: 2 put: month ]
		labels: [:ea | Date nameOfMonth: ea].
	self space.
	self
		textInputWithValue: aDate dayOfMonth 
		callback: [ :day | values at: 1 put: day ]
		maxLength: 2.
	self space.
	self 
		textInputWithValue: aDate year
		callback: [ :year | values at: 3 put: year]
		maxLength: 4.
	self hiddenInputWithCallback:
		[aBlock value: (Date
				newDay: (values first min: (Date daysInMonth: values second forYear: values third))
				monthNumber: values second
				year: values third)].
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 3/31/2006 12:26'!
defaultAction: actionBlock

	self
		style: 'position: absolute; top: -100em';
		submitButtonWithAction: actionBlock text: 'Default'.
	self
		style: 'position: absolute; top: -100em';
		textInputWithCallback: [:v | ].
! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/31/2006 11:39'!
divWithShow: showLink hide: hideLink do: aBlock
	| linkId divId onClick |
	divId := self ensureId.
	linkId := self nextId.
	#swapDisplay.
	onClick := 'swapDisplay(', linkId printString, ', ', divId asString printString, '); return false;'.
	self attributes id: linkId; style: 'display: block'.
	self anchorWithScript: onClick do: showLink.
	self attributes id: divId; style: 'display: none'.
	self div: [
		self anchorWithScript: onClick do: hideLink.
		self div: aBlock.
	]! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:46'!
document
	^ context document! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/31/2006 11:40'!
ensureId
	^ (self attributes at: 'id' ifAbsentPut: [self nextId]) value! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 9/19/2006 14:30'!
fileUploadWithCallback: aBlock
	aBlock fixCallbackTemps.
	self
		inputWithType: 'file'
		named: (self callbacks registerCallback: [:f | aBlock value: (f = '' ifFalse: [f])])
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 6/3/2004 19:23'!
form: aBlock
	self
		formWithMethod: 'post'
		action: context actionUrl urlString
		do: [
			self div: [
				context actionUrl parameters keysAndValuesDo:
				[:k :v |
				self inputWithType: 'hidden' named: k value: v].
			aBlock value
		]]! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 11/27/2005 18:55'!
formWithDefaultAction: defaultBlock do: aBlock
	self form:
		[self defaultAction: defaultBlock.
		aBlock value]
! !

!WAHtmlRenderer methodsFor: 'private' stamp: 'mb 3/23/2006 07:31'!
fromStringConverterBlockFor: anObject callback: aBlock
	^ [:v | 
	aBlock value: 
		( [anObject convertSeasideString: v] on: Error do: [:e | v] )
	]
! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/31/2006 11:41'!
getId
	"Compatibility"
	^ self nextId.! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 12/5/2003 00:51'!
hiddenInputWithCallback: callbackBlock
	self inputWithType: 'hidden' named: (self callbacks registerCallback: callbackBlock)
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
hiddenInputWithValue: anObject callback: callbackBlock
	self valueInputOfType: 'hidden'
		value: anObject
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'mb 9/14/2006 11:45'!
imageMapWithAction: aBlock form: aForm
	| point pointKey url id |
	aBlock fixTemps.
	point := ValueHolder new.
	pointKey := self callbacks registerCallback:
					[:ptString |
					point contents: (self parseImageMap: ptString)].
	url := self urlForAction: [aBlock value: point contents].
	self
		attributeAt: 'href'
		put: url, '&', pointKey, '='.
	id := self attributes at: 'id' ifAbsent: [nil].
	self tag: 'a' do: [
		id notNil ifTrue: [self cssId: id value , '-image'].
		self attributeAt: 'ismap' put: true.
		self imageWithForm: aForm.
	]! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'mb 2/17/2005 17:57'!
imageWithDocument: anObject mimeType: mimeType fileName: fileName
	self image: (self context urlForDocument: anObject mimeType: mimeType fileName: fileName).! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'mb 6/12/2006 14:24'!
imageWithFileNamed: fileName
	self imageWithFileNamed: fileName mimeType: nil! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'mb 6/12/2006 14:27'!
imageWithFileNamed: fileName mimeType: mimeType

	| document |
	document := WACachedDocument fileName: fileName.
	mimeType notNil ifTrue: [document mimeType: mimeType].
	self imageWithDocument: document mimeType: document mimeType fileName: fileName.
! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'mb 6/12/2006 10:25'!
imageWithForm: aForm
	self image: (self context urlForDocument: aForm mimeType: aForm mimeType) width: aForm width height: aForm height! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 3/22/2004 12:20'!
initializeWithContext: aRenderingContext callbacks: aCallbackStore
	context := aRenderingContext.
	callbacks := aCallbackStore.! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/8/2006 14:19'!
installShortcuts
	| aStream |
	shortcutBuffer notNil ifTrue:
		[aStream := (String new: 30) writeStream.
		shortcutBuffer associations do:
			[:each |
			aStream
				nextPutAll: 'addShortcut(';
				nextPutAll: each key printString;
				nextPut: $,;
				nextPutAll: each value asString printString;
				nextPut: $)]
		separatedBy:
			[aStream nextPutAll: '; '].
		shortcutBuffer := nil.
		#addShortcut.
		self script: aStream contents].
		! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 3/28/2007 13:13'!
isMultiple
	| value |
	^ (value := self attributeAt: 'multiple') notNil and: [value ~~ false]! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 3/31/2006 11:40'!
label: aString input: aBlock
	| id |
	id := self nextId.
	self labelFor: id do:
		[self text: aString.
		self space.
		self cssId: id.
		aBlock value]! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 3/31/2006 11:40'!
labelAfter: aString input: aBlock 
	| id |
	id := self nextId.
	self labelFor: id do: 
		[self cssId: id.
		aBlock value.
		self space.
		self text: aString]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 18:29'!
labelForSelector: aSymbol

	^ self labelForSelector: aSymbol of: nil! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/17/2005 10:42'!
labelForSelector: aSymbol of: anObject

	^ anObject labelForSelector: aSymbol! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 18:37'!
labelledRowForCheckboxOn: aSymbol of: anObject
	self tableRowWithLabel: (self labelForSelector: aSymbol of: anObject)
		on: aSymbol
		column: [self checkboxOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 18:40'!
labelledRowForList: aCollection on: aSymbol of: anObject
	self labelledRowForList: aCollection on: aSymbol of: anObject size: nil! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 5/6/2006 10:13'!
labelledRowForList: aCollection on: aSymbol of: anObject size: sizeIntegerOrNil
	self tableRowWithLabel: (self labelForSelector: aSymbol of: anObject)
		on: aSymbol
		column: 
			[sizeIntegerOrNil ifNotNil: [self attributeAt: #size put: sizeIntegerOrNil].
			self cssId: aSymbol.
			self
				selectFromList: aCollection
				selected: (anObject perform: aSymbol)
				callback: (self callbackForSelector: aSymbol of: anObject)]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 18:40'!
labelledRowForTextAreaOn: aSymbol of: anObject
	self tableRowWithLabel: (self labelForSelector: aSymbol of: anObject)
		on: aSymbol
		column: [self textAreaOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'JF 6/2/2003 13:31'!
labelledRowForTextInputOn: aSymbol of: anObject
	self labelledRowForTextInputOn: aSymbol of: anObject size: nil! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 18:32'!
labelledRowForTextInputOn: aSymbol of: anObject size: sizeIntegerOrNil
	self tableRowWithLabel: (self labelForSelector: aSymbol of: anObject)
		on: aSymbol
		column: 
			[sizeIntegerOrNil ifNotNil: [self attributeAt: #size put: sizeIntegerOrNil].
			self textInputOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/31/2006 11:40'!
nextId
	^ 'id', self context advanceKey
	! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 3/21/2004 00:03'!
openAnchorWithAction: actionBlock
	self
		attributeAt: 'href'
		put: (self urlForAction: actionBlock).
	self openTag: 'a'.! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 5/22/2004 18:03'!
openAnchorWithDocument: anObject mimeType: mimeType fileName: fileName
	self attributeAt: 'href' put: (self context urlForDocument: anObject mimeType: mimeType fileName: fileName).
	self openTag: #a.! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 3/28/2007 13:09'!
openSelect
	| name |
	name := self isMultiple
		ifTrue: [self callbacks registerMultiDispatchCallback]
		ifFalse: [self callbacks registerDispatchCallback].
	self attributes at: 'name' put: name.
	self openTag: 'select'.	! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 1/15/2005 00:50'!
optionGroupWithLabel: aString do: aBlock
	self attributes at: 'label' put: aString.
	self tag: 'optgroup' do: aBlock! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 1/15/2005 00:49'!
optionWithLabel: aString callback: aBlock
	self optionWithLabel: aString selected: false callback: aBlock! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
optionWithLabel: labelString selected: aBoolean callback: callbackBlock
	self 
		attributeAt: 'selected' put: aBoolean;
		attributeAt: 'value' put: (self callbacks registerCallback: callbackBlock).
	
	self tag: 'option' do: labelString.! !

!WAHtmlRenderer methodsFor: 'canvas compatibility' stamp: 'avi 3/18/2005 21:56'!
painter: aComponent
! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 7/11/2003 00:09'!
parseImageMap: aString
	|s x y|
	('?*,*' match: aString) ifFalse: [^ nil].
	s := aString readStream.
	s upTo: $?.
	x := s upTo: $,.
	y := s upToEnd.
	^ x asNumber @ y asNumber
	! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 9/2/2004 13:18'!
passwordInputWithCallback: callbackBlock
	self passwordInputWithValue: '' callback: callbackBlock! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 9/30/2004 21:50'!
passwordInputWithValue: anObject callback: callbackBlock
	self
		valueInputOfType: 'password'
		value: anObject
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/31/2006 11:41'!
peekNextId
	^ 'id', self context nextKey
	! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:49'!
radioButtonInGroup: radioGroupKey selected: aBoolean callback: callbackBlock
	self attributeAt: 'checked' put: aBoolean.
	
	self inputWithType: 'radio' named: radioGroupKey value: (self callbacks registerCallback: callbackBlock)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 3/22/2004 18:45'!
radioButtonInGroup: radioGroupKey withValue: value on: aSelector of: anObject
	self
		radioButtonInGroup: radioGroupKey
		selected: (value = (anObject perform: aSelector))
		callback: [anObject perform: aSelector asMutator with: value]! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
radioGroup
	^ self callbacks registerDispatchCallback.! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 4/13/2004 19:48'!
registry
	^ WACurrentSession value application ! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:43'!
request
	^ self context request! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:01'!
response
	^ self context response! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'mbany 4/14/2005 12:30'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock
	self selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: [:i | i displayString]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'mb 3/29/2007 13:17'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: labelsBlock 
	| isMultiple selected id |
	isMultiple := self isMultiple.
	selected := ValueHolder new contents: OrderedCollection new.
	isMultiple
		ifTrue: [id := self attributeAt: 'id'.
			id notNil
				ifTrue: [self attributeAt: 'id' put: id , '-hidden'].
			self attributeAt: 'multiple' put: false.
			self hiddenInputWithCallback: [selected contents: OrderedCollection new] fixCallbackTemps.
			self attributeAt: 'id' put: id.
			self attributeAt: 'multiple' put: true].
	self openSelect.
	callbackBlock fixCallbackTemps.
	aCollection
		do: [:item | 
			| isSelected | 
			isSelected := isMultiple
						ifTrue: [selectedObject includes: item]
						ifFalse: [item = selectedObject].
			self
				optionWithLabel: (labelsBlock value: item)
				selected: isSelected
				callback: [isMultiple
						ifTrue: [selected contents add: item]
						ifFalse: [callbackBlock value: item]] fixCallbackTemps].
	self closeTag: 'select'.
	isMultiple
		ifTrue: [self hiddenInputWithCallback: [callbackBlock value: selected contents asArray] fixCallbackTemps]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 3/13/2004 14:58'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: labelsBlock nilLabel: aString
	self selectFromList: (Array with: nil), aCollection asArray
		selected: selectedObject
		callback: callbackBlock
		labels: [:ea | ea ifNil: [aString] ifNotNil: [labelsBlock value: ea]]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 6/25/2003 23:03'!
selectInputOn: selectedSymbol of: anObject list: aCollection
	self
		selectFromList: aCollection
		selected: (anObject perform: selectedSymbol)
		callback: (self callbackForSelector: selectedSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mb 3/31/2006 11:40'!
spanWithShow: showLink hide: hideLink do: aBlock
	| linkId divId onClick |
	divId := self ensureId.
	linkId := self nextId.
	#swapDisplay.
	onClick := 'swapDisplay(', linkId printString, ', ', divId asString printString, '); return false;'.
	self attributes id: linkId; style: 'display: block'.
	self anchorWithScript: onClick do: showLink.
	self attributes id: divId; style: 'display: none'.
	self span: [
		self anchorWithScript: onClick do: hideLink.
		self span: aBlock.
	]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 14:24'!
submitButtonOn: aSymbol of: anObject
	self
		ensureCssId: aSymbol;
		submitButtonWithAction: (MessageSend receiver: anObject selector: aSymbol)
		text: (self labelForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
submitButtonWithAction: actionBlock
	self inputWithType: 'submit'
		named: (self callbacks registerActionCallback: actionBlock)
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 2/7/2004 02:07'!
submitButtonWithAction: actionBlock do: aBlock
	self buttonWithType: 'submit'
		named: (self callbacks registerActionCallback: actionBlock)
		value: nil
		do: aBlock
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 9/21/2006 16:05'!
submitButtonWithAction: actionBlock image: aForm
	self attributes
		at: 'src' put: (self context urlForDocument: aForm);
		width: aForm width;
		height: aForm height.
	self inputWithType: 'image'
		named: (self callbacks registerImageCallback: actionBlock)
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
submitButtonWithAction: aBlock text: aString
	self attributeAt: 'value' put: aString.
	self submitButtonWithAction: aBlock! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/10/2006 12:20'!
tableRowWithLabel: anObject on: aSymbol column: aBlock
	self tableRowWithLabel: [self labelFor: aSymbol do: anObject] column: aBlock
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 14:25'!
textAreaOn: aSymbol of: anObject
	self
		ensureCssId: aSymbol;
		textAreaWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 1/19/2006 18:07'!
textAreaWithCallback: callbackBlock
	self textAreaWithValue: nil callback: callbackBlock! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 1/19/2006 18:10'!
textAreaWithValue: anObject callback: callbackBlock
	| callback updateKey |
	callback := self fromStringConverterBlockFor: anObject callback: callbackBlock.
	updateKey := self callbacks registerCallback: callback.
	self
		textAreaNamed: updateKey
		value: anObject asSeasideString.
	^updateKey! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/9/2006 14:25'!
textInputOn: aSymbol of: anObject
	self
		ensureCssId: aSymbol;
		textInputWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 6/24/2003 16:15'!
textInputWithCallback: callbackBlock
	self textInputWithValue: '' callback: callbackBlock! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
textInputWithValue: anObject callback: callbackBlock
	self
		valueInputOfType: 'text'
		value: anObject
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 9/19/2006 14:30'!
textInputWithValue: aString callback: aBlock helpText: helpString
	aBlock fixCallbackTemps.
	aString ifNil:
		[self attributeAt: 'onfocus' put: 'if(''',helpString, ''' == this.value) {this.value=''''}; style.color=''black'''.
		self attributeAt: 'style' put: 'color: #aaa'].
	self textInputWithValue: (aString ifNil: [helpString]) callback: [:v | aBlock value: (v = helpString ifFalse: [v])]	! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 3/13/2004 14:17'!
textInputWithValue: anObject callback: callbackBlock maxLength: aNumber
	self attributes
		at: 'size' put: aNumber;
		at: 'maxlength' put: aNumber.
	self textInputWithValue: anObject callback: callbackBlock.! !

!WAHtmlRenderer methodsFor: 'compound' stamp: 'avi 9/19/2006 14:29'!
timeInputWithValue: aTime callback: aBlock
	| values |
	aBlock fixCallbackTemps.
	values := Array new: 2.
	self
		textInputWithValue: aTime hour
		callback: [:hour | values at: 1 put: hour]
		maxLength: 2.
	self space; text: ':'; space.
	self
		textInputWithValue: aTime minutes asTwoCharacterString
		callback: [:minute | values at: 2 put: minute asNumber]
		maxLength: 2.
	self hiddenInputWithCallback:
		[aBlock value:
			(Time
				hour: values first
				minute: (values second min: 59)
				second: 0)]
		
	
	! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'mbany 4/14/2005 12:31'!
unorderedList: aCollection selected: anObject callback: aBlock
	self unorderedList: aCollection selected: anObject  callback: aBlock labels: [:ea | ea displayString]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'mb 11/16/2006 18:58'!
unorderedList: aCollection selected: anObject callback: aBlock labels: labelBlock
	aBlock fixTemps.
	self ensureCssClass: 'options'.
	self unorderedList: [
		aCollection do:
			[:ea |
			self cssClass: (ea = anObject
					ifTrue: ['option option-selected']
					ifFalse: ['option']).
			self listItem: [self anchorWithAction: [aBlock value: ea] text: (labelBlock value: ea)]].
	]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 5/21/2004 18:10'!
unorderedListOn: aSymbol of: anObject list: aCollection
	self
		unorderedList: aCollection
		selected: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/7/2005 13:12'!
urlForAction: actionBlock
	| url |
	url := context actionUrl withParameter: (self callbacks registerActionCallback: actionBlock).
	^ url displayString! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'lr 6/8/2005 16:50'!
urlForAction: actionBlock andPath: aString
	| url |
	url := context actionUrl withParameter:  (self callbacks 
		registerActionCallback: actionBlock).
	url addToPath: aString.
	^ url displayString! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 5/22/2004 18:05'!
urlForDocument: anObject
	^ self context urlForDocument: anObject! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'lr 8/3/2006 13:22'!
urlForIdempotentAction: actionBlock
	| url |
	url := (context actionUrl
		withParameter:  (self callbacks registerActionCallback: actionBlock))
		withParameter: '_n'.
	^ url displayString! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mb 11/27/2005 18:59'!
valueInputOfType: typeString value: anObject callback: callbackBlock 
	| updateKey callback |
	callback := self fromStringConverterBlockFor: anObject callback: callbackBlock.
	updateKey := self callbacks registerCallback: callback.
	self
		inputWithType: typeString
		named: updateKey
		value: anObject asSeasideString.
	^ updateKey
! !

Object subclass: #WABrush
	instanceVariableNames: 'parent canvas isClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WABrush commentStamp: '<historical>' prior: 0!
I represent a brush to be used on a *WACanvas*.

Instance Variables
	canvas:		The canvas instance I am used with.
	parent:		The parent brush I am used within.
	closed:		Wether I have been closed/flushed yet.!

!WABrush class methodsFor: 'instance creation' stamp: 'mb 1/12/2006 18:53'!
new
	^self basicNew initialize! !

!WABrush methodsFor: 'private' stamp: 'mb 4/23/2007 14:20'!
close
	"Close and flush the receiver onto the canvas and its associated document."


	self isClosed ifFalse: [self with: []]! !

!WABrush methodsFor: 'initialize-release' stamp: 'pmm 1/26/2007 22:05'!
initialize
	isClosed := false! !

!WABrush methodsFor: 'testing' stamp: 'pmm 1/26/2007 22:05'!
isClosed
	^ isClosed! !

!WABrush methodsFor: 'private' stamp: 'lr 9/14/2005 22:33'!
labelForSelector: aSymbol of: anObject
	^ anObject labelForSelector: aSymbol.! !

!WABrush methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:27'!
parent
	^ parent! !

!WABrush methodsFor: 'convenience' stamp: 'mb 3/23/2006 16:19'!
session
	^ WACurrentSession value! !

!WABrush methodsFor: 'initialize-release' stamp: 'avi 6/13/2004 00:27'!
setParent: aBrush canvas: aCanvas
	parent := aBrush.
	canvas := aCanvas! !

!WABrush methodsFor: 'public api' stamp: 'avi 6/17/2004 12:17'!
with: aBlock
	canvas nest: aBlock.
	isClosed := true.! !

WABrush subclass: #WATagBrush
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WATagBrush commentStamp: '<historical>' prior: 0!
This is the superclass for all XML element classes. Its main addtions are
- element name (#tag)
- attributes (instance of WAHtmlAttributes)
- common events (onXXX), this is a hack and would better be solved with traits!

WATagBrush subclass: #WAAnchorTag
	instanceVariableNames: 'url isNavigation callbackKey extraParameters extraPath promptString fragment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAAnchorTag commentStamp: 'dc 7/11/2006 07:16' prior: 0!
I'm the class responsible for adding anchors (links) to your webpage. There are multiple ways of using me.


In the following case, the method #doSomethingOnClick will be sent to self when the user click on the anchor 'Click here to do something':

html anchor
  callback: [self doSomethingOnClick];
  text: 'Click here to do something'.


In fact, you are not obliged to render simple text for your anchors, a block can be executed instead:

html anchor
  callback: [self doSomethingIfUserClickMe];
  with: [put here some code to render things for the anchor text].


Following code is a shortcut to create an anchor:

html anchor
  on: #aSelector of: anObject

The text will be 'a Selector' (this is a special transformation of symbols to make them more readable)
The action will be the call of #aSelector on anObject.!

!WAAnchorTag methodsFor: 'private' stamp: 'lr 11/16/2006 11:18'!
actionUrl
	| actionUrl |
	^ callbackKey ifNotNil:
		[actionUrl := canvas context actionUrl withParameter: callbackKey.
		self isNavigation ifTrue: [actionUrl := actionUrl withParameter: '_n'].
		extraParameters ifNotNil:
			[extraParameters associationsDo: [:assoc | actionUrl addParameter: assoc key value: assoc value]]. 
		actionUrl fragment: fragment.
		extraPath
			ifNil: [actionUrl queryString]
			ifNotNil: [actionUrl addToPath: extraPath; asString]]! !

!WAAnchorTag methodsFor: 'callbacks' stamp: 'avi 11/27/2005 16:26'!
callback: aBlock
	callbackKey := canvas callbacks registerActionCallback: aBlock! !

!WAAnchorTag methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:18'!
canHaveShortcut
	^true! !

!WAAnchorTag methodsFor: 'public api' stamp: 'mb 9/8/2006 10:36'!
document: aDocument
	self document: aDocument mimeType: nil! !

!WAAnchorTag methodsFor: 'public api' stamp: 'mb 9/8/2006 10:35'!
document: aDocument mimeType: mimeType
	self document: aDocument mimeType: mimeType fileName: nil! !

!WAAnchorTag methodsFor: 'public api' stamp: 'mb 9/8/2006 10:34'!
document: aDocument mimeType: mimeType fileName: fileName
	self url: (canvas context urlForDocument: aDocument mimeType: mimeType fileName: fileName)
! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 11/27/2005 16:36'!
extraParameters: aCollection
	extraParameters := aCollection! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 2/1/2006 13:08'!
extraPath: aString
	extraPath := aString! !

!WAAnchorTag methodsFor: 'accessing' stamp: 'cb 9/6/2006 13:22'!
fragment

	^fragment ! !

!WAAnchorTag methodsFor: 'accessing' stamp: 'cb 9/6/2006 13:23'!
fragment: aString

	fragment := aString! !

!WAAnchorTag methodsFor: 'private' stamp: 'pmm 9/12/2006 18:08'!
handlerForForm: formName
	^ promptString
		ifNil:
				['submitFormTriggeringCallback('
				, formName asString printString
				, ', '
				, callbackKey displayString printString
				, ', "href" ); return false;']
		ifNotNil: 
				['if(x = prompt('
				, promptString printString
				, ')) submitFormTriggeringCallback('
				, formName asString printString
				, ', '
				, callbackKey displayString printString
				, ', x); return false;']
! !

!WAAnchorTag methodsFor: 'initialize-release' stamp: 'pmm 9/12/2006 18:08'!
initialize
	super initialize.
	isNavigation := false! !

!WAAnchorTag methodsFor: 'testing' stamp: 'avi 11/27/2005 21:05'!
isNavigation
	^ isNavigation ifNil: [false]! !

!WAAnchorTag methodsFor: 'public api' stamp: 'lr 11/30/2006 08:11'!
mailto: aString
	self url: 'mailto:' , aString; with: aString! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'avi 9/24/2005 20:50'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 11/27/2005 16:30'!
navigation
	isNavigation := true! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:00'!
newTarget
	self deprecatedApi.
	self target: '_new'! !

!WAAnchorTag methodsFor: 'public api' stamp: 'lr 9/14/2005 23:51'!
on: aSymbol of: anObject
	self callback: [ anObject perform: aSymbol ].
	self with: (self labelForSelector: aSymbol of: anObject).! !

!WAAnchorTag methodsFor: 'events' stamp: 'lr 11/16/2006 15:30'!
onClick: aString
	super onClick: aString.
	self attributes at: 'href' ifAbsentPut: [ 'javascript:void(0)' ]
! !

!WAAnchorTag methodsFor: 'events' stamp: 'lr 11/16/2006 15:30'!
onMouseOut: aString
	super onMouseOut: aString.
	self attributes at: 'href' ifAbsentPut: [ 'javascript:void(0)' ]! !

!WAAnchorTag methodsFor: 'events' stamp: 'lr 3/13/2006 19:52'!
onMouseOver: aString 
	super onMouseOver: aString.
	self attributes at: 'href' ifAbsentPut: [ 'javascript:void(0)' ]! !

!WAAnchorTag methodsFor: 'callbacks' stamp: 'pmm 1/26/2007 23:19'!
prompt: aString callback: aBlock
	callbackKey := canvas callbacks registerCallback: aBlock.
	promptString := aString! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'pmm 12/20/2006 12:09'!
rel: aString
	self deprecatedApi.
	self relationship: aString! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'pmm 12/20/2006 12:09'!
relationship: aString 
	self attributeAt: 'rel' put: aString! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 9/11/2005 14:40'!
resourceUrl: aString
	self url: (canvas document root absoluteUrlForResource: aString)! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'avi 6/22/2005 14:46'!
submitFormNamed: aString
	self onClick: (self handlerForForm: aString)! !

!WAAnchorTag methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:56'!
tag
	^ 'a'! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:29'!
target: aString
	self deprecatedApi.
	self attributeAt: 'target' put: aString! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:29'!
text: aString
	self deprecatedApi.
	self with: aString! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 10/12/2006 11:51'!
toggleStringFor: aCollection
	self deprecatedApi.
	^ String streamContents:
		[:stream |
		aCollection 
			do: [:ea |
				stream
					nextPutAll: ea displayString;
					nextPutAll: '=yes']
			separatedBy: [stream nextPutAll: ',']]! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 11/27/2005 16:26'!
url: aString
	url := aString! !

!WAAnchorTag methodsFor: 'public api' stamp: 'ac 2/5/2006 11:27'!
with: aBlock
	| newUrl |
	newUrl := url ifNil: [self actionUrl].
	newUrl ifNotNil: [self attributes at: 'href' put: newUrl].
	^ super with: aBlock! !

WAAnchorTag subclass: #WAImageMapTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAImageMapTag commentStamp: '<historical>' prior: 0!
A WAImageMapTag is supposed to be used like this:

	html map
		id: #pictureMap;
		title: 'Click here';
		callback: [ :point | self click: point + self offset];
		with: [
			html image
				form: self form ]
			
Examples can be found in WAScreenshot
!

!WAImageMapTag methodsFor: 'private' stamp: 'pmm 2/9/2007 20:08'!
callback: aBlock
	| pointKey  value tempCallbackKey tempUrl |
	aBlock fixCallbackTemps.
	value := ValueHolder new.
	pointKey := canvas callbacks registerCallback: [ :pointString |
	 	value contents: (self parseImageMap: pointString) ].
	tempCallbackKey := canvas callbacks registerActionCallback: [ aBlock value: value contents ].
	tempUrl := canvas context actionUrl withParameter: tempCallbackKey.
	self url: tempUrl queryString, '&', pointKey, '='.

! !

!WAImageMapTag methodsFor: 'private' stamp: 'pmm 9/20/2006 18:06'!
parseImageMap: aString
	| stream x y |
	('?*,*' match: aString) ifFalse: [^ nil].
	stream := aString readStream.
	stream upTo: $?.
	x := stream upTo: $,.
	y := stream upToEnd.
	^ x asNumber @ y asNumber! !

WAAnchorTag subclass: #WAPopupAnchorTag
	instanceVariableNames: 'name extent dependent showToolbar resizable showScrollbars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'ac 7/8/2005 19:15'!
beDependent
	dependent := true! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'ac 9/11/2005 13:08'!
beResizable
	resizable := true! !

!WAPopupAnchorTag methodsFor: 'accessing' stamp: 'ac 7/3/2005 16:08'!
extent: aPoint
	extent := aPoint! !

!WAPopupAnchorTag methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 15:28'!
initialize
	super initialize.
	dependent := false.! !

!WAPopupAnchorTag methodsFor: 'testing' stamp: 'ac 7/8/2005 19:15'!
isDependent
	^ dependent ifNil: [false]! !

!WAPopupAnchorTag methodsFor: 'testing' stamp: 'ac 9/11/2005 13:07'!
isResizable
	^ resizable ifNil: [resizable := false]! !

!WAPopupAnchorTag methodsFor: 'accessing' stamp: 'ac 7/3/2005 16:07'!
name: aString
	name := aString! !

!WAPopupAnchorTag methodsFor: 'private' stamp: 'avi 2/2/2006 02:21'!
popupString
	^ String streamContents:
		[:stream |
		stream 
			nextPutAll: 'window.open(';
			nextPut: $';
			nextPutAll: (url ifNil: [self actionUrl]);
			nextPut: $';
			nextPut: $,;
			nextPut: $';
			nextPutAll: name;
			nextPut: $';
			nextPut:$,;
			nextPut: $';
			nextPutAll: 'width=';
			nextPutAll: extent x displayString;
			nextPutAll: ',height=';
			nextPutAll: extent y displayString;
			nextPut: $,;
			nextPutAll: self toggleString;
			nextPut: $';
			nextPutAll: ').focus()']! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'avi 3/23/2006 22:56'!
shouldShowScrollbars
	^ showScrollbars ifNil: [showScrollbars := false]! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'ac 9/11/2005 13:05'!
shouldShowToolbar
	^ showToolbar ifNil: [showToolbar := false]! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'avi 3/23/2006 22:55'!
showScrollbars
	showScrollbars := true! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'ac 9/11/2005 13:04'!
showToolbar
	showToolbar := true! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'avi 3/23/2006 22:55'!
toggleArray
	^ Array streamContents:
		[:stream |
		self isDependent ifTrue: [stream nextPut: #dependent].
		self shouldShowToolbar ifTrue: [stream nextPut: #toolbar].
		self isResizable ifTrue: [stream nextPut: #resizable].
		self shouldShowScrollbars ifTrue: [stream nextPut: #scrollbars]]! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'pmm 11/2/2005 23:53'!
toggleString
	^ String streamContents:
		[:stream | 
		self toggleArray 
			do: [:ea |
				stream
					nextPutAll: ea;
					nextPutAll: '=yes'] 
			separatedBy: [stream nextPutAll: ',']]! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'ac 2/7/2006 10:50'!
with: aBlock
	self onClick: self popupString.
	self ignoreURL.
	^ super with: aBlock.! !

WATagBrush subclass: #WACanvasTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACanvasTag methodsFor: 'attributes' stamp: 'lr 5/18/2006 08:52'!
extent: aPoint
	self width: aPoint x; height: aPoint y! !

!WACanvasTag methodsFor: 'attributes' stamp: 'lr 5/18/2006 08:51'!
height: aNumber
	self attributeAt: 'height' put: aNumber displayString! !

!WACanvasTag methodsFor: 'accessing' stamp: 'lr 5/18/2006 08:50'!
tag
	^ 'canvas'! !

!WACanvasTag methodsFor: 'attributes' stamp: 'lr 5/18/2006 08:51'!
width: aNumber
	self attributeAt: 'width' put: aNumber displayString! !

WACanvasTag subclass: #WAImageTag
	instanceVariableNames: 'url fileName mimeType document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAImageTag methodsFor: 'attributes' stamp: 'avi 5/10/2005 14:33'!
altText: aString
	self attributes at: 'alt' put: aString
! !

!WAImageTag methodsFor: 'deprecated' stamp: 'lr 10/12/2006 14:25'!
border: aNumber
	self deprecatedApi.
	self attributes border: aNumber! !

!WAImageTag methodsFor: 'private' stamp: 'pmm 9/12/2006 18:04'!
close
	url isNil ifTrue: [
		self generateUrlForDocument ].
	self attributes at: 'src' put: url.
	super close.! !

!WAImageTag methodsFor: 'accessing' stamp: 'mb 6/12/2006 08:44'!
document: anObject
	document := anObject! !

!WAImageTag methodsFor: 'accessing' stamp: 'mb 6/12/2006 08:47'!
fileName: aString
	fileName := aString! !

!WAImageTag methodsFor: 'public api' stamp: 'mb 6/12/2006 08:50'!
form: aForm
	self extent: aForm extent.
	self document: aForm.! !

!WAImageTag methodsFor: 'private' stamp: 'pmm 9/12/2006 18:06'!
generateCachedDocumentFromFilename
	document := WACachedDocument fileName: fileName.
	mimeType isNil ifFalse: [
		document mimeType: mimeType ]! !

!WAImageTag methodsFor: 'private' stamp: 'pmm 9/12/2006 18:07'!
generateUrlForDocument
	document isNil ifTrue: [
		self generateCachedDocumentFromFilename ].
	mimeType isNil ifTrue: [
		mimeType := document mimeType ].
	url := canvas context
		urlForDocument: document
		mimeType: mimeType
		fileName: fileName! !

!WAImageTag methodsFor: 'initialize-release' stamp: 'mb 8/10/2006 08:01'!
initialize
	super initialize.
	self altText: ''.! !

!WAImageTag methodsFor: 'accessing' stamp: 'mb 6/12/2006 08:47'!
mimeType: aString
	mimeType := aString! !

!WAImageTag methodsFor: 'deprecated' stamp: 'lr 10/12/2006 14:25'!
noBorder
	self deprecatedApi.
	self border: 0! !

!WAImageTag methodsFor: 'public api' stamp: 'avi 9/11/2005 14:40'!
resourceUrl: aString
	self url: (canvas document root absoluteUrlForResource: aString)! !

!WAImageTag methodsFor: 'initialize-release' stamp: 'pmm 2/9/2007 20:10'!
setParent: aBrush canvas: aCanvas
	super setParent: aBrush canvas: aCanvas.
	(aBrush isKindOf: WAImageMapTag) ifTrue: [
		self attributeAt: 'ismap' put: true ]! !

!WAImageTag methodsFor: 'deprecated' stamp: 'lr 10/12/2006 14:25'!
src: aString
	self deprecatedApi.
	self url: aString
! !

!WAImageTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 12:00'!
tag
	^ 'img'! !

!WAImageTag methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:01'!
url: aString
	url := aString
! !

WATagBrush subclass: #WACollectionTag
	instanceVariableNames: 'list selected callbackBlock labelsBlock multiple'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACollectionTag commentStamp: '<historical>' prior: 0!
This element allows the use to select one (in single selection mode) or multiple (in single selection mode) elements. Multiple selection can be triggered with #beMultiple, single selection can be triggered with #beSingle .Default is single selection.

The general idea is that you pass the colletion of options to #list: and use #labels: to customize their rendering. The selected option(s) can be set with: #selected:.


This whole class is kind of an akward hack, but noone needs MI anyway. You can always get a way with composition and delegation!

!WACollectionTag methodsFor: 'adding' stamp: 'lr 9/25/2005 11:31'!
add: anObject
	^ list add: anObject.! !

!WACollectionTag methodsFor: 'adding' stamp: 'lr 9/25/2005 11:32'!
addAll: aCollection
	^ list addAll: aCollection.! !

!WACollectionTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 13:44'!
beMultiple
	multiple := true.! !

!WACollectionTag methodsFor: 'attributes' stamp: 'mb 4/23/2006 15:10'!
beSingle
	multiple := false.! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'avi 9/19/2006 14:31'!
callback: aBlock
	callbackBlock := aBlock fixCallbackTemps.! !

!WACollectionTag methodsFor: 'testing' stamp: 'mb 11/3/2006 14:08'!
hasCallback
	^callbackBlock notNil! !

!WACollectionTag methodsFor: 'initialization' stamp: 'mb 4/23/2006 15:10'!
initialize
	super initialize.
	list := OrderedCollection new.
	labelsBlock := [ :value | value ].
	multiple := false.
! !

!WACollectionTag methodsFor: 'testing' stamp: 'pmm 11/2/2005 22:11'!
isMultiple
	^ multiple.! !

!WACollectionTag methodsFor: 'testing' stamp: 'lr 9/26/2005 14:48'!
isSelected: anObject
	^ self isMultiple
		ifTrue: [ selected includes: anObject ]
		ifFalse: [ selected = anObject ].! !

!WACollectionTag methodsFor: 'private' stamp: 'lr 9/25/2005 11:40'!
labelForOption: anObject
	^ labelsBlock value: anObject.! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'mb 4/24/2007 17:35'!
labels: aBlock
	"Allows to customize the rendering of options by passing a block that converts each option to a string.
	aOneArgumentBlock should do no html rendering at all.
	If you need to do custom html rendering for the options use #with:"


	labelsBlock := aBlock fixCallbackTemps.! !

!WACollectionTag methodsFor: 'accessing' stamp: 'mb 4/24/2007 17:35'!
list: aCollection
	"the list of options to render, their rendering can be customized with #labels:"


	self addAll: aCollection.! !

!WACollectionTag methodsFor: 'attributes' stamp: 'pmm 7/19/2006 20:10'!
on: selector of: anObject
	"copy pasted from WASelectTag, we need a traitified version of seaside"
	self selected: (anObject perform: selector).
	self callback: [ :value | anObject perform: selector asMutator with: value ].! !

!WACollectionTag methodsFor: 'accessing' stamp: 'mb 4/24/2007 17:35'!
selected: anObject
	"sets the selected option
	one object in the case of single selection
	a collection of objects in the case of multiple selection"


	selected := anObject! !

WACollectionTag subclass: #WAListTag
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAListTag methodsFor: 'actions' stamp: 'lr 9/25/2005 11:37'!
beOrdered
	tag := 'ol'.! !

!WAListTag methodsFor: 'actions' stamp: 'lr 9/25/2005 11:37'!
beUnordered
	tag := 'ul'.! !

!WAListTag methodsFor: 'private' stamp: 'lr 9/26/2005 15:18'!
callbackForOption: anObject
	self isMultiple 
		ifTrue: [ 
			selected := (self isSelected: anObject)
				ifTrue: [ selected copyWithout: anObject ]
				ifFalse: [ selected copyWith: anObject ].
			callbackBlock value: selected ]
		ifFalse: [ callbackBlock value: anObject ].! !

!WAListTag methodsFor: 'accessing' stamp: 'lr 9/25/2005 11:37'!
tag
	^ tag ifNil: [ 'ul' ].! !

!WAListTag methodsFor: 'public' stamp: 'lr 11/16/2006 08:10'!
with: aBlock
	| brush |
	super with: [
		list do: [ :each |
			brush := canvas listItem class: 'option'.
			(self isSelected: each)
				ifTrue: [ brush class: 'option-selected' ].
			brush with: [
				self hasCallback
					ifFalse: [ canvas render: (self labelForOption: each) ]
					ifTrue: [
						canvas anchor
							callback: [ self callbackForOption: each ];
							with: (self labelForOption: each) ] ] ].
		aBlock value ]! !

WACollectionTag subclass: #WASelectTag
	instanceVariableNames: 'otherLabel otherCallbackBlock isOptional promptString isSubmitOnChange optionalLabel enablementBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WASelectTag commentStamp: '<historical>' prior: 0!
This element allows the use to select one (in single selection mode) or multiple (in single selection mode) elements. Default is single selection. Multiple selection can be triggered with #beMultiple.

Single selection is in general a drop-down list, so make sure the list of options is not too big.
Multiple selection has in general crappy browser support and a list of checkboxes is in general the better option.

If in single selection mode and you want enable "no selection" see #beOptional.

If you absolutely need to you can render the options yourself with 'html option' inside #with:

Make sure to check the superclass for more methods.

See WAInputTest >> #renderSingleSelectionOn: and WAInputTest >> #renderMultiSelectionOn: for examples.!

!WASelectTag methodsFor: 'attributes' stamp: 'mb 4/24/2007 17:38'!
beOptional
	"This adds a nil item to #list: which has the semantic of no selection. #optionalLabel: is the label for nil.
	This only really makes sense in single selection mode"


	isOptional := true! !

!WASelectTag methodsFor: 'attributes' stamp: 'mb 4/24/2007 17:35'!
beSubmitOnChange
	"submits the whole form in the user selects a value"


	isSubmitOnChange := true
! !

!WASelectTag methodsFor: 'public' stamp: 'mb 3/27/2007 09:21'!
enablementBlock: aBlock 
	enablementBlock := aBlock fixCallbackTemps! !

!WASelectTag methodsFor: 'testing' stamp: 'ac 4/13/2005 13:05'!
hasOther
	^ otherLabel notNil! !

!WASelectTag methodsFor: 'initialize-release' stamp: 'mb 3/28/2007 10:12'!
initialize
	super initialize.
	isOptional := false.
	isSubmitOnChange := false! !

!WASelectTag methodsFor: 'testing' stamp: 'mb 3/27/2007 09:24'!
isDisabled: option 
	^(self isEnabled: option) not! !

!WASelectTag methodsFor: 'testing' stamp: 'mb 3/27/2007 09:23'!
isEnabled: option 
	^ enablementBlock isNil
		or: [enablementBlock value: option]! !

!WASelectTag methodsFor: 'testing' stamp: 'pmm 11/2/2005 22:17'!
isOptional
	^ isOptional! !

!WASelectTag methodsFor: 'testing' stamp: 'pmm 11/2/2005 22:17'!
isSubmitOnChange
	^ isSubmitOnChange! !

!WASelectTag methodsFor: 'accessing' stamp: 'mb 4/7/2007 02:18'!
numberOfOptions
	| count |
	count := list size.
	self isOptional
		ifTrue: [count := count + 1].
	^ count! !

!WASelectTag methodsFor: 'attributes' stamp: 'mb 4/24/2007 17:35'!
optionalLabel: aString
	"the label for the nil element. See #beOptional"


	optionalLabel := aString! !

!WASelectTag methodsFor: 'private' stamp: 'mb 3/28/2007 09:50'!
optionsOn: html 
	| brush registeredSelection |
	self isOptional
		ifTrue: [brush := html option selected: selected isNil;  
						 yourself.
			self hasCallback
				ifTrue: [brush
						callback: [callbackBlock value: nil]].
			brush with: optionalLabel].
	registeredSelection := false.
	list
		do: [:each | 
			brush := html option.
			(self isDisabled: each)
				ifTrue: [brush disabled].
			((self isMultiple
						or: [registeredSelection not])
					and: [self isSelected: each])
				ifTrue: [brush selected: true.
					registeredSelection := true].
			self hasCallback
				ifTrue: [brush
						callback: [self isMultiple
								ifTrue: [selected add: each]
								ifFalse: [callbackBlock value: each]]].
			brush
				with: (self labelForOption: each)]! !

!WASelectTag methodsFor: 'attributes' stamp: 'mb 3/28/2007 10:11'!
otherLabel: labelString otherCallback: aBlock promptString: aString
	otherLabel := labelString.
	otherCallbackBlock := aBlock fixCallbackTemps.
	promptString := aString.! !

!WASelectTag methodsFor: 'attributes' stamp: 'mb 4/24/2007 17:35'!
size: anInteger
	"This attribute specifies the number of options in the list that should be visible at the same time."


	self attributes at: 'size' put: anInteger.! !

!WASelectTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 16:44'!
tag
	^ 'select'! !

!WASelectTag methodsFor: 'public' stamp: 'mb 11/3/2006 15:12'!
with: aBlock
	| hidden value other onChange |

	onChange := ''.
	self hasOther ifTrue: 
		[other := (canvas context nextKey asNumber + self numberOfOptions + 1) displayString.
		hidden := canvas context nextKey asString.
		value := ValueHolder new.
		canvas insert:
			[canvas hiddenInput id: hidden; value: nil; callback: [:n | value contents: n]; with: []].
		onChange := 'if(this.value == ' , other printString
			, ') {chooseOther(this, ' , hidden printString
			, ', ' , promptString printString , ')};'].

	self isSubmitOnChange ifTrue: [onChange := onChange, ' submit();'].
	onChange isEmpty ifFalse: [self onChange: onChange].

	self isMultiple ifTrue: [
		canvas insert:
			[canvas hiddenInput 
				callback: [ selected := OrderedCollection new ];
				with: [] ] ].
	self hasCallback ifTrue: [
		self attributes 
			at: 'name' put: (self isMultiple
				ifTrue: [ canvas callbacks registerMultiDispatchCallback ]
				ifFalse: [ canvas callbacks registerDispatchCallback ])].
	self attributes
		at: 'multiple' put: self isMultiple.
	super with: 
		[self optionsOn: canvas. 
		aBlock value.
		self hasOther ifTrue: 
			[canvas option 
				selected: false; 
				callback: [otherCallbackBlock value: value contents];
				with: otherLabel]].

	(self isMultiple and: [self hasCallback]) ifTrue: [
		canvas insert:
			[canvas hiddenInput 
				callback: [ callbackBlock value: selected ];
				with: [] ] ].! !

WATagBrush subclass: #WACompound
	instanceVariableNames: 'callbackBlock value properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACompound commentStamp: '<historical>' prior: 0!
This is the superclass for stuff that is not html elements but you still want to access via the canvas API.!

!WACompound methodsFor: 'callbacks' stamp: 'mb 11/3/2006 14:42'!
callback: aBlock
	callbackBlock := aBlock
! !

!WACompound methodsFor: 'testing' stamp: 'mb 11/3/2006 14:17'!
hasCallback
	^callbackBlock notNil! !

!WACompound methodsFor: 'initialization' stamp: 'pmm 1/30/2007 19:58'!
initialize
	super initialize.
	"do not remove properties, it is used by SeasideAsync"
	properties := Dictionary new.! !

!WACompound methodsFor: 'callbacks' stamp: 'pmm 7/19/2006 20:13'!
on: selector of: anObject
	"copy pasted for the third time, we really need a traitified version of seaside"
	self value: (anObject perform: selector).
	self callback: [ :date | anObject perform: selector asMutator with: date ].! !

!WACompound methodsFor: 'public api' stamp: 'mb 1/30/2006 18:40'!
value: aValue
	value := aValue! !

WACompound subclass: #WADateInput
	instanceVariableNames: 'options month day year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WADateInput commentStamp: '<historical>' prior: 0!
I am a composition of three input fields that allow the user to select year, month and day. #options: can be used to toggle them individually.
The argument for my callback blocks is an instance of Date.

See WADateTimeTest >> #renderDateTimeOn:!

!WADateInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 14:43'!
addCallback
	self hasCallback ifFalse: [^self].
	canvas forgetCurrentBrush.
	(canvas hiddenInput)
		callback:
			[callbackBlock value: self setValueWithNewDate];
		close.
! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:18'!
addDayCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #day of: self
! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:18'!
addMonthCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #month of: self

! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:19'!
addYearCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #year of: self! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:20'!
day
	^day! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:16'!
day: anIntegerOrString
	day := [anIntegerOrString asNumber] on: Error do: [:e | 1]
! !

!WADateInput methodsFor: 'accessing' stamp: 'mb 11/3/2006 09:57'!
defaultOptions
	^#(month day year)! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:20'!
month
	^month! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:16'!
month: anIntegerOrString
	month := [anIntegerOrString asNumber] on: Error do: [:e | 1]
! !

!WADateInput methodsFor: 'accessing' stamp: 'mb 11/3/2006 09:49'!
options
	^options ifNil: [ self defaultOptions ].! !

!WADateInput methodsFor: 'accessing' stamp: 'mb 11/3/2006 09:58'!
options: anArray
	"Valid values in the array : #year #month #day
	Can be used to control what is shown and in what order
	Default #(month day year)"
	options := anArray! !

!WADateInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 10:41'!
renderDay
	| brush |
	canvas forgetCurrentBrush.
	brush := (canvas textInput)
		id: (self id isNil ifTrue: [nil] ifFalse: [self id , '-day']);
		value: day;
		yourself.
	self addDayCallbackToBrush: brush.
	brush
		attributeAt: 'size' put: 2;
		attributeAt: 'maxlength' put: 2;
		attributeAt: 'max' put: 31;
		close.
! !

!WADateInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 14:16'!
renderMonth
	| brush |
	canvas forgetCurrentBrush.
	brush := (canvas select)
		id: self id;
		list: (1 to: 12);
		selected: month;
		yourself.
	self addMonthCallbackToBrush: brush.
	brush
		labels: [:ea | Date nameOfMonth: ea];
		close.
! !

!WADateInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 10:42'!
renderYear
	| brush |
	canvas forgetCurrentBrush.
	brush := (canvas textInput) 
		id: (self id isNil ifTrue: [nil] ifFalse: [self id , '-year']);
		value: year;
		yourself.
	self addYearCallbackToBrush: brush.
	brush
		attributeAt: 'size' put: 4;
		attributeAt: 'maxlength' put: 4;
		close.
! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/9/2006 07:37'!
setValueWithNewDate
	^value := Date
				newDay: ((day min: (Date daysInMonth: month forYear: year)) max: 1)
				monthNumber: month
				year: year.
! !

!WADateInput methodsFor: 'public api' stamp: 'mb 11/3/2006 10:16'!
with: aBlock
	value isNil ifTrue: [value := Date today].
	day := value dayOfMonth.
	month := value monthIndex.
	year := value year.
	self options do:
		[:each |
		self perform: ('render' , each asLowercase capitalized) asSymbol]
	separatedBy:
		[canvas space].
	self addCallback.
! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:20'!
year
	^year! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:16'!
year: anIntegerOrString
	year := [anIntegerOrString asNumber] on: Error do: [:e | 1900]
! !

WACompound subclass: #WATimeInput
	instanceVariableNames: 'withSeconds hours minutes seconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATimeInput commentStamp: '<historical>' prior: 0!
I am a composition of three input fields that allows the user to select hour, minute and optionally second.
#withSeconds and #withoutSeconds can be used to toggle seconds.

The argument for my callback blocks is an instance of Time.

See WADateTimeTest >> #renderDateTimeOn:!

!WATimeInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 14:44'!
addCallback
	self hasCallback ifFalse: [^self].
	canvas forgetCurrentBrush.
	(canvas hiddenInput)
		callback:
			[callbackBlock value: self setValueWithNewTime];
		close

! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:21'!
addHoursCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #hours of: self.

! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:22'!
addMinutesCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #minutes of: self.

! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:22'!
addSecondsCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #seconds of: self.

! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:21'!
hours
	^hours

! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:20'!
hours: anIntegerOrString
	hours := [anIntegerOrString asNumber] on: Error do: [:e | 0]

! !

!WATimeInput methodsFor: 'initialize-release' stamp: 'pmm 9/12/2006 19:18'!
initialize
	super initialize.
	self withoutSeconds! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:21'!
minutes
	^minutes! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:21'!
minutes: anIntegerOrString
	minutes := [anIntegerOrString asNumber] on: Error do: [:e | 0]

! !

!WATimeInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 10:44'!
renderHours
	| brush |
	canvas forgetCurrentBrush.
	brush := (canvas textInput)
		id: self id;
		value: hours asTwoCharacterString;
		yourself.
	self addHoursCallbackToBrush: brush.
	brush
		attributeAt: 'size' put: 2;
		attributeAt: 'maxlength' put: 2;
		close.
! !

!WATimeInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 10:45'!
renderMinutes
	| brush |
	canvas forgetCurrentBrush.
	brush := (canvas textInput)
		id: (self id isNil ifTrue: [nil] ifFalse: [self id , '-mins']);
		value: minutes asTwoCharacterString;
		yourself.
	self addMinutesCallbackToBrush: brush.
	brush
		attributeAt: 'size' put: 2;
		attributeAt: 'maxlength' put: 2;
		attributeAt: 'max' put: 59; 
		close.
! !

!WATimeInput methodsFor: 'private rendering' stamp: 'mb 11/3/2006 10:46'!
renderSeconds
	| brush |
	canvas forgetCurrentBrush.
	brush := (canvas textInput)
		id: (self id isNil ifTrue: [nil] ifFalse: [self id , '-secs']);
		value: seconds asTwoCharacterString;
		yourself.
	self addSecondsCallbackToBrush: brush.
	brush
		attributeAt: 'size' put: 2;
		attributeAt: 'maxlength' put: 2;
		attributeAt: 'max' put: 59; 
		close.
	! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:21'!
seconds
	^seconds! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:21'!
seconds: anIntegerOrString
	seconds := [anIntegerOrString asNumber] on: Error do: [:e | 0]

! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 11:11'!
setValueWithNewTime
	^value := Time
				hour: hours
				minute: (minutes min: 59)
				second: (seconds min: 59).
	! !

!WATimeInput methodsFor: 'public api' stamp: 'mb 11/3/2006 10:16'!
with: aBlock
	value isNil ifTrue: [value := Time now].
	hours := value hour.
	minutes := value minutes.
	seconds := value seconds.
	self renderHours.
	canvas space; text: ':'; space.
	self renderMinutes.
	withSeconds ifTrue:
		[canvas space; text: ':'; space.
		self renderSeconds]
	ifFalse:
		[seconds := 0].
	self addCallback.
! !

!WATimeInput methodsFor: 'accessing' stamp: 'mb 2/6/2006 09:55'!
withSeconds
	withSeconds := true! !

!WATimeInput methodsFor: 'accessing' stamp: 'mb 2/6/2006 09:56'!
withoutSeconds
	withSeconds := false! !

WATagBrush subclass: #WADivTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WADivTag methodsFor: 'public api' stamp: 'avi 6/3/2005 15:40'!
clear
	self class: 'clear'.
	self with: [canvas space]! !

!WADivTag methodsFor: 'accessing' stamp: 'avi 6/3/2005 15:39'!
tag
	^ 'div'! !

WATagBrush subclass: #WAFieldSetTag
	instanceVariableNames: 'legend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAFieldSetTag methodsFor: 'private' stamp: 'mb 3/8/2006 18:03'!
before
	legend ifNotNil: [canvas legend: legend]
! !

!WAFieldSetTag methodsFor: 'accessing' stamp: 'mb 3/8/2006 17:47'!
legend: aString
	legend := aString
	! !

!WAFieldSetTag methodsFor: 'accessing' stamp: 'mb 3/8/2006 17:44'!
tag
	^ 'fieldset'! !

WATagBrush subclass: #WAFormInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

WAFormInputTag subclass: #WAAbstractTextAreaTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAAbstractTextAreaTag commentStamp: '<historical>' prior: 0!
An abstract class to describe the HTML elements that allow the user to enter text.!

!WAAbstractTextAreaTag methodsFor: 'callbacks' stamp: 'lr 11/16/2006 15:27'!
callback: aBlock
	self name: (canvas callbacks registerCallback: aBlock).
	self value: self value asSeasideString! !

!WAAbstractTextAreaTag methodsFor: 'javascript' stamp: 'mb 10/10/2006 23:24'!
exampleText: aString
	(self value isNil or: [self value = aString]) ifTrue:
		[self
			onFocus: 'if(value == ', aString printString, '){value=''''; style.color=''black''}';
			style: 'color: #aaa';
			value: aString]! !

!WAAbstractTextAreaTag methodsFor: 'javascript' stamp: 'mb 3/27/2007 09:57'!
setCursorPosition: anInteger 
	self setSelectionFrom: anInteger to: anInteger! !

!WAAbstractTextAreaTag methodsFor: 'javascript' stamp: 'mb 3/27/2007 09:59'!
setSelectionFrom: start to: stop 
	"Insert the javascript for setting the selection"
	| aStream |
	self ensureId.
	aStream := (String new: 30) writeStream.
	#setCursor.
	aStream nextPutAll: 'setSelection(';
		 nextPutAll: self id printString.
	start isNumber
		ifTrue: [aStream nextPutAll: ',' , start asString]
		ifFalse: [aStream nextPutAll: ',1'].
	stop isNumber
		ifTrue: [aStream nextPutAll: ',' , stop asString].
	aStream nextPut: $).
	self session addLoadScript: aStream contents! !

WAAbstractTextAreaTag subclass: #WATextAreaTag
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATextAreaTag commentStamp: '<historical>' prior: 0!
I am a multi line text input widget. See WAInputTest >> #renderTextAreaWithExampleOn: for examples.!

!WATextAreaTag methodsFor: 'attributes' stamp: 'mb 4/24/2007 17:35'!
columns: anInteger
	"This attribute specifies the visible width in average character widths. User agents may wrap visible text lines to keep long lines visible without the need for scrolling."


	self attributeAt: 'cols' put: anInteger.! !

!WATextAreaTag methodsFor: 'attributes' stamp: 'mb 4/24/2007 17:35'!
rows: anInteger
	"This attribute specifies the number of visible text lines. If more are entered, the widget scrolls."


	self attributeAt: 'rows' put: anInteger.! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'ac 4/13/2005 01:51'!
tag
	^ 'textarea'! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:42'!
value
	^value! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'ac 8/30/2005 16:26'!
value: aString
	value := aString! !

!WATextAreaTag methodsFor: 'public api' stamp: 'ac 8/30/2005 16:29'!
with: aBlock
	^ value ifNotNil: [super with: value] ifNil: [super with: aBlock]! !

WAAbstractTextAreaTag subclass: #WATextInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATextInputTag commentStamp: '<historical>' prior: 0!
I am a single line text input widget. See WAInputTest >> #renderTextInputWithExampleOn: for examples.!

WATextInputTag subclass: #WAPasswordInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAPasswordInputTag commentStamp: '<historical>' prior: 0!
I am a password input widget that does not display the entered text.!

!WAPasswordInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:33'!
type
	^ 'password'! !

!WATextInputTag methodsFor: 'attributes' stamp: 'lr 10/10/2005 20:04'!
beRangeInput
	self type: 'range'.! !

!WATextInputTag methodsFor: 'attributes' stamp: 'lr 10/10/2005 20:04'!
beSearchInput
	self type: 'search'.! !

!WATextInputTag methodsFor: 'attributes' stamp: 'mb 4/24/2007 17:35'!
maxLength: aNumber
	"This attribute specifies the maximum number of characters the user may enter. This number may exceed the specified #size:, in which case the user agent should offer a scrolling mechanism. The default value for this attribute is an unlimited number."


	self attributeAt: 'maxlength' put: aNumber! !

!WATextInputTag methodsFor: 'attributes' stamp: 'mb 4/24/2007 17:35'!
size: aNumber
	"This attribute tells the user agent the initial width of the widget. The width is given in number of characters."


	self attributeAt: 'size' put: aNumber! !

!WATextInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:50'!
type
	^ 'text'! !

WAFormInputTag subclass: #WACheckboxTag
	instanceVariableNames: 'value callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACheckboxTag methodsFor: 'private' stamp: 'avi 4/28/2005 14:16'!
after
	canvas hiddenInput callback:
		[callback value: value.
		value := false]! !

!WACheckboxTag methodsFor: 'callbacks' stamp: 'avi 9/19/2006 14:31'!
callback: aBlock
	value := false.
	callback := aBlock fixCallbackTemps.
	super callback: [value := true]! !

!WACheckboxTag methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:20'!
canHaveShortcut
	^true! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'avi 9/19/2006 14:31'!
onTrue: trueBlock onFalse: falseBlock
	trueBlock fixCallbackTemps. falseBlock fixCallbackTemps.
	self callback: [ :v | v ifTrue: [ trueBlock value ] ifFalse: [ falseBlock value ] ].! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'pmm 7/19/2006 19:29'!
submitFormNamed: formName
	self onClick: 'submitForm('
				, formName asString printString 
				, '); return false;'.! !

!WACheckboxTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:44'!
type
	^ 'checkbox'! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 13:47'!
value: aBoolean
	self attributeAt: 'checked' put: aBoolean.! !

WAFormInputTag subclass: #WAFileUploadTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAFileUploadTag commentStamp: '<historical>' prior: 0!
I represent a file input element (<input type="file"). My callbacks will be evaluated with an instance of WAFile as an argument.!

!WAFileUploadTag methodsFor: 'callbacks' stamp: 'avi 9/19/2006 14:30'!
callback: aBlock
	aBlock fixCallbackTemps.
	super callback: [ :file | aBlock value: (file = '' ifFalse: [ file ]) ].! !

!WAFileUploadTag methodsFor: 'callbacks' stamp: 'lr 10/19/2005 00:13'!
on: selector of: anObject
	self callback: [ :value | anObject perform: selector asMutator with: value ].! !

!WAFileUploadTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:45'!
type
	^ 'file'! !

!WAFormInputTag methodsFor: 'callbacks' stamp: 'lr 1/4/2007 09:35'!
callback: aBlock
	self name: (canvas callbacks registerCallback: aBlock)! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
name: aString
	self attributes at: 'name' put: aString! !

!WAFormInputTag methodsFor: 'callbacks' stamp: 'lr 1/4/2007 09:35'!
on: selector of: anObject
	self value: (anObject perform: selector).
	self callback: [ :value | anObject perform: selector asMutator with: value ]! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'mb 4/24/2007 17:35'!
readonly: aBoolean
	"When set to true, this boolean attribute prohibits changes to the widget."


	self attributes at: 'readonly' put: aBoolean! !

!WAFormInputTag methodsFor: 'javascript' stamp: 'lr 1/4/2007 09:35'!
setFocus
	self ensureId.
	self session addLoadScript: 'setFocus(' , self id printString , ')'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
submitOnClick
	self onClick: 'submit()'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'mb 4/30/2007 09:24'!
tabindex: anInteger
	"deprecated, use #tabIndex:"
	self deprecatedApi.
	self attributes at: 'tabindex' put: anInteger! !

!WAFormInputTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 12:08'!
tag
	^ 'input'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:37'!
text: aString
	self value: aString! !

!WAFormInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:43'!
type
	^ nil! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
type: aString
	self attributes at: 'type' put: aString! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
value
	^ self attributes at: 'value'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
value: anObject
	anObject ifNotNil: [ self attributes at: 'value' put: anObject ]! !

!WAFormInputTag methodsFor: 'public' stamp: 'lr 11/16/2006 15:31'!
with: aBlock
	self type isNil ifFalse: [
		self attributes at: 'type' ifAbsentPut: [ self type ].
		self class: self type ].
	super with: aBlock! !

WAFormInputTag subclass: #WAHiddenInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAHiddenInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:45'!
type
	^ 'hidden'! !

WAFormInputTag subclass: #WARadioButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 10:39'!
beChecked
	self attributeAt: 'checked' put: true.! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 10:40'!
beUnchecked
	self attributeAt: 'checked' put: false.! !

!WARadioButtonTag methodsFor: 'callbacks' stamp: 'pmm 1/8/2007 12:14'!
callback: aBlock
	self value: (canvas callbacks registerCallback: aBlock)! !

!WARadioButtonTag methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:20'!
canHaveShortcut
	^true! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 11:32'!
group: aRadioGroup
	self name: aRadioGroup key.! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 11:01'!
selected: aBoolean
	self attributeAt: 'checked' put: aBoolean.! !

!WARadioButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:46'!
type
	^ 'radio'! !

WAFormInputTag subclass: #WASubmitButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

WASubmitButtonTag subclass: #WAButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:37'!
type
	^ 'button'! !

WASubmitButtonTag subclass: #WACancelButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACancelButtonTag methodsFor: 'callbacks' stamp: 'lr 1/4/2007 09:33'!
callback: aBlock
	self name: (canvas callbacks registerCancelActionCallback: aBlock)! !

WASubmitButtonTag subclass: #WAImageButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:33'!
callback: aBlock
	self name: (canvas callbacks registerImageCallback: aBlock)! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:33'!
extent: aPoint
	self width: aPoint x; height: aPoint y! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:33'!
form: aForm
	self extent: aForm extent.
	self url: (canvas context urlForDocument: aForm)! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:43'!
height: aNumber
	self attributes at: 'height' put: aNumber! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:33'!
resourceUrl: aString
	self url: (canvas document root absoluteUrlForResource: aString)! !

!WAImageButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:49'!
type
	^ 'image'! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:33'!
url: aString
	self attributes at: 'src' put: aString! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:43'!
width: aNumber
	self attributes at: 'width' put: aNumber! !

!WASubmitButtonTag methodsFor: 'callbacks' stamp: 'lr 1/4/2007 09:32'!
callback: aBlock
	self name: (canvas callbacks registerActionCallback: aBlock)! !

!WASubmitButtonTag methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:19'!
canHaveShortcut
	^true! !

!WASubmitButtonTag methodsFor: 'callbacks' stamp: 'lr 1/4/2007 09:32'!
on: aSymbol of: anObject
	self value: (self labelForSelector: aSymbol of: anObject).
	self callback: [ anObject perform: aSymbol ]! !

!WASubmitButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:49'!
type
	^ 'submit'! !

WATagBrush subclass: #WAFormTag
	instanceVariableNames: 'defaultAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAFormTag methodsFor: 'attributes' stamp: 'lr 7/9/2006 18:56'!
action: aString
	self attributeAt: 'action' put: aString! !

!WAFormTag methodsFor: 'private' stamp: 'lr 1/30/2007 11:33'!
after
	canvas div: [
		canvas context actionUrl parameters keysAndValuesDo: [ :k :v | 
			canvas hiddenInput 
				name: k; 
				value: v ] ]! !

!WAFormTag methodsFor: 'private' stamp: 'mb 3/28/2007 10:06'!
before
	defaultAction ifNil: [^nil].
	"XHTML validator requires a div in form"
	canvas div: [
		canvas submitButton
			callback: defaultAction;
			value: 'Default';
			style: 'position: absolute; top: -100em';
			with: nil.
		canvas textInput
			callback: [:v];
			style: 'position: absolute; top: -100em'].! !

!WAFormTag methodsFor: 'callbacks' stamp: 'mb 3/28/2007 10:07'!
defaultAction: aBlock
	defaultAction := aBlock.! !

!WAFormTag methodsFor: 'attributes' stamp: 'lr 7/9/2006 18:57'!
method: aString
	self attributeAt: 'method' put: aString! !

!WAFormTag methodsFor: 'attributes' stamp: 'avi 6/8/2005 21:46'!
multipart
	self attributeAt: 'enctype' put: 'multipart/form-data'! !

!WAFormTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 21:37'!
multipart: aBoolean
	aBoolean ifTrue: [ self multipart ].! !

!WAFormTag methodsFor: 'attributes' stamp: 'avi 6/9/2005 16:02'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAFormTag methodsFor: 'attributes' stamp: 'avi 3/21/2006 16:51'!
noAutocomplete
	self attributeAt: 'autocomplete' put: 'off'! !

!WAFormTag methodsFor: 'attributes' stamp: 'lr 7/9/2006 18:57'!
post
	self method: 'post'! !

!WAFormTag methodsFor: 'initialize-release' stamp: 'lr 7/9/2006 18:56'!
setParent: aBrush canvas: aCanvas
	super setParent: aBrush canvas: aCanvas.
	self post; action: ''! !

!WAFormTag methodsFor: 'private' stamp: 'avi 6/17/2004 11:29'!
tag
	^ 'form'! !

WATagBrush subclass: #WAGenericTag
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

WAGenericTag subclass: #WAEditTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAEditTag commentStamp: 'pmm 3/28/2007 10:40' prior: 0!
INS and DEL are used to markup sections of the document that have been inserted or deleted with respect to a different version of a document (e.g., in draft legislation where lawmakers need to view the changes).

These two elements are unusual for HTML in that they may serve as either block-level or inline elements (but not both). They may contain one or more words within a paragraph or contain one or more block-level elements such as paragraphs, lists and tables.

This example could be from a bill to change the legislation for how many deputies a County Sheriff can employ from 3 to 5.

<P>
  A Sheriff can employ <DEL>3</DEL><INS>5</INS> deputies.
</P>

The INS and DEL elements must not contain block-level content when these elements behave as inline elements.!

!WAEditTag methodsFor: 'attributes' stamp: 'pmm 3/28/2007 10:37'!
cite: aUrl
	"The value of this attribute is a URI that designates a source document or message. This attribute is intended to point to information explaining why a document was changed."
	self attributeAt: 'cite' put: aUrl! !

!WAEditTag methodsFor: 'attributes' stamp: 'pmm 3/28/2007 10:38'!
datetime: anObject
	"The value of this attribute specifies the date and time when the change was made.
	ISO date format"
	self attributeAt: 'datetime' put: anObject! !

!WAGenericTag class methodsFor: 'instance creation' stamp: 'pmm 1/26/2007 23:05'!
tag: aString
	^ self new initializeWithTag: aString! !

!WAGenericTag methodsFor: 'initialize-release' stamp: 'avi 6/13/2004 00:40'!
initializeWithTag: aString
	tag := aString! !

!WAGenericTag methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:40'!
tag
	^ tag! !

WATagBrush subclass: #WAHeadingTag
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAHeadingTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 14:12'!
level
	^ level ifNil: [1]! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level1
	level := 1.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level2
	level := 2.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level3
	level := 3.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level4
	level := 4.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'dc 8/16/2006 07:43'!
level5
	level := 5.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'dc 8/16/2006 07:43'!
level6
	level := 6.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 21:33'!
level: anInteger
	level := anInteger! !

!WAHeadingTag methodsFor: 'accessing' stamp: 'avi 5/10/2005 14:33'!
tag
	^ 'h', self level displayString ! !

WATagBrush subclass: #WAIframeTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAIframeTag methodsFor: 'conveniance' stamp: 'lr 12/6/2006 21:47'!
contents: anObject
	| key |
	key := canvas callbacks registerActionCallback: [ self performRendering: anObject ].
	self url: (canvas context actionUrl withParameter: key)! !

!WAIframeTag methodsFor: 'conveniance' stamp: 'lr 8/9/2006 08:34'!
document: anObject
	self document: anObject mimeType: nil! !

!WAIframeTag methodsFor: 'conveniance' stamp: 'lr 8/9/2006 08:31'!
document: anObject mimeType: aMimeString
	self document: anObject mimeType: aMimeString fileName: nil! !

!WAIframeTag methodsFor: 'conveniance' stamp: 'lr 12/6/2006 21:46'!
document: anObject mimeType: aMimeString fileName: aFileNameString
	self url: (canvas context
		urlForDocument: anObject 
		mimeType: aMimeString 
		fileName: aFileNameString)! !

!WAIframeTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:42'!
height: anInteger
	self attributes at: 'height' put: anInteger! !

!WAIframeTag methodsFor: 'attributes' stamp: 'lr 3/10/2006 12:18'!
name: aString
	self attributes at: 'name' put: aString! !

!WAIframeTag methodsFor: 'private' stamp: 'pmm 10/7/2006 18:45'!
performRendering: anObject
	| innerContext docRoot session document response renderer  |
	innerContext := canvas context copy.
	docRoot := WARenderedHtmlRoot context: innerContext.
	docRoot resourceBaseUrl: innerContext document root resourceBaseUrl.
	docRoot base target: '_top'.
	session := WACurrentSession value.
	document := session outputDocumentClass root: docRoot.
	response := WAResponse new.
	response headerAt: 'Cache-Control' put: 'No-cache'.
	document stream: response stream.
	canvas context document: document.
	renderer := canvas species context: canvas context callbacks: canvas callbacks.
	renderer render: anObject; flush. 
	document close.
	session returnResponse: response! !

!WAIframeTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:32'!
src: anUrl
	self deprecatedApi.
	self url: anUrl! !

!WAIframeTag methodsFor: 'accessing' stamp: 'lr 3/8/2006 23:25'!
tag
	^ 'iframe'! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 8/26/2006 00:06'!
url: aString
	self attributeAt: 'src' put: aString! !

!WAIframeTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:43'!
width: anInteger
	self attributes at: 'width' put: anInteger! !

WATagBrush subclass: #WALabelTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WALabelTag methodsFor: 'attributes' stamp: 'ac 7/9/2005 04:36'!
for: aString
	self attributeAt: 'for' put: aString.! !

!WALabelTag methodsFor: 'accessing' stamp: 'ac 7/9/2005 04:36'!
tag
	^ 'label'! !

WATagBrush subclass: #WAObjectTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:27'!
archive: aUrl
	self attributeAt: 'archive' put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:25'!
classId: aUrl
	self attributeAt: 'classid' put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:26'!
codebase: aUrl
	self attributeAt: 'codebase' put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:28'!
codetype: aString
	self attributeAt: 'codetype' put: aString! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:28'!
declare: aBoolean
	self attributeAt: 'declare' put: aBoolean! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:57'!
height: anInteger
	self attributeAt: 'height' put: anInteger! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:29'!
standby: aString
	self attributeAt: 'standby' put: aString! !

!WAObjectTag methodsFor: 'accessing' stamp: 'pmm 2/11/2007 19:24'!
tag
	^ 'object'! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:28'!
type: aString
	self attributeAt: 'type' put: aString! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:26'!
url: aUrl
	self attributeAt: 'data' put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:57'!
width: anInteger
	self attributeAt: 'width' put: anInteger! !

WATagBrush subclass: #WAOptionGroupTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAOptionGroupTag commentStamp: 'pmm 4/24/2007 10:53' prior: 0!
The OPTGROUP element allows authors to group choices logically. This is particularly helpful when the user must choose from a long list of options; groups of related choices are easier to grasp and remember than a single long list of options.

It has crappy browser support and noone as ever used it. See WAInputTest >> #renderOptionGroupOn: for examples.!

!WAOptionGroupTag methodsFor: 'attributes' stamp: 'pmm 4/24/2007 10:49'!
label: aString
	"This attribute specifies the label for the option group."
	self attributeAt: 'label' put: aString! !

!WAOptionGroupTag methodsFor: 'accessing' stamp: 'pmm 4/24/2007 10:49'!
tag
	^ 'optgroup'! !

WATagBrush subclass: #WAOptionTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAOptionTag methodsFor: 'attributes' stamp: 'pmm 1/8/2007 12:18'!
callback: aBlock
	"this is one of these methods that are copy-pasted all over the place
	but people don't need traits because traits do not solve real world problems"
	self attributeAt: 'value' put: (canvas callbacks registerCallback: aBlock).! !

!WAOptionTag methodsFor: 'attributes' stamp: 'pmm 4/24/2007 10:48'!
label: aString
	"This attribute allows authors to specify a shorter label for an option than the content of the OPTION element. When specified, user agents should use the value of this attribute rather than the content of the OPTION element as the option label."
	self attributeAt: 'label' put: aString! !

!WAOptionTag methodsFor: 'attributes' stamp: 'pmm 7/19/2006 20:06'!
on: selector of: anObject
	"copy pasted from WASelectTag, we need a traitified version of seaside"
	self selected: (anObject perform: selector).
	self callback: [ :value | anObject perform: selector asMutator with: value ].! !

!WAOptionTag methodsFor: 'attributes' stamp: 'ac 3/17/2005 17:13'!
selected: aBoolean
	self attributeAt: 'selected' put: aBoolean.! !

!WAOptionTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 17:13'!
tag
	^ 'option'! !

WATagBrush subclass: #WAParameterTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAParameterTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 20:04'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAParameterTag methodsFor: 'accessing' stamp: 'pmm 2/11/2007 20:12'!
tag
	^ 'param'! !

!WAParameterTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 20:06'!
type: aString
	self attributeAt: 'type' put: aString! !

!WAParameterTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 20:05'!
value: aString
	self attributeAt: 'value' put: aString! !

WATagBrush subclass: #WARubyTextTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WARubyTextTag methodsFor: 'attributes' stamp: 'pmm 9/18/2006 19:01'!
span: anInteger
	self attributeAt: 'rbspan' put: anInteger! !

!WARubyTextTag methodsFor: 'accessing' stamp: 'pmm 9/18/2006 19:00'!
tag
	^ 'rt'! !

WATagBrush subclass: #WAScriptTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAScriptTag methodsFor: 'private' stamp: 'lr 11/21/2006 20:36'!
after
	self document text: '/*]]>*/'! !

!WAScriptTag methodsFor: 'private' stamp: 'lr 11/21/2006 20:36'!
before
	self document text: '/*<!![CDATA[*/'! !

!WAScriptTag methodsFor: 'attributes' stamp: 'cwp 9/11/2006 17:25'!
resourceUrl: aString
	self url: (canvas document root absoluteUrlForResource: aString)! !

!WAScriptTag methodsFor: 'accessing' stamp: 'dwj 6/10/2005 13:10'!
tag
	^ 'script'! !

!WAScriptTag methodsFor: 'attributes' stamp: 'pmm 8/26/2006 00:05'!
url: aString
	self attributes at: 'src' put: aString! !

!WAScriptTag methodsFor: 'public' stamp: 'lr 11/21/2006 20:29'!
with: aString
	self attributes at: 'type' ifAbsentPut: [ 'text/javascript' ].
	super with: [ self document text: aString ]! !

WATagBrush subclass: #WATableCellTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:08'!
align: aString
	self attributes at: 'align' put: aString.! !

!WATableCellTag methodsFor: 'attributes' stamp: 'mb 12/8/2006 16:55'!
character: aStringOrCharacter
	self attributes at: 'char' put: aStringOrCharacter displayString.! !

!WATableCellTag methodsFor: 'attributes' stamp: 'mb 12/8/2006 16:55'!
characterOffset: anInteger
	self attributes at: 'charoff' put: anInteger.! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:08'!
colSpan: anInteger
	self attributes at: 'colspan' put: anInteger.! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:08'!
rowSpan: anInteger
	self attributes at: 'rowspan' put: anInteger.! !

!WATableCellTag methodsFor: 'attributes' stamp: 'mb 12/8/2006 15:05'!
scope: aString
	self attributes at: 'scope' put: aString.! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:09'!
verticalAlign: aString
	self attributes at: 'valign' put: aString.! !

WATableCellTag subclass: #WATableDataTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableDataTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 22:09'!
tag
	^ 'td'! !

WATableCellTag subclass: #WATableHeadingTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableHeadingTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 22:10'!
tag
	^ 'th'! !

WATagBrush subclass: #WATableColumnGroupTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'mb 12/7/2006 20:20'!
align: aString
	self attributes at: 'align' put: aString.! !

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'mb 12/7/2006 20:24'!
character: aStringOrCharacter
	self attributes at: 'char' put: aStringOrCharacter displayString.! !

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'mb 12/7/2006 20:24'!
characterOffset: anInteger
	self attributes at: 'charoff' put: anInteger.! !

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'mb 12/7/2006 20:23'!
span: anInteger
	self attributes at: 'span' put: anInteger.! !

!WATableColumnGroupTag methodsFor: 'accessing' stamp: 'mb 12/8/2006 15:51'!
tag
	^ 'colgroup'! !

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'mb 12/7/2006 20:21'!
verticalAlign: aString
	self attributes at: 'valign' put: aString.! !

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'mb 12/7/2006 20:22'!
width: aNumber
	self attributeAt: 'width' put: aNumber displayString! !

WATableColumnGroupTag subclass: #WATableColumnTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableColumnTag methodsFor: 'accessing' stamp: 'mb 12/8/2006 15:51'!
tag
	^ 'col'! !

WATagBrush subclass: #WATableTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableTag methodsFor: 'deprecated' stamp: 'pmm 12/20/2006 12:24'!
align: aString
	self deprecatedApi.
	self attributes at: 'align' put: aString.! !

!WATableTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:33'!
border: anInteger
	self deprecatedApi.
	self attributes at: 'border' put: anInteger! !

!WATableTag methodsFor: 'attributes' stamp: 'lr 12/30/2006 00:11'!
cellpadding: anInteger
	self attributes at: 'cellpadding' put: anInteger! !

!WATableTag methodsFor: 'attributes' stamp: 'lr 12/30/2006 00:11'!
cellspacing: anInteger
	self attributes at: 'cellspacing' put: anInteger! !

!WATableTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 18:07'!
layout
	self deprecatedApi.
	self border: 0.
	self cellspacing: 0.
	self cellpadding: 0! !

!WATableTag methodsFor: 'attributes' stamp: 'mb 12/8/2006 15:03'!
summary: aString
	self attributes at: 'summary' put: aString! !

!WATableTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 15:22'!
tag
	^ 'table'! !

!WATagBrush class methodsFor: 'code generation' stamp: 'pmm 9/12/2006 19:28'!
tag
	"WASelectTag tag"
	"WAGenericTag tag"
	^(self selectors includes: #tag)
		ifTrue: [ self new tag ]
		ifFalse: [ nil ]! !

!WATagBrush methodsFor: 'attributes' stamp: 'mb 4/23/2007 14:20'!
accessKey: aString
	"Set a keyboard shortcut to access an element."


	self attributeAt: 'accesskey' put: aString! !

!WATagBrush methodsFor: 'javascript' stamp: 'pmm 9/12/2006 19:12'!
addShortcut: aString
	self canHaveShortcut ifFalse: [
		self error: 'May not assign shortcut on items that are not clickable' ].
	
	self ensureId.
	self session addLoadScript: (String streamContents: [ :stream |
		stream
			nextPutAll: 'addShortcut(';
			nextPutAll: aString printString;
			nextPut: $,;
			nextPutAll: self id printString;
			nextPut: $) ])! !

!WATagBrush methodsFor: 'attributes' stamp: 'mb 3/8/2006 17:51'!
addStyle: aString
	self attributes addStyle: aString.! !

!WATagBrush methodsFor: 'private' stamp: 'mb 4/23/2007 14:20'!
after
	"This template method is called directly after rendering the content of the receiver."


! !

!WATagBrush methodsFor: 'attributes' stamp: 'mb 3/23/2006 17:08'!
attributeAt: key
	^(self attributes at: key ifAbsent: [key -> nil]) value.! !

!WATagBrush methodsFor: 'attributes' stamp: 'avi 6/17/2004 12:40'!
attributeAt: key put: value
	self attributes at: key put: value! !

!WATagBrush methodsFor: 'attributes' stamp: 'avi 6/13/2004 01:03'!
attributes
	^ attributes ifNil: [attributes := WAHtmlAttributes new]! !

!WATagBrush methodsFor: 'attributes' stamp: 'avi 6/17/2004 14:15'!
attributes: anHtmlAttributes
	attributes := anHtmlAttributes
! !

!WATagBrush methodsFor: 'private' stamp: 'mb 4/23/2007 14:20'!
before
	"This template method is called directly before rendering the content of the receiver."


! !

!WATagBrush methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:18'!
canHaveShortcut
	^false! !

!WATagBrush methodsFor: 'attributes' stamp: 'mb 4/23/2007 14:20'!
class: aString
	"This attribute assigns one or more class names to an element; the element may be said to belong to these classes. A class name may be shared by several element instances. Multiple classes might be added to one brush."


	self attributes addClass: aString! !

!WATagBrush methodsFor: 'attributes' stamp: 'lr 12/28/2006 22:44'!
class: aString if: aBoolean
	aBoolean ifTrue: [ self class: aString ]! !

!WATagBrush methodsFor: 'private' stamp: 'mb 4/23/2007 14:20'!
closeTag
	"Close the receiving tag onto the document."


	self document closeTag: self tag.
! !

!WATagBrush methodsFor: 'javascript' stamp: 'avi 3/9/2006 17:41'!
confirm: aString
	self onClick: 'return confirm("', aString, '")'! !

!WATagBrush methodsFor: 'events' stamp: 'mb 10/10/2006 22:49'!
disableEnter
	self onEnter: ''.! !

!WATagBrush methodsFor: 'attributes' stamp: 'ac 10/16/2005 19:55'!
disabled
	self disabled: true.! !

!WATagBrush methodsFor: 'attributes' stamp: 'ac 10/16/2005 19:55'!
disabled: aBoolean
	self attributes at: 'disabled' put: aBoolean.! !

!WATagBrush methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:39'!
document
	^ canvas document! !

!WATagBrush methodsFor: 'public' stamp: 'mb 4/23/2007 14:20'!
ensureId
	"Answer the id of the receiving attribute. In case the receiver doesn't have an id yet, generate a new one."



	"Makes sure this tag has an id attribute and returns it.
	If it doesn't already have one, one is generated."

	| id |
	^self id ifNil: [
		id := canvas nextId.
		self id: id.
		id ]
! !

!WATagBrush methodsFor: 'accessing' stamp: 'pmm 10/12/2006 23:11'!
id

	"Convert to a String in case it was supplied as a Symbol"

	| idValue |
	idValue := self attributeAt: 'id'.
	^idValue ifNotNil: [ idValue asString ]
! !

!WATagBrush methodsFor: 'attributes' stamp: 'mb 4/23/2007 14:20'!
id: aString
	"The id attribute assigns a identifier to an element. The id of an element must be unique within a document."


	self attributeAt: 'id' put: aString! !

!WATagBrush methodsFor: 'javascript' stamp: 'ac 10/5/2005 00:16'!
ignoreURL
	^ self onClick: 'return false'! !

!WATagBrush methodsFor: 'events' stamp: 'mb 4/23/2007 14:37'!
onBlur: aString 
	"The onblurs event occurs when the element that is in focus, loses that focus."


	self attributes
		at: 'onblur'
		append: aString
		separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'mb 4/23/2007 14:37'!
onChange: aString 
	"The onchange event occurs when a select input element has a selection made or when a text input element has a change in the text."


	self attributes
		at: 'onchange'
		append: aString
		separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onClick: aString
	"The onclick event occurs when the pointing device button is clicked over an element."

	self attributes at: 'onclick' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onDoubleClick: aString
	"The ondblclick event occurs when the pointing device button is double clicked over an element."

	self attributes at: 'ondblclick' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'mb 10/10/2006 22:48'!
onEnter: aString
	self onKeyPress: 'if((window.event ? window.event.keyCode : event.which) == 13){', aString displayString, '; return false}; return true'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onError: aString
	self attributes at: 'onerror' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onFocus: aString
	"The onfocus event occurs when an element receives focus either by the pointing device or by tabbing navigation."

	self attributes at: 'onfocus' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onKeyDown: aString
	"The onkeydown event occurs when a key is pressed down over an element."

	self attributes at: 'onkeydown' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onKeyPress: aString
	"The onkeypress event occurs when a key is pressed and released over an element."

	self attributes at: 'onkeypress' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onKeyUp: aString
	"The onkeyup event occurs when a key is released over an element."

	self attributes at: 'onkeyup' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'mb 6/21/2006 18:28'!
onLoad: aString
	"The onload event occurs when the user agent finishes loading a window."

	self attributes at: 'onload' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onMouseDown: aString
	"The onmousedown event occurs when the pointing device button is pressed over an element."

	self attributes at: 'onmousedown' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onMouseMove: aString
	"The onmousemove event occurs when the pointing device is moved while it is over an element."

	self attributes at: 'onmousemove' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onMouseOut: aString
	"The onmouseout event occurs when the pointing device is moved away from an element."

	self attributes at: 'onmouseout' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onMouseOver: aString
	"The onmouseover event occurs when the pointing device is moved onto an element."

	self attributes at: 'onmouseover' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onMouseUp: aString
	"The onmouseup event occurs when the pointing device button is released over an element."

	self attributes at: 'onmouseup' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onReset: aString
	"The onreset event occurs when a form is reset."

	self attributes at: 'onreset' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onResize: aString
	self attributes at: 'onresize' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onScroll: aString
	self attributes at: 'onscroll' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onSelect: aString
	"The onselect event occurs when a user selects some text in a text field."

	self attributes at: 'onselect' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onSubmit: aString
	"The onsubmit event occurs when a form is submitted."

	self attributes at: 'onsubmit' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onUnload: aString
	"The onunload event occurs when the user agent removes a document from a window."

	self attributes at: 'onunload' append: aString separator: ';'! !

!WATagBrush methodsFor: 'private' stamp: 'mb 4/23/2007 14:20'!
openTag
	"Open the receiving and all associated attributes onto the document."


	self document openTag: self tag attributes: attributes.! !

!WATagBrush methodsFor: 'public' stamp: 'avi 3/18/2005 22:10'!
section: aSymbol
	self class: (canvas painter classForSection: aSymbol).
	self with: [canvas painter perform: aSymbol with: canvas]! !

!WATagBrush methodsFor: 'attributes' stamp: 'mb 4/23/2007 14:20'!
style: aString
	"This attribute offers optional CSS style information. The attribute is deprecated and should be avoided in favor of an external stylesheet. Multiple styles might be added to one brush."


	self attributes addStyle: aString! !

!WATagBrush methodsFor: 'attributes' stamp: 'kph 5/23/2007 07:53'!
tabIndex: aNumberOrString 
	"Set the tab order of an element."
	self attributes at: 'tabindex' put: aNumberOrString asString
! !

!WATagBrush methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:30'!
tag
	self subclassResponsibility! !

!WATagBrush methodsFor: 'attributes' stamp: 'mb 4/23/2007 14:20'!
title: aString
	"This attribute offers advisory information about the element for which it is set."


	self attributeAt: 'title' put: aString! !

!WATagBrush methodsFor: 'public' stamp: 'mb 4/23/2007 14:20'!
with: aBlock
	"Render anObject into the receiver. Make sure that you call #with: last in the cascade, as this method will serialize the tag onto the output document."


	self openTag.
	super with: [self within: aBlock].
	self closeTag.
	parent := attributes := nil.	
! !

!WATagBrush methodsFor: 'convenience' stamp: 'avi 3/16/2006 12:20'!
withLineBreaks: aString
	self with: [canvas withLineBreaks: aString]! !

!WATagBrush methodsFor: 'private' stamp: 'ac 4/13/2005 00:44'!
within: aBlock
	self before.
	aBlock renderOn: canvas.
	self after.! !

Object subclass: #WACachedDocument
	instanceVariableNames: 'fullFileName mimeDocument mimeType'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WACachedDocument commentStamp: '<historical>' prior: 0!
This class is for serving smallish files like PNG images etc using WADocumentHandler. Using the Canvas API for HTML generation you simply do this:

	html image fileName: 'myimage.png'

or:

	html image fileName: 'myimage.blurp' mimeType: 'blurp'

This will create a request handler in your WAApplication registry that is accessible on a unique URL and does not expire.
The actual contents of the file will only be read upon first access, we could augment this class with smarter caching, like checking the modification time on disk.

The class has a Cache class var holding a Dictionary of created instances so you can clear and preload files into the image using:

	WACachedDocument
		clearCache;
		fileName: 'myimage.png';
		fileName: 'another.gif'; "etc"
		preloadCache!

!WACachedDocument class methodsFor: 'cache' stamp: 'gk 1/19/2006 08:15'!
clearCache
	"Clear the cache of instances. This will cause
	the files to be lazily reread from disk."

	Cache := Dictionary new! !

!WACachedDocument class methodsFor: 'instance-creation' stamp: 'gk 1/12/2006 14:17'!
fileName: aFileName
	"Check the cache to see if we already have this file loaded.
	We only rely on the local filename!!"

	^Cache at: aFileName ifAbsentPut: [self fullFileName: aFileName]! !

!WACachedDocument class methodsFor: 'instance-creation' stamp: 'gk 1/10/2006 13:22'!
fullFileName: fullFileName

	^self new fullFileName: fullFileName! !

!WACachedDocument class methodsFor: 'initialize-release' stamp: 'gk 1/12/2006 14:05'!
initialize
	self clearCache! !

!WACachedDocument class methodsFor: 'cache' stamp: 'gk 1/19/2006 08:14'!
preloadCache
	"Load the files into the image for the currently
	created instances in the Cache."

	Cache valuesDo: [:d | d asMIMEDocument ]! !

!WACachedDocument methodsFor: 'comparing' stamp: 'gk 1/10/2006 13:13'!
= other
	"Currently we do not take file modification time on disk into account."

	^other species = self species and: [other fullFileName = fullFileName]! !

!WACachedDocument methodsFor: 'public' stamp: 'mb 6/2/2006 10:49'!
asMIMEDocument
	^self asMIMEDocumentType: mimeType! !

!WACachedDocument methodsFor: 'public' stamp: 'mb 6/2/2006 10:49'!
asMIMEDocumentType: type
	"Lazy caching."
	^mimeDocument ifNil: [
		mimeType := type.
		mimeDocument := SeasidePlatformSupport
				mimeDocumentOfType: mimeType 
				from: fullFileName].
	! !

!WACachedDocument methodsFor: 'accessing' stamp: 'gk 1/10/2006 11:19'!
fullFileName
	^fullFileName! !

!WACachedDocument methodsFor: 'initialize-release' stamp: 'gk 1/10/2006 11:12'!
fullFileName: aFileName
	fullFileName := aFileName
	! !

!WACachedDocument methodsFor: 'comparing' stamp: 'gk 1/10/2006 13:14'!
hash
	"Currently we do not take file modification time on disk into account.
	Note that mimeType and mimeDocument are set lazily later, so we can't use
	the mimeType in the hash."

	^fullFileName hash! !

!WACachedDocument methodsFor: 'accessing' stamp: 'gk 1/10/2006 11:18'!
mimeType
	^mimeType! !

!WACachedDocument methodsFor: 'accessing' stamp: 'gk 1/10/2006 11:14'!
mimeType: anObject
	^mimeType := anObject! !

Object subclass: #WACallback
	instanceVariableNames: 'context owner key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

WACallback subclass: #WAActionCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAActionCallback methodsFor: 'accessing' stamp: 'avi 9/19/2006 14:31'!
block: aZeroArgBlock
	block := aZeroArgBlock fixCallbackTemps.! !

!WAActionCallback methodsFor: 'evaluation' stamp: 'avi 6/8/2004 01:51'!
evaluateWithArgument: anObject
	block value.
	self signalRenderNotification! !

!WAActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 8! !

!WAActionCallback methodsFor: 'evaluation' stamp: 'rjl 4/16/2006 15:56'!
signalRenderNotification 
	WARenderNotification raiseSignal! !

WAActionCallback subclass: #WACancelActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WACancelActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 3! !

WAActionCallback subclass: #WADefaultActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WADefaultActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 10! !

WAActionCallback subclass: #WAImageCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAImageCallback methodsFor: 'converting' stamp: 'avi 9/2/2004 14:46'!
convertKey: aString
	^ aString, '.x'! !

!WACallback methodsFor: 'comparing' stamp: 'avi 6/7/2004 22:38'!
<= other
	^ self priority < other priority or: [self priority = other priority and: [self key asNumber <= other key asNumber]]! !

!WACallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 21:48'!
context
	^ context! !

!WACallback methodsFor: 'converting' stamp: 'avi 9/2/2004 14:46'!
convertKey: aString
	^ aString! !

!WACallback methodsFor: 'evaluation' stamp: 'avi 6/7/2004 21:49'!
evaluateWithArgument: anObject
	self subclassResponsibility! !

!WACallback methodsFor: 'evaluation' stamp: 'avi 6/8/2004 01:52'!
evaluateWithField: anObject 
	self evaluateWithArgument: (self valueForField: anObject)! !

!WACallback methodsFor: 'accessing' stamp: 'avi 9/2/2004 14:46'!
key
	^ (self convertKey: key)! !

!WACallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 21:48'!
owner
	^ owner! !

!WACallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:17'!
priority
	self subclassResponsibility ! !

!WACallback methodsFor: 'initialization' stamp: 'avi 6/7/2004 22:39'!
setContext: aRenderingContext owner: anObject key: aString
	context := aRenderingContext.
	owner := anObject.
	key := aString! !

!WACallback methodsFor: 'converting' stamp: 'avi 6/7/2004 21:51'!
valueForField: anObject
	^ anObject
		ifNil: ['']
		ifNotNil:
			[(anObject isCollection and: [anObject isString not])
					ifTrue: [anObject isEmpty
								ifTrue: ['']
								ifFalse: [anObject first]]
					ifFalse: [anObject]]! !

WACallback subclass: #WADispatchCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WADispatchCallback methodsFor: 'evaluation' stamp: 'lr 4/19/2006 08:05'!
evaluateWithArgument: anObject
	(context callbackAt: anObject) 
		ifNotNilDo: [ :callback | callback evaluateWithArgument: nil ]! !

!WADispatchCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:42'!
priority
	^ 5! !

WADispatchCallback subclass: #WAMultiDispatchCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAMultiDispatchCallback methodsFor: 'evaluation' stamp: 'lr 10/10/2005 19:56'!
evaluateWithField: anObject
	(anObject isCollection and: [ anObject isString not ]) 
		ifFalse: [ ^ super evaluateWithField: anObject ].
	anObject do: [ :each | 
		self evaluateWithArgument: (self valueForField: each) ].! !

WACallback subclass: #WAValueCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAValueCallback methodsFor: 'accessing' stamp: 'avi 9/19/2006 14:29'!
block: aOneArgBlock
	block := aOneArgBlock fixCallbackTemps! !

!WAValueCallback methodsFor: 'evaluation' stamp: 'avi 6/7/2004 22:17'!
evaluateWithArgument: anObject
	block valueWithPossibleArgs: (Array with: anObject)! !

!WAValueCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:41'!
priority
	^ 5! !

Object subclass: #WACallbackRegistry
	instanceVariableNames: 'context owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WACallbackRegistry class methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:04'!
context: aContext owner: anObject
	^ self basicNew initializeWithContext: aContext owner: anObject! !

!WACallbackRegistry methodsFor: 'initialization' stamp: 'avi 6/7/2004 22:04'!
initializeWithContext: aContext owner: anObject
	context := aContext.
	owner := anObject! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:10'!
registerActionCallback: aBlock
	^ self storeCallback: (WAActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:10'!
registerCallback: aBlock
	^ self storeCallback: (WAValueCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:41'!
registerCancelActionCallback: aBlock
	^ self storeCallback: (WACancelActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:41'!
registerDefaultActionCallback: aBlock
	^ self storeCallback: (WADefaultActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:10'!
registerDispatchCallback
	^ self storeCallback: WADispatchCallback new! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 9/2/2004 14:42'!
registerImageCallback: aBlock
	^ self storeCallback: (WAImageCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'lr 10/10/2005 20:00'!
registerMultiDispatchCallback
	^ self storeCallback: WAMultiDispatchCallback new! !

!WACallbackRegistry methodsFor: 'callbacks' stamp: 'avi 6/7/2004 22:43'!
storeCallback: aCallback
	| key |
	key := context storeCallback: aCallback.
	aCallback setContext: context owner: owner key: key.
	^ key
! !

Object subclass: #WACallbackStream
	instanceVariableNames: 'callbacks request'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WACallbackStream class methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 01:58'!
callbacks: aDictionary request: aRequest
	^ self basicNew initializeWithCallbacks: aDictionary request: aRequest! !

!WACallbackStream methodsFor: 'testing' stamp: 'avi 6/8/2004 01:59'!
atEnd
	^ callbacks atEnd! !

!WACallbackStream methodsFor: 'initialization' stamp: 'lr 9/26/2005 14:10'!
initializeWithCallbacks: aDictionary request: aRequest
	| collection |
	collection := SortedCollection new.
	aRequest fields keys do:
		[:ea |
		aDictionary at: ea ifPresent: [:callback | collection add: callback]].
	callbacks := ReadStream on: collection asArray.
	request := aRequest! !

!WACallbackStream methodsFor: 'accessing' stamp: 'avi 6/8/2004 01:59'!
position
	^ callbacks position! !

!WACallbackStream methodsFor: 'processing' stamp: 'avi 6/12/2004 00:21'!
processCallbacksWithOwner: anObject
	| callback |
	[callbacks atEnd not and: [callbacks peek owner == anObject]] whileTrue:
		[callback := callbacks next.
		callback evaluateWithField: (request fields at: callback key)]! !

!WACallbackStream methodsFor: 'accessing' stamp: 'avi 6/12/2004 00:25'!
upToEnd
	^ callbacks upToEnd! !

Object subclass: #WACanvas
	instanceVariableNames: 'currentBrush parentBrush painter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WACanvas commentStamp: '<historical>' prior: 0!
This is the superclass of all canvas. It's a rendering interfact that generates brushes (see WABrush).

Subclass this class, if you want to generate an XML dialect.!

!WACanvas methodsFor: 'public api' stamp: 'avi 6/17/2004 12:36'!
brush: aBrush
	self flush.
	currentBrush := aBrush.
	aBrush setParent: parentBrush canvas: self.
	^ aBrush! !

!WACanvas methodsFor: 'private' stamp: 'avi 6/17/2004 12:12'!
flush
	currentBrush ifNotNil:
		[currentBrush close.
		currentBrush := nil]! !

!WACanvas methodsFor: 'private' stamp: 'mb 1/30/2006 18:12'!
forgetCurrentBrush
	currentBrush := nil.! !

!WACanvas methodsFor: 'private' stamp: 'avi 9/21/2005 23:19'!
insert: aBlock
	| oldBrush |
	oldBrush := currentBrush.
	currentBrush := nil.
	aBlock value.
	currentBrush := oldBrush! !

!WACanvas methodsFor: 'private' stamp: 'avi 6/17/2004 12:37'!
nest: aBlock
	parentBrush := currentBrush.
	currentBrush := nil.
	aBlock renderOn: self.
	self flush.
	parentBrush := parentBrush parent.
! !

!WACanvas methodsFor: 'accessing' stamp: 'avi 3/18/2005 21:56'!
painter
	^ painter! !

!WACanvas methodsFor: 'accessing' stamp: 'avi 3/18/2005 21:56'!
painter: anObject
	painter := anObject! !

!WACanvas methodsFor: 'public api' stamp: 'pmm 10/15/2006 11:33'!
render: anObject
	self flush.
	anObject renderOn: self! !

WACanvas subclass: #WAHtmlCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WAHtmlCanvas commentStamp: '<historical>' prior: 0!
This canvas knows about HTML but nothing about callbacks.!

!WAHtmlCanvas class methodsFor: 'code generation' stamp: 'ac 7/9/2005 04:31'!
generateBinaryFor: aCollection
	(aCollection size = 3 and: [(self includesSelector: aCollection third) not]) ifTrue:
		[self 
			compile: aCollection third, ' aBlock
	self ', aCollection second, ' with: aBlock'
			classified: self generatedCategory].
! !

!WAHtmlCanvas class methodsFor: 'code generation' stamp: 'mb 3/16/2006 16:04'!
generateTags
	"((( WAHtmlCanvas generateTags )))"
	self tags do:
		[:spec |
		self generateUnaryFor: spec.
		self generateBinaryFor: spec].! !

!WAHtmlCanvas class methodsFor: 'code generation' stamp: 'ac 7/9/2005 04:29'!
generateUnaryFor: aCollection
	(self includesSelector: aCollection second) ifFalse:
		[self 
			compile: aCollection second, '
	^ self ', (self patternFor: aCollection first)
			classified: self generatedCategory]! !

!WAHtmlCanvas class methodsFor: 'code generation' stamp: 'ac 7/9/2005 04:30'!
generatedCategory
	^ 'html-generated'! !

!WAHtmlCanvas class methodsFor: 'code generation' stamp: 'mb 3/16/2006 16:04'!
patternFor: aString
	WATagBrush allSubclassesDo:
		[:each | each tag = aString
			ifTrue: [^ 'brush: ', each name, ' new']].
	^ 'tag: ', aString printString! !

!WAHtmlCanvas class methodsFor: 'accessing' stamp: 'pmm 2/11/2007 20:13'!
tags
	"
	self generateTags
	"

	^ #(
		('a' anchor)
		('iframe' iframe)
		('canvas' canvas canvas:)

		('h1' heading)
		
		('p' paragraph paragraph:)
		('div' div div:)
		('span' span span:)

		('blockquote' blockquote blockquote:)
		('address' address address:)
		('dd' definitionData definitionData:)
		('dl' definitionList definitionList:)
		('dt' definitionTerm definitionTerm:)

		('code' code code:)
		('pre' preformatted preformatted:)
		('em' emphasis emphasis:)
		('small' small small:)
		('big' big big:)
		('strong' strong strong:)
		('label' label label:)
		('legend' legend legend:)
		('fieldset' fieldSet fieldSet:)
		
		('abbr' abbreviated abbreviated:)
		('acronym' acronym acronym:)
		('code' code code:)
		('cite' citation citation:)
		('dfn' definition definition:)
		('samp' sampleOutput sampleOutput:)
		('kbd' keyboardInput keyboardInput:)
		('q' quote quote:)
		('var' variable variable:)
						
		('ul' unorderedList unorderedList:)
		('ol' orderedList orderedList:)
		('li' listItem listItem:)
		
		('br' break)
		('hr' horizontalRule)
		
		('form' form form:)
		('img' image image:)
		
		('table' table table:)
		('th' tableHeading tableHeading:)
		('tr' tableRow tableRow:)
		('td' tableData tableData:)
		('tbody' tableBody tableBody:)
		('thead' tableHead tableHead:)
		('tfoot' tableFoot tableFoot:)
		('col' tableColumn tableColumn:)
		('colgroup' tableColumnGroup tableColumnGroup:)
		('caption' tableCaption tableCaption:)
		
		('script' script script:)
		
		('ruby' ruby ruby:)
		('rbc' rubyBaseContainer rubyBaseContainer:)
		('rtc' rubyTextContainer rubyTextContainer:)
		('rb' rubyBase rubyBase:)
		('rt' rubyText rubyText:)
		('rp' rubyParentheses rubyParentheses:)
		
		('object' object object:)
		('param' parameter parameter:)
		)! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:23'!
abbreviated
	"Defines an abbreviation, such as 'M.', 'Inc.', 'et al.', 'etc.'"
	^ self tag: 'abbr'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
abbreviated: aBlock
	self abbreviated with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:24'!
acronym
	"Defines an acronym, such as 'GmbH', 'NATO', and 'F.B.I.'"
	^ self tag: 'acronym'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/24/2006 13:42'!
acronym: aBlock
	self acronym with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
address
	"Defines an address element."


	^ self tag: 'address'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:44'!
address: aBlock
	self address with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
anchor
	"Defines an anchor."


	^ self brush: WAAnchorTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
big
	"Defines big text."


	^ self tag: 'big'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 2/21/2006 14:36'!
big: aBlock
	self big with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
blockquote
	"Defines a long quotation."


	^ self tag: 'blockquote'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
blockquote: aBlock
	self blockquote with: aBlock! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:34'!
bold
	self deprecatedApi.
	^ self tag: 'b'! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:03'!
bold: aBlock
	self deprecatedApi.
	self bold with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
break
	"Inserts a single line break."


	^ self tag: 'br'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'lr 5/18/2006 08:55'!
canvas
	^ self brush: WACanvasTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 11/30/2006 16:29'!
canvas: aBlock
	self canvas with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
citation
	"Defines a citation."


	^ self tag: 'cite'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
citation: aBlock
	self citation with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
code
	"Defines computer code text."


	^ self tag: 'code'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
code: aBlock
	self code with: aBlock! !

!WAHtmlCanvas methodsFor: 'public api' stamp: 'lr 10/3/2006 08:51'!
comment: aString
	self flush.
	self document comment: aString displayString
! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
definition
	"Defines a definition term."


	^ self tag: 'dfn'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
definition: aBlock
	self definition with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
definitionData
	"Defines a definition description."


	^ self tag: 'dd'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 5/31/2006 20:26'!
definitionData: aBlock
	self definitionData with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
definitionList
	"Defines a definition list."


	^ self tag: 'dl'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:42'!
definitionList: aBlock
	self definitionList with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
definitionTerm
	"Defines a definition term."


	^ self tag: 'dt'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:42'!
definitionTerm: aBlock
	self definitionTerm with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'mb 4/23/2007 14:20'!
deleted
	"Defines deleted text."


	^ self
		brush: (WAEditTag tag: 'del')! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'pmm 3/28/2007 10:42'!
deleted: aBlock
	self deleted with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
div
	"Defines a section in a document."


	^ self brush: WADivTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
div: aBlock
	self div with: aBlock! !

!WAHtmlCanvas methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:57'!
document
	self subclassResponsibility! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
emphasis
	"Defines emphasized text."


	^ self tag: 'em'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/8/2006 17:14'!
emphasis: aBlock
	self emphasis with: aBlock! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'mb 1/5/2006 18:27'!
encode: anObject
	"This is needed by the SeasideAsync package"
	^WAAbstractHtmlBuilder encode: anObject! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'mbany 4/14/2005 12:26'!
encodeCharacter: aCharacter
	self html: ('&#', aCharacter asInteger displayString, ';').  ! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
fieldSet
	"Defines a fieldset."


	^ self brush: WAFieldSetTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/24/2006 13:45'!
fieldSet: aBlock
	self fieldSet with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'mb 4/23/2007 14:20'!
form
	"Defines a form."


	^ self tag: 'form'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
form: aBlock
	self form with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
heading
	"Defines header 1 to header 6."


	^ self brush: WAHeadingTag new! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'ac 3/16/2005 14:14'!
heading: aBlock
	self heading with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'pmm 12/24/2005 17:38'!
heading: aBlock level: aNumber
	self heading
		level: aNumber;
		with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
horizontalRule
	"Defines a horizontal rule."


	^ self tag: 'hr'! !

!WAHtmlCanvas methodsFor: 'public api' stamp: 'mb 4/23/2007 14:20'!
html: aString
	"Emit aString unescaped onto the target document."


	self flush.
	self document text: aString displayString
! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/8/2006 10:56'!
iframe
	^ self brush: WAIframeTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
image
	"Defines an image."


	^ self brush: WAImageTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/24/2006 13:51'!
image: aBlock
	self image with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'lr 9/14/2005 22:22'!
imageForm: aForm
	self image form: aForm.! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'mb 4/23/2007 14:20'!
inserted
	"Defines inserted text."


	^ self
		brush: (WAEditTag tag: 'ins')! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'pmm 3/28/2007 10:41'!
inserted: aBlock
	self inserted with: aBlock! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:34'!
italic
	self deprecatedApi.
	^ self tag: 'i'! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:03'!
italic: aBlock
	self deprecatedApi.
	self italic with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
keyboardInput
	"Keyboard, text to be entered by the user."


	^ self tag: 'kbd'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
keyboardInput: aBlock
	self keyboardInput with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
label
	"Defines a label for a form control."


	^ self brush: WALabelTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
label: aBlock
	self label with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
legend
	"Defines a title in a fieldset."


	^ self tag: 'legend'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/8/2006 18:00'!
legend: aBlock
	self legend with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
listItem
	"Defines a list item."


	^ self tag: 'li'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
listItem: aBlock
	self listItem with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'mb 4/23/2007 14:20'!
map
	"Defines an anchor to be used around an image."


	^ self brush: WAImageMapTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
object
	"Defines an embedded object."


	^ self brush: WAObjectTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 2/11/2007 19:31'!
object: aBlock
	self object with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'mb 4/23/2007 14:20'!
orderedList
	"Defines an ordered list."


	^ self brush: WAListTag new beOrdered.! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'lr 9/25/2005 11:52'!
orderedList: aBlock
	self orderedList with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
paragraph
	"Defines a paragraph."


	^ self tag: 'p'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
paragraph: aBlock
	self paragraph with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
parameter
	"Defines a parameter for an object."


	^ self brush: WAParameterTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'lr 2/13/2007 00:12'!
parameter: aBlock
	self parameter! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'ac 7/3/2005 15:46'!
popupAnchor
	^ self brush: WAPopupAnchorTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
preformatted
	"Defines preformatted text."


	^ self tag: 'pre'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
preformatted: aBlock
	self preformatted with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
quote
	"Defines a short quotation."


	^ self tag: 'q'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
quote: aBlock
	self quote with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
ruby
	^ self tag: 'ruby'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
ruby: aBlock
	self ruby with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyBase
	^ self tag: 'rb'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyBase: aBlock
	self rubyBase with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyBaseContainer
	^ self tag: 'rbc'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyBaseContainer: aBlock
	self rubyBaseContainer with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyParentheses
	^ self tag: 'rp'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyParentheses: aBlock
	self rubyParentheses with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyText
	^ self brush: WARubyTextTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyText: aBlock
	self rubyText with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyTextContainer
	^ self tag: 'rtc'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 9/21/2006 16:26'!
rubyTextContainer: aBlock
	self rubyTextContainer with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
sampleOutput
	"Sample output, from a program or script."


	^ self tag: 'samp'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
sampleOutput: aBlock
	self sampleOutput with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
script
	"Defines a script."


	^ self brush: WAScriptTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
script: aBlock
	self script with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
small
	"Defines small text."


	^ self tag: 'small'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
small: aBlock
	self small with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'mb 10/31/2006 16:13'!
space
	self html: self spaceEntity! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'mb 2/6/2006 10:48'!
space: n
	n timesRepeat: [self space].
! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'mb 11/4/2006 10:23'!
spaceEntity
	"To be subclassed as needed"
	^'&nbsp;'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
span
	"Defines a section in a document."


	^ self tag: 'span'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
span: aBlock
	self span with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
strong
	"Defines strong text."


	^ self tag: 'strong'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/20/2005 01:24'!
strong: aBlock
	self strong with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'avi 1/9/2006 22:05'!
submitButton
	^ self brush: WASubmitButtonTag new.! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
table
	"Defines a table."


	^ self brush: WATableTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
table: aBlock
	self table with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
tableBody
	"Defines a table body."


	^ self tag: 'tbody'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableBody: aBlock
	self tableBody with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
tableCaption
	"Defines a table caption."


	^ self tag: 'caption'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 12/8/2006 16:17'!
tableCaption: aBlock
	self tableCaption with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
tableColumn
	"Defines attributes for table columns."


	^ self brush: WATableColumnTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 12/7/2006 20:27'!
tableColumn: aBlock
	self tableColumn with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
tableColumnGroup
	"Defines groups of table columns."


	^ self brush: WATableColumnGroupTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 12/7/2006 20:27'!
tableColumnGroup: aBlock
	self tableColumnGroup with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
tableData
	"Defines a table cell."


	^ self brush: WATableDataTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableData: aBlock
	self tableData with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
tableFoot
	"Defines a table footer."


	^ self tag: 'tfoot'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableFoot: aBlock
	self tableFoot with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
tableHead
	"Defines a table header."


	^ self tag: 'thead'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableHead: aBlock
	self tableHead with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
tableHeading
	"Defines a table header."


	^ self brush: WATableHeadingTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/16/2005 16:15'!
tableHeading: aBlock
	self tableHeading with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
tableRow
	"Defines a table row."


	^ self tag: 'tr'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableRow: aBlock
	self tableRow with: aBlock! !

!WAHtmlCanvas methodsFor: 'public api' stamp: 'mb 4/23/2007 14:20'!
tag: aString
	"Defines a generic tag with the name aString."


	^ self brush: (WAGenericTag tag: aString)! !

!WAHtmlCanvas methodsFor: 'public api' stamp: 'mb 4/23/2007 14:20'!
text: anObject
	"Emit aString onto the target document."


	self html: (self encode: anObject)! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'avi 1/9/2006 22:07'!
textInput
	^ self brush: WATextInputTag new! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:34'!
underline
	self deprecatedApi.
	^ self tag: 'u'! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:03'!
underline: aBlock
	self deprecatedApi.
	self underline with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'mb 4/23/2007 14:20'!
unorderedList
	"Defines an unordered list."


	^ self brush: WAListTag new beUnordered.! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
unorderedList: aBlock
	self unorderedList with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/23/2007 14:20'!
variable
	"Defines a variable."


	^ self tag: 'var'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 9/30/2006 20:06'!
variable: aBlock
	self variable with: aBlock! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'avi 2/17/2006 20:36'!
withLineBreaks: aString
	| stream |
	stream := aString readStream.
	[stream atEnd] whileFalse:
		[self text: stream nextLine.
		stream atEnd ifFalse: [self break]]! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'avi 6/23/2006 10:16'!
withLineBreaksAndUrls: aString
	| stream |
	aString ifNil: [^ self].
	stream := aString readStream.
	[stream atEnd] whileFalse:
		[self withUrls: stream nextLine.
		stream atEnd ifFalse: [self break]]! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'lr 11/16/2006 18:12'!
withUrls: aString
	| stream url |
	stream := aString readStream.
	[stream atEnd] whileFalse:
		[self text: (stream upToAll: 'http://').
		stream atEnd ifFalse:
			[url := 'http://', (stream upTo: $ ).
			self anchor url: url; with: url.
			self text: ' ']]! !

WAHtmlCanvas subclass: #WARenderCanvas
	instanceVariableNames: 'context callbacks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WARenderCanvas commentStamp: '<historical>' prior: 0!
This canvas knows about callbacks and is intertwined with the rest of the framework.!

!WARenderCanvas class methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 00:59'!
context: aRenderingContext callbacks: aCallbackStore
	^ self basicNew initializeWithContext: aRenderingContext callbacks: aCallbackStore! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 9/23/2005 18:07'!
button
	^ self brush: WAButtonTag new.! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'mb 5/1/2007 12:18'!
callbacks
	"Answer the callback registry."


	^ callbacks! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'mb 12/1/2006 11:27'!
cancelButton
	^ self brush: WACancelButtonTag new.! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'avi 4/28/2005 14:01'!
checkbox
	^ self brush: WACheckboxTag new	! !

!WARenderCanvas methodsFor: 'private' stamp: 'avi 7/5/2004 11:56'!
close
	self flush.! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'mb 5/1/2007 12:18'!
context
	"Answer the rendering context."


	^ context! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'mb 2/6/2006 10:09'!
dateInput
	^ self brush: WADateInput new! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'mb 5/1/2007 12:18'!
document
	"Answer the XHTML document."


	^ self context document! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'avi 6/8/2005 21:49'!
fileUpload
	^ self brush: WAFileUploadTag new	! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'avi 1/9/2006 21:52'!
form
	^ self brush: WAFormTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 9/23/2005 18:09'!
hiddenInput
	^ self brush: WAHiddenInputTag new.! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 9/14/2005 22:01'!
imageButton
	^ self brush: WAImageButtonTag new.! !

!WARenderCanvas methodsFor: 'initialize-release' stamp: 'avi 6/13/2004 01:01'!
initializeWithContext: aRenderingContext callbacks: aCallbackStore
	context := aRenderingContext.
	callbacks := aCallbackStore! !

!WARenderCanvas methodsFor: 'public api' stamp: 'lr 3/28/2006 20:16'!
nextId
	^ 'id' , context advanceKey! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/17/2005 17:13'!
option
	^ self brush: WAOptionTag new.! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/17/2005 17:14'!
option: aBlock
	^ self option with: aBlock! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'mb 5/1/2007 10:41'!
optionGroup
	^ self brush: WAOptionGroupTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'mb 5/1/2007 10:41'!
optionGroup: aBlock 
	^ self optionGroup with: aBlock! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 9/23/2005 18:09'!
passwordInput
	^ self brush: WAPasswordInputTag new.! !

!WARenderCanvas methodsFor: 'public api' stamp: 'mb 3/31/2006 11:38'!
peekNextId
	^ 'id' , context nextKey! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 10:45'!
radioButton
	^ self brush: WARadioButtonTag new.! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 10:46'!
radioButton: aBlock
	^ self radioButton with: aBlock! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 11:29'!
radioGroup
	^ WARadioGroup canvas: self! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 10:44'!
radioGroup: aBlock
	^ aBlock value: self radioGroup! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/17/2005 17:15'!
select
	^ self brush: WASelectTag new	! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'mb 5/1/2007 10:36'!
select: aBlock
	^ self select with: aBlock! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/22/2005 17:50'!
textArea
	^ self brush: WATextAreaTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'mb 2/6/2006 10:10'!
timeInput
	^ self brush: WATimeInput new! !

WARenderCanvas subclass: #WARenderCanvasForTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WARenderCanvasForTest commentStamp: 'mb 3/28/2007 14:06' prior: 0!
This class is intended to be used during unit tests, typically subclasses of WARenderCanvasTestCase.
It allows the production of an html fragments that can be verified for correctness.

See subclasses of WARenderCanvasTestCase for examples of unit tests.
!

!WARenderCanvasForTest class methodsFor: 'instance creation' stamp: 'mb 2/21/2007 12:13'!
new
	| context doc callbacks |
	context := WARenderingContext new.
	doc := (WAHtmlTestDocument new)
				initializeWithRoot: (WARenderedHtmlRoot context: context);
				setStateToBody;
				yourself.
	context document: doc.
	context actionUrl: WAUrl new.
	callbacks := WACallbackRegistry context: context owner: nil.
	^self context: context callbacks: callbacks! !

!WARenderCanvasForTest methodsFor: 'accessing' stamp: 'mb 2/21/2007 13:03'!
contents
	self  flush.
	^self document stream contents! !

!WARenderCanvasForTest methodsFor: 'public api' stamp: 'mb 2/21/2007 13:07'!
reset
	^self document reset! !

!WARenderCanvasForTest methodsFor: 'public api' stamp: 'mb 2/21/2007 12:06'!
setStateToBody
	self document setStateToBody.
! !

!WARenderCanvasForTest methodsFor: 'public api' stamp: 'mb 2/21/2007 12:06'!
setStateToHead
	self document setStateToHead.
! !

!WARenderCanvasForTest methodsFor: 'xml' stamp: 'mb 2/21/2007 13:22'!
spaceEntity
	"To be subclassed as needed"
	^'&#160;'! !

!WARenderCanvasForTest methodsFor: 'accessing' stamp: 'mb 3/29/2007 10:43'!
xmlContents
	"
	Make sure you enclose your tested html in some container
	(a div element for instance) to ensure xml well-formedness
	thus avoiding parse errors
	"
	^SeasidePlatformSupport parseDocumentFrom: self contents readStream! !

WAHtmlCanvas subclass: #WAStaticHtmlCanvas
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WAStaticHtmlCanvas commentStamp: '<historical>' prior: 0!
This canvas can be used to generate static/RESTful HTML pages.!

!WAStaticHtmlCanvas class methodsFor: 'instance creation' stamp: 'avi 9/10/2005 17:20'!
document: aDocument
	^ self basicNew initializeWithDocument: aDocument! !

!WAStaticHtmlCanvas class methodsFor: 'instance creation' stamp: 'avi 9/10/2005 17:28'!
root: anHtmlRoot
	^ self document: (WAHtmlStreamDocument root: anHtmlRoot)! !

!WAStaticHtmlCanvas methodsFor: 'accessing' stamp: 'avi 9/10/2005 17:20'!
document
	^ document! !

!WAStaticHtmlCanvas methodsFor: 'accessing' stamp: 'ac 6/9/2006 12:42'!
document: aDocument
	document := aDocument! !

!WAStaticHtmlCanvas methodsFor: 'initialize-release' stamp: 'avi 9/10/2005 17:20'!
initializeWithDocument: aDocument
	document := aDocument! !

!WAStaticHtmlCanvas methodsFor: 'form-elements' stamp: 'ac 6/10/2006 18:52'!
textArea
	^ self brush: WATextAreaTag new! !

Object subclass: #WAClosingConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

!WAClosingConditionalComment methodsFor: 'writing' stamp: 'pmm 10/11/2006 17:11'!
writeOn: aStream
	aStream nextPutAll: '<!![endif]-->'.! !

Object subclass: #WAConditionalComment
	instanceVariableNames: 'condition root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

!WAConditionalComment class methodsFor: 'instance creation' stamp: 'pmm 10/11/2006 17:37'!
root: anHtmlRoot
	^self new initializeWithRoot: anHtmlRoot! !

!WAConditionalComment methodsFor: 'private' stamp: 'pmm 10/11/2006 17:13'!
addToCondition: aString
	condition := condition, aString! !

!WAConditionalComment methodsFor: 'flow-control' stamp: 'pmm 10/11/2006 17:46'!
do: aBlock
	root addHeadElement: (WAOpeningConditionalComment condition: condition).
	aBlock value.
	root addHeadElement: (WAClosingConditionalComment new).! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:19'!
equal
	"implicit of nothing else"! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:14'!
greaterThan
	self addToCondition: ' gt'! !

!WAConditionalComment methodsFor: 'operators' stamp: 'lr 11/16/2006 19:11'!
greaterThanOrEqual
	self deprecatedApi.
	self greaterThan; orEqual! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie
	self addToCondition: ' IE'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie5
	self addToCondition: ' IE 5'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie50
	self addToCondition: ' IE 5.0'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie55
	self addToCondition: ' IE 5.5'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie6
	self addToCondition: ' IE 6'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie7
	self addToCondition: ' IE 7'! !

!WAConditionalComment methodsFor: 'initialize-release' stamp: 'pmm 10/11/2006 17:36'!
initializeWithRoot: anHtmlRoot
	root := anHtmlRoot.
	condition := 'if'! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:15'!
lessThan
	self addToCondition: ' lt'! !

!WAConditionalComment methodsFor: 'operators' stamp: 'lr 11/16/2006 19:11'!
lessThanOrEqual
	self deprecatedApi.
	self lessThan; orEqual! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/19/2006 20:19'!
orEqual
	self addToCondition: 'e'! !

Object subclass: #WAConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAConfiguration class methodsFor: 'instance creation' stamp: 'avi 1/30/2004 16:39'!
new
	^ self basicNew initialize! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 16:27'!
addAncestorsTo: tempCollection linearization: linearCollection
	(linearCollection includes: self)
		ifTrue: [tempCollection do: [:ea | linearCollection add: ea before: self].
				tempCollection removeAllSuchThat: [:ea | true]]
		ifFalse: [tempCollection add: self.
				self ancestors isEmpty
					ifTrue: [linearCollection addAll: tempCollection.
							tempCollection removeAllSuchThat: [:ea | true]]
					ifFalse: [self ancestors do: [:ea | ea addAncestorsTo: tempCollection linearization: linearCollection]]]! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 17:16'!
allAncestors
	| temp linear |
	temp := OrderedCollection new.
	linear := OrderedCollection new.
	self addAncestorsTo: temp linearization: linear.
	^ linear allButFirst asArray! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 17:16'!
allAncestorsDo: aBlock
	self allAncestors do: aBlock! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/1/2004 14:53'!
allAttributes
	^ Array streamContents:
		[:s | 
		self withAllAncestorsDo: [:ea | s nextPutAll: ea attributes]]
! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 3/24/2004 11:59'!
allPotentialAncestors
	^ #()! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/2/2004 14:43'!
ancestors
	^ #()! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/1/2004 14:54'!
attributeNamed: aSymbol
	^ self allAttributes
		detect: [:ea | ea key = aSymbol]
		ifNone: [self error: 'No attribute named ', aSymbol printString]
! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 2/1/2004 17:34'!
attributes
	^ #()! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 1/30/2004 16:32'!
attributesAndValuesDo: keyValueBlock
	^ self allAttributes do:
		[:ea |
		keyValueBlock value: ea value: (self valueForAttribute: ea)]! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/5/2004 13:21'!
groupedAttributes
	| dict sorted |
	dict := Dictionary new.
	sorted := SortedCollection sortBlock: [:a :b | a key <= b key].
	self allAttributes do:
		[:ea |
		(dict at: ea group ifAbsentPut: [SortedCollection sortBlock: [:a :b | a key <= b key]])
			add: ea].
	dict associationsDo:
		[:assoc |
		sorted add: assoc].
	^ sorted
		! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 1/30/2004 16:21'!
hasAttributeNamed: aSymbol
	^ self allAttributes anySatisfy: [:ea | ea key = aSymbol]! !

!WAConfiguration methodsFor: 'testing' stamp: 'kph 9/30/2006 01:45'!
hasGroupNamed: aSymbol
	^ self allAttributes anySatisfy: [:ea | ea group = aSymbol]! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 2/3/2004 22:59'!
hasLocalValueForAttribute: anAttribute
	self localValueAt: anAttribute key ifAbsent: [^ false].
	^ true! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 3/23/2004 14:53'!
hasMutableAncestry
	^ false! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 12:40'!
inheritedValueAndSourceAt: aSymbol do: aBlock
	self allAncestorsDo:
		[:ea |
		(ea localValueAt: aSymbol ifAbsent: [])
			ifNotNilDo: [:val | ^ aBlock value: val value: ea]].
	^ nil! !

!WAConfiguration methodsFor: 'testing' stamp: 'jf 2/1/2004 18:03'!
inheritsFrom: aConfiguration
	^ self allAncestors anySatisfy: [:ea | ea = aConfiguration]
	
	! !

!WAConfiguration methodsFor: 'initializing' stamp: 'avi 2/2/2004 14:34'!
initialize
	! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:58'!
localValueAt: aSymbol ifAbsent: absentBlock
	self subclassResponsibility! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 12:40'!
lookupValueAt: aSymbol
	^ self inheritedValueAndSourceAt: aSymbol do: [:value :source | value]! !

!WAConfiguration methodsFor: 'accessing' stamp: 'avi 3/24/2004 11:55'!
name
	^ self subclassResponsibility! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 3/23/2004 14:47'!
potentialAncestors
	^ self allPotentialAncestors reject: [:ea | ea = self or: [(self inheritsFrom: ea) or: [ea inheritsFrom: self]]]! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:58'!
valueAt: aSymbol
	^ self localValueAt: aSymbol ifAbsent: [self lookupValueAt: aSymbol]! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:59'!
valueForAttribute: anAttribute
	^ self valueAt: anAttribute key! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 16:28'!
withAllAncestorsDo: aBlock
	aBlock value: self.
	^ self allAncestorsDo: aBlock! !

WAConfiguration subclass: #WASystemConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

WASystemConfiguration subclass: #WAAuthConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAAuthConfiguration methodsFor: 'ancestry' stamp: 'avi 11/16/2005 23:32'!
ancestors
	^ Array with: (WARenderLoopConfiguration new)! !

!WAAuthConfiguration methodsFor: 'attributes' stamp: 'avi 4/13/2004 21:12'!
attributes
	^ Array
		with: (WAStringAttribute key: #login group: #authentication)
		with: (WAStringAttribute key: #password group: #authentication)
		
! !

!WAAuthConfiguration methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:07'!
mainClass
	^ WAAuthMain! !

WASystemConfiguration subclass: #WAGlobalConfiguration
	instanceVariableNames: ''
	classVariableNames: 'DeploymentMode'
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAGlobalConfiguration class methodsFor: 'initialization' stamp: 'avi 3/16/2006 23:39'!
initialize
	DeploymentMode ifNil: [self setDevelopmentMode]! !

!WAGlobalConfiguration class methodsFor: 'configuration' stamp: 'avi 3/16/2006 23:35'!
setDeploymentMode
	DeploymentMode := true! !

!WAGlobalConfiguration class methodsFor: 'configuration' stamp: 'avi 3/16/2006 23:36'!
setDevelopmentMode
	DeploymentMode := false! !

!WAGlobalConfiguration methodsFor: 'attributes' stamp: 'lr 2/12/2007 22:04'!
attributes
	^ Array 
		with: ((WAListAttribute key: #serverProtocol group: #server) options: #(http https))
		with: (WAStringAttribute key: #serverHostname group: #server)
		with: (WANumberAttribute key: #serverPort group: #server)
		with: (WAStringAttribute key: #serverPath group: #server)
		with: (WABooleanAttribute key: #deploymentMode)! !

!WAGlobalConfiguration methodsFor: 'defaults' stamp: 'avi 3/16/2006 23:35'!
deploymentMode
	^ DeploymentMode! !

!WAGlobalConfiguration methodsFor: 'defaults' stamp: 'avi 2/2/2004 15:00'!
serverPort
	^ 80! !

!WAGlobalConfiguration methodsFor: 'defaults' stamp: 'avi 2/2/2004 15:00'!
serverProtocol
	^ #http! !

WASystemConfiguration subclass: #WARenderLoopConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARenderLoopConfiguration methodsFor: 'ancestry' stamp: 'lr 2/12/2007 22:33'!
ancestors
	^ Array with: WASessionConfiguration new! !

!WARenderLoopConfiguration methodsFor: 'attributes' stamp: 'avi 9/11/2005 14:30'!
attributes
	^ Array
		with: ((WAListAttribute key: #rootComponent) options: self rootComponents)
		with: (WAStringAttribute key: #resourceBaseUrl group: #server)! !

!WARenderLoopConfiguration methodsFor: 'defaults' stamp: 'avi 2/2/2004 17:02'!
errorHandler
	^ WAWalkbackErrorHandler! !

!WARenderLoopConfiguration methodsFor: 'defaults' stamp: 'avi 4/13/2004 20:24'!
mainClass
	^ WARenderLoopMain! !

!WARenderLoopConfiguration methodsFor: 'defaults' stamp: 'avi 3/29/2004 19:09'!
rootComponents
	^ (WAComponent allSubclasses select: [:ea | ea canBeRoot]) asSortedCollection: [:a :b | a name <= b name]! !

WASystemConfiguration subclass: #WASessionConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WASessionConfiguration methodsFor: 'ancestry' stamp: 'avi 11/16/2005 23:33'!
ancestors
	^ Array with: WAGlobalConfiguration new! !

!WASessionConfiguration methodsFor: 'attributes' stamp: 'avi 11/27/2005 17:57'!
attributes
	^ Array
		with: (WANumberAttribute key: #sessionExpirySeconds)
		with: ((WAListAttribute key: #sessionClass) options: self sessionClasses)
		with: ((WAListAttribute key: #mainClass) options: self mainClasses)
		with: ((WAListAttribute key: #errorHandler) options: self errorHandlerClasses)
		with: (WABooleanAttribute key: #useSessionCookie)! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'avi 4/13/2004 20:10'!
errorHandler
	^ WASimpleErrorHandler! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'avi 4/7/2004 13:59'!
errorHandlerClasses
	^ WAErrorHandler allSubclasses! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'avi 2/5/2004 12:20'!
mainClasses
	^ WAMain allSubclasses! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'avi 2/2/2004 15:05'!
sessionClass
	^ WASession! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'avi 2/2/2004 15:04'!
sessionClasses
	^ WASession withAllSubclasses! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'avi 2/2/2004 15:05'!
sessionExpirySeconds
	^ 600! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'avi 11/12/2005 21:42'!
useSessionCookie
	^ false! !

!WASystemConfiguration class methodsFor: 'accessing' stamp: 'lr 5/3/2006 09:44'!
instance
	^ instance ifNil: [ instance := self basicNew initialize ]! !

!WASystemConfiguration class methodsFor: 'instance creation' stamp: 'avi 11/16/2005 23:33'!
new
	^ self instance! !

!WASystemConfiguration methodsFor: 'attributes' stamp: 'avi 2/2/2004 14:01'!
attributes
	self subclassResponsibility ! !

!WASystemConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 23:00'!
localValueAt: aSymbol ifAbsent: absentBlock
	^ (self respondsTo: aSymbol)
		ifTrue: [self perform: aSymbol]
		ifFalse: [absentBlock value]! !

!WASystemConfiguration methodsFor: 'accessing' stamp: 'avi 11/16/2005 23:31'!
name
	^ self class name! !

WAConfiguration subclass: #WAUserConfiguration
	instanceVariableNames: 'values ancestors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAUserConfiguration class methodsFor: 'initialization' stamp: 'avi 11/17/2005 00:27'!
initialize
	self allInstances do: [:ea | ea instVarNamed: 'ancestors' put: (ea ancestors collect: [:c  | [c instVarNamed: 'parent'] ifError: [c]])] 
	! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
addAncestor: aConfiguration
	(self inheritsFrom: aConfiguration)
		ifFalse: [ancestors add: aConfiguration]! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'avi 11/16/2005 23:39'!
allPotentialAncestors
	^ WASystemConfiguration allSubclasses collect: [:ea | ea new]! !

!WAUserConfiguration methodsFor: 'accessing' stamp: 'avi 11/16/2005 23:39'!
ancestors
	^ ancestors! !

!WAUserConfiguration methodsFor: 'menu' stamp: 'avi 3/23/2004 14:51'!
clear
	values := Dictionary new.! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
clearValueForAttribute: anAttribute
	values removeKey: anAttribute key ifAbsent: []! !

!WAUserConfiguration methodsFor: 'testing' stamp: 'avi 11/16/2005 23:39'!
hasMutableAncestry
	^ true! !

!WAUserConfiguration methodsFor: 'initialization' stamp: 'avi 11/16/2005 23:39'!
initialize
	super initialize.
	values := Dictionary new.
	ancestors := OrderedCollection new.! !

!WAUserConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 14:51'!
localValueAt: aSymbol ifAbsent: errorBlock
	^ values at: aSymbol ifAbsent: errorBlock! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValues
	| dict |
	dict := Dictionary new.
	self allAttributes do:
		[:attr | (self localValueAt: attr key ifAbsent: [nil])
			ifNotNilDo: [:value | dict at: attr key put: (attr stringForValue: value)]].
		
	^ dict! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValues: aDictionary
	self allAttributes do:
		[:attr | (aDictionary at: attr key ifAbsent: [nil])
			ifNotNilDo: [:string | self valueAt: attr key put: (attr valueFromString: string)]]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
overrideAttribute: anAttribute
	self takeValue: (self valueForAttribute: anAttribute) forAttribute: anAttribute! !

!WAUserConfiguration methodsFor: 'copying' stamp: 'lr 12/12/2006 11:24'!
postCopy
	super postCopy.
	values := values copy.
	ancestors := ancestors collect: [ :each | each copy ]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
removeAncestor: aConfiguration
	ancestors remove: aConfiguration ifAbsent: []! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 15:21'!
takeValue: anObject forAttribute: anAttribute
	^ anObject ifNotNil: [values at: anAttribute key put: anObject]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
valueAt: aSymbol put: anObject
	^ self takeValue: anObject forAttribute: (self attributeNamed: aSymbol)! !

Object subclass: #WAConfigurationAttribute
	instanceVariableNames: 'key group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WAConfigurationAttribute subclass: #WABooleanAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WABooleanAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:11'!
accept: aVisitor with: anObject
	^ aVisitor visitBooleanAttribute: self with: anObject! !

!WABooleanAttribute methodsFor: 'as yet unclassified' stamp: 'avi 4/26/2004 14:42'!
valueFromString: aString
	^ aString = 'true'
		ifTrue: [true]
		ifFalse: [aString = 'false'
				 ifTrue: [false]
				 ifFalse: [self error: 'Invalid value for boolean attribute']]
! !

!WAConfigurationAttribute class methodsFor: 'accessing' stamp: 'avi 2/5/2004 13:15'!
key: aSymbol
	^ self key: aSymbol group: nil! !

!WAConfigurationAttribute class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:14'!
key: keySymbol group: groupSymbol
	^ self basicNew initializeWithKey: keySymbol group: groupSymbol! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:12'!
accept: aVisitor with: anObject
	self subclassResponsibility ! !

!WAConfigurationAttribute methodsFor: 'accessing' stamp: 'avi 2/5/2004 13:21'!
group
	^ group ifNil: [#general]! !

!WAConfigurationAttribute methodsFor: 'initialization' stamp: 'avi 2/5/2004 13:14'!
initializeWithKey: keySymbol group: groupSymbol
	key := keySymbol.
	group := groupSymbol! !

!WAConfigurationAttribute methodsFor: 'accessing' stamp: 'avi 1/30/2004 16:40'!
key
	^ key! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:28'!
stringForValue: anObject
	^ anObject displayString! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:07'!
valueFromString: aString
	self subclassResponsibility ! !

WAConfigurationAttribute subclass: #WAListAttribute
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:13'!
accept: aVisitor with: anObject
	^ aVisitor visitListAttribute: self with: anObject! !

!WAListAttribute methodsFor: 'accessing' stamp: 'avi 1/31/2004 12:12'!
options
	^ options! !

!WAListAttribute methodsFor: 'accessing' stamp: 'avi 1/31/2004 12:11'!
options: aCollection
	options := aCollection! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:29'!
valueFromString: aString
	^ self options
		detect: [:ea | ea displayString = aString]
		ifNone: [self error: 'No matching list option']! !

WAConfigurationAttribute subclass: #WANumberAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WANumberAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:13'!
accept: aVisitor with: anObject
	^ aVisitor visitNumberAttribute: self with: anObject! !

!WANumberAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:10'!
valueFromString: aString
	^ Number readFrom: aString! !

WAConfigurationAttribute subclass: #WAStringAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WAStringAttribute subclass: #WAPasswordAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAPasswordAttribute methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:02'!
accept: aVisitor with: anObject
	^ aVisitor visitPasswordAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:12'!
accept: aVisitor with: anObject
	^ aVisitor visitStringAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'as yet unclassified' stamp: 'lr 5/3/2006 09:56'!
valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [ aString ]! !

Object subclass: #WACookie
	instanceVariableNames: 'key value path expiry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WACookie commentStamp: '<historical>' prior: 0!
I represent a cookie, a piece of information that is stored on the client and read and writable by the server. I am basically a key/value pair of strings.
You can never trust information in a cookie, the client is free to edit it.
I model only a part of the full cookie specification.

For more information see  RFC2965 (http://tools.ietf.org/html/rfc2965)!

!WACookie class methodsFor: 'accessing' stamp: 'avi 5/18/2004 22:59'!
key: keyString value: valueString
	^ self new
		key: keyString;
		value: valueString;
		yourself! !

!WACookie methodsFor: 'comparing' stamp: 'pmm 10/12/2006 16:53'!
= other
	^(other isKindOf: WACookie)
		and: [ self key = other key
		and: [ self path = other path ] ]! !

!WACookie methodsFor: 'api' stamp: 'avi 5/18/2004 23:13'!
expireIn: aDuration
	self expiry: DateAndTime now + aDuration! !

!WACookie methodsFor: 'accessing' stamp: 'avi 5/18/2004 22:53'!
expiry
	^ expiry! !

!WACookie methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:22'!
expiry: aDateTime
	expiry := aDateTime asUTC! !

!WACookie methodsFor: 'private' stamp: 'mbany 4/14/2005 12:18'!
expiryString
	^ String streamContents:
		[:s |
		s
			nextPutAll: (expiry dayOfWeekName first: 3);
			nextPutAll: ', ';
			nextPutAll: expiry dayOfMonth displayString;
			nextPut: $-;
			nextPutAll: expiry monthName;
			nextPut: $-;
			nextPutAll: expiry year displayString;
			space;
			nextPutAll: expiry hour24 displayString;
			nextPut: $:;
			nextPutAll: expiry minute displayString; 
			nextPut: $:;
			nextPutAll: expiry second displayString;
			nextPutAll: ' GMT']! !

!WACookie methodsFor: 'comparing' stamp: 'pmm 10/12/2006 16:53'!
hash
	^self key hash
		bitXor: self path hash! !

!WACookie methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:21'!
key
	^ key! !

!WACookie methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:22'!
key: aString
	key := aString! !

!WACookie methodsFor: 'accessing' stamp: 'avi 5/18/2004 22:53'!
path
	^ path ifNil: ['/']! !

!WACookie methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:22'!
path: aString
	path := aString! !

!WACookie methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:21'!
value
	^ value! !

!WACookie methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:22'!
value: aString
	value := aString! !

!WACookie methodsFor: 'api' stamp: 'mb 2/27/2006 08:02'!
valueWithExpiry
	^ expiry
		ifNil: [self value]
		ifNotNil: [(self value ifNil: ['']), '; expires=', self expiryString]! !

Object subclass: #WAErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

WAErrorHandler subclass: #WADebugErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WADebugErrorHandler methodsFor: 'actions' stamp: 'lr 6/7/2006 10:06'!
handleError: anError
	SeasidePlatformSupport openDebuggerOn: anError! !

!WAErrorHandler class methodsFor: 'actions' stamp: 'avi 3/28/2004 21:22'!
handleError: anError
	^ self new handleError: anError! !

!WAErrorHandler class methodsFor: 'actions' stamp: 'avi 3/28/2004 21:23'!
handleWarning: aWarning
	^ self new handleWarning: aWarning! !

!WAErrorHandler methodsFor: 'actions' stamp: 'avi 2/2/2004 16:54'!
handleError: anError
	anError pass! !

!WAErrorHandler methodsFor: 'actions' stamp: 'avi 2/2/2004 16:54'!
handleWarning: aWarning
	self handleError: aWarning! !

WAErrorHandler subclass: #WASimpleErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WASimpleErrorHandler methodsFor: 'actions' stamp: 'avi 5/18/2004 16:16'!
handleError: anError
	WACurrentSession value returnResponse: (WAResponse internalError: anError)! !

WAErrorHandler subclass: #WAWalkbackErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WAWalkbackErrorHandler methodsFor: 'actions' stamp: 'mb 1/13/2006 09:55'!
handleError: anError
	WARenderLoop new
		call: (WAWalkback new exception: anError) 
		withToolFrame: false.
	SeasidePlatformSupport openDebuggerOn: anError.
! !

!WAWalkbackErrorHandler methodsFor: 'actions' stamp: 'RJT 5/8/2007 12:27'!
handleWarning: aWarning
	WARenderLoop new call: (WAFormDialog new addMessage: aWarning messageText; yourself).
	aWarning resume.! !

Object subclass: #WAFile
	instanceVariableNames: 'contents contentType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WAFile commentStamp: '<historical>' prior: 0!
I represent a file that was uploaded by the user via #fileInput.!

!WAFile methodsFor: 'accessing' stamp: 'avi 4/28/2004 11:13'!
contentType
	^ contentType! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:21'!
contentType: aString
	contentType := aString! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:39'!
contents
	"Answer a ByteArray"
	^ contents! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:37'!
contents: aByteArray
	contents := aByteArray! !

!WAFile methodsFor: 'accessing' stamp: 'ab 10/31/2002 10:39'!
fileName
	"compensate for windows explorer behavior"
	^ ('#:\*' match: fileName)
		ifTrue: [fileName copyAfterLast: $\]
		ifFalse: [fileName]! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:21'!
fileName: aString
	fileName := aString! !

Object subclass: #WAHtmlAttributes
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlAttributes commentStamp: '<historical>' prior: 0!
I represent the attributes of a XHTML tag. I am essentially a dictionary, but I provide some conveniance methods related to attribute addition and rendering.!

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'mb 4/23/2007 14:20'!
addClass: aString
	"Add an additional class aString to the receiver."


	aString ifNotNil: [ self at: 'class' append: aString ]! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:02'!
addMeasurementStyle: aString withValue: aValue
	| styleValue |
	self deprecatedApi.
	styleValue := aValue isNumber
		ifTrue: [ aValue px ]
		ifFalse: [ aValue displayString ].
	self addStyle: aString , ': ' , styleValue! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 11/16/2006 19:02'!
addScript: aString
	aString ifNotNil: [ self at: 'script' append: aString separator: ';' ]! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'mb 4/23/2007 14:20'!
addStyle: aString
	"Add an additional CSS style definition aString to the receiver."


	aString ifNotNil: [ self at: 'style' append: aString separator: ';' ]! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:00'!
align
	self deprecatedApi
! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'pmm 11/21/2006 18:13'!
align: aValue
	self deprecatedApi.
	self at: 'align' put: aValue! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:00'!
alignBottom
	self deprecatedApi.
	self at: 'valign' put: 'bottom'! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:01'!
alignCenter
	self deprecatedApi.
	self addStyle: 'text-align: center'! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'avi 6/22/2005 01:55'!
associations
	^ self attributes associations! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'mb 4/23/2007 14:20'!
at: keyString
	"Answer the value associated with the attribute aKey. Answer nil, if no such attribute is defined."


	^ (self at: keyString ifAbsent: [keyString -> nil]) value! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'mb 4/23/2007 14:20'!
at: keyString append: aString
	"Append aValue to the attribute aKey. If already present, concatenate it with a space. Ignore the request if aValue is nil."


	^ self at: keyString append: aString separator: ' '! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'mb 4/23/2007 14:20'!
at: keyString append: aString separator: separatorString
	"Append aValue to the attribute aKey. If already present, concatenate it with aString. Ignore the request if aValue is nil."


	aString ifNil: [^ self at: keyString].
	^ self at: keyString put: 
		(String streamContents:
			[:stream |
			self at: keyString ifPresent: 
				[:s | stream nextPutAll: s; nextPutAll: separatorString].
			stream nextPutAll: aString displayString])! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'ac 3/16/2005 11:49'!
at: keyString ifAbsent: aBlock
	^ self associations
		detect: [:ea | ea key = keyString]
		ifNone: aBlock! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'mb 3/16/2006 23:55'!
at: keyString ifAbsentPut: errBlock
	"What if errBlock evaluates to nil ?"
	^ self at: keyString ifAbsent: [self attributes add: keyString -> errBlock value]! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'ac 9/25/2005 17:50'!
at: keyString ifPresent: aBlock
	^ aBlock value: (self at: keyString ifAbsent: [^ nil]) value! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'mb 4/23/2007 14:20'!
at: keyString put: valueString
	"Set the value of the attribute aKey to be aValue. Ignore the request if the aValue is nil."


	valueString ifNotNil: [self attributes at: keyString put: valueString]! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'avi 6/22/2005 01:49'!
attributes
	^ attributes ifNil: [attributes := Dictionary new]! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:01'!
background: aValue
	self deprecatedApi.
	self addStyle: 'background-image: url(' , aValue displayString , ')'
! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:01'!
backgroundColor: aValue
	self deprecatedApi.
	self addStyle: 'background-color: ' , aValue displayString! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:12'!
bgcolor
	self deprecatedApi! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'pmm 11/21/2006 18:14'!
bgcolor: aValue
	self deprecatedApi.
	self at: 'bgcolor' put: aValue! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:01'!
border: aValue
	| cssValue |
	self deprecatedApi.
	cssValue := 'none'.
	aValue displayString = '1' ifTrue: [cssValue := 'solid 1px black'].
	aValue displayString = '2' ifTrue: [cssValue := 'solid 2px black'].
	self addStyle: 'border: ' , cssValue.
! !

!WAHtmlAttributes methodsFor: 'dnu' stamp: 'pmm 1/22/2007 13:35'!
doesNotUnderstand: aMessage
	| argCount |
	self deprecatedApi.
	argCount := aMessage arguments size.
	argCount = 0 ifTrue: [^ self at: aMessage selector asLowercase put: true].
	argCount = 1 ifTrue: [^ self at: aMessage selector allButLast asLowercase put: aMessage argument].
	^ super doesNotUnderstand: aMessage! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:01'!
height: aValue	
	self deprecatedApi.
	self addMeasurementStyle: 'height' withValue: aValue! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:01'!
noBorder
	self deprecatedApi.
	self border: 0! !

!WAHtmlAttributes methodsFor: 'copying' stamp: 'lr 11/8/2005 21:58'!
postCopy
	super postCopy.
	attributes := attributes copy.! !

!WAHtmlAttributes methodsFor: 'javascript' stamp: 'pmm 1/22/2007 13:24'!
submitOnChange
	self at: 'onchange' put: 'submit()'! !

!WAHtmlAttributes methodsFor: 'javascript' stamp: 'pmm 1/22/2007 13:24'!
submitOnClick
	self at: 'onclick' put: 'submit()'! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'lr 11/16/2006 19:02'!
width: aValue
	self deprecatedApi.
	self addMeasurementStyle: 'width' withValue: aValue! !

!WAHtmlAttributes methodsFor: 'printing' stamp: 'lr 6/14/2006 07:59'!
writeKey: aKey value: aValue on: aStream
	aValue = false ifFalse: [
		aStream nextPut: $ ; nextPutAll: aKey; nextPutAll: '="'.
		aValue = true
			ifFalse: [ WAAbstractHtmlBuilder encode: aValue to: aStream ]
			ifTrue: [ aStream nextPutAll: aKey ].
		aStream nextPut: $" ]! !

!WAHtmlAttributes methodsFor: 'printing' stamp: 'pmm 1/22/2007 13:26'!
writeOn: aStream
	attributes ifNil: [ ^ self ].
	attributes keysAndValuesDo: [ :key :value |
		self 
			writeKey: key 
			value: value on: aStream ]! !

Object subclass: #WAHtmlDocument
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlDocument class methodsFor: 'instance creation' stamp: 'mb 3/30/2006 12:32'!
new
	^ self root: self newRoot! !

!WAHtmlDocument class methodsFor: 'instance creation' stamp: 'mb 3/30/2006 12:32'!
newRoot
	^ self rootClass new! !

!WAHtmlDocument class methodsFor: 'instance creation' stamp: 'avi 6/18/2004 18:22'!
root: anHtmlRoot
	^ self basicNew initializeWithRoot: anHtmlRoot! !

!WAHtmlDocument class methodsFor: 'instance creation' stamp: 'mb 3/30/2006 12:27'!
rootClass
	^ WAHtmlRoot! !

!WAHtmlDocument methodsFor: 'public' stamp: 'avi 7/8/2004 00:02'!
close! !

!WAHtmlDocument methodsFor: 'public' stamp: 'avi 5/18/2004 13:29'!
closeTag: aString
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'public' stamp: 'lr 10/3/2006 09:10'!
comment: aString
	"Display aString as comment in the resulting HTML document, the default implementation doesn't bother rendering comments."! !

!WAHtmlDocument methodsFor: 'initialization' stamp: 'avi 6/19/2004 18:04'!
initializeWithRoot: aRoot
	root := aRoot! !

!WAHtmlDocument methodsFor: 'public' stamp: 'avi 5/18/2004 13:28'!
openTag: aString attributes: anAttributes
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'accessing' stamp: 'avi 6/18/2004 18:24'!
root
	^ root! !

!WAHtmlDocument methodsFor: 'testing' stamp: 'mb 12/7/2006 21:48'!
shouldPrintCloseTagFor: aString
	^ (#('hr' 'br' 'input' 'img' 'link' 'col') includes: aString asString) not! !

!WAHtmlDocument methodsFor: 'public' stamp: 'pmm 4/19/2006 17:44'!
text: aString
	self subclassResponsibility ! !

WAHtmlDocument subclass: #WAHtmlStreamDocument
	instanceVariableNames: 'state stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlStreamDocument methodsFor: 'accessing' stamp: 'avi 7/8/2004 00:40'!
bodyStream
	state = #head ifTrue:
		[state := #body.
		root writeOn: stream].
	^ stream! !

!WAHtmlStreamDocument methodsFor: 'public' stamp: 'avi 7/8/2004 00:41'!
close
	self bodyStream nextPutAll: '</body></html>'! !

!WAHtmlStreamDocument methodsFor: 'public' stamp: 'avi 7/8/2004 00:39'!
closeTag: aString
	self writeCloseTag: aString on: self bodyStream! !

!WAHtmlStreamDocument methodsFor: 'initialization' stamp: 'avi 7/8/2004 00:38'!
initializeWithRoot: anHtmlRoot
	super initializeWithRoot: anHtmlRoot.
	stream := String new writeStream.
	state := #head! !

!WAHtmlStreamDocument methodsFor: 'public' stamp: 'avi 7/8/2004 00:39'!
openTag: aString attributes: anAttributes
	self writeOpenTag: aString attributes: anAttributes on: self bodyStream! !

!WAHtmlStreamDocument methodsFor: 'accessing' stamp: 'avi 7/8/2004 00:39'!
stream
	^ stream! !

!WAHtmlStreamDocument methodsFor: 'accessing' stamp: 'avi 7/8/2004 00:38'!
stream: aStream
	stream := aStream! !

!WAHtmlStreamDocument methodsFor: 'public' stamp: 'mb 3/13/2006 15:48'!
text: aString
	self bodyStream nextPutAll: aString displayString! !

!WAHtmlStreamDocument methodsFor: 'private' stamp: 'avi 5/18/2004 13:52'!
writeCloseTag: aString on: aStream
	(self shouldPrintCloseTagFor: aString)
		ifTrue: [aStream nextPutAll: '</'; nextPutAll: aString; nextPut: $>]! !

!WAHtmlStreamDocument methodsFor: 'private' stamp: 'avi 6/13/2004 01:04'!
writeOpenTag: aString attributes: anAttributes on: aStream
	aStream
		nextPut: $<;
		nextPutAll: aString.
	anAttributes ifNotNil: [anAttributes writeOn: aStream].
	(self shouldPrintCloseTagFor: aString) ifFalse: [aStream nextPutAll: ' /'].
	aStream nextPut: $>! !

WAHtmlStreamDocument subclass: #WAHtmlTestDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlTestDocument commentStamp: 'mb 3/28/2007 14:06' prior: 0!
This class is intended to be used by unit tests.
The instances of this class are created and used by WARenderCanvasForTest.
It allows the production of an html fragments that can be verified for correctness.

See subclasses of WARenderCanvasTestCase for examples of unit tests.
!

!WAHtmlTestDocument methodsFor: 'public api' stamp: 'mb 2/21/2007 12:08'!
reset
	self stream reset! !

!WAHtmlTestDocument methodsFor: 'public api' stamp: 'mb 2/21/2007 12:08'!
setStateToBody
	state := #body.! !

!WAHtmlTestDocument methodsFor: 'public api' stamp: 'mb 2/21/2007 12:08'!
setStateToHead
	state := #head.! !

WAHtmlDocument subclass: #WAPrettyPrintedDocument
	instanceVariableNames: 'html indentLevel indentCloseTags firstLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAPrettyPrintedDocument class methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
renderer: aRenderer
	^ self basicNew initializeWithRenderer: aRenderer! !

!WAPrettyPrintedDocument methodsFor: 'private' stamp: 'lr 9/6/2006 11:20'!
attribute: anAssociation
	| attr value |
	attr := anAssociation key asLowercase.
	value := anAssociation value.
	
	value = false ifFalse:
		[html space.
		html span class: (self cssClassForAttribute: attr); with:
			[html text: attr].
		html text: '='.
		html span class: 'attribute-value'; with:
			[html text: '"'.
			attr = 'href'
				ifTrue: [value ifNotNil: [html anchor url: value; with: value displayString]]
				ifFalse:
					[value = true
						ifFalse: [html text: value displayString]
						ifTrue: [html text: attr]].
			html text: '"']]! !

!WAPrettyPrintedDocument methodsFor: 'private' stamp: 'avi 6/19/2004 21:07'!
attributes: anAttributes
	anAttributes ifNotNil: [anAttributes associations do: [:ea | self attribute: ea]]! !

!WAPrettyPrintedDocument methodsFor: 'public' stamp: 'lr 10/3/2006 08:58'!
closeTag: aString
	indentLevel := indentLevel - 1.
	indentCloseTags removeLast 
		ifTrue: [ self indent ].

	(self shouldPrintCloseTagFor: aString) ifTrue:
		[html text: '</'.
		html span class: (self cssClassFor: aString); with: aString.
		html text: '>']! !

!WAPrettyPrintedDocument methodsFor: 'public' stamp: 'lr 10/3/2006 09:06'!
comment: aString
	self indent.
	html span 
		class: 'comment';
		with: [ html text: '<!!-- '; text: aString; text: ' -->' ]! !

!WAPrettyPrintedDocument methodsFor: 'testing' stamp: 'lr 10/3/2006 08:59'!
cssClassFor: aString
	^ (self isKnownTag: aString)
		ifTrue: [ 'tag-known' ]
		ifFalse: [ 'tag-unknown' ]! !

!WAPrettyPrintedDocument methodsFor: 'testing' stamp: 'lr 10/3/2006 08:59'!
cssClassForAttribute: aString
	^ (self isKnownAttribute: aString)
		ifTrue: [ 'attribute-known' ]
		ifFalse: [ 'attribute-unknown' ]! !

!WAPrettyPrintedDocument methodsFor: 'private' stamp: 'lr 11/23/2006 10:03'!
indent
	firstLine
		ifTrue: [ firstLine := false ]
		ifFalse: [ html break ].
	indentLevel timesRepeat: [ html space ]! !

!WAPrettyPrintedDocument methodsFor: 'initialization' stamp: 'lr 11/23/2006 10:02'!
initializeWithRenderer: aRenderer
	html := aRenderer.
	indentCloseTags := OrderedCollection with: false.
	indentLevel := 0.
	firstLine := true! !

!WAPrettyPrintedDocument methodsFor: 'testing' stamp: 'avi 4/2/2005 22:20'!
isKnownAttribute: aString
	^ self knownAttributes includes: aString asLowercase asSymbol! !

!WAPrettyPrintedDocument methodsFor: 'testing' stamp: 'avi 4/2/2005 22:20'!
isKnownTag: aString
	^ self knownTags includes: aString asSymbol! !

!WAPrettyPrintedDocument methodsFor: 'testing' stamp: 'avi 5/22/2004 12:40'!
knownAttributes
	^ #(abbr
accept-charset
accept
accesskey
action
align
alink
alt
archive
axis
background
bgcolor
bgproperties
border
cellpadding
cellspacing
char
charoff
charset
checked
cite
class
classid
clear
code
codebase
codetype
color
cols
colspan
compact
content
coords
data
datetime
declare
defer
dir
direction
disabled
encoding
enctype
face
for
frame
frameborder
framespacing
gutter
headers
height
href
hreflang
hspace
http-equiv
id
ismap
label
lang
leftmargin
link
longdesc
loop
lowsrc
marginheight
marginwidth
maxlength
media
method
methods
multiple
name
nohref
noresize
noshade
nowrap
object
onabort
onblur
onchange
onclick
ondblclick
onerror
onfocus
onkeydown
onkeypress
onkeyup
onload
onmousedown
onmousemove
onmouseout
onmouseover
onmouseup
onreset
onselect
onsubmit
onunload
prompt
PUBLIC
readonly
rel
rev
rows
rowspan
rules
scheme
scope
scrolling
selected
shape
size
span
src
standby
style
summary
tabindex
target
text
title
type
urn
usemap
valign
value
valuetype
version
vlink
vspace
width
wrap
xml:lang
xmlns)! !

!WAPrettyPrintedDocument methodsFor: 'testing' stamp: 'avi 5/22/2004 12:40'!
knownTags
	^ #(?xml
!!doctype
!!dt
a
abbr
acronym
address
applet
area
attach
b
base
basefont
bdo
big
blink
blockquote
body
br
button
caption
center
cite
code
col
colgroup
comment
component
dd
del
dfn
dir
div
dl
dt
em
fieldset
font
form
frame
frameset
h
h1
h2
h3
h4
h5
h6
head
hr
html
i
iframe
img
input
ins
isindex
kbd
label
legend
li
link
listing
map
menu
meta
multicol
nextid
nobr
noframes
noscript
object
ol
optgroup
option
p
param
plaintext
pre
q
s
samp
script
select
small
span
strike
strong
style
sub
sup
table
tbody
td
textarea
textflow
tfoot
th
thead
title
tr
tt
u
ul
var
wbr
xmp)! !

!WAPrettyPrintedDocument methodsFor: 'public' stamp: 'lr 1/5/2007 18:44'!
openTag: aString attributes: anAttributes
	Continuation currentDo: [ :cc |
		self indent.
		html text: '<'.
		html anchor 
			class: (self cssClassFor: aString);
			callback: [ cc invoke: [ self halt. WARenderNotification raiseSignal ] ];
			with: aString.
		self attributes: anAttributes.
		(self shouldPrintCloseTagFor: aString)
			ifFalse: [ html space; text: '/' ].
		html text: '>'.
		indentLevel := indentLevel + 1.
		indentCloseTags removeLast; addLast: true; addLast: false ]! !

!WAPrettyPrintedDocument methodsFor: 'accessing' stamp: 'ac 9/23/2005 22:08'!
root
	^ html context document root! !

!WAPrettyPrintedDocument methodsFor: 'public' stamp: 'lr 10/3/2006 08:55'!
text: aString
	html text: aString! !

WAHtmlDocument subclass: #WAProfiledDocument
	instanceVariableNames: 'tags attributes names classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAProfiledDocument methodsFor: 'public' stamp: 'lr 12/6/2006 20:43'!
closeTag: aString! !

!WAProfiledDocument methodsFor: 'initialization' stamp: 'lr 12/6/2006 21:43'!
initializeWithRoot: aRoot
	super initializeWithRoot: aRoot.
	tags := Bag new.
	attributes := Bag new.
	names := Set new.	
	classes := Set new! !

!WAProfiledDocument methodsFor: 'public' stamp: 'lr 12/6/2006 21:44'!
openTag: aString attributes: anAttributes
	tags add: aString.
	anAttributes ifNil: [ ^ self ].
	attributes addAll: anAttributes attributes keys.
	anAttributes at: 'id' ifPresent: [ :value | names add: value ].
	anAttributes at: 'class' ifPresent: [ :value | classes addAll: (value findTokens: ' ') ]! !

!WAProfiledDocument methodsFor: 'rendering' stamp: 'lr 12/6/2006 21:03'!
renderCount: aBag titled: aString on: html
	aBag isEmpty ifTrue: [ ^ self ].
	html heading level: 1; with: aString.
	html unorderedList
		list: aBag sortedCounts;
		labels: [ :each | each value displayString , ' (' , each key displayString , ')' ]! !

!WAProfiledDocument methodsFor: 'rendering' stamp: 'lr 12/6/2006 21:01'!
renderList: aCollection titled: aString on: html
	aCollection isEmpty ifTrue: [ ^ self ].
	html heading level: 1; with: aString.
	html unorderedList list: aCollection asSortedCollection! !

!WAProfiledDocument methodsFor: 'rendering' stamp: 'lr 12/6/2006 21:42'!
renderOn: html
	self renderCount: tags titled: 'Tags' on: html.
	self renderCount: attributes titled: 'Attributes' on: html.
	self renderList: names titled: 'Names' on: html.
	self renderList: classes titled: 'Classes' on: html! !

!WAProfiledDocument methodsFor: 'public' stamp: 'lr 12/6/2006 20:52'!
text: aString! !

Object subclass: #WAHtmlElement
	instanceVariableNames: 'children name attributes isClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

WAHtmlElement subclass: #WABaseElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

!WABaseElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:43'!
target: aString
	self attributeAt: 'target' put: aString! !

!WABaseElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:43'!
url: aString
	self attributeAt: 'href' put: aString! !

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:17'!
named: aString
	^ self named: aString attributes: (WAHtmlAttributes new)! !

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:17'!
named: aString attributes: anAttributes
	^ self new initializeWithName: aString attributes: anAttributes! !

!WAHtmlElement methodsFor: 'commands' stamp: 'ab 1/11/2003 13:47'!
add: anElement
	children ifNil: [children := OrderedCollection new].
	children add: anElement.! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'rjl 8/4/2006 11:36'!
attributeAt: aString
    ^attributes at: aString! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'pmm 10/11/2006 19:57'!
attributeAt: aString ifAbsent: aBlock
    ^(attributes at: aString ifAbsent: [ nil -> aBlock value ]) value
	! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'ab 5/12/2003 11:14'!
attributeAt: aString put: anObject
	attributes at: aString put: anObject! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:49'!
beClosed
	isClosed := true! !

!WAHtmlElement methodsFor: 'commands' stamp: 'ab 3/29/2003 00:10'!
childrenDo: aBlock
	children ifNotNil: [children do: aBlock]! !

!WAHtmlElement methodsFor: 'initialize-release' stamp: 'avi 5/18/2004 13:49'!
initializeWithName: aString attributes: anAttributes
	name := aString.
	attributes := anAttributes.
	isClosed := true.! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'JF 6/11/2003 14:47'!
name
	^ name asLowercase! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'pmm 9/20/2006 20:47'!
notClosed
	isClosed := false! !

!WAHtmlElement methodsFor: 'printing' stamp: 'ac 6/9/2006 12:58'!
prettyPrintHtmlOn: aStream
	self prettyPrintHtmlOn: aStream indentLevel: 0.! !

!WAHtmlElement methodsFor: 'printing' stamp: 'ac 6/9/2006 13:00'!
prettyPrintHtmlOn: aStream indentLevel: anInteger
	aStream cr.
	anInteger timesRepeat: [aStream tab].
	self printOpenTagOn: aStream.
	self childrenDo: [:ea | ea prettyPrintHtmlOn: aStream indentLevel: anInteger + 1].
	self shouldPrintCloseTag ifTrue: [self printCloseTagOn: aStream].! !

!WAHtmlElement methodsFor: 'printing' stamp: 'JF 6/11/2003 14:44'!
printCloseTagOn: aStream 
	aStream
		nextPutAll: '</';
		nextPutAll: self name;
		nextPut: $>! !

!WAHtmlElement methodsFor: 'printing' stamp: 'avi 5/22/2004 15:17'!
printHtmlOn: aStream
	self printOpenTagOn: aStream.
	self childrenDo: [:ea | ea writeOn: aStream].
	self shouldPrintCloseTag ifTrue: [self printCloseTagOn: aStream].! !

!WAHtmlElement methodsFor: 'printing' stamp: 'avi 6/19/2004 18:07'!
printOpenTagOn: aStream 
	aStream
		nextPut: $<;
		nextPutAll: self name.
	attributes ifNotNil: [attributes writeOn: aStream].
	self shouldPrintCloseTag ifFalse: [aStream nextPutAll: ' /'].
	aStream nextPut: $>! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:51'!
shouldPrintCloseTag
	^ isClosed! !

!WAHtmlElement methodsFor: 'commands' stamp: 'avi 6/19/2004 18:10'!
writeOn: aStream
	self printOpenTagOn: aStream.
	self childrenDo: [:ea | ea isString ifTrue: [aStream nextPutAll: ea] ifFalse: [ea writeOn: aStream]].
	self shouldPrintCloseTag ifTrue: [self printCloseTagOn: aStream].! !

WAHtmlElement subclass: #WAMetaElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:20'!
beLeftToRight
	self textDirection: 'LTR'! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:20'!
beRightToLeft
	self textDirection: 'RTL'! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
content: aString
	self attributeAt: 'content' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:27'!
contentType: aString
	self responseHeaderName: 'Content-Type'.
	self content: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:29'!
contentType: aConentTypeString charset: aCharsetString
	self contentType: aConentTypeString, '; charset=', aCharsetString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:18'!
language: aString
	self attributeAt: 'lang' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'mb 10/13/2006 10:12'!
redirectAfter: seconds to: aString
	self responseHeaderName: 'refresh'.
	self content: seconds displayString , ';URL=' , aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:25'!
responseHeaderName: aString
	self attributeAt: 'http-equiv' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
scheme: aString
	self attributeAt: 'scheme' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:19'!
textDirection: aString
	self attributeAt: 'dir' put: aString! !

WAHtmlElement subclass: #WARootedElement
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

WARootedElement subclass: #WALinkElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

!WALinkElement commentStamp: '<historical>' prior: 0!
This element defines a link. Unlike A, it may only appear in the HEAD section of a document, although it may appear any number of times. Although LINK has no content, it conveys relationship information that may be rendered by user agents in a variety of ways (e.g., a tool-bar with a drop-down menu of links).!

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addAll
	self addMedia: 'all'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addAural
	self addMedia: 'aural'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addBraille
	self addMedia: 'braille'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addHandheld
	self addMedia: 'handheld'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:34'!
addMedia: aString
	| media |
	media :=	(((attributes at: 'media' ifAbsent: [ '' ])
		findTokens: $,)
			collect: [ :each | each withBlanksTrimmed ])
				asSet.
	
	media add: aString.
	
	self media: (String streamContents: [ :stream |
		media
			do: [ :each | stream nextPutAll: each ]
			separatedBy: [ stream nextPutAll: ', ' ] ])
	! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addPrint
	self addMedia: 'print'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addProjection
	self addMedia: 'projection'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addScreen
	self addMedia: 'screen'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addTeletype
	self addMedia: 'tty'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addTelevision
	self addMedia: 'tv'! !

!WALinkElement methodsFor: 'relationship' stamp: 'mb 4/23/2007 14:20'!
beAlternate
	"Gives alternate representations of the current document."


	self relationship: 'alternate'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:14'!
beAlternateStylesheet
	self relationship: 'alternate stylesheet'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beAppendix
	self relationship: 'appendix'! !

!WALinkElement methodsFor: 'type' stamp: 'pmm 10/7/2006 18:34'!
beAtom
	self type: 'application/atom+xml'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beAuthor
	self relationship: 'author'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beBookmark
	self relationship: 'bookmark'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beChapter
	self relationship: 'chapter'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beClossary
	self relationship: 'lossary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beCopyright
	self relationship: 'copyright'! !

!WALinkElement methodsFor: 'type' stamp: 'pmm 10/7/2006 17:40'!
beCss
	self type: 'text/css'! !

!WALinkElement methodsFor: 'relationship' stamp: 'mb 4/23/2007 14:20'!
beFirst
	"Indicates that the current document is a part of a series, and that the first document in the series is the referenced document."


	self relationship: 'first'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:17'!
beFontDefinition
	self relationship: 'fontdef'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beHelp
	self relationship: 'help'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:10'!
beIndex
	self relationship: 'index'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beLast
	self relationship: 'last'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:58'!
beMicrosummary
	"http://wiki.mozilla.org/Microsummaries"
	self relationship: 'microsummary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'mb 4/23/2007 14:20'!
beNext
	"Indicates that the current document is a part of a series, and that the next document in the series is the referenced document."


	self relationship: 'next'! !

!WALinkElement methodsFor: 'relationship' stamp: 'mb 4/23/2007 14:20'!
bePrevious
	"Indicates that the current document is a part of a series, and that the previous document in the series is the referenced document."


	self relationship: 'previous'! !

!WALinkElement methodsFor: 'type' stamp: 'pmm 10/7/2006 18:34'!
beRss
	self type: 'application/rss+xml'! !

!WALinkElement methodsFor: 'relationship' stamp: 'mb 4/23/2007 14:20'!
beSearch
	"Gives a link to a resource that can be used to search through the current document and its related pages. "


	self relationship: 'search'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beSection
	self relationship: 'section'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:16'!
beShortcutIcon
	self relationship: 'shortcut icon'! !

!WALinkElement methodsFor: 'relationship' stamp: 'mb 4/23/2007 14:20'!
beStart
	"Refers to the first document in a collection of documents. This link type tells search engines which document is considered by the author to be the starting point of the collection."


	self relationship: 'start'! !

!WALinkElement methodsFor: 'relationship' stamp: 'mb 4/23/2007 14:20'!
beStylesheet
	"Imports a stylesheet."


	self relationship: 'stylesheet'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beSubsection
	self relationship: 'subsection'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:10'!
beTableOfContents
	self relationship: 'contents'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beTop
	self relationship: 'top'! !

!WALinkElement methodsFor: 'relationship' stamp: 'mb 4/23/2007 14:20'!
beUp
	"Provides a link to a document giving the context for the current document."


	self relationship: 'up'! !

!WALinkElement methodsFor: 'media' stamp: 'mb 4/23/2007 14:20'!
media: aString
	"This attribute specifies the intended destination medium for style information. It may be a single media descriptor or a comma-separated list. The default value for this attribute is 'screen'."


	self attributeAt: 'media' put: aString! !

!WALinkElement methodsFor: 'relationship' stamp: 'mb 4/23/2007 14:20'!
relationship: aString
	"This attribute describes the relationship from the current document to the anchor specified by the href(url) attribute. The value of this attribute is a space-separated list of link types."


	self attributeAt: 'rel' put: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 17:09'!
title: aString
	self attributeAt: 'title' put: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:10'!
url: aString
	self attributeAt: 'href' put: aString! !

!WARootedElement class methodsFor: 'instance creation' stamp: 'pmm 10/7/2006 17:49'!
named: aString root: anHtmlRoot
	^(self named: aString)
		setRoot: anHtmlRoot;
		yourself! !

!WARootedElement class methodsFor: 'instance creation' stamp: 'pmm 10/7/2006 17:48'!
root: anHtmlRoot
	^self new
		setRoot: anHtmlRoot;
		yourself! !

!WARootedElement methodsFor: 'attributes' stamp: 'pmm 10/10/2006 23:12'!
document: aDocument
	self document: aDocument mimeType: self typeOrNil! !

!WARootedElement methodsFor: 'attributes' stamp: 'pmm 10/10/2006 23:22'!
document: aDocument fileName: fileName
	self document: aDocument mimeType: self typeOrNil fileName: fileName! !

!WARootedElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 17:54'!
document: aDocument mimeType: mimeType
	self document: aDocument mimeType: mimeType fileName: nil! !

!WARootedElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 17:54'!
document: aDocument mimeType: mimeType fileName: fileName
	self url: (root context urlForDocument: aDocument mimeType: mimeType fileName: fileName)! !

!WARootedElement methodsFor: 'attributes' stamp: 'lr 10/12/2006 10:55'!
resourceUrl: aString
	self url: (root absoluteUrlForResource: aString)! !

!WARootedElement methodsFor: 'initialize-release' stamp: 'pmm 10/7/2006 17:40'!
setRoot: anHtmlRoot
	root := anHtmlRoot! !

!WARootedElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 16:53'!
type: aString
	self attributeAt: 'type' put: aString! !

!WARootedElement methodsFor: 'private' stamp: 'pmm 10/11/2006 19:54'!
typeOrNil
	^self attributeAt: 'type' ifAbsent:  [ nil ]! !

!WARootedElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:15'!
url: aString
	self subclassResponsibility ! !

WARootedElement subclass: #WAScriptElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

!WAScriptElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:05'!
beJavascript
	self type: 'text/javascript'! !

!WAScriptElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:11'!
url
	^self attributeAt: 'src' ifAbsent: [ nil ]! !

!WAScriptElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:10'!
url: aString
	self attributeAt: 'src' put: aString! !

Object subclass: #WAHtmlRoot
	instanceVariableNames: 'docType title htmlAttrs headAttrs bodyAttrs headElements scripts styles resourceBaseUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlRoot class methodsFor: 'instance creation' stamp: 'avi 6/19/2004 18:05'!
new
	^ self basicNew initialize! !

!WAHtmlRoot methodsFor: 'api' stamp: 'avi 9/11/2005 14:39'!
absoluteUrlForResource: aString
	(aString beginsWith: 'http') ifTrue: [^ aString].
	resourceBaseUrl ifNil: [^ aString].
	^ resourceBaseUrl, aString! !

!WAHtmlRoot methodsFor: 'api' stamp: 'lr 10/12/2006 08:50'!
addHeadElement: anHtmlElement
	^ headElements add: anHtmlElement! !

!WAHtmlRoot methodsFor: 'initialize-release' stamp: 'mb 2/9/2006 18:45'!
addHtmlNameSpace
	htmlAttrs
		at: 'xmlns' put: 'http://www.w3.org/1999/xhtml';
		at: 'xml:lang' put: 'en';
		at: 'lang' put: 'en'.
! !

!WAHtmlRoot methodsFor: 'initialize-release' stamp: 'pmm 10/7/2006 18:36'!
addMetaContentType
	self meta contentType: self contentType charset: self charSet
! !

!WAHtmlRoot methodsFor: 'javascript' stamp: 'mb 4/23/2007 14:20'!
addScript: aString
	"Include the script aString into the receiver."


	(scripts includes: aString) ifFalse: [scripts add: aString]! !

!WAHtmlRoot methodsFor: 'css' stamp: 'mb 4/23/2007 14:20'!
addStyle: aString
	"Include the style-sheet aString into the receiver."


	(styles includes: aString) ifFalse: [styles add: aString]! !

!WAHtmlRoot methodsFor: 'new-api' stamp: 'pmm 10/7/2006 18:44'!
base
	^self addHeadElement: (WABaseElement named: 'base')
! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 6/17/2004 15:56'!
bodyAttributes
	^ bodyAttrs! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'mb 2/9/2006 18:48'!
charSet
	^'utf-8'! !

!WAHtmlRoot methodsFor: 'api' stamp: 'pmm 10/7/2006 18:44'!
contentBase: urlString
	self base url: urlString! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'mb 3/30/2006 12:28'!
contentType
	^'text/html'! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 6/17/2004 15:53'!
docType
	^ docType! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'mb 4/23/2007 14:20'!
docType: aString
	"Set the document-type of the receiver. The table at http://www.w3.org/TR/2002/NOTE-xhtml-media-types-20020430/ summarizes the recommendation to content authors for labeling their XHTML documents:
	
Media type				XHTML 1.0 (HTML compatible)	XHTML 1.0 (other)	XHTML Basic / 1.1	XHTML+MathML
text/html				MAY							SHOULD NOT			SHOULD NOT			SHOULD NOT
application/xhtml+xml	SHOULD							SHOULD				SHOULD				SHOULD
application/xml			MAY							MAY				MAY				MAY
text/xml					MAY							MAY				MAY				MAY"


	docType := aString! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'pmm 10/19/2006 20:20'!
forIE5Do: aBlock
	self deprecatedApi.
	self if  greaterThan; orEqual; ie5; do: aBlock! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:21'!
forIE6Do: aBlock
	self deprecatedApi.
	self if ie6; do: aBlock! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:21'!
forIE7Do: aBlock
	self deprecatedApi.
	self if ie7; do: aBlock! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 6/17/2004 15:57'!
headAttributes
	^ headAttrs! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 6/17/2004 15:54'!
htmlAttributes
	^ htmlAttrs! !

!WAHtmlRoot methodsFor: 'new-api' stamp: 'pmm 10/11/2006 17:35'!
if
	^WAConditionalComment root: self
! !

!WAHtmlRoot methodsFor: 'initialize-release' stamp: 'mb 2/10/2006 11:26'!
initialize
	htmlAttrs := WAHtmlAttributes new.
	headAttrs := WAHtmlAttributes new.
	bodyAttrs := WAHtmlAttributes new.
	headElements := OrderedCollection new.
	scripts := OrderedCollection new.
	styles := OrderedCollection new.
	docType := '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'.
	title := 'Seaside'.

	self addHtmlNameSpace.
	self addMetaContentType.! !

!WAHtmlRoot methodsFor: 'new-api-convenience' stamp: 'pmm 10/10/2006 23:05'!
javascript
	^self script
		beJavascript;
		yourself! !

!WAHtmlRoot methodsFor: 'new-api' stamp: 'pmm 10/7/2006 17:51'!
link
	^self addHeadElement: (WALinkElement named: 'link' root: self)
! !

!WAHtmlRoot methodsFor: 'javascript' stamp: 'pmm 10/7/2006 18:12'!
linkToScript: url 
	"only link to script if it's not already been linked too, necessary when lists of child components try to link to dependant scripts, a google map for example"

	| fullUrl |
	fullUrl := self absoluteUrlForResource: url asString.
	headElements 
		detect: [ :each | each name = 'script' and: [ each url = fullUrl ] ]
		ifNone: [ self scriptElementWithSrc: fullUrl ]! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 09:08'!
linkToStyle: url
	self deprecatedApi.
	self stylesheet resourceUrl: url asString
! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:49'!
linkToStyle: url titled: aString
	self deprecatedApi.
	self stylesheet
		resourceUrl: url asString;
		title: aString
! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:49'!
linkToStyle: url titled: aString media: aMediaString
	self deprecatedApi.
	self stylesheet
		resourceUrl: url asString;
		title: aString;
		media: aMediaString
! !

!WAHtmlRoot methodsFor: 'new-api' stamp: 'pmm 10/7/2006 19:05'!
meta
	^self addHeadElement: ((WAMetaElement named: 'meta')
		notClosed;
		yourself)
! !

!WAHtmlRoot methodsFor: 'api' stamp: 'pmm 10/7/2006 18:41'!
redirectTo: locationString delay: aNumber
	self meta redirectAfter: aNumber to: locationString! !

!WAHtmlRoot methodsFor: 'api' stamp: 'lr 10/12/2006 08:50'!
removeHeadElement: anHtmlElement
	^ headElements remove: anHtmlElement! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 9/11/2005 14:39'!
resourceBaseUrl
	^ resourceBaseUrl! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 9/11/2005 14:38'!
resourceBaseUrl: aString
	resourceBaseUrl := aString! !

!WAHtmlRoot methodsFor: 'new-api' stamp: 'pmm 10/7/2006 18:03'!
script
	^self addHeadElement: (WAScriptElement named: 'script' root: self)
! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 09:07'!
scriptElementWithSrc: aString
	self deprecatedApi.
	^ self javascript
		url: aString;
		yourself! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:52'!
styleElementWithHref: aString
	self deprecatedApi.
	^ self removeHeadElement: (self stylesheet
		url: aString)! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'pmm 1/26/2007 22:01'!
styleElementWithHref: anUrlString titled: aTitleString
	self deprecatedApi.
	^ self removeHeadElement: (self stylesheet
		url: anUrlString;
		title: aTitleString;
		yourself)
! !

!WAHtmlRoot methodsFor: 'deprecated' stamp: 'pmm 1/26/2007 22:01'!
styleElementWithHref: anUrlString titled: aTitleString media: aMediaString
	self deprecatedApi.
	^ self removeHeadElement: (self stylesheet
		url: anUrlString;
		title: aTitleString;
		media: aMediaString;
		yourself)! !

!WAHtmlRoot methodsFor: 'new-api-convenience' stamp: 'lr 10/12/2006 08:49'!
stylesheet
    ^self link beStylesheet; beCss; notClosed; yourself! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 6/17/2004 15:53'!
title
	^ title! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 6/17/2004 15:54'!
title: aString
	title := aString! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'mb 2/10/2006 11:26'!
writeHeadOn: aStream
	aStream nextPutAll: '<title>', title, '</title>'.
	headElements do: [:ea | ea writeOn: aStream].
	styles do: [:ea | self writeStyle: ea on: aStream].
	scripts do: [:ea | self writeScript: ea on: aStream].
! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'avi 7/5/2004 11:45'!
writeOn: aStream
	aStream nextPutAll: docType.
	aStream nextPutAll: '<html'.
	htmlAttrs writeOn: aStream.
	aStream nextPutAll: '><head'.
	headAttrs writeOn: aStream.
	aStream nextPutAll: '>'.
	self writeHeadOn: aStream. 
	aStream nextPutAll: '</head><body'.
	bodyAttrs writeOn: aStream.
	aStream nextPutAll: '>'.! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 11/21/2006 20:43'!
writeScript: aString on: aStream
	aStream
		nextPutAll: '<script type="text/javascript">/*<!![CDATA[*/';
		nextPutAll: aString;
		nextPutAll: '/*]]>*/</script>'! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'avi 6/18/2004 18:37'!
writeStyle: aString on: aStream
	aStream
		nextPutAll: '<style>';
		nextPutAll: aString;
		nextPutAll: '</style>'! !

WAHtmlRoot subclass: #WARenderedHtmlRoot
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WARenderedHtmlRoot class methodsFor: 'accessing' stamp: 'avi 6/24/2004 01:21'!
context: aRenderingContext
	^ self basicNew initializeWithContext: aRenderingContext! !

!WARenderedHtmlRoot methodsFor: 'accessing' stamp: 'avi 3/27/2005 20:29'!
context
	^ context! !

!WARenderedHtmlRoot methodsFor: 'initialize-release' stamp: 'mb 9/21/2006 17:15'!
initializeWithContext: aRenderingContext
	context := aRenderingContext.
	self initialize.! !

!WARenderedHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:21'!
linkWithScript: aString
	self deprecatedApi.
	self javascript
		document: aString
! !

!WARenderedHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:51'!
linkWithStyle: aString
	self deprecatedApi.
	self stylesheet
		document: aString
! !

!WARenderedHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:51'!
linkWithStyle: aString titled: aTitleString
	self deprecatedApi.
	self stylesheet
		title: aString;
		document: aString! !

!WARenderedHtmlRoot methodsFor: 'deprecated' stamp: 'lr 10/12/2006 08:51'!
linkWithStyle: aString titled: aTitleString media: aMediaString
	self deprecatedApi.
	self stylesheet
		title: aString;
		media: aMediaString;
		document: aString
! !

!WARenderedHtmlRoot methodsFor: 'writing' stamp: 'pmm 10/11/2006 00:02'!
writeScript: aString on: aStream
	"this is ugly code, but at least you know can see that at first glance"
	| script |
	script := self javascript document: aString; yourself.
	script writeOn: aStream.
	self removeHeadElement: script ! !

!WARenderedHtmlRoot methodsFor: 'writing' stamp: 'lr 10/12/2006 08:51'!
writeStyle: aString on: aStream
	"this is ugly code, but at least you know can see that at first glance"
	| style |
	style := self stylesheet document: aString; yourself.
	style writeOn: aStream.
	self removeHeadElement: style! !

Object subclass: #WAKom
	instanceVariableNames: 'entryPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

WAKom class
	instanceVariableNames: 'port service'!

!WAKom commentStamp: 'pmm 10/14/2006 14:34' prior: 0!
I provide an adapter between Seaside and the Comanche web server. To start a new server on port 8080, evaluate

	WAKom startOn: 8080.
	
and to stop it, evaluate

	WAKom stop.

I don't work on Squeak 3.9 for non-ASCII characters.
	
The state of the service (running or stopped) is automatically restored when quitting and reopening an image.

If you want to reset the password of the config application (reachable at /seaside/config) evaluate

	WADispatcherEditor initialize.!

WAKom class
	instanceVariableNames: 'port service'!

!WAKom class methodsFor: 'service' stamp: 'avi 4/2/2005 22:18'!
createService
   Smalltalk at: #HttpService ifPresent:
       [:hs |
       ^ (hs on: port named: 'seaside') plug: self default].
   Smalltalk at: #ComancheNetService ifPresent:
       [:cns |
       ^ (cns named: 'seaside' onPort: port) module: self default].
   self error: 'Comanche is not installed.  Install Comanche from
SqueakMap and try again.'
! !

!WAKom class methodsFor: 'accessing' stamp: 'lr 2/12/2007 20:32'!
default
	^ self entryPoint: WADispatcher default! !

!WAKom class methodsFor: 'service' stamp: 'avi 11/20/2003 01:13'!
entryPoint: anEntryPoint
	^ self new entryPoint: anEntryPoint! !

!WAKom class methodsFor: 'service' stamp: 'lr 2/12/2007 20:31'!
initialize
	Smalltalk addToStartUpList: self after: AutoStart.
	Smalltalk addToShutDownList: self! !

!WAKom class methodsFor: 'service' stamp: 'avi 9/26/2003 23:52'!
pause
	service ifNotNil:
		[service unregister.
		service := nil]! !

!WAKom class methodsFor: 'accessing' stamp: 'avi 10/6/2005 21:26'!
port
	^ port! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:32'!
setDebugMode
	service setDebugMode.! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:33'!
setDeploymentMode
	service setDeploymentMode.! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:32'!
setVerboseMode
	service setVerboseMode.! !

!WAKom class methodsFor: 'service' stamp: 'avi 10/30/2005 16:40'!
shutDown
	self pause! !

!WAKom class methodsFor: 'service' stamp: 'avi 9/26/2003 23:52'!
startOn: aPort
	self stop.
	port := aPort.
	service := self createService.
	service start.
! !

!WAKom class methodsFor: 'service' stamp: 'avi 10/7/2005 16:23'!
startUp
	port := (SmalltalkImage current extractParameters at: 'PORT' ifAbsent: [port]).
	port ifNotNil: [self startOn: port asNumber]! !

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:41'!
stop
	self pause.
	port := nil.
! !

!WAKom methodsFor: 'private' stamp: 'pmm 10/14/2006 14:28'!
contentsOfResponse: aResponse
	^aResponse contents! !

!WAKom methodsFor: 'converting' stamp: 'pmm 10/14/2006 14:24'!
convertRequest: aKomRequest
	| request |
	self processMultipartFields: aKomRequest.

	request := WARequest
		method: aKomRequest method
		url: aKomRequest url unescapePercents 
		headers: aKomRequest header
		fields: (self fieldsOf: aKomRequest)
		cookies: aKomRequest cookies
		nativeRequest: aKomRequest.

	aKomRequest method = 'PUT'
		ifTrue: [request fields
					at: 'PUTData'
					put: (aKomRequest stream next: aKomRequest contentLength)].
	^ request! !

!WAKom methodsFor: 'converting' stamp: 'pmm 10/14/2006 14:30'!
convertResponse: aResponse
	| komResponse |
	aResponse ifNil: [^ HttpResponse fromString: 'Request handling aborted; reload to retry'].

	komResponse :=  HttpResponse new.

	aResponse cookies do:
		[:assoc | komResponse setCookieName: assoc key value: assoc valueWithExpiry path: assoc path].
		
	aResponse headers associationsDo: [:assoc | komResponse fieldAt: assoc key put: assoc value].
	(HttpResponse classPool at: #StatusCodes) associationsDo:
		[:assoc |
		assoc value key = aResponse status ifTrue: [komResponse status: assoc key]].
	komResponse contents: (self contentsOfResponse: aResponse).
	komResponse contentType: aResponse contentType.

	^ komResponse
! !

!WAKom methodsFor: 'accessing' stamp: 'avi 11/20/2003 01:13'!
entryPoint: anEntryPoint
	entryPoint := anEntryPoint! !

!WAKom methodsFor: 'private' stamp: 'pmm 10/14/2006 14:23'!
fieldsOf: aKomRequest
	^aKomRequest method = 'POST'
		ifTrue: [ aKomRequest postFields ]
		ifFalse: [ aKomRequest getFields ]! !

!WAKom methodsFor: 'actions' stamp: 'lr 2/12/2007 20:32'!
handleRequest: aRequest
	^ entryPoint handleRequest: aRequest! !

!WAKom methodsFor: 'actions' stamp: 'lr 2/12/2007 23:25'!
log: aRequest
	Transcript cr; show: aRequest rawUrl! !

!WAKom methodsFor: 'actions' stamp: 'lr 2/12/2007 20:33'!
process: komRequest
	|request response komResponse |
	^ WAReadWriteLock global read:
		[self log: komRequest.
		request := self convertRequest: komRequest.

		response := self handleRequest: request.
		komResponse := self convertResponse: response.

		response release.
		komResponse]! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 13:53'!
processHttp
	HttpResponse current: (self process: HttpRequest current).
	^ true! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 11:24'!
processHttpRequest: aRequest
	^ self process: aRequest! !

!WAKom methodsFor: 'actions' stamp: 'mb 4/23/2006 15:25'!
processMultipartFields: aRequest
	aRequest multipartFormFieldsDo:
		[:chunk |
		chunk fileName isEmptyOrNil ifFalse:
			[|stream file|
			stream := WriteStream on: String new.
			chunk saveToStream: stream.
			file := WAFile new
				fileName: chunk fileName;
				contents: stream contents;
				contentType: chunk contentType;
				yourself.
			aRequest postFields at: chunk fieldName put: file]].! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 14:11'!
validateForStack: anArray! !

WAKom subclass: #WAKomEncoded39
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!WAKomEncoded39 commentStamp: 'pmm 10/14/2006 14:34' prior: 0!
I have the same resposibility like WAKomEncoded except that I'm for Squeak 3.9.!

WAKomEncoded39 subclass: #WAKomEncoded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!WAKomEncoded commentStamp: 'pmm 10/14/2006 14:11' prior: 0!
I provide an adapter between Seaside and the Comanche web server with response/request conversion from UTF-8 to WideString and back in Squeak 3.8.

see WAKom!

!WAKomEncoded methodsFor: 'private' stamp: 'pmm 10/14/2006 14:36'!
fieldsOf: aKomRequest
	^(super fieldsOf: aKomRequest) associationsDo: [ :association |
		(association value isKindOf: OrderedCollection) ifTrue: [
			association value: (association value collect: [ :s |
			| multiString |	
			multiString := (MultiByteBinaryOrTextStream with: s) reset.
			multiString converter: UTF8TextConverter new.
			multiString contents] ) ] ]! !

!WAKomEncoded39 methodsFor: 'private' stamp: 'mb 11/1/2006 18:32'!
contentsOfResponse: aResponse
	| responseStream tokens type subTypes  |
	responseStream := aResponse.
	tokens := aResponse contentType findTokens: '/'.
	type := tokens first.
	subTypes := tokens second findTokens: '+'.
	(type = 'text' or: [subTypes includes: 'xml']) ifTrue: [
		responseStream := MultiByteBinaryOrTextStream on: WideString new encoding: #utf8.
		responseStream nextPutAll: aResponse contents.
		responseStream binary reset ].
	^responseStream contents readStream! !

Object subclass: #WALRUCache
	instanceVariableNames: 'table ageTable max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WALRUCache class methodsFor: 'instance creation' stamp: 'pmm 4/18/2006 20:17'!
new
	^ self basicNew initialize! !

!WALRUCache class methodsFor: 'instance creation' stamp: 'ab 7/15/2002 00:10'!
new: max
	^ self new capacity: max! !

!WALRUCache methodsFor: 'accessing' stamp: 'ab 2/15/2003 21:18'!
at: key
	^ self at: key ifAbsent: [self error: 'No entry for ', key]! !

!WALRUCache methodsFor: 'accessing' stamp: 'ab 2/15/2003 21:28'!
at: key ifAbsent: errorBlock
	|val|
	val := table at: key ifAbsent: [^ errorBlock value].
	ageTable at: val put: 0.
	^ val.! !

!WALRUCache methodsFor: 'accessing' stamp: 'ab 5/24/2003 00:37'!
at: key put: val
	|removals|
	table at: key put: val.
	ageTable at: val put: 0.
	removals := OrderedCollection new.
	ageTable associationsDo:
		[:assoc |
		assoc value > max ifTrue: [removals add: assoc key].
		assoc value: assoc value + 1].
	removals do: [:ea | self remove: ea].
	! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 7/15/2002 00:10'!
capacity: aNumber
	max := aNumber! !

!WALRUCache methodsFor: 'initialize-release' stamp: 'ab 2/18/2003 19:07'!
initialize
	max := 20.
	table := Dictionary new.
	ageTable := Dictionary new.! !

!WALRUCache methodsFor: 'testing' stamp: 'avi 1/31/2004 17:45'!
isEmpty
	^ table isEmpty! !

!WALRUCache methodsFor: 'callbacks' stamp: 'mbany 4/14/2005 12:44'!
nextKey
	|key|
	[table includesKey: (key := WAExternalID new displayString)] whileTrue.
	^ key! !

!WALRUCache methodsFor: 'removing' stamp: 'ab 7/10/2003 11:48'!
remove: anObject
	ageTable removeKey: anObject.
	table removeKey: (table keyAtValue: anObject)! !

!WALRUCache methodsFor: 'printing' stamp: 'ab 2/15/2003 21:23'!
store: anObject
	|key|
	key := self nextKey.
	self at: key put: anObject.
	^ key! !

Object subclass: #WALibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WALibrary commentStamp: '<historical>' prior: 0!
I'm the common superclass of file and string libraries.!

WALibrary subclass: #WAFileLibrary
	instanceVariableNames: ''
	classVariableNames: 'MimeTypes'
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

WAFileLibrary class
	instanceVariableNames: 'default'!

!WAFileLibrary commentStamp: '<historical>' prior: 0!
== What does FileLibrary do
It allows to serve static files directly from seaside without the need for a standalone server like Apache or to configure Kom. These files can reference each other (say a CSS references an image) and can be distrubuted the same way as normal Smalltalk code (Monticello, SqueakMap, ...).

Each file in a file library is represented by a method. The method name is created from the file name, the dot is removed and the first letter of the suffix in capitalized. This puts certain limitations to the allowed filenames. Eg. 'main.css' becomes #mainCss.

Like Script- and StyleLibraries FileLibraries can be added to an application so that they automatically include themselves in the document root. Implement #selectorsToInclude and return the selectors you whish to be added to the document root.

== How to use FileLibrary

= How to create a FileLibrary
- First create the static files and put them in some directory. From there they can reference the other files in the same directory normally with their filenames.
- Make sure you have a "Files" entry that serves your files. This is a normal entry point type that you can find in your /seaside/config application. If you don't already have one, you can create it if you select "Files" in the type field of the "add entry point" dialog. For the rest of this text we assume you chose "files" as the path.
- Create a subclass of WAFileLibrary, for the rest of this text I assume its name is MyFileLibrary.
- To add the files to your file library there are two ways.
1. Programmatically with MyFileLibrary class >> #addAllFilesIn: / #addFileNamed:. For example MyFileLibrary addAllFilesIn: '/path/to/directory/with/files' or MyFileLibrary addFileNamed: '/path/to/background.png'.
2. Via the web interface. Go to your /seaside/config application and there click configure for your "Files". Click "configure" behind MyFileLibrary. There you can add a file by uploading it (select the file, then click "Add")

Note that a "Files" can consist of several file libraries and can even have tradional script or style libraries.

= How to integrate a FileLibrary into your existing application
Files from a FileLibrary are ingetrated the same way other static files are integrated. They have a constant path that is '/seaside/<Static File Library>/<FileLibrary class name>/<filename>' so for example '/seaside/files/MyFileLibrary/background.png'. These can be conveniently generated by 'MyFileLibrary / #aSelector' where #aSelector is the name of the method representing that file. For example 'MyFileLibrary / #backgroundPng'.

== Examples:

= Including a css manually
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet 
		url: WAFileLibraryDemo / #mainCss
		
= Displaying an Image
renderContentOn: html
	html image
		url: WAFileLibraryDemo / #mainJpg!

WAFileLibrary class
	instanceVariableNames: 'default'!

WAFileLibrary subclass: #WADispatcherFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WADispatcherFiles methodsFor: 'accessing-pictures' stamp: 'mb 2/23/2007 09:42'!
floppyGif
	| xxxCache |
	xxxCache := #(nil) beMutable.
	(xxxCache at: 1) isNil ifTrue: [
		xxxCache at: 1 put: #(71 73 70 56 57 97 14 0 14 0 247 0 0 0 0 0 128 0 0 0 128 0 128 128 0 0 0 128 128 0 128 0 128 128 128 128 128 192 192 192 255 0 0 0 255 0 255 255 0 0 0 255 255 0 255 0 255 255 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 51 0 0 102 0 0 153 0 0 204 0 0 255 0 51 0 0 51 51 0 51 102 0 51 153 0 51 204 0 51 255 0 102 0 0 102 51 0 102 102 0 102 153 0 102 204 0 102 255 0 153 0 0 153 51 0 153 102 0 153 153 0 153 204 0 153 255 0 204 0 0 204 51 0 204 102 0 204 153 0 204 204 0 204 255 0 255 0 0 255 51 0 255 102 0 255 153 0 255 204 0 255 255 51 0 0 51 0 51 51 0 102 51 0 153 51 0 204 51 0 255 51 51 0 51 51 51 51 51 102 51 51 153 51 51 204 51 51 255 51 102 0 51 102 51 51 102 102 51 102 153 51 102 204 51 102 255 51 153 0 51 153 51 51 153 102 51 153 153 51 153 204 51 153 255 51 204 0 51 204 51 51 204 102 51 204 153 51 204 204 51 204 255 51 255 0 51 255 51 51 255 102 51 255 153 51 255 204 51 255 255 102 0 0 102 0 51 102 0 102 102 0 153 102 0 204 102 0 255 102 51 0 102 51 51 102 51 102 102 51 153 102 51 204 102 51 255 102 102 0 102 102 51 102 102 102 102 102 153 102 102 204 102 102 255 102 153 0 102 153 51 102 153 102 102 153 153 102 153 204 102 153 255 102 204 0 102 204 51 102 204 102 102 204 153 102 204 204 102 204 255 102 255 0 102 255 51 102 255 102 102 255 153 102 255 204 102 255 255 153 0 0 153 0 51 153 0 102 153 0 153 153 0 204 153 0 255 153 51 0 153 51 51 153 51 102 153 51 153 153 51 204 153 51 255 153 102 0 153 102 51 153 102 102 153 102 153 153 102 204 153 102 255 153 153 0 153 153 51 153 153 102 153 153 153 153 153 204 153 153 255 153 204 0 153 204 51 153 204 102 153 204 153 153 204 204 153 204 255 153 255 0 153 255 51 153 255 102 153 255 153 153 255 204 153 255 255 204 0 0 204 0 51 204 0 102 204 0 153 204 0 204 204 0 255 204 51 0 204 51 51 204 51 102 204 51 153 204 51 204 204 51 255 204 102 0 204 102 51 204 102 102 204 102 153 204 102 204 204 102 255 204 153 0 204 153 51 204 153 102 204 153 153 204 153 204 204 153 255 204 204 0 204 204 51 204 204 102 204 204 153 204 204 204 204 204 255 204 255 0 204 255 51 204 255 102 204 255 153 204 255 204 204 255 255 255 0 0 255 0 51 255 0 102 255 0 153 255 0 204 255 0 255 255 51 0 255 51 51 255 51 102 255 51 153 255 51 204 255 51 255 255 102 0 255 102 51 255 102 102 255 102 153 255 102 204 255 102 255 255 153 0 255 153 51 255 153 102 255 153 153 255 153 204 255 153 255 255 204 0 255 204 51 255 204 102 255 204 153 255 204 204 255 204 255 255 255 0 255 255 51 255 255 102 255 255 153 255 255 204 255 255 255 33 249 4 1 0 0 16 0 44 0 0 0 0 14 0 14 0 0 8 108 0 253 76 241 131 162 160 65 131 254 168 77 161 198 208 96 170 84 212 80 68 164 230 135 97 42 135 212 46 66 68 177 112 99 193 140 23 51 162 168 40 242 160 196 141 29 31 130 132 248 240 34 73 63 48 99 194 68 73 241 159 205 155 255 96 249 113 89 19 231 191 88 255 42 114 236 121 19 168 78 158 126 112 2 141 181 77 232 194 164 54 97 229 188 21 139 224 200 158 75 183 49 77 106 178 235 193 128 0 59) asByteArray ].
	^ xxxCache at: 1! !

!WADispatcherFiles methodsFor: 'accessing-styles' stamp: 'mb 2/23/2007 09:41'!
libraryEditorCss
	^'
.saveButton {
	margin: 0 1em 0 0;
	width: 12px;
}
'! !

!WADispatcherFiles methodsFor: 'accessing-styles' stamp: 'mb 2/14/2007 17:57'!
netStyleCss

	^'
/* The MIT License 
 *
 * Copyright (c) 2003 Lukas Renggli
 * Copyright (c) 2003 Software Composition Group, University of Berne
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is furnished 
 * to do so, subject to the following conditions: 
 *
 * The above copyright notice and this permission notice shall be included in all 
 * copies or substantial portions of the Software. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL 
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 
/* -- basic -- */
html, body, div {
	margin: 0;
}

img {
	border: 0px none white;
}
	
body {
    background-image: url(top.jpg);
	background-repeat: no-repeat;
	color: #222222;
	font-size: 90%;
	font-family: Verdana, Arial, Helvetica, sans-serif;
	padding-top: 100px;
	margin: 2em;
}

a, a:link, a:active, a:visited, a:focus, a:hover {
	color: #65769A;
}

a, a:link, a:visited {
	text-decoration: none;
}

a:active, a:focus, a:hover {
	text-decoration: underline;
}

h1 {
    color: #F5AE17;
	font-size: 120%;
	font-family: Verdana, Arial, Helvetica, sans-serif;
}

h2 {
    color: #F5AE17;
	font-size: 110%;
	font-family: Verdana, Arial, Helvetica, sans-serif;
}

pre {
	background-color: #eeeeff;
	border: 1px dashed #65769A;
	padding: 1em;
}

div.version {
	font-size: 70%;
}
'! !

!WADispatcherFiles methodsFor: 'accessing' stamp: 'mb 2/23/2007 09:41'!
selectorsToInclude
	^#(
		netStyleCss
		libraryEditorCss
	)! !

!WADispatcherFiles methodsFor: 'accessing-pictures' stamp: 'mb 2/14/2007 16:42'!
topJpg
	| xxxCache |
	xxxCache := #(nil) beMutable.
	(xxxCache at: 1) isNil ifTrue: [
		xxxCache at: 1 put: #(255 216 255 224 0 16 74 70 73 70 0 1 2 0 0 100 0 100 0 0 255 236 0 17 68 117 99 107 121 0 1 0 4 0 0 0 60 0 0 255 238 0 14 65 100 111 98 101 0 100 192 0 0 0 1 255 219 0 132 0 6 4 4 4 5 4 6 5 5 6 9 6 5 6 9 11 8 6 6 8 11 12 10 10 11 10 10 12 16 12 12 12 12 12 12 16 12 14 15 16 15 14 12 19 19 20 20 19 19 28 27 27 27 28 31 31 31 31 31 31 31 31 31 31 1 7 7 7 13 12 13 24 16 16 24 26 21 17 21 26 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 255 192 0 17 8 0 107 3 29 3 1 17 0 2 17 1 3 17 1 255 196 0 184 0 0 3 0 3 1 1 1 0 0 0 0 0 0 0 0 0 0 2 3 1 5 6 4 7 8 1 1 1 0 3 1 1 0 0 0 0 0 0 0 0 0 0 0 1 2 3 4 5 6 16 0 1 3 3 1 5 2 7 10 9 7 8 11 1 0 0 1 0 2 3 17 4 5 6 33 49 65 18 7 81 19 97 129 34 50 211 20 86 113 145 161 177 66 82 35 164 165 22 193 98 114 146 51 131 132 212 70 225 130 162 210 36 21 71 209 178 67 83 52 85 133 87 240 241 226 242 115 147 195 116 37 53 8 23 17 1 0 2 1 2 5 3 2 6 2 2 3 1 0 0 0 0 1 2 3 17 97 33 49 18 19 4 65 81 20 145 50 113 129 177 209 34 5 161 66 193 35 240 225 98 51 255 218 0 12 3 1 0 2 17 3 17 0 63 0 235 52 181 212 86 250 142 209 207 119 44 119 176 73 106 215 238 164 167 107 54 248 105 69 209 226 91 248 76 122 196 181 230 143 229 19 238 232 175 49 151 214 215 206 202 225 92 216 114 67 101 205 171 188 152 110 128 222 28 55 53 255 0 140 186 230 34 99 143 38 150 210 210 125 59 171 172 95 29 213 168 245 136 188 139 155 89 71 44 240 191 178 162 142 30 2 23 60 197 169 248 54 70 150 115 153 125 15 149 199 53 210 99 220 236 157 136 31 236 146 26 78 193 195 187 119 202 241 173 89 48 211 47 255 0 54 247 103 91 218 187 195 144 146 202 218 239 159 184 171 102 102 201 32 120 229 123 72 222 8 43 92 206 76 51 252 184 215 221 150 149 191 46 109 77 197 156 177 56 130 23 118 47 34 44 231 190 57 135 156 138 46 134 182 16 122 236 45 140 178 129 69 203 228 229 233 171 110 42 107 46 223 76 97 127 188 243 49 91 17 91 12 111 44 247 123 54 58 111 244 113 159 17 169 92 126 45 116 172 228 159 186 220 191 6 252 211 172 244 199 40 125 73 102 197 195 218 205 253 231 168 178 121 83 229 65 111 92 117 153 225 244 78 14 149 195 221 46 162 238 165 116 136 134 137 157 101 124 245 233 177 192 228 46 88 126 155 186 49 65 255 0 137 55 144 223 141 89 231 3 231 153 183 247 49 71 108 13 68 44 108 117 252 145 69 228 248 113 213 121 183 188 234 235 207 58 68 67 64 87 180 225 97 0 128 64 32 16 8 4 25 8 50 16 48 80 48 64 193 20 193 3 5 3 4 14 16 48 80 56 64 225 20 193 64 237 64 225 3 133 20 237 64 225 65 64 129 218 129 194 138 160 64 237 80 56 65 64 162 168 212 14 20 20 106 7 106 138 160 65 70 160 112 160 160 69 80 40 28 32 163 84 14 17 84 10 7 106 10 5 3 132 85 26 160 112 130 129 3 133 20 225 3 133 5 2 7 10 41 194 7 8 24 40 28 32 112 138 96 160 112 129 130 6 10 7 8 24 34 152 32 200 80 50 12 160 16 8 4 2 1 0 128 64 32 16 8 4 2 1 0 131 243 29 140 177 221 91 155 105 29 200 226 67 162 144 111 99 198 214 184 44 242 107 134 253 81 203 213 141 116 189 116 125 3 79 231 14 82 221 208 221 81 153 107 64 27 117 31 250 198 141 130 102 246 131 242 151 125 45 19 26 199 219 45 19 19 235 205 76 142 41 243 92 51 33 143 151 212 243 48 138 69 114 60 217 27 254 174 97 242 154 123 120 44 166 62 140 91 141 61 169 153 146 115 236 174 227 245 60 197 190 203 139 55 113 252 120 207 202 97 92 185 49 105 198 57 54 214 218 141 65 164 49 57 175 165 145 166 222 249 163 232 239 34 217 32 166 234 252 225 224 42 83 44 199 15 69 154 234 249 238 115 9 147 196 146 220 180 93 237 165 104 204 156 35 201 240 119 141 249 37 107 183 139 19 252 177 206 147 236 202 50 204 112 183 213 162 188 195 158 65 44 68 62 55 138 177 237 218 8 88 226 243 38 179 211 110 19 11 124 58 198 176 215 139 41 121 233 69 219 62 69 116 104 237 206 173 237 133 177 179 183 239 131 57 231 121 17 219 69 74 243 202 253 140 111 191 189 121 87 180 231 201 211 28 189 127 7 101 99 183 93 101 245 125 45 132 110 31 17 21 187 188 171 169 43 45 220 135 123 165 126 215 109 240 86 129 118 222 218 240 142 81 201 207 88 250 141 87 149 254 236 193 92 220 55 244 239 111 115 110 56 153 101 242 89 240 149 113 87 91 23 157 33 167 196 88 11 12 101 181 166 247 198 192 102 61 178 184 3 33 252 229 218 210 213 106 235 129 222 226 236 107 177 207 146 242 106 124 216 90 4 127 210 43 143 204 188 198 59 125 62 188 219 176 198 182 143 171 128 203 206 100 157 222 234 158 22 61 42 103 182 178 215 46 247 56 64 32 16 8 4 2 1 6 66 6 8 50 20 12 16 48 69 48 64 225 64 193 3 4 14 20 12 17 78 16 56 80 56 64 225 3 133 20 237 64 225 64 225 5 26 160 112 138 112 130 129 64 225 5 26 162 156 32 163 84 14 212 20 10 42 141 64 237 80 81 168 40 20 83 132 20 8 29 170 10 4 85 2 129 218 130 129 64 225 21 70 168 28 32 112 162 168 16 56 64 225 64 225 3 133 20 225 3 132 14 20 14 16 48 69 56 80 48 64 225 2 77 113 20 45 172 142 167 96 226 84 87 134 92 180 167 100 77 12 29 167 105 255 0 34 154 143 51 175 46 156 106 101 119 136 211 226 65 190 182 36 219 196 78 210 88 218 159 18 162 193 65 148 25 64 32 16 8 4 2 1 0 128 64 32 16 8 4 2 1 7 228 200 38 116 79 4 21 233 229 199 22 135 45 109 163 161 179 187 124 206 134 226 218 94 227 35 108 107 111 55 111 107 29 218 210 188 202 94 112 91 73 251 39 252 58 173 17 146 53 143 185 220 97 51 176 101 98 112 44 238 47 161 217 117 106 126 73 221 204 218 239 97 224 189 74 206 177 239 14 89 87 41 137 135 32 216 223 222 58 218 250 223 109 157 244 126 124 103 176 252 230 118 181 93 17 237 192 106 121 164 185 24 140 211 27 109 150 104 250 55 143 209 92 180 124 184 143 198 213 205 147 22 156 99 147 109 111 233 46 137 236 100 140 44 123 67 152 225 71 53 194 160 143 8 43 68 78 140 220 126 91 167 241 181 207 184 193 72 219 73 31 182 75 57 42 235 119 159 0 243 152 125 194 178 201 20 201 26 94 63 63 84 172 205 126 215 45 62 58 250 214 110 238 247 19 114 201 235 65 220 52 76 199 248 90 230 159 141 113 219 192 201 63 101 162 107 187 116 121 21 245 142 46 155 72 233 107 191 91 110 95 45 23 115 36 64 139 11 34 107 221 3 176 189 244 217 206 87 93 49 215 21 122 107 198 103 156 181 90 211 121 214 93 170 131 143 212 114 255 0 120 234 139 28 104 219 109 141 105 189 186 28 59 221 208 52 252 107 171 13 116 174 190 237 87 158 47 104 5 206 3 121 39 227 91 216 56 221 71 112 100 206 100 228 249 22 141 142 202 35 195 201 104 116 159 210 162 242 188 219 235 209 95 126 63 183 252 186 176 71 57 252 156 53 211 185 165 37 122 56 43 165 92 215 158 40 173 204 2 1 0 128 64 32 16 8 25 6 66 6 10 6 8 24 34 152 40 24 32 96 129 194 7 10 6 8 28 34 152 40 40 16 48 80 56 69 80 32 112 160 112 129 194 130 129 20 237 80 80 32 112 138 163 84 14 16 81 170 7 106 10 53 69 56 65 70 168 40 212 83 181 65 64 130 129 64 237 8 170 5 3 181 5 26 129 194 130 129 20 225 65 64 129 218 162 168 16 56 64 237 80 56 64 225 69 56 64 225 3 133 3 4 14 17 76 20 14 16 70 238 233 176 51 102 217 29 230 143 194 84 153 26 153 36 124 142 47 121 230 113 222 74 138 244 91 227 167 148 115 59 232 217 243 157 248 2 10 56 97 32 217 53 199 59 184 208 147 240 48 21 201 147 206 195 78 118 143 215 244 110 175 143 121 229 15 84 89 172 64 13 141 147 128 0 13 109 90 224 54 108 222 66 194 63 178 193 60 58 191 196 254 203 62 46 79 103 186 25 225 153 188 209 72 217 27 218 210 15 196 186 233 146 183 141 107 49 45 86 172 199 56 84 44 216 178 128 64 32 16 8 4 2 1 0 128 64 32 16 8 4 2 15 200 235 216 113 47 109 114 248 158 8 43 70 92 81 104 103 75 232 232 108 238 164 158 72 174 109 165 22 249 24 127 69 55 7 14 44 120 226 210 188 234 101 183 143 58 76 107 79 209 213 53 140 156 99 238 118 248 108 196 121 24 94 28 206 230 246 10 54 234 216 239 105 249 205 237 99 184 21 233 210 241 104 137 142 49 46 91 86 98 116 151 163 35 142 180 200 219 122 189 211 77 26 121 161 153 155 36 137 227 115 216 238 223 6 229 150 158 168 206 31 81 94 99 238 98 196 234 7 130 233 60 155 12 160 217 28 224 124 151 252 217 7 21 207 147 22 188 107 244 108 173 189 221 98 231 108 8 4 9 52 209 65 11 230 149 193 177 198 210 231 184 240 3 105 86 35 89 208 153 113 26 111 189 184 183 184 203 206 41 62 94 94 254 135 123 98 101 99 137 191 154 42 187 226 35 232 231 111 177 241 119 151 76 217 177 190 81 241 44 50 219 74 178 172 113 124 255 0 43 20 158 189 154 133 213 239 89 123 35 220 15 205 145 160 181 222 53 228 249 188 50 214 222 157 46 188 28 105 49 187 142 186 137 236 144 212 47 87 13 226 106 228 189 116 148 22 246 176 128 64 32 16 8 4 25 65 148 25 8 24 40 24 32 96 138 96 160 96 129 194 6 8 28 40 28 34 152 32 112 160 112 129 194 129 194 41 194 7 10 7 106 10 5 3 132 85 26 160 112 130 129 20 237 80 81 168 28 40 40 212 20 10 41 194 10 5 3 132 85 26 160 163 80 59 84 20 106 42 141 80 59 80 80 40 28 34 157 168 40 20 14 16 81 170 41 194 7 10 7 106 10 4 12 20 83 132 14 20 14 16 56 64 193 69 56 65 151 189 172 99 158 237 205 21 40 52 178 200 233 36 47 118 247 44 85 234 183 134 24 32 245 187 159 48 109 96 63 1 43 94 92 181 199 94 171 114 101 74 77 167 72 106 114 57 105 239 30 64 37 144 124 152 193 223 249 75 229 188 207 62 249 167 78 84 246 253 222 190 15 30 41 27 188 43 129 208 16 82 9 230 130 65 36 47 44 120 226 22 120 242 218 147 173 103 73 99 106 197 163 73 117 88 92 200 189 6 41 7 45 195 69 77 55 17 218 23 211 248 30 127 123 248 207 220 242 188 143 31 163 140 114 109 87 164 229 8 4 2 1 0 128 64 32 16 8 4 2 1 0 128 65 249 29 123 14 32 131 209 109 114 248 158 8 43 70 108 49 104 108 165 244 151 73 101 121 113 43 226 188 179 144 51 35 110 41 29 124 217 25 188 196 255 0 1 94 102 44 147 227 219 73 251 39 252 110 234 189 123 145 172 125 206 239 23 145 183 201 88 50 246 223 99 92 121 37 140 249 209 200 60 230 59 240 118 133 235 196 184 212 187 180 180 188 182 125 165 228 66 107 105 60 248 207 104 220 230 158 14 28 10 76 15 46 63 53 121 167 101 142 203 43 35 174 112 210 30 75 60 161 21 124 68 238 142 227 240 57 105 190 46 174 49 205 157 109 163 178 107 154 246 135 52 135 53 194 173 112 218 8 60 66 229 109 101 7 59 174 69 236 248 150 99 44 227 123 164 201 74 216 31 43 1 61 220 126 115 220 105 187 96 162 221 130 35 93 125 152 100 229 162 176 227 38 1 177 67 23 119 11 0 108 96 236 1 163 114 223 57 107 12 58 101 182 180 181 101 188 116 27 92 124 231 46 92 151 234 150 202 215 71 47 171 180 189 236 247 131 47 139 99 101 185 228 17 93 218 56 134 247 204 110 208 90 227 185 225 97 122 87 45 58 45 195 218 89 86 211 89 214 28 13 220 86 50 72 98 184 230 178 185 249 80 220 180 198 65 252 162 57 79 190 185 187 89 177 114 142 168 219 246 109 235 199 125 165 231 118 1 207 111 60 68 72 211 185 204 33 195 224 89 252 249 172 233 104 210 83 227 196 242 121 223 129 184 31 36 173 181 254 194 24 79 141 40 187 15 112 62 73 91 35 206 171 9 241 229 55 99 39 28 10 217 30 101 88 206 25 73 214 115 55 123 86 216 242 43 44 103 28 162 232 220 221 225 109 139 68 176 152 42 201 25 8 50 16 48 80 100 32 96 129 130 41 194 129 130 6 8 28 40 28 32 96 138 112 160 112 129 194 7 10 7 106 41 194 129 194 7 106 10 5 3 181 21 70 168 28 32 112 162 168 212 20 106 129 194 10 53 20 237 80 81 168 40 213 3 181 21 70 168 29 168 40 213 5 2 41 218 160 163 80 56 80 80 34 157 161 5 2 129 194 7 106 138 160 64 225 64 237 64 225 3 133 20 225 3 133 3 132 12 16 56 81 78 16 120 242 114 17 27 35 31 40 212 251 129 73 87 146 210 30 250 118 176 249 187 221 238 5 4 53 5 225 124 226 217 187 35 138 133 222 23 17 248 2 249 191 237 252 153 181 250 35 149 127 87 169 225 98 210 189 94 237 74 241 221 161 0 128 65 72 39 146 9 153 52 102 143 97 168 255 0 160 89 227 201 52 180 90 57 195 27 86 45 26 75 186 180 184 109 197 180 115 183 116 141 14 167 97 226 23 218 97 203 25 41 22 143 87 135 146 157 54 152 120 177 186 155 77 229 46 167 179 198 101 108 239 174 237 127 218 109 237 167 138 89 35 161 161 231 107 28 75 118 246 173 172 23 202 101 241 88 155 71 94 101 47 96 176 180 110 199 92 92 200 200 99 7 194 247 150 132 11 138 205 225 179 22 222 181 137 191 183 200 91 86 157 253 172 172 153 149 236 230 140 184 32 189 229 237 157 149 179 238 175 39 142 218 218 33 89 39 153 237 141 141 29 174 115 136 1 7 142 199 83 105 204 133 180 215 86 25 91 59 187 91 125 183 19 193 113 20 145 198 55 249 110 107 136 111 141 7 166 243 41 140 178 176 118 66 242 238 27 107 6 52 61 247 114 200 214 66 26 237 206 50 56 134 208 215 181 7 134 108 212 57 45 55 121 145 211 121 11 43 167 155 121 141 141 239 122 217 108 196 205 97 228 50 73 25 35 145 174 167 61 56 32 109 43 54 98 125 57 143 155 53 53 173 198 85 240 180 222 77 143 37 214 174 144 239 48 151 109 44 236 64 71 171 116 172 185 35 139 143 51 98 252 152 60 166 197 183 48 153 249 187 59 160 238 122 248 144 115 29 49 214 185 157 75 147 214 118 217 33 8 139 3 156 184 198 88 247 44 44 61 196 62 111 120 75 157 204 239 8 162 139 46 159 41 171 116 174 38 229 150 185 92 205 141 133 204 148 49 193 115 115 20 47 112 59 168 215 185 165 84 108 227 146 57 24 217 35 112 124 111 1 204 123 77 65 7 104 32 132 12 128 65 249 29 123 14 32 128 65 237 199 221 186 25 69 10 227 242 176 197 161 187 21 244 151 99 166 242 141 199 231 33 149 199 251 6 84 136 47 24 124 209 41 253 28 158 254 197 167 196 188 218 157 63 237 79 209 179 53 116 182 190 146 239 46 113 243 68 226 88 11 227 224 70 241 238 174 186 101 137 105 154 232 243 155 99 60 111 129 240 247 208 202 57 101 137 205 171 92 211 192 133 157 166 18 53 91 77 225 47 177 46 154 1 114 100 197 184 7 90 91 73 87 73 9 53 230 111 63 22 118 46 108 183 137 252 91 41 19 13 226 210 204 32 16 8 4 17 185 179 180 186 103 119 115 11 38 103 205 123 67 135 194 173 109 49 201 38 53 105 110 116 30 149 156 243 27 22 198 227 198 34 230 124 69 108 140 246 99 219 135 145 253 56 194 210 144 221 95 91 129 184 71 112 234 15 19 131 130 194 211 89 157 102 181 250 50 141 99 148 202 7 167 101 181 238 179 23 45 175 207 108 114 127 156 22 54 199 138 220 233 31 167 232 177 107 199 171 205 39 79 179 45 53 139 45 20 227 230 205 108 214 252 44 43 15 143 134 99 148 199 230 203 185 127 119 134 231 69 234 88 201 62 173 105 118 209 194 39 186 39 31 115 159 152 41 241 49 233 194 214 137 220 239 91 214 33 206 100 49 162 25 91 5 237 172 184 249 223 178 49 56 29 219 207 99 36 27 10 189 172 180 227 19 213 27 29 84 183 14 82 209 95 89 190 222 66 215 10 16 187 60 124 253 112 209 147 31 76 188 161 117 53 50 16 48 80 48 64 193 20 193 3 5 3 4 14 16 48 80 56 64 225 20 193 64 225 3 132 14 20 83 181 5 2 129 194 7 106 7 10 42 141 64 237 80 81 168 28 40 170 53 3 133 5 26 130 129 69 56 65 70 160 118 168 40 17 84 106 129 194 10 53 65 64 138 112 160 118 160 160 80 80 34 157 170 10 4 14 17 78 20 14 16 56 80 80 32 112 162 156 32 112 129 194 129 130 7 8 167 10 6 8 53 185 35 91 128 59 26 62 50 177 149 83 18 223 164 145 221 128 15 124 255 0 34 64 231 174 159 207 115 43 254 115 220 118 239 218 87 196 103 183 85 237 59 203 222 199 26 86 33 37 169 152 64 32 16 8 61 58 131 27 157 204 244 195 63 139 193 201 221 101 174 45 167 130 201 193 220 132 185 204 7 144 63 103 41 125 75 121 184 85 125 63 245 22 153 195 167 180 203 202 243 35 75 254 79 155 244 186 215 165 147 106 93 55 100 113 119 122 43 168 88 24 92 199 227 95 24 182 245 250 194 89 41 123 220 199 11 134 184 115 60 109 14 247 64 94 163 146 90 38 106 205 19 169 250 133 168 178 253 66 179 200 101 224 196 95 77 141 192 97 224 179 158 238 198 8 96 113 99 165 145 177 53 205 50 200 91 82 29 241 114 208 170 222 106 45 21 130 214 24 61 65 211 92 54 79 27 117 45 228 86 121 252 107 113 215 86 214 83 227 229 36 72 242 199 48 49 178 70 121 75 121 125 212 29 149 254 6 207 169 189 97 206 226 117 19 159 46 154 209 17 89 182 223 16 215 185 145 92 93 223 68 101 51 77 202 65 60 141 28 163 254 245 72 241 245 175 162 154 58 207 65 230 115 186 102 208 96 50 56 251 41 31 56 177 115 160 134 234 213 160 58 88 39 141 167 149 192 181 181 27 55 239 73 130 36 221 66 195 100 238 116 103 78 50 163 15 46 163 211 120 88 237 238 51 216 11 118 137 31 52 110 179 99 34 148 66 118 75 220 158 99 203 225 236 169 2 6 14 62 152 207 211 158 163 229 180 28 243 67 6 67 25 116 114 120 25 0 134 59 41 217 103 43 124 139 98 214 186 46 243 109 104 226 211 74 55 205 160 13 60 249 124 185 232 247 75 244 110 42 237 248 217 53 128 130 198 235 33 22 201 34 181 107 65 152 70 118 81 207 231 3 220 168 226 131 232 67 255 0 206 253 34 24 33 136 254 225 139 99 57 70 70 167 215 121 233 250 78 255 0 206 230 174 223 155 224 166 196 208 213 243 110 154 228 175 52 7 79 186 173 113 4 174 188 189 192 229 238 173 237 238 101 242 157 36 172 107 96 138 89 59 124 162 28 228 87 143 69 207 209 8 48 16 207 169 240 57 76 254 163 200 198 219 140 206 78 251 23 121 116 247 220 74 208 100 238 164 44 32 52 56 209 174 102 253 245 65 214 116 47 47 111 105 173 51 186 99 3 30 75 238 83 237 155 145 195 179 37 4 240 250 164 194 64 203 139 120 204 205 7 145 221 224 115 69 120 118 212 164 36 190 226 170 4 31 145 215 176 226 8 4 13 29 121 197 22 55 228 176 223 74 75 112 210 61 196 131 25 99 216 70 254 96 118 81 121 94 60 255 0 223 195 217 215 150 63 235 125 194 7 61 208 70 231 138 60 181 165 195 176 145 181 109 183 54 16 162 138 16 8 4 18 185 146 72 237 229 146 54 119 146 49 142 115 35 173 57 156 5 64 175 133 90 198 178 146 229 126 246 106 174 24 0 63 105 142 135 199 77 158 53 209 216 143 118 190 185 99 239 94 172 173 127 184 27 78 195 114 192 71 193 229 120 149 236 87 220 235 150 62 244 234 234 127 244 81 248 15 172 55 225 109 42 19 177 95 115 174 71 222 141 97 93 152 56 129 226 13 211 41 226 117 40 157 154 238 117 200 251 207 172 127 220 176 211 255 0 114 208 71 139 143 137 59 53 220 235 150 14 166 214 127 238 107 112 120 31 89 4 31 131 201 241 167 102 187 157 114 207 222 93 105 93 152 123 111 8 55 45 248 13 40 83 179 93 206 185 99 239 30 181 255 0 116 219 83 129 245 141 190 54 210 169 217 174 231 92 188 249 60 174 106 235 29 115 30 119 25 107 30 48 69 35 167 145 179 119 142 105 12 37 133 128 15 56 190 128 44 171 142 34 120 106 147 105 158 111 159 101 43 234 150 221 225 230 151 185 103 57 59 201 229 27 215 31 143 255 0 233 109 57 107 45 217 126 216 252 26 117 233 57 76 168 96 160 200 64 193 20 193 16 225 69 48 64 193 3 133 3 132 83 4 14 20 14 16 56 64 225 69 59 80 56 80 56 65 64 160 112 138 112 130 129 64 225 5 26 162 168 212 14 20 14 212 20 106 138 163 80 59 84 20 106 10 53 69 81 168 29 168 40 213 3 132 85 2 129 218 130 129 64 225 21 70 168 28 32 160 81 78 16 56 64 225 64 225 3 133 20 225 3 132 14 20 14 16 48 69 56 80 48 65 173 201 182 151 0 246 180 124 101 99 42 166 33 223 73 35 123 64 62 241 254 84 129 160 191 136 197 123 51 8 2 143 36 1 186 132 212 124 11 226 252 170 77 114 218 39 221 238 225 182 180 137 65 115 182 4 2 1 0 131 97 153 196 106 155 190 159 223 91 233 139 243 139 212 19 14 251 31 116 67 8 231 99 154 67 29 222 53 237 229 145 172 229 173 54 86 171 234 191 170 199 53 195 27 241 121 30 93 181 201 248 56 150 227 186 149 175 53 118 147 186 212 58 89 154 98 219 75 92 250 245 238 65 247 49 79 37 196 205 109 4 54 205 136 151 8 222 241 87 115 26 83 141 70 223 69 204 244 228 180 215 81 52 6 173 203 103 180 54 54 45 69 167 117 4 198 243 41 167 93 51 109 167 134 241 223 164 158 9 31 228 210 77 238 27 123 41 176 20 27 45 51 121 214 109 77 169 237 50 25 187 22 232 205 47 98 28 249 49 76 150 11 203 187 233 78 198 182 73 57 15 119 27 119 158 94 87 112 219 90 180 37 172 244 158 186 193 107 121 53 230 129 183 131 35 46 66 8 237 181 30 159 158 65 7 173 136 5 33 154 41 93 228 182 70 55 201 218 125 250 144 131 153 215 163 175 125 67 210 151 248 139 109 47 14 150 177 49 23 92 193 113 125 21 197 213 241 110 209 111 17 96 107 35 107 142 242 250 87 182 149 168 117 121 155 110 168 224 49 154 67 33 167 109 142 78 12 93 147 45 53 14 151 18 65 27 166 61 195 90 217 34 153 224 142 120 158 211 185 219 118 111 65 164 195 104 157 107 149 135 168 250 155 41 136 143 11 146 213 184 199 99 241 152 22 205 28 143 172 118 210 70 217 39 149 180 143 158 71 60 123 155 106 131 214 122 75 154 202 244 123 74 225 223 47 247 54 178 211 81 219 221 99 110 11 154 246 195 121 0 243 36 116 101 224 177 219 137 109 120 29 180 161 104 106 204 90 215 255 0 208 78 128 98 93 160 109 153 150 167 118 115 174 200 195 234 1 219 187 227 11 65 146 156 121 67 171 241 32 135 74 122 91 168 237 244 206 184 192 235 168 219 35 245 29 253 195 229 187 141 236 120 184 108 241 6 190 226 62 83 86 85 245 115 67 154 8 236 72 38 82 195 230 58 241 162 113 241 105 185 180 156 90 198 222 201 162 12 102 110 214 246 43 66 248 24 41 16 158 57 3 143 51 91 64 78 207 116 249 196 59 126 155 216 117 29 150 247 217 61 117 127 19 239 178 18 7 218 225 109 91 31 171 216 68 218 253 27 100 107 121 164 123 171 229 18 231 13 155 14 245 73 118 72 129 7 228 117 236 56 130 12 129 85 38 70 207 25 141 146 105 6 197 231 249 126 84 86 29 56 113 107 46 175 79 224 14 110 253 144 52 127 241 22 79 14 188 155 132 178 180 236 137 135 136 28 74 215 226 210 113 214 111 111 186 220 191 6 89 173 213 61 49 202 31 84 170 201 24 46 0 18 77 0 218 73 77 6 142 211 87 88 94 100 165 181 181 99 230 182 128 30 242 249 191 162 239 1 253 27 79 202 62 226 221 216 157 24 119 35 86 222 222 238 41 193 44 59 70 240 119 173 119 164 215 155 40 180 74 213 88 168 65 163 189 182 48 76 104 62 141 219 90 127 2 237 199 126 168 105 181 116 151 158 171 99 17 84 5 80 21 64 205 138 87 10 181 132 129 188 211 98 147 104 52 37 204 246 118 162 183 151 80 91 83 120 150 70 131 239 86 170 117 123 46 141 76 250 195 6 211 201 98 217 178 147 112 16 179 146 47 28 143 160 162 215 147 47 76 107 105 138 178 173 117 229 197 206 229 243 55 151 197 174 201 24 227 182 136 243 67 142 132 213 156 195 115 165 113 243 200 224 184 114 249 51 127 227 143 95 199 246 111 174 46 158 54 250 57 124 141 227 174 38 46 38 181 43 171 198 195 209 13 57 111 172 188 107 177 165 144 129 130 129 130 6 8 166 10 6 8 24 32 112 129 194 129 130 41 194 6 10 10 4 14 20 12 17 84 8 28 40 28 32 112 160 160 69 59 84 20 8 28 34 168 213 3 181 5 2 129 218 130 129 69 59 80 80 40 40 212 83 181 65 70 160 160 80 59 66 10 53 20 225 65 70 160 160 81 78 16 80 40 28 32 112 162 168 16 56 64 225 64 225 3 133 20 225 3 132 14 20 12 16 56 69 56 80 48 65 228 201 197 205 19 100 31 32 208 251 133 73 87 134 214 110 230 118 201 242 70 199 123 135 122 129 245 5 135 120 209 121 16 230 160 164 148 219 228 240 114 240 255 0 183 241 53 142 229 127 63 221 223 225 102 211 248 203 64 190 125 233 4 2 1 7 171 27 99 37 237 211 97 111 155 190 71 110 163 120 174 159 23 199 156 215 138 199 230 213 155 44 82 186 187 120 216 198 48 49 128 6 176 80 1 194 158 226 251 26 214 43 26 71 39 137 51 172 234 101 146 4 2 1 0 128 240 32 16 8 4 2 1 0 128 64 32 252 142 189 135 19 32 18 84 153 27 60 118 53 210 184 18 54 111 36 238 1 121 254 79 147 167 8 116 226 197 175 55 83 131 193 205 151 121 130 217 198 28 100 103 150 234 245 187 29 33 27 227 132 246 118 185 105 193 131 79 231 147 159 164 127 204 255 0 231 254 182 100 201 254 181 229 238 250 69 141 181 157 141 172 118 182 145 182 40 34 28 172 99 119 0 183 90 102 103 89 107 136 209 139 252 173 150 62 217 247 87 147 54 24 24 42 231 184 252 3 180 165 105 51 200 155 104 228 47 47 114 154 148 253 39 62 63 4 79 147 15 155 61 200 237 127 204 97 236 93 120 241 197 127 22 155 91 86 202 6 65 111 11 32 129 141 138 24 197 25 27 69 0 11 98 61 150 23 28 151 76 219 177 222 73 241 173 121 107 173 89 82 120 179 156 205 221 99 239 241 77 104 97 179 188 159 213 238 28 65 230 14 115 124 138 26 241 43 70 58 68 196 251 179 181 180 152 110 59 208 181 51 44 134 57 26 90 240 28 211 193 88 153 142 73 60 90 172 147 177 56 235 119 93 94 92 119 16 55 139 142 243 216 56 146 183 215 37 167 132 67 9 172 67 156 155 88 91 58 167 31 140 158 118 13 211 92 60 64 195 238 3 229 17 226 88 223 201 165 120 90 209 249 113 90 226 153 229 15 4 218 171 54 225 228 71 99 106 59 15 121 51 135 191 228 215 224 90 167 206 166 188 34 210 203 177 109 158 57 117 14 89 199 233 51 15 107 120 139 120 163 135 222 62 81 90 167 203 188 199 10 125 103 86 125 152 142 114 240 79 145 134 66 77 197 221 221 215 226 203 59 249 125 230 114 251 202 119 179 207 45 43 248 71 239 169 209 142 55 121 125 123 23 8 164 86 177 3 243 156 222 119 123 238 169 83 181 154 211 172 218 127 79 209 122 233 28 162 18 184 207 78 241 64 227 78 0 110 89 227 240 35 213 141 188 137 107 102 186 146 67 180 174 236 120 34 174 123 100 153 71 122 220 193 144 168 200 64 193 64 193 3 4 83 5 3 132 12 16 48 64 225 64 225 20 193 3 133 3 132 14 20 14 17 78 16 56 80 80 32 112 160 112 138 163 84 14 16 81 170 41 218 130 129 3 133 5 26 130 141 81 78 16 80 40 40 212 83 181 65 70 160 112 160 163 80 80 40 167 106 10 4 14 20 85 26 129 194 129 194 10 53 69 56 64 225 65 70 160 112 129 194 138 112 129 194 129 130 7 8 24 40 167 8 24 32 203 152 215 176 177 222 107 133 10 131 231 154 251 84 187 78 66 45 98 97 126 70 225 164 192 226 15 35 91 187 188 174 231 120 27 239 173 184 112 245 79 30 76 50 95 70 163 167 29 77 101 179 70 39 61 53 32 53 54 247 178 31 54 187 75 100 39 135 133 111 205 131 94 48 195 30 79 119 208 111 240 34 95 237 24 242 215 70 241 204 24 8 161 7 109 88 119 81 124 167 153 253 76 235 213 143 233 251 61 124 30 100 105 165 190 173 60 246 183 48 56 137 162 115 8 217 180 108 247 215 141 147 5 233 58 90 38 29 213 201 91 114 148 218 199 189 193 173 105 115 142 224 5 74 215 21 153 157 33 148 206 141 141 158 3 33 112 65 115 59 152 206 222 103 236 52 252 157 235 191 7 245 153 111 206 58 99 127 217 207 147 202 165 119 150 117 62 171 193 232 188 107 154 202 79 146 148 30 226 218 190 91 157 193 210 17 230 180 127 212 190 163 193 240 43 72 210 191 156 188 159 35 200 155 78 178 249 230 137 234 189 221 134 86 233 217 215 186 123 59 249 12 210 202 208 73 138 74 6 213 173 31 38 141 2 129 122 121 112 68 199 7 45 50 105 60 95 109 178 189 180 190 181 142 238 210 86 207 111 51 67 163 149 134 173 32 174 25 137 142 109 241 58 172 162 132 2 13 78 164 213 56 109 61 101 235 89 25 131 43 178 40 134 215 189 221 141 104 219 227 89 210 147 105 224 198 214 136 124 103 25 213 92 188 90 198 76 189 211 203 177 247 39 186 150 208 15 37 176 52 158 239 148 87 99 155 90 215 142 213 219 108 17 211 167 171 68 100 157 117 125 187 11 156 197 230 172 89 123 142 157 179 192 241 195 99 154 126 107 154 118 180 174 27 86 107 58 75 162 38 37 238 88 168 64 32 241 102 51 56 220 61 132 151 249 25 132 22 209 10 185 199 105 39 131 90 6 215 19 192 5 149 107 51 58 66 76 232 248 166 119 171 121 121 245 52 57 12 104 238 236 108 201 108 54 239 255 0 74 199 121 252 253 156 212 225 185 118 215 199 142 157 37 207 57 39 87 216 244 198 163 178 212 56 136 178 118 141 123 35 146 173 123 30 40 90 246 249 205 174 227 67 196 46 59 210 107 58 75 125 109 172 54 171 6 79 201 0 84 175 94 101 196 217 99 236 123 195 204 234 6 141 174 113 216 0 29 171 131 200 207 233 14 140 120 253 221 30 27 16 114 196 2 76 56 134 31 41 219 159 112 71 1 216 197 48 224 232 254 86 227 127 209 111 147 171 132 114 119 182 243 65 111 11 32 129 173 142 24 192 107 24 209 64 0 236 89 79 20 135 139 49 170 109 113 172 107 118 207 119 46 200 45 99 218 247 31 192 60 43 58 99 213 140 219 70 129 144 220 223 92 182 255 0 52 241 44 237 53 183 180 110 216 97 241 124 167 120 87 77 98 35 132 53 204 234 217 250 216 237 85 7 173 14 212 12 203 186 61 166 187 136 73 142 11 3 88 159 89 192 78 88 126 154 216 182 226 35 248 209 56 59 226 92 216 184 89 178 252 155 91 44 171 46 108 224 184 105 217 43 26 255 0 206 21 88 90 186 74 196 240 91 215 135 106 154 46 174 27 83 100 61 103 63 33 121 14 139 29 19 68 77 59 64 150 95 40 184 13 213 0 45 94 84 204 82 43 31 237 250 51 197 247 76 207 163 152 190 203 74 231 144 28 74 120 254 28 105 196 201 158 94 7 94 76 238 43 182 60 122 195 68 228 148 204 210 30 43 56 199 12 122 164 165 238 60 86 93 48 154 177 82 174 136 194 160 65 144 131 33 3 5 3 4 12 16 48 69 48 80 48 64 193 3 132 14 20 12 17 78 20 14 16 56 64 225 69 59 80 56 80 56 64 237 65 64 160 112 138 163 84 14 212 14 213 21 64 130 129 64 237 65 70 160 118 168 170 53 5 26 160 112 138 163 84 20 106 7 106 130 141 69 59 84 20 106 10 5 3 132 83 181 5 2 129 194 10 53 69 56 64 225 64 225 3 132 14 20 83 132 14 20 14 16 48 69 56 80 56 64 193 3 5 6 167 84 105 108 110 163 198 186 206 241 180 112 242 160 157 190 124 111 237 31 132 44 233 121 172 235 9 106 234 248 14 166 210 89 157 59 118 96 191 139 232 156 226 32 186 110 216 228 3 109 90 120 26 112 59 87 161 76 145 104 224 229 181 102 30 205 49 212 29 71 167 128 138 214 97 61 165 65 54 179 213 236 0 111 12 218 11 43 224 82 248 107 101 173 230 29 221 143 94 44 203 63 183 98 100 99 235 180 193 35 94 8 237 242 195 40 185 231 197 159 73 109 140 207 83 250 239 129 13 250 60 109 219 157 216 227 19 71 192 231 41 241 103 220 239 67 154 205 117 183 80 222 196 98 199 91 69 141 107 129 14 144 56 205 46 221 197 174 33 141 31 154 182 215 198 172 115 226 198 114 203 129 145 247 217 11 215 61 221 229 213 229 195 170 104 11 228 123 143 128 84 149 209 194 33 171 155 111 158 208 250 147 5 101 5 238 70 215 187 130 112 60 166 158 110 236 157 205 146 155 26 229 133 50 214 211 164 50 154 76 39 167 181 142 161 211 242 243 99 110 156 200 143 159 108 255 0 46 23 111 222 195 187 127 10 37 241 197 185 165 109 48 250 21 135 94 134 198 228 49 6 148 219 37 188 181 36 254 67 218 63 206 92 243 226 251 75 108 102 108 29 215 141 63 203 228 227 111 11 187 15 116 7 190 30 126 37 143 197 159 117 239 67 71 150 235 174 86 102 62 60 102 62 59 66 118 50 105 94 102 117 43 191 151 149 141 6 158 234 206 190 44 122 203 25 205 62 143 157 100 50 89 44 181 243 174 175 166 125 213 228 180 105 123 182 184 240 13 0 124 65 116 197 98 35 131 84 206 173 189 206 128 213 118 248 72 243 18 216 191 213 100 161 49 128 76 205 105 220 247 199 74 134 149 132 101 172 206 154 178 232 157 53 107 112 153 252 190 18 243 214 241 151 14 183 148 208 62 155 90 246 131 94 87 52 236 33 101 106 69 163 73 72 180 199 39 209 49 93 119 189 141 140 102 87 24 201 220 43 207 61 187 204 103 193 244 110 15 31 210 92 246 241 99 210 91 99 55 187 113 255 0 247 141 61 203 255 0 215 94 115 118 125 21 61 254 127 192 176 248 179 238 189 232 106 178 93 121 185 115 94 204 110 41 177 18 41 28 215 18 243 144 105 188 198 214 142 63 140 178 175 139 239 41 57 159 58 206 106 76 222 114 228 220 100 238 223 112 234 249 12 59 35 102 253 141 96 242 70 245 211 90 69 121 53 77 166 121 186 141 5 211 27 221 64 99 190 190 46 181 196 212 16 105 71 204 222 198 87 112 63 57 106 203 158 43 194 57 179 166 61 95 120 178 178 181 177 180 138 210 210 38 195 109 3 67 34 141 162 128 0 184 38 117 157 101 209 17 162 202 43 242 141 164 60 206 219 187 137 43 191 53 253 33 207 74 183 120 235 102 222 184 7 85 184 248 207 149 192 204 225 195 242 66 195 30 30 159 229 63 119 232 182 190 188 35 147 168 101 243 88 208 198 81 173 104 163 90 54 0 2 202 97 53 107 175 181 52 238 113 181 199 209 243 238 124 199 204 143 221 237 43 58 227 247 99 54 121 172 196 118 206 124 206 113 154 234 79 210 220 191 107 143 128 118 15 2 220 197 234 245 227 74 215 96 222 107 177 7 146 93 65 108 210 91 25 117 195 198 246 196 42 60 110 59 22 51 58 115 88 141 74 205 66 192 230 137 224 124 13 118 198 202 92 215 182 191 140 6 208 177 173 226 103 132 172 214 97 238 23 198 160 85 102 197 177 146 253 178 70 232 221 181 175 5 174 30 2 40 185 226 27 26 221 57 145 116 88 225 106 227 229 90 189 241 120 129 217 240 21 158 74 241 74 203 100 114 71 181 97 210 186 184 251 251 158 105 239 164 175 149 36 228 19 224 107 64 11 94 106 235 104 252 25 82 116 137 104 164 53 113 43 178 177 193 166 74 178 64 128 64 32 16 8 50 16 48 65 144 160 96 129 130 41 130 33 130 138 112 129 130 6 10 7 8 167 8 24 40 28 32 112 129 194 138 118 160 160 80 56 64 237 65 64 162 157 168 29 170 10 4 14 213 21 70 160 118 168 40 212 20 106 138 118 160 163 80 56 80 81 168 170 5 3 132 20 106 130 129 20 237 80 81 168 28 40 40 17 78 213 5 2 7 8 167 10 7 8 40 20 14 16 56 81 78 16 56 64 225 64 193 3 132 83 133 3 4 12 16 48 80 56 65 43 219 11 59 235 103 218 222 66 201 237 228 20 124 111 21 5 88 153 142 68 195 231 249 238 137 225 174 220 249 177 55 47 176 145 219 68 47 29 236 53 173 118 110 112 247 215 69 60 153 142 109 86 197 30 142 58 251 163 58 210 220 188 192 203 123 198 131 228 119 82 134 185 194 189 146 134 1 239 173 209 228 213 132 226 151 154 223 164 122 242 103 242 190 193 176 10 87 158 73 225 167 185 228 57 231 224 86 124 138 123 167 110 206 139 19 208 156 131 220 199 229 178 49 194 205 189 228 86 205 50 59 193 71 191 148 15 205 43 93 188 168 244 134 113 135 221 244 141 57 162 52 230 158 4 227 173 121 102 119 159 113 33 50 72 120 111 118 239 21 23 53 242 218 220 219 107 72 134 238 88 162 154 55 69 43 27 36 111 20 115 28 1 105 29 132 21 173 147 129 212 29 24 211 89 7 58 108 115 159 139 156 131 228 198 57 225 38 155 62 140 238 254 105 11 162 158 77 163 159 22 171 98 137 113 23 189 18 213 208 200 225 109 37 173 212 95 37 193 238 141 199 221 107 155 65 249 203 124 121 53 107 156 82 214 195 210 93 125 36 129 142 198 136 129 223 35 231 131 148 126 107 220 126 5 151 200 167 186 118 236 222 98 250 25 158 153 224 228 175 109 237 34 168 171 98 230 153 228 113 222 24 209 239 149 133 188 168 244 101 24 101 244 61 57 211 77 43 131 115 38 138 219 214 111 89 74 93 92 30 119 2 5 42 214 159 37 190 32 185 175 154 214 109 174 56 135 84 64 32 130 42 14 194 10 212 205 198 106 30 147 233 76 187 159 52 80 156 125 219 246 153 173 246 52 146 106 73 140 249 27 125 197 190 153 237 27 181 219 28 75 128 200 116 59 83 195 39 246 43 171 107 200 169 189 197 208 190 191 146 67 219 253 37 209 30 85 125 90 231 12 180 239 233 62 191 107 220 209 139 230 0 208 60 79 111 67 225 21 144 21 159 126 158 236 123 118 109 241 253 15 213 19 63 251 101 205 181 164 84 222 28 233 95 95 201 1 163 250 75 9 242 171 232 177 138 93 238 157 233 30 150 196 61 179 206 199 100 110 154 121 154 251 138 114 52 138 17 203 24 242 120 113 170 231 191 145 105 217 182 184 226 29 179 90 214 180 53 160 6 141 128 13 128 5 161 176 32 16 126 86 132 115 145 8 52 7 108 174 31 55 179 198 189 26 215 142 178 230 153 244 109 197 235 34 140 52 81 145 176 80 14 0 5 150 154 177 213 228 151 35 61 213 88 199 24 160 59 28 241 231 59 220 236 11 56 174 137 50 104 166 100 76 12 140 114 180 112 31 133 84 36 153 48 211 202 193 222 63 176 110 30 233 73 149 121 102 186 116 159 167 127 56 225 19 118 48 127 149 106 155 76 242 101 164 122 162 110 136 28 172 28 173 236 27 20 237 235 205 122 180 228 104 238 171 86 187 107 93 176 131 196 44 103 22 156 97 98 250 189 214 23 133 191 64 231 87 187 219 27 143 22 118 120 150 216 157 97 135 171 97 235 222 21 52 93 94 56 46 140 87 243 128 124 153 128 144 123 163 97 89 76 112 71 175 215 143 106 199 69 213 165 158 90 153 255 0 26 87 31 124 5 141 171 252 161 98 120 60 39 122 221 13 114 194 160 64 32 16 8 4 25 64 193 3 5 6 66 6 8 167 8 24 40 24 32 96 129 194 129 194 6 8 167 10 7 8 28 40 28 34 157 168 28 40 28 32 160 80 56 69 56 65 64 160 112 130 141 81 84 8 29 170 10 53 3 133 21 70 160 163 80 59 84 20 106 138 163 80 56 65 70 168 28 34 168 20 14 212 20 10 7 8 170 5 3 132 14 20 85 2 7 8 28 40 40 16 56 81 76 16 56 64 225 64 225 3 4 83 133 3 132 12 16 48 80 48 64 193 20 193 3 5 6 66 12 160 16 8 4 2 1 0 128 64 32 16 8 4 2 1 0 128 64 32 252 183 247 75 171 144 190 94 93 35 206 57 200 107 253 113 163 152 3 64 105 221 174 191 149 179 79 107 114 59 72 245 134 67 89 52 126 193 185 158 186 218 120 254 141 62 86 199 103 118 78 149 234 248 221 163 137 61 130 241 190 137 95 151 177 217 221 39 233 46 179 59 248 59 103 205 23 173 31 250 73 242 246 59 59 147 238 135 89 233 65 163 0 29 130 245 190 137 99 242 118 59 91 148 232 222 178 159 224 207 174 183 209 43 242 182 59 91 143 185 157 101 246 51 235 173 244 74 252 189 142 206 224 104 206 178 143 224 207 174 183 209 41 242 182 59 59 168 205 37 214 86 185 174 58 54 156 188 125 117 187 191 242 146 60 157 142 214 239 95 221 110 176 123 31 245 214 250 36 249 59 29 173 211 147 74 117 131 188 99 254 231 238 216 127 182 55 113 253 82 124 173 142 214 234 125 214 235 7 177 255 0 92 111 162 79 147 177 218 221 229 151 72 245 140 185 220 186 54 181 53 255 0 109 111 162 79 147 177 218 221 47 185 157 101 246 51 235 173 244 74 252 189 142 206 227 238 103 89 125 140 250 235 125 18 124 189 147 179 184 251 153 214 95 99 62 186 223 68 159 47 99 179 184 251 153 214 95 99 62 186 223 68 159 47 99 179 184 251 153 214 95 99 62 186 223 68 159 47 99 179 184 251 153 214 95 99 62 186 223 68 159 47 99 179 184 251 153 214 95 99 62 186 223 68 159 47 99 179 184 251 155 214 95 99 62 188 223 68 159 47 101 236 238 207 220 222 178 251 23 245 230 250 36 249 123 39 103 118 126 231 245 151 216 191 175 55 209 39 202 217 123 59 179 247 67 172 190 197 253 121 190 137 62 86 199 103 118 126 232 245 147 216 175 175 55 209 41 242 182 59 59 179 247 79 172 190 197 125 121 190 137 62 86 199 103 118 126 234 117 151 216 175 175 55 209 39 202 216 236 238 207 221 110 178 251 19 245 230 250 36 249 91 29 173 217 26 95 172 190 196 253 121 190 133 62 86 199 107 115 13 51 214 95 98 126 190 223 66 159 43 99 181 187 35 77 245 151 216 143 175 183 208 169 242 118 59 91 178 52 239 89 125 136 250 251 125 10 124 157 142 214 230 26 127 172 190 195 253 125 190 133 62 78 203 218 221 145 129 235 47 176 255 0 95 111 161 79 147 177 218 220 195 7 214 95 97 190 190 223 66 159 39 99 180 200 194 245 147 216 111 180 27 232 83 228 236 118 140 48 253 100 31 192 191 104 55 208 169 242 54 59 76 140 79 89 125 133 251 65 190 133 62 70 199 104 195 23 214 95 97 62 208 111 160 79 145 177 219 48 199 117 151 216 79 180 27 232 19 228 108 118 217 22 29 101 31 192 127 104 183 208 41 242 54 59 102 22 93 101 31 192 127 104 183 208 39 127 99 182 97 105 214 65 252 5 246 139 125 2 119 246 94 219 34 223 172 163 248 11 237 22 250 4 239 236 118 204 33 235 40 254 1 251 69 190 129 59 251 29 179 6 117 151 216 31 180 155 232 20 239 236 118 204 7 89 71 240 7 218 77 244 9 222 216 237 178 29 214 81 254 31 253 164 223 221 211 189 177 208 97 39 89 71 248 127 246 147 127 119 78 246 199 65 132 221 100 31 225 247 218 77 253 221 78 246 203 208 97 115 214 81 254 31 125 166 223 221 211 189 177 208 97 119 214 65 254 30 253 166 223 221 211 187 177 208 102 222 245 143 254 94 253 166 223 221 211 187 177 208 163 111 186 195 255 0 47 190 210 111 238 234 119 78 131 139 254 175 255 0 203 255 0 180 155 251 186 119 78 133 27 144 234 239 29 3 246 147 127 119 78 233 208 163 114 29 90 227 160 169 255 0 17 111 238 233 220 58 84 110 71 170 252 116 37 63 226 45 244 9 220 94 149 91 145 234 175 29 13 246 131 125 2 157 195 165 70 228 122 163 199 68 83 254 32 223 64 157 195 165 86 228 122 157 199 69 83 246 246 250 4 238 29 42 55 35 212 190 58 50 159 183 183 208 167 89 210 171 114 29 71 227 163 169 251 115 125 10 157 103 74 173 200 117 15 142 145 167 237 173 244 41 214 116 170 220 135 80 56 233 58 126 218 223 66 157 102 138 54 255 0 94 113 210 212 253 176 122 36 235 93 21 109 246 184 227 166 41 251 88 244 73 212 104 171 111 181 167 29 55 79 218 135 162 83 168 209 86 222 235 14 58 122 159 181 15 70 157 70 138 54 243 86 113 192 83 246 145 232 211 168 209 86 221 234 158 56 58 126 208 61 26 117 26 42 219 173 75 199 13 79 215 143 234 38 166 138 54 231 80 241 196 83 245 227 250 137 169 162 173 184 206 241 197 211 245 195 250 138 106 104 163 110 51 92 113 180 253 104 254 170 106 40 217 242 220 113 244 253 104 254 170 106 170 54 108 159 27 42 126 179 254 202 106 40 217 114 28 109 41 252 255 0 228 77 69 27 37 239 27 106 127 63 249 16 56 125 215 24 41 252 239 228 80 56 125 199 24 191 165 252 136 28 58 95 245 127 10 6 5 255 0 55 225 64 192 158 196 25 64 32 16 8 4 2 1 0 128 64 32 16 8 4 2 1 0 131 28 80 8 50 16 8 4 2 1 0 128 64 13 200 3 185 0 128 226 128 64 32 16 8 4 2 1 0 128 64 32 16 8 4 2 1 0 128 64 32 16 8 4 2 1 0 128 64 32 16 8 4 2 1 0 128 64 32 16 8 4 2 1 0 128 64 32 16 8 4 2 1 0 128 64 32 16 8 4 2 1 0 128 64 32 16 8 4 2 1 0 128 64 32 16 8 4 2 1 0 128 64 32 16 8 4 2 1 0 128 64 32 16 8 4 2 1 7 255 217) asByteArray ].
	^ xxxCache at: 1! !

!WAFileLibrary class methodsFor: 'adding-files' stamp: 'pmm 10/4/2006 20:31'!
addAllFilesIn: aPathString
	"adds all files in the directory specified by aPathString to the current file library"
	(SeasidePlatformSupport filesIn: aPathString)
		do: [ :each | self addFileAt: each ]! !

!WAFileLibrary class methodsFor: 'adding-files' stamp: 'pmm 10/5/2006 18:29'!
addFileAt: aPath
	"adds the file specified by aFilename to the current file library"
	self
		addFileAt: aPath
		contents: (SeasidePlatformSupport
			contentsOfFile: aPath
			binary: (self isBinaryAt: aPath))! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/4/2006 20:29'!
addFileAt: aPath contents: aByteArrayOrString
	self
		addFileNamed: (SeasidePlatformSupport localNameOf: aPath)
		contents: aByteArrayOrString! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/5/2006 18:37'!
addFileNamed: aFilename contents: aByteArrayOrString
	| selector |
	selector := self asSelector: aFilename.
	(self isBinary: aFilename)
		ifTrue: [ self compileBinary: aByteArrayOrString selector: selector ]
		ifFalse: [ self compileText: aByteArrayOrString selector: selector ]! !

!WAFileLibrary class methodsFor: 'vw port-squeak' stamp: 'mb 10/18/2006 11:58'!
adjustForVisualWorks
	| newSource oldSource badCode goodCode |
	badCode := 'xxxCache := #(nil).'.
	goodCode := 'xxxCache := #(nil) beMutable.'.
	self selectors do: [:selector |
		oldSource := self sourceCodeAt: selector.
		(oldSource indexOfSubCollection: badCode startingAt: 1) > 0 ifTrue:
			[newSource := oldSource copyReplaceAll: badCode with: goodCode.
			self compile: newSource classified: self methodCategory]].! !

!WAFileLibrary class methodsFor: 'private' stamp: 'mb 12/13/2006 19:12'!
asSelector: aFilename 
	| mainPart extension |
	mainPart := (aFilename copyUpToLast: $.)
				reject: [:each | each isAlphaNumeric not].
	[mainPart first isDigit]
		whileTrue: [mainPart := mainPart allButFirst].
	extension := (aFilename copyAfterLast: $.) asLowercase capitalized.
	^ (mainPart , extension) asSymbol! !

!WAFileLibrary class methodsFor: 'private' stamp: 'mb 10/17/2006 13:18'!
compileBinary: aByteArrayOrString selector: aSymbol	
	| code |
	code := SeasidePlatformSupport asMethodReturningByteArray: aByteArrayOrString named: aSymbol.
	SeasidePlatformSupport compile: code into: self classified: self methodCategory! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 2/11/2007 18:35'!
compileMimeDatabaseString
	self class
		compile:  self createMimeDatabaseString
		classified: 'accessing-defaults'! !

!WAFileLibrary class methodsFor: 'private' stamp: 'mb 10/17/2006 13:18'!
compileText: aByteArrayOrString selector: aSymbol	
	| code |
	code := String streamContents: [ :stream |
		stream nextPutAll: aSymbol; cr.
		stream tab; nextPutAll: '^ '''.
		aByteArrayOrString asString do: [ :each |
			each = $' ifTrue: [ stream nextPut: $' ].
			stream nextPut: each ].
		stream nextPutAll: '''' ].
	SeasidePlatformSupport compile: code into: self classified: self methodCategory! !

!WAFileLibrary class methodsFor: 'private' stamp: 'mb 4/23/2007 14:37'!
createMimeDatabaseString
	"Teads /etc/mime.types for mime types and creates the #defaultMimeTypes method.
	You should not execute this method. If you still do it remember to send #initialize."


	^ String
		streamContents: [:stream | 
			| database | 
			stream nextPutAll: 'defaultMimeTypes
	^ #(
'.
			database := self readMimeDatabase.
			database keysSortedSafely
				do: [:key | stream nextPut: Character tab;
						 nextPut: Character tab;
						 print: key;
						 space;
						
						print: (database at: key);
						 cr].
			stream nextPutAll: '
	)']! !

!WAFileLibrary class methodsFor: 'instance-creation' stamp: 'lr 2/18/2007 12:29'!
default
	^ default ifNil: [ default := self new ]! !

!WAFileLibrary class methodsFor: 'accessing-defaults' stamp: 'pmm 4/20/2006 20:52'!
defaultMimeType
	^ 'application/octet-stream'! !

!WAFileLibrary class methodsFor: 'accessing-defaults' stamp: 'pmm 2/11/2007 18:56'!
defaultMimeTypes
	^ #(
		'%' 'application/x-trash'
		'323' 'text/h323'
		'abw' 'application/x-abiword'
		'ai' 'application/postscript'
		'aif' 'audio/x-aiff'
		'aifc' 'audio/x-aiff'
		'aiff' 'audio/x-aiff'
		'alc' 'chemical/x-alchemy'
		'art' 'image/x-jg'
		'asc' 'text/plain'
		'asf' 'video/x-ms-asf'
		'asn' 'chemical/x-ncbi-asn1-spec'
		'aso' 'chemical/x-ncbi-asn1-binary'
		'asx' 'video/x-ms-asf'
		'au' 'audio/basic'
		'avi' 'video/x-msvideo'
		'b' 'chemical/x-molconn-Z'
		'bak' 'application/x-trash'
		'bat' 'application/x-msdos-program'
		'bcpio' 'application/x-bcpio'
		'bib' 'text/x-bibtex'
		'bin' 'application/octet-stream'
		'bmp' 'image/x-ms-bmp'
		'book' 'application/x-maker'
		'bsd' 'chemical/x-crossfire'
		'c' 'text/x-csrc'
		'c++' 'text/x-c++src'
		'c3d' 'chemical/x-chem3d'
		'cac' 'chemical/x-cache'
		'cache' 'chemical/x-cache'
		'cascii' 'chemical/x-cactvs-binary'
		'cat' 'application/vnd.ms-pki.seccat'
		'cbin' 'chemical/x-cactvs-binary'
		'cc' 'text/x-c++src'
		'cdf' 'application/x-cdf'
		'cdr' 'image/x-coreldraw'
		'cdt' 'image/x-coreldrawtemplate'
		'cdx' 'chemical/x-cdx'
		'cdy' 'application/vnd.cinderella'
		'cef' 'chemical/x-cxf'
		'cer' 'chemical/x-cerius'
		'chm' 'chemical/x-chemdraw'
		'chrt' 'application/x-kchart'
		'cif' 'chemical/x-cif'
		'class' 'application/java-vm'
		'cls' 'text/x-tex'
		'cmdf' 'chemical/x-cmdf'
		'cml' 'chemical/x-cml'
		'cod' 'application/vnd.rim.cod'
		'com' 'application/x-msdos-program'
		'cpa' 'chemical/x-compass'
		'cpio' 'application/x-cpio'
		'cpp' 'text/x-c++src'
		'cpt' 'image/x-corelphotopaint'
		'crl' 'application/x-pkcs7-crl'
		'crt' 'application/x-x509-ca-cert'
		'csf' 'chemical/x-cache-csf'
		'csh' 'text/x-csh'
		'csm' 'chemical/x-csml'
		'csml' 'chemical/x-csml'
		'css' 'text/css'
		'csv' 'text/comma-separated-values'
		'ctab' 'chemical/x-cactvs-binary'
		'ctx' 'chemical/x-ctx'
		'cu' 'application/cu-seeme'
		'cub' 'chemical/x-gaussian-cube'
		'cxf' 'chemical/x-cxf'
		'cxx' 'text/x-c++src'
		'dat' 'chemical/x-mopac-input'
		'dcr' 'application/x-director'
		'deb' 'application/x-debian-package'
		'dif' 'video/dv'
		'diff' 'text/plain'
		'dir' 'application/x-director'
		'djv' 'image/vnd.djvu'
		'djvu' 'image/vnd.djvu'
		'dl' 'video/dl'
		'dll' 'application/x-msdos-program'
		'dmg' 'application/x-apple-diskimage'
		'dms' 'application/x-dms'
		'doc' 'application/msword'
		'dot' 'application/msword'
		'dv' 'video/dv'
		'dvi' 'application/x-dvi'
		'dx' 'chemical/x-jcamp-dx'
		'dxr' 'application/x-director'
		'emb' 'chemical/x-embl-dl-nucleotide'
		'embl' 'chemical/x-embl-dl-nucleotide'
		'ent' 'chemical/x-pdb'
		'eps' 'application/postscript'
		'etx' 'text/x-setext'
		'exe' 'application/x-msdos-program'
		'ez' 'application/andrew-inset'
		'fb' 'application/x-maker'
		'fbdoc' 'application/x-maker'
		'fch' 'chemical/x-gaussian-checkpoint'
		'fchk' 'chemical/x-gaussian-checkpoint'
		'fig' 'application/x-xfig'
		'flac' 'application/x-flac'
		'fli' 'video/fli'
		'fm' 'application/x-maker'
		'frame' 'application/x-maker'
		'frm' 'application/x-maker'
		'gal' 'chemical/x-gaussian-log'
		'gam' 'chemical/x-gamess-input'
		'gamin' 'chemical/x-gamess-input'
		'gau' 'chemical/x-gaussian-input'
		'gcd' 'text/x-pcs-gcd'
		'gcf' 'application/x-graphing-calculator'
		'gcg' 'chemical/x-gcg8-sequence'
		'gen' 'chemical/x-genbank'
		'gf' 'application/x-tex-gf'
		'gif' 'image/gif'
		'gjc' 'chemical/x-gaussian-input'
		'gjf' 'chemical/x-gaussian-input'
		'gl' 'video/gl'
		'gnumeric' 'application/x-gnumeric'
		'gpt' 'chemical/x-mopac-graph'
		'gsf' 'application/x-font'
		'gsm' 'audio/x-gsm'
		'gtar' 'application/x-gtar'
		'h' 'text/x-chdr'
		'h++' 'text/x-c++hdr'
		'hdf' 'application/x-hdf'
		'hh' 'text/x-c++hdr'
		'hin' 'chemical/x-hin'
		'hpp' 'text/x-c++hdr'
		'hqx' 'application/mac-binhex40'
		'hs' 'text/x-haskell'
		'hta' 'application/hta'
		'htm' 'text/html'
		'html' 'text/html'
		'hxx' 'text/x-c++hdr'
		'ica' 'application/x-ica'
		'ice' 'x-conference/x-cooltalk'
		'ico' 'image/x-icon'
		'ics' 'text/calendar'
		'icz' 'text/calendar'
		'ief' 'image/ief'
		'iges' 'model/iges'
		'igs' 'model/iges'
		'iii' 'application/x-iphone'
		'inp' 'chemical/x-gamess-input'
		'ins' 'application/x-internet-signup'
		'iso' 'application/x-iso9660-image'
		'isp' 'application/x-internet-signup'
		'ist' 'chemical/x-isostar'
		'istr' 'chemical/x-isostar'
		'jad' 'text/vnd.sun.j2me.app-descriptor'
		'jar' 'application/java-archive'
		'java' 'text/x-java'
		'jdx' 'chemical/x-jcamp-dx'
		'jmz' 'application/x-jmol'
		'jng' 'image/x-jng'
		'jnlp' 'application/x-java-jnlp-file'
		'jpe' 'image/jpeg'
		'jpeg' 'image/jpeg'
		'jpg' 'image/jpeg'
		'js' 'application/x-javascript'
		'kar' 'audio/midi'
		'key' 'application/pgp-keys'
		'kil' 'application/x-killustrator'
		'kin' 'chemical/x-kinemage'
		'kpr' 'application/x-kpresenter'
		'kpt' 'application/x-kpresenter'
		'ksp' 'application/x-kspread'
		'kwd' 'application/x-kword'
		'kwt' 'application/x-kword'
		'latex' 'application/x-latex'
		'lha' 'application/x-lha'
		'lhs' 'text/x-literate-haskell'
		'lsf' 'video/x-la-asf'
		'lsx' 'video/x-la-asf'
		'ltx' 'text/x-tex'
		'lzh' 'application/x-lzh'
		'lzx' 'application/x-lzx'
		'm3u' 'audio/x-mpegurl'
		'm4a' 'audio/mpeg'
		'maker' 'application/x-maker'
		'man' 'application/x-troff-man'
		'mcif' 'chemical/x-mmcif'
		'mcm' 'chemical/x-macmolecule'
		'mdb' 'application/msaccess'
		'me' 'application/x-troff-me'
		'mesh' 'model/mesh'
		'mid' 'audio/midi'
		'midi' 'audio/midi'
		'mif' 'application/x-mif'
		'mm' 'application/x-freemind'
		'mmd' 'chemical/x-macromodel-input'
		'mmf' 'application/vnd.smaf'
		'mml' 'text/mathml'
		'mmod' 'chemical/x-macromodel-input'
		'mng' 'video/x-mng'
		'moc' 'text/x-moc'
		'mol' 'chemical/x-mdl-molfile'
		'mol2' 'chemical/x-mol2'
		'moo' 'chemical/x-mopac-out'
		'mop' 'chemical/x-mopac-input'
		'mopcrt' 'chemical/x-mopac-input'
		'mov' 'video/quicktime'
		'movie' 'video/x-sgi-movie'
		'mp2' 'audio/mpeg'
		'mp3' 'audio/mpeg'
		'mp4' 'video/mp4'
		'mpc' 'chemical/x-mopac-input'
		'mpe' 'video/mpeg'
		'mpeg' 'video/mpeg'
		'mpega' 'audio/mpeg'
		'mpg' 'video/mpeg'
		'mpga' 'audio/mpeg'
		'ms' 'application/x-troff-ms'
		'msh' 'model/mesh'
		'msi' 'application/x-msi'
		'mvb' 'chemical/x-mopac-vib'
		'mxu' 'video/vnd.mpegurl'
		'nb' 'application/mathematica'
		'nc' 'application/x-netcdf'
		'nwc' 'application/x-nwc'
		'o' 'application/x-object'
		'oda' 'application/oda'
		'odb' 'application/vnd.oasis.opendocument.database'
		'odc' 'application/vnd.oasis.opendocument.chart'
		'odf' 'application/vnd.oasis.opendocument.formula'
		'odg' 'application/vnd.oasis.opendocument.graphics'
		'odi' 'application/vnd.oasis.opendocument.image'
		'odm' 'application/vnd.oasis.opendocument.text-master'
		'odp' 'application/vnd.oasis.opendocument.presentation'
		'ods' 'application/vnd.oasis.opendocument.spreadsheet'
		'odt' 'application/vnd.oasis.opendocument.text'
		'ogg' 'application/ogg'
		'old' 'application/x-trash'
		'oth' 'application/vnd.oasis.opendocument.text-web'
		'oza' 'application/x-oz-application'
		'p' 'text/x-pascal'
		'p7r' 'application/x-pkcs7-certreqresp'
		'pac' 'application/x-ns-proxy-autoconfig'
		'pas' 'text/x-pascal'
		'pat' 'image/x-coreldrawpattern'
		'pbm' 'image/x-portable-bitmap'
		'pcf' 'application/x-font'
		'pcf.Z' 'application/x-font'
		'pcx' 'image/pcx'
		'pdb' 'chemical/x-pdb'
		'pdf' 'application/pdf'
		'pfa' 'application/x-font'
		'pfb' 'application/x-font'
		'pgm' 'image/x-portable-graymap'
		'pgn' 'application/x-chess-pgn'
		'pgp' 'application/pgp-signature'
		'pk' 'application/x-tex-pk'
		'pl' 'text/x-perl'
		'pls' 'audio/x-scpls'
		'pm' 'text/x-perl'
		'png' 'image/png'
		'pnm' 'image/x-portable-anymap'
		'pot' 'text/plain'
		'ppm' 'image/x-portable-pixmap'
		'pps' 'application/vnd.ms-powerpoint'
		'ppt' 'application/vnd.ms-powerpoint'
		'prf' 'application/pics-rules'
		'prt' 'chemical/x-ncbi-asn1-ascii'
		'ps' 'application/postscript'
		'psd' 'image/x-photoshop'
		'psp' 'text/x-psp'
		'py' 'text/x-python'
		'pyc' 'application/x-python-code'
		'pyo' 'application/x-python-code'
		'qt' 'video/quicktime'
		'qtl' 'application/x-quicktimeplayer'
		'ra' 'audio/x-realaudio'
		'ram' 'audio/x-pn-realaudio'
		'rar' 'application/rar'
		'ras' 'image/x-cmu-raster'
		'rd' 'chemical/x-mdl-rdfile'
		'rdf' 'application/rdf+xml'
		'rgb' 'image/x-rgb'
		'rm' 'audio/x-pn-realaudio'
		'roff' 'application/x-troff'
		'ros' 'chemical/x-rosdal'
		'rpm' 'application/x-redhat-package-manager'
		'rss' 'application/rss+xml'
		'rtf' 'text/rtf'
		'rtx' 'text/richtext'
		'rxn' 'chemical/x-mdl-rxnfile'
		'sct' 'text/scriptlet'
		'sd' 'chemical/x-mdl-sdfile'
		'sd2' 'audio/x-sd2'
		'sda' 'application/vnd.stardivision.draw'
		'sdc' 'application/vnd.stardivision.calc'
		'sdd' 'application/vnd.stardivision.impress'
		'sdf' 'chemical/x-mdl-sdfile'
		'sdp' 'application/vnd.stardivision.impress'
		'sdw' 'application/vnd.stardivision.writer'
		'ser' 'application/java-serialized-object'
		'sgf' 'application/x-go-sgf'
		'sgl' 'application/vnd.stardivision.writer-global'
		'sh' 'text/x-sh'
		'shar' 'application/x-shar'
		'shtml' 'text/html'
		'sid' 'audio/prs.sid'
		'sik' 'application/x-trash'
		'silo' 'model/mesh'
		'sis' 'application/vnd.symbian.install'
		'sit' 'application/x-stuffit'
		'skd' 'application/x-koan'
		'skm' 'application/x-koan'
		'skp' 'application/x-koan'
		'skt' 'application/x-koan'
		'smf' 'application/vnd.stardivision.math'
		'smi' 'application/smil'
		'smil' 'application/smil'
		'snd' 'audio/basic'
		'spc' 'chemical/x-galactic-spc'
		'spl' 'application/x-futuresplash'
		'src' 'application/x-wais-source'
		'stc' 'application/vnd.sun.xml.calc.template'
		'std' 'application/vnd.sun.xml.draw.template'
		'sti' 'application/vnd.sun.xml.impress.template'
		'stl' 'application/vnd.ms-pki.stl'
		'stw' 'application/vnd.sun.xml.writer.template'
		'sty' 'text/x-tex'
		'sv4cpio' 'application/x-sv4cpio'
		'sv4crc' 'application/x-sv4crc'
		'svg' 'image/svg+xml'
		'svgz' 'image/svg+xml'
		'sw' 'chemical/x-swissprot'
		'swf' 'application/x-shockwave-flash'
		'swfl' 'application/x-shockwave-flash'
		'sxc' 'application/vnd.sun.xml.calc'
		'sxd' 'application/vnd.sun.xml.draw'
		'sxg' 'application/vnd.sun.xml.writer.global'
		'sxi' 'application/vnd.sun.xml.impress'
		'sxm' 'application/vnd.sun.xml.math'
		'sxw' 'application/vnd.sun.xml.writer'
		't' 'application/x-troff'
		'tar' 'application/x-tar'
		'taz' 'application/x-gtar'
		'tcl' 'text/x-tcl'
		'tex' 'text/x-tex'
		'texi' 'application/x-texinfo'
		'texinfo' 'application/x-texinfo'
		'text' 'text/plain'
		'tgf' 'chemical/x-mdl-tgf'
		'tgz' 'application/x-gtar'
		'tif' 'image/tiff'
		'tiff' 'image/tiff'
		'tk' 'text/x-tcl'
		'tm' 'text/texmacs'
		'torrent' 'application/x-bittorrent'
		'tr' 'application/x-troff'
		'ts' 'text/texmacs'
		'tsp' 'application/dsptype'
		'tsv' 'text/tab-separated-values'
		'txt' 'text/plain'
		'udeb' 'application/x-debian-package'
		'uls' 'text/iuls'
		'ustar' 'application/x-ustar'
		'val' 'chemical/x-ncbi-asn1-binary'
		'vcd' 'application/x-cdlink'
		'vcf' 'text/x-vcard'
		'vcs' 'text/x-vcalendar'
		'vmd' 'chemical/x-vmd'
		'vms' 'chemical/x-vamas-iso14976'
		'vor' 'application/vnd.stardivision.writer'
		'vrm' 'x-world/x-vrml'
		'vrml' 'x-world/x-vrml'
		'vsd' 'application/vnd.visio'
		'wad' 'application/x-doom'
		'wav' 'audio/x-wav'
		'wax' 'audio/x-ms-wax'
		'wbmp' 'image/vnd.wap.wbmp'
		'wbxml' 'application/vnd.wap.wbxml'
		'wk' 'application/x-123'
		'wm' 'video/x-ms-wm'
		'wma' 'audio/x-ms-wma'
		'wmd' 'application/x-ms-wmd'
		'wml' 'text/vnd.wap.wml'
		'wmlc' 'application/vnd.wap.wmlc'
		'wmls' 'text/vnd.wap.wmlscript'
		'wmlsc' 'application/vnd.wap.wmlscriptc'
		'wmv' 'video/x-ms-wmv'
		'wmx' 'video/x-ms-wmx'
		'wmz' 'application/x-ms-wmz'
		'wp5' 'application/wordperfect5.1'
		'wpd' 'application/wordperfect'
		'wrl' 'x-world/x-vrml'
		'wsc' 'text/scriptlet'
		'wvx' 'video/x-ms-wvx'
		'wz' 'application/x-wingz'
		'xbm' 'image/x-xbitmap'
		'xcf' 'application/x-xcf'
		'xht' 'application/xhtml+xml'
		'xhtml' 'application/xhtml+xml'
		'xlb' 'application/vnd.ms-excel'
		'xls' 'application/vnd.ms-excel'
		'xlt' 'application/vnd.ms-excel'
		'xml' 'application/xml'
		'xpi' 'application/x-xpinstall'
		'xpm' 'image/x-xpixmap'
		'xsl' 'application/xml'
		'xtel' 'chemical/x-xtel'
		'xul' 'application/vnd.mozilla.xul+xml'
		'xwd' 'image/x-xwindowdump'
		'xyz' 'chemical/x-xyz'
		'zip' 'application/zip'
		'zmt' 'chemical/x-mopac-input'
		'~' 'application/x-trash'

	)! !

!WAFileLibrary class methodsFor: 'class initialization' stamp: 'pmm 4/20/2006 20:52'!
initialize
	"self initialize"
	MimeTypes := Dictionary new.
	1 to: self defaultMimeTypes size by: 2 do: [ :index |
		MimeTypes
			at: (self defaultMimeTypes at: index)
			put: (self defaultMimeTypes at: index + 1) ]! !

!WAFileLibrary class methodsFor: 'private' stamp: 'mb 4/7/2007 01:35'!
isBinary: aFilename 
	| contentType |
	contentType := self
				mimetypeFor: (aFilename copyAfterLast: $.).
	^ (contentType beginsWith: 'text/') not
		and: [contentType ~= 'application/x-javascript']
! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/5/2006 18:37'!
isBinaryAt: aPath
	^self isBinary: (SeasidePlatformSupport localNameOf: aPath)! !

!WAFileLibrary class methodsFor: 'private' stamp: 'mb 4/23/2007 14:20'!
methodCategory
	"the method category for uploaded files"


	^#uploaded! !

!WAFileLibrary class methodsFor: 'accessing' stamp: 'pmm 4/20/2006 20:52'!
mimetypeFor: aString
	^ self mimetypes at: aString ifAbsent: [ self defaultMimeType ]! !

!WAFileLibrary class methodsFor: 'accessing' stamp: 'pmm 4/20/2006 20:51'!
mimetypes
	^ MimeTypes! !

!WAFileLibrary class methodsFor: 'private' stamp: 'mb 4/23/2007 14:20'!
readMimeDatabase
	"reads /etc/mime.types for mime types"


	"self readMimeDatabase"
	| stream content types tokens value keys |
	stream := CrLfFileStream readOnlyFileNamed: '/etc/mime.types'.
	content := [ stream contentsOfEntireFile ]
		ensure: [ stream close ].
	types := Dictionary new.
	content linesDo: [ :each |
		(each isEmpty or: [ each first = $# ]) ifFalse: [ 
			tokens := each findTokens: String tab.
			tokens size > 1 ifTrue: [
				value := tokens first.
				keys := tokens second findTokens: ' '.
				keys do: [ :key |
					types at: key put: value ] ] ] ].
	^types! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/13/2007 18:03'!
register
	"no longer needed left in so that code can still be loaded since it is sent in class side initialize methods"! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/16/2007 16:01'!
unregister
	"no longer used"! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/16/2007 16:05'!
urlOf: aSymbol
	^self new urlOf: aSymbol! !

!WAFileLibrary methodsFor: 'actions' stamp: 'mb 4/23/2007 14:20'!
addFile: aFile
	"adds a file to the receiver
	
	aFile an instance of of WAFile"


	| contents |
	aFile isNil ifTrue: [ ^self "in case no file was selected for uploading" ].
	
	contents := (self class isBinary: aFile fileName)
		ifTrue: [ aFile contents ]
		ifFalse: [ SeasidePlatformSupport convertToSmalltalkNewlines: aFile contents ].
	self class addFileNamed: aFile fileName contents: contents! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 2/18/2007 12:27'!
asFilename: aSelector
	| dotIndex extension |
	dotIndex := self lastUpperCaseIndexIn: aSelector.
	extension := (aSelector last:  aSelector size - dotIndex + 1) asLowercase.
	^ (aSelector first: dotIndex - 1) , '.' , extension! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 2/18/2007 12:27'!
asSelector: aFilename
	^ self class asSelector: aFilename
	! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 4/22/2006 00:03'!
compileBinary: aString selector: aSymbol	
	| code |
	code := String streamContents: [ :stream |
		stream nextPutAll: aSymbol; cr.
		stream tab; nextPutAll: '^ #('.
		aString asByteArray
			do: [ :each | each printOn: stream ]
			separatedBy: [ stream space ].
		stream nextPutAll: ') asByteArray' ].
	SeasidePlatformSupport compile: code into: self class classified: aSymbol
	! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 4/22/2006 00:03'!
compileText: aString selector: aSymbol	
	| code |
	code := String streamContents: [ :stream |
		stream nextPutAll: aSymbol; cr.
		stream tab; nextPutAll: '^ '''.
		aString do: [ :each |
			each = $' ifTrue: [ stream nextPut: $' ].
			stream nextPut: each ].
		stream nextPutAll: '''' ].
	SeasidePlatformSupport compile: code into: self class classified: aSymbol
	! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'pmm 4/22/2006 00:41'!
configurationComponent
	^ WAFileLibraryEditor new
		library: self;
		yourself! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 2/22/2007 07:21'!
fileSelectors
	^ (self class selectors
		select: [ :each | self isFileSelector: each ])
		removeAllFoundIn: self nonFileSelectors;
		yourself! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 2/18/2007 12:28'!
isFileSelector: aSymbol 
	^ aSymbol isUnary and: [ (self lastUpperCaseIndexIn: aSymbol) > 1 ]! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 2/18/2007 12:28'!
lastUpperCaseIndexIn: aString
	^ aString findLast: [ :each | each isUppercase ]! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:18'!
mimetypeForFile: aFilename
	^self class mimetypeFor: (aFilename copyAfterLast: $.)! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 2/22/2007 07:17'!
nonFileSelectors
	^#(
		nonFileSelectors
		selectorsToInclude
	)! !

!WAFileLibrary methodsFor: 'actions' stamp: 'pmm 4/21/2006 23:57'!
removeFile: aFilename
	SeasidePlatformSupport
		removeSelector: (self asSelector: aFilename)
		from: self class! !

!WAFileLibrary methodsFor: 'actions' stamp: 'lr 2/18/2007 12:27'!
renameFile: oldName to: newName 
	| contents file |
	(self asSelector: oldName) = (self asSelector: newName)
		ifTrue: [ ^ nil ].
	contents := self perform: (self asSelector: oldName).
	file := WAFile new contents: contents.
	file fileName: newName.
	self addFile: file.
	self removeFile: oldName! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'mb 4/23/2007 14:20'!
selectorsToInclude
	"The files represented by the selectors this method returns will be automatically added to the html <head> if the receiver is added to the respective Seaside application.
	
	This makes only sense for CSS and JS files"


	^ #()! !

!WAFileLibrary methodsFor: 'processing' stamp: 'mb 4/23/2007 14:20'!
updateRoot: aHtmlRoot
	"Only override if you want to automatically include new types of resources. The default implementation knows how to reference CSS, JS and FavIcons into aHtmlRoot."


	self selectorsToInclude do: [ :each |
		(each endsWith: #Js)
			ifTrue: [ aHtmlRoot javascript url: (self urlOf: each) ].
		(each endsWith: #Ico)
			ifTrue: [ aHtmlRoot link beShortcutIcon; url: (self urlOf: each) ].
		(each endsWith: #Css)
			ifTrue: [ aHtmlRoot stylesheet url: (self urlOf: each) ] ]! !

WAFileLibrary subclass: #WAFileLibraryDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAFileLibraryDemo methodsFor: 'accessing' stamp: 'mb 10/17/2006 14:09'!
mainCss
	^'/* Pier

   Copyright (c) 2003-2006 Lukas Renggli
   Copyright (c) 2005-2006 Software Composition Group, University of Berne
*/

* {
	margin: 0px;
	padding: 0px;
}

body { 
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 12px;
	color: #111111;
	margin: 10px;
}

img {
	border: none; 
}

td, 
th { 
	text-align: left; 
	vertical-align: top; 
}

a {
	text-decoration: none; 
	color: #092565; 
}

a:hover {
	text-decoration: underline;
}

.broken {
    color: #aa0000;
}

.protected {
    color: #aaaaaa;
}'! !

!WAFileLibraryDemo methodsFor: 'accessing' stamp: 'pmm 4/13/2006 20:20'!
mainJpg
	^ #(255 216 255 224 0 16 74 70 73 70 0 1 1 1 0 72 0 72 0 0 255 225 0 22 69 120 105 102 0 0 77 77 0 42 0 0 0 8 0 0 0 0 0 0 255 219 0 67 0 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 255 219 0 67 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 255 192 0 17 8 0 4 2 152 3 1 34 0 2 17 1 3 17 1 255 196 0 24 0 1 0 3 1 0 0 0 0 0 0 0 0 0 0 0 0 0 1 7 9 10 255 196 0 38 16 0 2 3 0 1 1 8 3 1 0 0 0 0 0 0 0 0 1 17 81 145 7 2 6 8 9 40 49 54 116 195 65 103 129 183 255 196 0 20 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 255 196 0 20 17 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 255 218 0 12 3 1 0 2 17 3 17 0 63 0 235 191 191 103 181 250 190 7 87 216 85 254 17 73 62 9 229 249 83 230 63 181 191 230 188 74 0 26 177 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 94 137 47 225 32 0 0 0 0 0 132 253 84 145 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 140 168 241 117 73 112 55 16 66 75 204 143 100 255 0 31 173 121 108 0 44 254 226 126 215 233 248 29 63 88 0 15 255 217) asByteArray.! !

WAFileLibrary subclass: #WAStandardFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WAStandardFiles commentStamp: '<historical>' prior: 0!
A collection of standard scripts, styles, and images.
Images are hostly needed for halos.
Scripts are mostly needed for convenience and shortcuts.
Styles are mostly needed for halos and WASimpleNavigation.!

!WAStandardFiles methodsFor: 'accessing-styles' stamp: 'pmm 2/13/2007 19:18'!
basicsCss
	^ 'div.clearer {clear: both}
.option-selected {font-weight: bold}'! !

!WAStandardFiles methodsFor: 'accessing-scripts' stamp: 'pmm 2/13/2007 19:16'!
externalAnchorsJs
	^ '// See http://www.sitepoint.com/article/standards-compliant-world
function externalLinks() {
	if (!!document.getElementsByTagName) return;
	var anchors = document.getElementsByTagName("a");
	for (var i=0; i<anchors.length; i++) {
	var anchor = anchors[i];
	if (anchor.getAttribute("href") && anchor.getAttribute("rel") == "external")
		anchor.target = "_blank";
	}
}'! !

!WAStandardFiles methodsFor: 'accessing-images' stamp: 'mb 2/22/2007 10:11'!
haloDebugGif
	| xxxCache |
	xxxCache := #(nil) beMutable.
	(xxxCache at: 1) isNil ifTrue: [
		xxxCache at: 1 put: #(71 73 70 56 57 97 16 0 16 0 128 0 0 63 63 63 212 212 212 33 249 4 1 0 0 1 0 44 0 0 0 0 16 0 16 0 64 2 27 140 143 169 192 173 207 158 60 113 90 3 80 189 120 243 15 122 156 168 101 221 213 56 33 9 130 5 0 59) asByteArray ].
	^ xxxCache at: 1! !

!WAStandardFiles methodsFor: 'accessing-images' stamp: 'mb 2/22/2007 10:11'!
haloPaintGif
	| xxxCache |
	xxxCache := #(nil) beMutable.
	(xxxCache at: 1) isNil ifTrue: [
		xxxCache at: 1 put: #(71 73 70 56 57 97 16 0 16 0 128 0 0 63 63 63 212 212 212 33 249 4 1 0 0 1 0 44 0 0 0 0 16 0 16 0 64 2 31 140 143 169 0 199 26 216 131 212 200 138 211 156 153 183 12 134 209 23 54 87 231 144 148 167 66 15 39 198 71 1 0 59) asByteArray ].
	^ xxxCache at: 1! !

!WAStandardFiles methodsFor: 'accessing-images' stamp: 'mb 2/22/2007 10:11'!
haloViewGif
	| xxxCache |
	xxxCache := #(nil) beMutable.
	(xxxCache at: 1) isNil ifTrue: [
		xxxCache at: 1 put: #(71 73 70 56 57 97 16 0 16 0 128 0 0 63 63 63 212 212 212 33 249 4 1 0 0 1 0 44 0 0 0 0 16 0 16 0 64 2 33 140 143 121 96 224 223 84 120 80 218 139 17 115 147 78 73 113 217 72 150 73 21 106 77 40 50 203 6 137 230 76 7 5 0 59) asByteArray ].
	^ xxxCache at: 1! !

!WAStandardFiles methodsFor: 'accessing-styles' stamp: 'pmm 2/13/2007 19:18'!
kalseyTabsCss
	"this is from http://kalsey.com/tools/csstabs/ - would also be nice to do http://www.alistapart.com/articles/slidingdoors/"
	^ '
.kalsey .navigation-options {
	border-bottom : 1px solid #ccc;
	margin : 0;
	padding-bottom : 19px;
	padding-left : 10px;
}

.kalsey .navigation-options ul, .kalsey .navigation-options li	{
	display : inline;
	list-style-type : none;
	margin : 0;
	padding : 0;
}

	
.kalsey .navigation-options a:link, .kalsey .navigation-options a:visited	{
	background : #E8EBF0;
	border : 1px solid #ccc;
	color : #666;
	float : left;
	font-size : small;
	font-weight : normal;
	line-height : 14px;
	margin-right : 8px;
	padding : 2px 10px 2px 10px;
	text-decoration : none;
}

.kalsey .navigation-options a:link.active, .kalsey .navigation-options a:visited.active	{
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-options ul a:hover	{
	color : #f00;
}

.kalsey .navigation-options .option-selected a {
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-content {
	background : #fff;
	border : 1px solid #ccc;
	border-top : none;
	clear : both;
	margin : 0px;
	padding : 15px;
	line-height: 1.1;  /* IE6 CSS workaround - http://www.dracos.co.uk/web/css/ie6floatbug/ */
}
'! !

!WAStandardFiles methodsFor: 'accessing-scripts' stamp: 'mb 3/28/2007 16:01'!
miscJs
	^ '
	function swapDisplay(a, b) {
		var tmp = document.getElementById(a).style.display;
		document.getElementById(a).style.display = document.getElementById(b).style.display;
		document.getElementById(b).style.display = tmp;
	}

	function submitFormTriggeringCallback(formName, callbackKey, value) {
		if (value)
			{
				var ele = document.createElement("input");
				ele.type = "hidden";
				ele.name = callbackKey;
				ele.value = value;
				document.forms[formName].appendChild(ele)
			}
		submitForm(formName)
	}

	function submitForm(formName) {
		document.forms[formName].submit();
	}
	
	function chooseOther(select, hiddenId, p) {
		value = prompt(p);
		document.getElementById(hiddenId).value = value;
		select.options[select.options.length-1].text = value;
	}
	
	function enableChoice(enableID, disableID) {
		document.getElementById(enableID).disabled = false;
		document.getElementById(disableID).disabled = true;
	}

	function setFocus(elementId) {
		document.getElementById(elementId).focus();
	}

	function setSelection(elementId, start, stop) {
		var input = document.getElementById(elementId);
		input.focus();
		/* When stop parameter not supplied, all field is selected */
		if (!!start) start = 1;
		if (!!stop) stop = input.value.length + 1;
		if (typeof document.selection !!= "undefined") {
	    		/* Place selection in MS-IE */
	    		var range = document.selection.createRange();
	     	range.moveStart("character", start - 1);
	     	range.moveEnd("character", stop - start);
	 		range.select();
	  	} else if (typeof input.selectionStart !!= "undefined") {
		  	/* Place selection in Gecko browsers */
	    		input.selectionStart = start - 1;
	    		input.selectionEnd = stop - 1;
	  	} else {
	  		/* Other browsers, please feel free to implement */
			alert("unknown browser");
		}
	}

'! !

!WAStandardFiles methodsFor: 'accessing' stamp: 'pmm 2/22/2007 07:11'!
selectorsToInclude
	^#(
		basicsCss
		kalseyTabsCss
		sourceStyleCss
		
		externalAnchorsJs
		miscJs
		shortcutsJs
	)! !

!WAStandardFiles methodsFor: 'accessing-scripts' stamp: 'pmm 2/13/2007 19:16'!
shortcutsJs
	^ '

	var shortcutKeys = [];
	var shortcutElements = [];	

	function resetShortcuts() {
		shortcutKeys = [];
		shortcutElements = [];	
	}

	function addShortcut(shortcut, elementID) {
		var elem = document.getElementById(elementID);
		if ((elem.tagName == "INPUT" & (elem.type == "submit" || elem.type == "checkbox" || elem.type == "radio")) || elem.tagName == "A")
			{
			shortcutKeys[shortcutKeys.length] = shortcut;
			shortcutElements[shortcutElements.length] = elem;
			}
		else alert("Attempt to assign a shortcut (" + shortcut + ") to something that is not clickable");
	}

	function onKeyDown(event) {
		var keyname = "";
		var element;
		var nav;
		if (navigator.userAgent.indexOf("Safari") > 0)
			nav = "Safari";
		else if (navigator.product == "Gecko")
			nav = "Gecko";
		else
			nav = "IE";
		// cope with MS-IE
		if (event == null) event = window.event;
		if (event) {
			if (event.ctrlKey) keyname = keyname + "Ctrl-";
			if (event.altKey) keyname = keyname + "Alt-";
			if (event.metaKey) keyname = keyname + "Meta-";
			// cope with Netscape
			var keyCode = event.which;
			if (keyCode == null) keyCode = event.keyCode;
			if (keyCode == null) keyCode = event.charCode;
			if (keyCode !!= 0) {
				var character = String.fromCharCode(keyCode);
				character = character.toLowerCase();
				if (event.shiftKey) character = character.toUpperCase();
				// cope with special keys, designated with some logical names
				if (keyCode == 27) character = "Esc";
				if (keyCode == 8) character = "Backspace";
				if (keyCode == 9) character = "Tab";
				if (keyCode == 13) character = "Return";
				if (keyCode == 37) character = "Left";
				if (keyCode == 38) character = "Up";
				if (keyCode == 39) character = "Right";
				if (keyCode == 40) character = "Down";
				// cope with func-keys (some keys not intercepted for MS-IE)
				if ((keyCode >= 112) & (keyCode <= 123)) character = "F" + (keyCode - 112 + 1);
				for ( var x = 1 ; x <= shortcutKeys.length ; x++ ) {
					if (shortcutKeys[x-1] == keyname+character) {
						// alert("key=" + keyCode + " " + keyname + character);
						element = shortcutElements[x-1];
						if (element.tagName == "A" & nav !!= "IE") {
							if (element.onclick) 
								element.onclick.call();
							else
								/* This does not work for anchor in IE */
								location.href = element.href;
						} else  {
							element.click();
						}
					}
				}
				return false;
			}
		}
	}

'! !

!WAStandardFiles methodsFor: 'accessing-styles' stamp: 'pmm 2/13/2007 19:19'!
sourceStyleCss
	^'.halo .halo-source .tag-known {
	font-weight: bold;
	color: navy;
}
.halo .halo-source .attribute-known {
	color: navy;
}
.halo .halo-source .attribute-value {
	color: purple;
}
.halo-source .comment {
	font-style: italic;
	color: green;
}'! !

!WAStandardFiles methodsFor: 'processing' stamp: 'mb 2/20/2007 01:01'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot bodyAttributes
		at: 'onkeydown'
		put: 'onKeyDown(event)'	
	! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:25'!
asFilename: aFilename
	self subclassResponsibility! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:25'!
asSelector: aFilename
	self subclassResponsibility! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:18'!
documentAt: aFilename ifAbsent: aBlock
	| selector |
	selector := self asSelector: aFilename.
	^(self fileSelectors includes: selector)
		ifTrue: [ WAResponse
			document: (self documentForFile: aFilename)
			mimeType: (self mimetypeForFile: aFilename) ]
		ifFalse: [ aBlock value ]
! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:17'!
documentForFile: aFilename
	^self perform: (self asSelector: aFilename)! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:25'!
fileSelectors
	self subclassResponsibility! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:20'!
filenames
	^ self fileSelectors collect: [ :each | self asFilename: each ]! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:24'!
mimetypeForFile: aFilename
	self subclassResponsibility! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:21'!
name
	^ self class name! !

!WALibrary methodsFor: 'processing' stamp: 'mb 2/23/2007 10:29'!
updateRoot: anHtmlRoot! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/22/2007 16:03'!
urlForFile: aFilename
	^ self urlOf: (self asSelector: aFilename)! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/22/2007 16:03'!
urlOf: aSymbol
	^ self urlOf: aSymbol using: WAFileHandler default! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/22/2007 16:03'!
urlOf: aSymbol using: aHandler
	^ aHandler baseUrl
		addToPath: self className;
		addToPath: (self asFilename: aSymbol);
		yourself! !

WALibrary subclass: #WAStringLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

WAStringLibrary class
	instanceVariableNames: 'default'!

!WAStringLibrary commentStamp: '<historical>' prior: 0!
Deprecated, pleas use WAFileLibrary instead.!

WAStringLibrary class
	instanceVariableNames: 'default'!

WAStringLibrary subclass: #WAScriptLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WAScriptLibrary commentStamp: '<historical>' prior: 0!
Deprecated, pleas use WAFileLibrary instead.!

!WAScriptLibrary methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:31'!
extension
	^ '.js'! !

!WAScriptLibrary methodsFor: 'accessing' stamp: 'lr 11/21/2006 20:43'!
mimetype
	^ 'text/javascript'! !

!WAScriptLibrary methodsFor: 'processing' stamp: 'lr 2/18/2007 12:30'!
updateRoot: anHtmlRoot
	self do: [ :each | anHtmlRoot addScript: each ]! !

WAScriptLibrary subclass: #WAStandardScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WAStandardScripts commentStamp: '<historical>' prior: 0!
Deprecated, replaced by WAStandardFiles.!

!WAStandardScripts methodsFor: 'scripts' stamp: 'lr 12/28/2006 21:38'!
externalAnchors
	^ '// See http://www.sitepoint.com/article/standards-compliant-world
function externalLinks() {
	if (!!document.getElementsByTagName) return;
	var anchors = document.getElementsByTagName("a");
	for (var i=0; i<anchors.length; i++) {
	var anchor = anchors[i];
	if (anchor.getAttribute("href") && anchor.getAttribute("rel") == "external")
		anchor.target = "_blank";
	}
}'! !

!WAStandardScripts methodsFor: 'scripts' stamp: 'mb 3/28/2007 16:00'!
misc
	^ '
	function swapDisplay(a, b) {
		var tmp = document.getElementById(a).style.display;
		document.getElementById(a).style.display = document.getElementById(b).style.display;
		document.getElementById(b).style.display = tmp;
	}

	function submitFormTriggeringCallback(formName, callbackKey, value) {
		if (value)
			{
				var ele = document.createElement("input");
				ele.type = "hidden";
				ele.name = callbackKey;
				ele.value = value;
				document.forms[formName].appendChild(ele)
			}
		submitForm(formName)
	}

	function submitForm(formName) {
		document.forms[formName].submit();
	}
	
	function chooseOther(select, hiddenId, p) {
		value = prompt(p);
		document.getElementById(hiddenId).value = value;
		select.options[select.options.length-1].text = value;
	}
	
	function enableChoice(enableID, disableID) {
		document.getElementById(enableID).disabled = false;
		document.getElementById(disableID).disabled = true;
	}

	function setFocus(elementId) {
		document.getElementById(elementId).focus();
	}

	function setSelection(elementId, start, stop) {
		var input = document.getElementById(elementId);
		input.focus();
		/* When stop parameter not supplied, all field is selected */
		if (!!start) start = 1;
		if (!!stop) stop = input.value.length + 1;
		if (typeof document.selection !!= "undefined") {
	    		/* Place selection in MS-IE */
	    		var range = document.selection.createRange();
	     	range.moveStart("character", start - 1);
	     	range.moveEnd("character", stop - start);
	 		range.select();
	  	} else if (typeof input.selectionStart !!= "undefined") {
		  	/* Place selection in Gecko browsers */
	    		input.selectionStart = start - 1;
	    		input.selectionEnd = stop - 1;
	  	} else {
	  		/* Other browsers, please feel free to implement */
			alert("unknown browser");
		}
	}

'! !

!WAStandardScripts methodsFor: 'scripts' stamp: 'mb 3/9/2006 11:08'!
shortcuts
	^ '

	var shortcutKeys = [];
	var shortcutElements = [];	

	function resetShortcuts() {
		shortcutKeys = [];
		shortcutElements = [];	
	}

	function addShortcut(shortcut, elementID) {
		var elem = document.getElementById(elementID);
		if ((elem.tagName == "INPUT" & (elem.type == "submit" || elem.type == "checkbox" || elem.type == "radio")) || elem.tagName == "A")
			{
			shortcutKeys[shortcutKeys.length] = shortcut;
			shortcutElements[shortcutElements.length] = elem;
			}
		else alert("Attempt to assign a shortcut (" + shortcut + ") to something that is not clickable");
	}

	function onKeyDown(event) {
		var keyname = "";
		var element;
		var nav;
		if (navigator.userAgent.indexOf("Safari") > 0)
			nav = "Safari";
		else if (navigator.product == "Gecko")
			nav = "Gecko";
		else
			nav = "IE";
		// cope with MS-IE
		if (event == null) event = window.event;
		if (event) {
			if (event.ctrlKey) keyname = keyname + "Ctrl-";
			if (event.altKey) keyname = keyname + "Alt-";
			if (event.metaKey) keyname = keyname + "Meta-";
			// cope with Netscape
			var keyCode = event.which;
			if (keyCode == null) keyCode = event.keyCode;
			if (keyCode == null) keyCode = event.charCode;
			if (keyCode !!= 0) {
				var character = String.fromCharCode(keyCode);
				character = character.toLowerCase();
				if (event.shiftKey) character = character.toUpperCase();
				// cope with special keys, designated with some logical names
				if (keyCode == 27) character = "Esc";
				if (keyCode == 8) character = "Backspace";
				if (keyCode == 9) character = "Tab";
				if (keyCode == 13) character = "Return";
				if (keyCode == 37) character = "Left";
				if (keyCode == 38) character = "Up";
				if (keyCode == 39) character = "Right";
				if (keyCode == 40) character = "Down";
				// cope with func-keys (some keys not intercepted for MS-IE)
				if ((keyCode >= 112) & (keyCode <= 123)) character = "F" + (keyCode - 112 + 1);
				for ( var x = 1 ; x <= shortcutKeys.length ; x++ ) {
					if (shortcutKeys[x-1] == keyname+character) {
						// alert("key=" + keyCode + " " + keyname + character);
						element = shortcutElements[x-1];
						if (element.tagName == "A" & nav !!= "IE") {
							if (element.onclick) 
								element.onclick.call();
							else
								/* This does not work for anchor in IE */
								location.href = element.href;
						} else  {
							element.click();
						}
					}
				}
				return false;
			}
		}
	}

'! !

!WAStandardScripts methodsFor: 'processing' stamp: 'lr 2/19/2007 11:17'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot bodyAttributes
		at: 'onkeydown'
		put: 'onKeyDown(event)'! !

!WAStringLibrary class methodsFor: 'instance-creation' stamp: 'lr 2/18/2007 12:30'!
default
	^ default ifNil: [ default := self new ]! !

!WAStringLibrary methodsFor: 'private' stamp: 'mb 2/22/2007 16:12'!
asFilename: aSelector
	^ aSelector , self extension! !

!WAStringLibrary methodsFor: 'converting' stamp: 'pmm 4/22/2006 00:49'!
asSelector: aFilename
	^(aFilename copyUpToLast: $.) asSymbol! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'avi 6/24/2004 00:13'!
at: aSymbol
	^ self perform: aSymbol! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'avi 6/24/2004 00:13'!
at: aSymbol put: aString
	self class compile: aSymbol, '
	^ ', aString printString! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'pmm 4/22/2006 00:42'!
configurationComponent
	^ WAStringLibraryEditor new
		library: self;
		yourself! !

!WAStringLibrary methodsFor: 'enumerating' stamp: 'mb 2/9/2006 16:02'!
do: aBlock
	self keys do: 
		[:each |
		| object |
		object := self at: each.
		object isString ifTrue: [aBlock value: object]].! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'pmm 4/22/2006 00:32'!
extension
	self subclassResponsibility ! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'mb 10/17/2006 13:59'!
fileSelectors
	^self keys select: [:each | (self at: each) isString].! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'avi 9/21/2005 21:52'!
keys
	^ (self class selectors select: [:ea | ea isUnary]) asSortedCollection! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'pmm 4/22/2006 00:36'!
mimetype
	self subclassResponsibility ! !

!WAStringLibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:18'!
mimetypeForFile: aFilename
	^self mimetype
! !

WAStringLibrary subclass: #WAStyleLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WAStyleLibrary commentStamp: '<historical>' prior: 0!
Deprecated, pleas use WAFileLibrary instead.!

WAStyleLibrary subclass: #WAStandardStyles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WAStandardStyles commentStamp: '<historical>' prior: 0!
Deprecated, replaced by WAStandardFiles.!

!WAStandardStyles methodsFor: 'styles' stamp: 'lr 9/26/2005 15:15'!
basics
	^ 'div.clearer {clear: both}
.option-selected {font-weight: bold}'! !

!WAStandardStyles methodsFor: 'styles' stamp: 'mb 11/16/2006 18:59'!
kalseyTabs
	"this is from http://kalsey.com/tools/csstabs/ - would also be nice to do http://www.alistapart.com/articles/slidingdoors/"
	^ '
.kalsey .navigation-options {
	border-bottom : 1px solid #ccc;
	margin : 0;
	padding-bottom : 19px;
	padding-left : 10px;
}

.kalsey .navigation-options ul, .kalsey .navigation-options li	{
	display : inline;
	list-style-type : none;
	margin : 0;
	padding : 0;
}

	
.kalsey .navigation-options a:link, .kalsey .navigation-options a:visited	{
	background : #E8EBF0;
	border : 1px solid #ccc;
	color : #666;
	float : left;
	font-size : small;
	font-weight : normal;
	line-height : 14px;
	margin-right : 8px;
	padding : 2px 10px 2px 10px;
	text-decoration : none;
}

.kalsey .navigation-options a:link.active, .kalsey .navigation-options a:visited.active	{
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-options ul a:hover	{
	color : #f00;
}

.kalsey .navigation-options .option-selected a {
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-content {
	background : #fff;
	border : 1px solid #ccc;
	border-top : none;
	clear : both;
	margin : 0px;
	padding : 15px;
	line-height: 1.1;  /* IE6 CSS workaround - http://www.dracos.co.uk/web/css/ie6floatbug/ */
}
'! !

!WAStandardStyles methodsFor: 'styles' stamp: 'lr 10/3/2006 09:27'!
sourceStyle
	^'.halo .halo-source .tag-known {
	font-weight: bold;
	color: navy;
}
.halo .halo-source .attribute-known {
	color: navy;
}
.halo .halo-source .attribute-value {
	color: purple;
}
.halo-source .comment {
	font-style: italic;
	color: green;
}'! !

!WAStyleLibrary methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:31'!
extension
	^ '.css'! !

!WAStyleLibrary methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:31'!
mimetype
	^ 'text/css'! !

!WAStyleLibrary methodsFor: 'processing' stamp: 'lr 2/18/2007 12:32'!
updateRoot: anHtmlRoot
	self do: [ :each | anHtmlRoot addStyle: each ]! !

Object subclass: #WAListener
	instanceVariableNames: 'port process dispatcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

WAListener class
	instanceVariableNames: 'default'!

WAListener class
	instanceVariableNames: 'default'!

!WAListener class methodsFor: 'accessing' stamp: 'lr 6/28/2006 15:19'!
default
	^ default! !

!WAListener class methodsFor: 'accessing' stamp: 'avi 1/6/2006 14:19'!
dispatcher
	^ WADispatcher default! !

!WAListener class methodsFor: 'initialization' stamp: 'lr 6/28/2006 14:37'!
initialize
	Smalltalk addToStartUpList: self after: AutoStart.
	Smalltalk addToShutDownList: self! !

!WAListener class methodsFor: 'instance-creation' stamp: 'avi 1/6/2006 14:18'!
port: aNumber
	^ self basicNew initializeWithPort: aNumber! !

!WAListener class methodsFor: 'initialization' stamp: 'lr 6/28/2006 14:39'!
shutDown
	default ifNotNil: [ default stop ]! !

!WAListener class methodsFor: 'public' stamp: 'lr 6/28/2006 14:39'!
startOn: aNumber
	default ifNotNil: [ default stop ].
	default := self port: aNumber.
	default dispatcher: self dispatcher.
	default start! !

!WAListener class methodsFor: 'initialization' stamp: 'lr 6/28/2006 14:39'!
startUp
	default ifNotNil: [ default start ]! !

!WAListener class methodsFor: 'public' stamp: 'lr 6/28/2006 14:39'!
stop
	default ifNotNil: [ default stop ].
	default := nil! !

!WAListener methodsFor: 'private' stamp: 'pmm 10/14/2006 14:35'!
convertRequest: aKomRequest
	| request |
	request := WARequest
		method: aKomRequest method
		url: aKomRequest url unescapePercents 
		headers: aKomRequest header
		fields: (self fieldsOf: aKomRequest)
		cookies: aKomRequest cookies
		nativeRequest: aKomRequest.

	aKomRequest method = 'PUT'
		ifTrue: [request fields
					at: 'PUTData'
					put: (aKomRequest stream next: aKomRequest contentLength)].
	^ request! !

!WAListener methodsFor: 'accessing' stamp: 'avi 1/6/2006 14:19'!
dispatcher
	^dispatcher! !

!WAListener methodsFor: 'accessing' stamp: 'avi 1/6/2006 14:19'!
dispatcher: anObject
	dispatcher := anObject! !

!WAListener methodsFor: 'private' stamp: 'pmm 10/14/2006 14:35'!
fieldsOf: aKomRequest
	^aKomRequest method = 'POST'
		ifTrue: [ aKomRequest postFields ]
		ifFalse: [ aKomRequest getFields ]! !

!WAListener methodsFor: 'initialization' stamp: 'avi 1/6/2006 14:18'!
initializeWithPort: aNumber
	port := aNumber.! !

!WAListener methodsFor: 'private' stamp: 'lr 10/15/2006 11:42'!
listenLoop
	| socket |
	socket := Socket newTCP.
	socket listenOn: port backlogSize: 50.
	socket isValid 
		ifFalse: [ self error: 'Cannot create socket on port ' , port asString ].
	[ [ socket isValid ifFalse: [
			"will trigger #ifCurtailed: block and destroy socket"
			^self listenLoop ].
		self waitForConnectionOn: socket ] repeat ]
		ifCurtailed: [
			"probably copy pasted from ConnectionQueue >> #listenLoop"
			(Delay forMilliseconds: 10) wait.
			socket destroy ].! !

!WAListener methodsFor: 'private' stamp: 'pmm 10/14/2006 14:17'!
outputStreamFor: aSocketStream
	^aSocketStream! !

!WAListener methodsFor: 'private' stamp: 'pmm 10/14/2006 14:19'!
processConnection: aSocket
	| stream |
	stream := SocketStream on: aSocket.
	stream autoFlush: true.
	[ [ [ self
			writeResponseForRequest: (HttpRequest readFromStream: stream)
			on: (self outputStreamFor: stream). ]
		ensure: [ stream close ] ]
		ifCurtailed: [ aSocket destroy ] ]
		forkAt: Processor userBackgroundPriority! !

!WAListener methodsFor: 'public' stamp: 'lr 6/28/2006 14:16'!
start
	self stop.
	process := [ [ self listenLoop ] repeat ] 
		forkAt: Processor highIOPriority! !

!WAListener methodsFor: 'public' stamp: 'avi 1/6/2006 14:18'!
stop
	process ifNotNil: [process terminate. process := nil]! !

!WAListener methodsFor: 'private' stamp: 'lr 6/28/2006 14:12'!
waitForConnectionOn: aSocket
	| connection |
	connection := (aSocket waitForAcceptFor: 10)
		ifNil: [ ^ self ].
	self processConnection: connection! !

!WAListener methodsFor: 'private' stamp: 'lr 7/3/2006 16:27'!
writeResponseForRequest: aRequest on: aStream
	| request response |
	request := self convertRequest: aRequest.
	request responseStream: aStream.
	response := dispatcher handleRequest: request.	
	response ifNil: [ ^ self ].
	response writeOn: aStream.
	response release! !

Object subclass: #WAMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAMain methodsFor: 'convenience' stamp: 'mb 4/23/2007 14:52'!
application
	"Answer the application to which this entry point is associated."


	^ self session application! !

!WAMain methodsFor: 'user authentication' stamp: 'mb 4/23/2007 14:52'!
session
	"Answer the session to which this entry point is associated."


	^ WACurrentSession value! !

!WAMain methodsFor: 'accessing' stamp: 'mb 4/23/2007 14:52'!
start: aRequest
	"The main entry point into a session."


	self subclassResponsibility! !

WAMain subclass: #WARenderLoopMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

WARenderLoopMain subclass: #WAAuthMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAAuthMain methodsFor: 'as yet unclassified' stamp: 'avi 5/19/2004 14:16'!
createRoot
	| root |
	root := super createRoot.
	root addDecoration: (WABasicAuthentication new authenticator: self).
	^ root! !

!WAAuthMain methodsFor: 'password verification' stamp: 'pmm 9/12/2006 18:10'!
verifyPassword: password forUser: username
	^self application login = username
		and: [ self application password = password ]! !

!WARenderLoopMain methodsFor: 'decorations' stamp: 'avi 2/10/2004 16:09'!
call: aComponent
	^ WARenderLoop new call: aComponent! !

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: 'avi 4/22/2004 14:59'!
createRoot
	^ self rootClass new! !

!WARenderLoopMain methodsFor: 'accessing' stamp: 'mb 5/26/2006 09:17'!
rootClass
	^ self application rootComponent! !

!WARenderLoopMain methodsFor: 'accessing' stamp: 'avi 11/7/2005 11:51'!
start: aRequest
	| root |
	root := self createRoot.
	root visiblePresentersDo: [:ea | ea initialRequest: aRequest].
	(WARenderLoop new root: root) run
! !

Object subclass: #WAModelProxy
	instanceVariableNames: 'cache model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAModelProxy commentStamp: '<historical>' prior: 0!
I am a fake object that can be interposed between the real model object and the client, so that the data can be validated or collected before commiting to the real model.

If you have a model instance like

	model := WAStoreAddress new.
	model street: 'Rathausgasse 34'.

create a model proxy by evaluating the following code:

	proxy := WAModelProxy on: model.
	
Then use the accessors of the proxy as you would do with your model:

	proxy country: 'Switzerland'.
	proxy street -> 'Rathausgasse 34'
	...
	
To propagate the values into your model send #commit :

	proxy commit.
	model country -> 'Switzerland'!

!WAModelProxy class methodsFor: 'instance creation' stamp: 'ab 11/26/2002 17:21'!
on: anObject
	^ self new setModel: anObject! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 12/12/2002 00:18'!
commit
	cache keysAndValuesDo:
		[:key :value |
		self performRealWrite: key with: value].

	cache := Dictionary new.
! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'pmm 9/12/2006 18:37'!
doesNotUnderstand: aMessage
	^ aMessage selector isUnary
		ifTrue: [self performRead: aMessage selector]
		ifFalse: [
			(aMessage selector isKeyword and: [aMessage arguments size = 1])
				ifTrue: [self performWrite: aMessage selector allButLast with: aMessage argument]
				ifFalse: [super doesNotUnderstand: aMessage]]! !

!WAModelProxy methodsFor: 'accessing' stamp: 'ab 11/26/2002 17:22'!
model
	^ model! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:24'!
name
	^ model name! !

!WAModelProxy methodsFor: 'private' stamp: 'pmm 9/12/2006 18:36'!
performRead: aSymbol
	^ cache
		at: aSymbol asSymbol
		ifAbsent: [ model perform: aSymbol ]! !

!WAModelProxy methodsFor: 'private' stamp: 'mb 1/5/2006 13:51'!
performRealWrite: aSymbol with: anObject
	model perform: aSymbol asSymbol asMutator with: anObject! !

!WAModelProxy methodsFor: 'private' stamp: 'mb 1/5/2006 13:51'!
performWrite: aSymbol with: anObject
	cache at: aSymbol asSymbol put: anObject! !

!WAModelProxy methodsFor: 'initializing' stamp: 'ab 12/12/2002 00:18'!
setModel: anObject
	model := anObject.
	cache := Dictionary new.! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:24'!
value
	^ model value! !

Object subclass: #WAOpeningConditionalComment
	instanceVariableNames: 'condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document-Elements'!

!WAOpeningConditionalComment class methodsFor: 'instance creation' stamp: 'pmm 10/11/2006 17:38'!
condition: aString
	^self new
		condition: aString;
		yourself! !

!WAOpeningConditionalComment methodsFor: 'accessing' stamp: 'pmm 10/11/2006 17:31'!
condition
	^condition! !

!WAOpeningConditionalComment methodsFor: 'accessing' stamp: 'pmm 10/11/2006 17:31'!
condition: aString
	condition := aString! !

!WAOpeningConditionalComment methodsFor: 'writing' stamp: 'pmm 10/11/2006 17:33'!
writeOn: aStream
	aStream
		nextPutAll: '<!!--[';
		nextPutAll: self condition;
		nextPutAll: ']>'
	! !

Object subclass: #WAPluggableSelectBox
	instanceVariableNames: 'changeSelected model selected size list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAPluggableSelectBox class methodsFor: 'instance creation' stamp: 'ab 2/15/2003 18:28'!
on: anObject list: listSelector selected: selectedSelector changeSelected: changeSelectedSelector
	^ self 
		on: anObject
		list: listSelector
		selected: selectedSelector
		changeSelected: changeSelectedSelector
		size: 10! !

!WAPluggableSelectBox class methodsFor: 'instance creation' stamp: 'pmm 4/19/2006 17:42'!
on: anObject list: listSelector selected: selectedSelector changeSelected: changeSelectedSelector size: aNumber
	^ self new
		model: anObject;
		list: listSelector;
		selected: selectedSelector;
		changeSelected: changeSelectedSelector;
		size: aNumber;
		yourself! !

!WAPluggableSelectBox methodsFor: 'accessing' stamp: 'ab 10/1/2002 14:16'!
changeSelected: aSymbol
	changeSelected := aSymbol! !

!WAPluggableSelectBox methodsFor: 'accessing' stamp: 'ab 10/1/2002 14:16'!
list: aSymbol
	list := aSymbol! !

!WAPluggableSelectBox methodsFor: 'accessing' stamp: 'ab 2/15/2003 18:24'!
model: anObject
	model := anObject! !

!WAPluggableSelectBox methodsFor: 'rendering' stamp: 'pmm 4/23/2006 21:30'!
renderOn: html
	|array|
	array := (model perform: list) asArray.
	html div
		class: 'column-choice';
		with: [
			html form: [
				html select
					beSubmitOnChange;
					size: size;
					list: array;
					selected: (array at: (model perform: selected) ifAbsent: []);
					callback: [ :item |
						model perform: changeSelected with: (array indexOf: item) ] ] ].	! !

!WAPluggableSelectBox methodsFor: 'accessing' stamp: 'ab 10/1/2002 14:16'!
selected: aSymbol
	selected := aSymbol! !

!WAPluggableSelectBox methodsFor: 'accessing' stamp: 'ab 2/15/2003 18:25'!
size: aNumber
	size := aNumber! !

Object subclass: #WAPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

WAPresenter subclass: #WAComponent
	instanceVariableNames: 'decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WAComponent commentStamp: '<historical>' prior: 0!
I am a class representing a graphical element of a seaside application. A component has state (instance variables, that might be backtracked using #registerObjectForBacktracking:), behavior decorations, children and an appearance that is specified in #renderContentOn:. A component might chose to display another component with #call:.

Child Components:
It is common for a component to display instances of other components while rendering itself.  It does this by passing them into the #render: method of WACanvas.  For example, this #renderContentOn: method simply renders a heading and then displays a counter component 
immediately below it:

	renderContentOn: html
		html heading level3; with: 'My Counter'.
		html render: myCounter.

It's important that you use #render:, rather than directly calling the #renderContentOn: method of the subcomponent. The following is *not* correct:

	renderContentOn: html
		html heading level3; with: 'My Counter'.
		myCounter renderContentOn: html.   "DON'T DO THIS".

These subcomponents are usually instance variables of the component that is "embedding" them.  They are commonly created as part of the components #initialize method:

	initialize
		myCounter := WACounter new.

They may also be stored in a collection. One fairly common pattern is to keep a lazily initialized dictionary of subcomponents that match a collection of model items. For example, if you wanted a BudgetItemRow subcomponent for each member of budgetItems, you might do something like this:

	initialize
		budgetRows := Dictionary new.

	rowForItem: anItem
		^budgetRows at: anItem ifAbsentPut: [ BudgetItemRow item: anItem ].

	renderContentOn: html
		self budgetItems
			do: [ :each | html render: (self rowForItem: each) ]
			separatedBy: [ html horizontalLine ].

Each parent component *must* implement a #children method that returns a collection of all of the subcomponents that it might display on the next render. For the above two examples, #children might look like this:

	children
		^Array with: myCounter

or this:

	children
		^self budgetItems collect: [ :each | self rowForItem: each ].
		
Call/Answer:
If a subcomponent makes a #call: to another component, that component will appear in place of the subcomponent.  In the first example, if myCounter made a #call: to DateSelector, that DateSelector would appear in the context of the counter's parent, with the 'My Counter' heading 
above it.

Since a subcomponent has not been #call:'d, in general #answer: is a no-op.  However, the parent may attach an #onAnswer: block to the subcomponent to be notified if it sends #answer:. This allows one component to be used both from #call: and through embedding. For example:

	initialize
		dateSelector := WADateSelector new 
			onAnswer: [ :date | self dateChosen: date ].
			
Visibility:
A component is visible if
- it is the root component of an application
- a child of of a visible component (returned by #children) that has not been #call:'d
- passed as an argument to #call: on a visible component!

WAComponent subclass: #WAAlphabeticBatchedList
	instanceVariableNames: 'items currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'avi 12/18/2004 18:26'!
allPages
	^ $A to: $Z! !

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'mbany 4/14/2005 12:37'!
batch
	^ items select: [:ea | ea displayString asUppercase first = self currentPage]! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:20'!
currentPage
	^ currentPage ifNil: [currentPage := self validPages first]! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:16'!
currentPage: aCharacter
	currentPage := aCharacter! !

!WAAlphabeticBatchedList methodsFor: 'initialization' stamp: 'pmm 11/2/2005 22:49'!
initialize
	super initialize.
	self session registerObjectForBacktracking: self.! !

!WAAlphabeticBatchedList methodsFor: 'testing' stamp: 'avi 12/18/2004 18:21'!
isOnFirstPage
	^ self validPages first = self currentPage! !

!WAAlphabeticBatchedList methodsFor: 'testing' stamp: 'avi 12/18/2004 18:21'!
isOnLastPage
	^ self validPages last = self currentPage! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:13'!
items
	^ items! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:20'!
items: aCollection
	items := aCollection! !

!WAAlphabeticBatchedList methodsFor: 'actions' stamp: 'avi 12/18/2004 18:19'!
nextPage
	self isOnLastPage ifFalse: [currentPage := self validPages after: currentPage]! !

!WAAlphabeticBatchedList methodsFor: 'actions' stamp: 'avi 12/18/2004 18:19'!
previousPage
	self isOnFirstPage ifFalse: [currentPage := self validPages before: currentPage]
! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:14'!
renderContentOn: html
	items isEmpty ifFalse: [
		html div
			id: 'batch';
			with: [
				self renderPreviousOn: html.
				self renderPagesOn: html. 
				self renderNextOn: html ] ]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:14'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchor callback: [ self nextPage ]; with: '>>' ]
		ifTrue: [ html text: '>>' ]		! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:15'!
renderPagesOn: html
	self allPages
		do: [ :char |
			currentPage = char
				ifFalse: [
					(self validPages includes: char)
						ifTrue: [ html anchor callback: [self currentPage: char]; with: char]
						ifFalse: [ html text: char ] ]
				ifTrue: [ html strong: char ] ]
		separatedBy: [ html space ]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:16'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchor callback: [ self previousPage ]; with: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space.! !

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'mbany 4/14/2005 12:37'!
validPages
	^ (items collect: [:ea | ea displayString asUppercase first]) asSet asSortedCollection! !

WAComponent subclass: #WABatchSelection
	instanceVariableNames: 'batcher linkSelector textSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WABatchSelection class methodsFor: 'instance-creation' stamp: 'pmm 4/19/2006 17:39'!
items: aCollection link: linkSelector text: textSelector
	^ self new
		items: aCollection;
		linkSelector: linkSelector;
		textSelector: textSelector;
		yourself! !

!WABatchSelection methodsFor: 'accessing' stamp: 'rjl 8/4/2006 11:35'!
batchSize
    ^batcher batchSize! !

!WABatchSelection methodsFor: 'accessing' stamp: 'rjl 8/4/2006 11:34'!
batchSize: aSize
    batcher batchSize: aSize! !

!WABatchSelection methodsFor: 'accessing' stamp: 'avi 2/10/2004 20:43'!
children
	^ Array with: batcher! !

!WABatchSelection methodsFor: 'commands' stamp: 'avi 12/9/2003 13:17'!
choose: anItem
	self answer: anItem! !

!WABatchSelection methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:10'!
items: aCollection
	batcher := WABatchedList new 
		items: aCollection;
		batchSize: 8;
		yourself! !

!WABatchSelection methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:22'!
linkSelector: aSymbol
	linkSelector := aSymbol! !

!WABatchSelection methodsFor: 'rendering' stamp: 'lr 1/7/2007 17:47'!
renderContentOn: html
	html unorderedList: [
		batcher batch do: [ :each |
			html anchor
				callback: [ self choose: each ];
				with: (each perform: linkSelector).
			html break.
			html text: (each perform: textSelector).
			html paragraph ] ].
	html div
		style: 'text-align: center';
		with: batcher.! !

!WABatchSelection methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:22'!
textSelector: aSymbol
	textSelector := aSymbol! !

WAComponent subclass: #WABatchTest
	instanceVariableNames: 'batcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WABatchTest methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:33'!
children
	^ Array with: batcher! !

!WABatchTest methodsFor: 'initialization' stamp: 'pmm 9/12/2006 18:10'!
initialize
	super initialize.
	batcher := WAAlphabeticBatchedList new items: Collection allSubclasses! !

!WABatchTest methodsFor: 'rendering' stamp: 'dc 7/21/2006 21:16'!
renderContentOn: html
	html render: batcher.
	html unorderedList
		list: batcher batch! !

WAComponent subclass: #WABatchedList
	instanceVariableNames: 'items batchSize currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WABatchedList class methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:13'!
example
	^self new
		items: (1 to: 100);
		yourself.
		! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
batch
	^ self items copyFrom: self startIndex to: self endIndex! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
batchSize
	^ batchSize! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:09'!
batchSize: aNumber
	batchSize := aNumber! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage
	^ currentPage! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage: aNumber
	currentPage := aNumber! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
endIndex
	^ self currentPage * self batchSize min: self items size! !

!WABatchedList methodsFor: 'initialization' stamp: 'rjl 8/9/2006 14:31'!
initialize
	super initialize.
	self batchSize: 10.
	self currentPage: 1.
	self session registerObjectForBacktracking: self.! !

!WABatchedList methodsFor: 'testing' stamp: 'rjl 8/9/2006 14:32'!
isOnFirstPage
	^ self currentPage = 1! !

!WABatchedList methodsFor: 'testing' stamp: 'rjl 8/9/2006 14:32'!
isOnLastPage
	^ self currentPage = self maxPages! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
items
	^ items! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 22:57'!
items: aCollection
	items := aCollection! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
maxPages
	^ (self items size / self batchSize) ceiling! !

!WABatchedList methodsFor: 'actions' stamp: 'rjl 8/9/2006 14:31'!
nextPage
	self isOnLastPage ifFalse: [self currentPage: self currentPage + 1]! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:44'!
pageRange
	^ self pageRangeStart to: self pageRangeEnd! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:50'!
pageRangeEnd
	^ self maxPages min: self currentPage + 9! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:51'!
pageRangeStart
	^ 1 max: self currentPage - 9! !

!WABatchedList methodsFor: 'actions' stamp: 'rjl 8/9/2006 14:31'!
previousPage
	self isOnFirstPage ifFalse: [self currentPage: self currentPage - 1]! !

!WABatchedList methodsFor: 'rendering' stamp: 'al 9/7/2006 17:05'!
renderContentOn: html
	self maxPages > 0 ifTrue: [
		html div
			id: 'batch';
			with: [
				self renderPreviousOn: html.
				self renderPagesOn: html. 
				self renderNextOn: html ] ]! !

!WABatchedList methodsFor: 'rendering' stamp: 'al 9/7/2006 17:06'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchor callback: [ self nextPage ]; with: '>>' ]
		ifTrue: [ html text: '>>' ]		! !

!WABatchedList methodsFor: 'rendering' stamp: 'al 9/7/2006 17:07'!
renderPagesOn: html
	self pageRange
		do: [ :index |
			self currentPage = index
				ifFalse: [html anchor callback: [self currentPage: index]; with: index]
				ifTrue: [html strong: index ] ]
		separatedBy: [ html space ]! !

!WABatchedList methodsFor: 'rendering' stamp: 'al 9/7/2006 17:07'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchor callback: [ self previousPage ]; with: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space.! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
startIndex
	^ (self currentPage - 1) * self batchSize + 1! !

WAComponent subclass: #WABrowser
	instanceVariableNames: 'contents model message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WABrowser class methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:18'!
description
	^ 'Smalltalk Code Browser'! !

!WABrowser class methodsFor: 'instance-creation' stamp: 'lr 11/3/2006 13:50'!
fullOnClass: aClass
	^ self fullOnClass: aClass selector: nil! !

!WABrowser class methodsFor: 'instance-creation' stamp: 'lr 11/3/2006 13:50'!
fullOnClass: aClass selector: aSelector
	^ self new model: (Browser new setClass: aClass selector: aSelector)! !

!WABrowser class methodsFor: 'initialization' stamp: 'lr 2/12/2007 21:51'!
initialize
	self registerAsApplication: 'tools/classbrowser'! !

!WABrowser methodsFor: 'actions' stamp: 'avi 4/28/2004 11:40'!
accept
	|save|
	SeasidePlatformSupport ensureAuthorInitials: [self request: 'Please enter your initials:'].
	message := nil.
	save := contents.
	model contents: contents notifying: self.
	contents := save.
! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/8/2002 19:41'!
columnView: columnName
	^WAPluggableSelectBox
		on: model
		list: (columnName, 'List') asSymbol
		selected: (columnName, 'ListIndex') asSymbol
		changeSelected: (columnName, 'ListIndex:') asSymbol! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:50'!
contents
	^contents! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:54'!
contents: aString
	contents := aString! !

!WABrowser methodsFor: 'processing' stamp: 'lr 2/12/2007 22:42'!
initialRequest: aRequest
	| theClass |
	super initialRequest: aRequest.
	aRequest fields at: 'class' ifPresent:
		[:className | 
		Smalltalk at: className asSymbol ifPresent:
			[:class |
			theClass := (aRequest fields includesKey: 'meta')
					ifTrue: [class class]
					ifFalse: [class].
			self model setClass: theClass selector: nil.
			aRequest fields at: 'method' ifPresent:
				[:selector |
				self model setClass: theClass selector: selector asSymbol]]]! !

!WABrowser methodsFor: 'initialization' stamp: 'pmm 11/2/2005 22:48'!
initialize
	super initialize.
	self model: Browser new.! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/8/2002 22:13'!
model
	^model 
! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 2/18/2003 19:07'!
model: aBrowserModel
	model := aBrowserModel.
	model addDependent: self.
	self session registerObjectForBacktracking: model.
	contents := model contents.! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 23:36'!
notify: aString at: location in: sourceStream
	message := aString allButLast: 3! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 11/26/2002 14:08'!
renderColumnsOn: html
	|cols|
	cols := #(systemCategory class messageCategory message)
				collect: [:sel | self columnView: sel].

	html table: [
		html tableRow: [
			cols do: [:ea | html tableData: [html render: ea]].
		]
	]! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 6/15/2003 12:57'!
renderContentOn: html
	self
		renderColumnsOn: html;
		renderModeButtonsOn: html;
		renderMessageOn: html;
		renderContentPaneOn: html
	! !

!WABrowser methodsFor: 'rendering' stamp: 'mb 11/1/2006 18:58'!
renderContentPaneOn: html
	html form: [
		html textArea
			id: 'contents';
			columns: 80;
			rows: 12;
			on: #contents of: self.
		html break.
		html submitButton on: #accept of: self ]! !

!WABrowser methodsFor: 'rendering' stamp: 'lr 11/16/2006 15:35'!
renderMessageOn: html
	message ifNotNil: [ html strong: message ]! !

!WABrowser methodsFor: 'rendering' stamp: 'pmm 4/23/2006 21:30'!
renderModeButtonsOn: html
	html form: [
		html submitButton callback: [ self showInstance ]; value: 'instance'.
		html submitButton callback: [ self showHelp ]; value: 'help'.
		html submitButton callback: [ self showClass ]; value: 'class' ]! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/11/2002 00:00'!
select! !

!WABrowser methodsFor: 'actions' stamp: 'ab 10/11/2002 00:00'!
selectFrom: aPos to: anotherPos
! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:44'!
selectionInterval
	^ 1 to: 1! !

!WABrowser methodsFor: 'actions' stamp: 'LR 9/13/2002 20:38'!
showClass
	self model indicateClassMessages! !

!WABrowser methodsFor: 'actions' stamp: 'LR 9/13/2002 20:42'!
showHelp
	self model plusButtonHit! !

!WABrowser methodsFor: 'actions' stamp: 'LR 9/13/2002 20:39'!
showInstance
	self model indicateInstanceMessages! !

!WABrowser methodsFor: 'accessing' stamp: 'lr 1/7/2007 18:10'!
style
	^ '#contents {width: 65em; height: 20em; font-family: Tahoma, Arial, Helvetica, Sans;}
.column-choice select {width: 15em;; font-size: 90%}'! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:44'!
text
	^ Text fromString: ''! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 01:45'!
update: aSymbol
	contents := model contents! !

!WABrowser methodsFor: 'processing' stamp: 'mb 3/13/2007 15:14'!
updateUrl: aUrl
	super updateUrl: aUrl.
	self model selectedClass ifNotNilDo: [ :class | 
		aUrl addParameter: 'class' value: class fullName.
		self model metaClassIndicated 
			ifTrue: [ aUrl addParameter: 'meta' ] ].
	self model selectedMessageName ifNotNilDo: [ :method |
		aUrl addParameter: 'method' value: method ]! !

WAComponent subclass: #WACacheTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WACacheTest methodsFor: 'rendering' stamp: 'avi 10/26/2004 15:41'!
renderContentOn: html
	Smalltalk garbageCollect.  
	html heading: ResponseContinuation allInstances size.
	html heading: AnswerContinuation allInstances size.
	html heading: EscapeContinuation allInstances size.
	html anchorWithAction: [self inform: 'answer'] text: 'call'.
	html break.
	html anchorWithAction: [self call: self class new] text: 'keep calling'.! !

!WACacheTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 18:55'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WACallbackTest
	instanceVariableNames: 'transcript counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WACallbackTest methodsFor: 'accessing' stamp: 'mb 2/17/2005 17:50'!
children

	^ Array with: counter.! !

!WACallbackTest methodsFor: 'initialization' stamp: 'mb 4/23/2006 15:09'!
initialize
	super initialize.
	transcript := String new writeStream.
	counter := WACounter new.! !

!WACallbackTest methodsFor: 'rendering' stamp: 'mb 2/17/2005 17:50'!
renderContentOn: html
	html anchorWithCallback: [] do: 'Idempotent'.
	html space.
	html anchorWithAction: [] do: 'Side Effect'.
	
	html form: [
		html defaultAction: [transcript cr; nextPutAll: 'default action'].
		html textInputWithValue: '' callback: [:v | transcript cr; nextPutAll: 'text: ', v printString].
		html textInputWithValue: '' callback: [:v | transcript cr; nextPutAll: 'text2: ', v printString].
		html break.
		html submitButton.
		html space.
		html submitButtonWithAction: [transcript cr; nextPutAll: 'go'] text: 'Go'.
		html space.
		html cancelButtonWithAction: [transcript cr; nextPutAll: 'cancel'].
	].
	html preformatted: transcript contents.
	html horizontalRule.
	html render: counter.! !

!WACallbackTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 18:55'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WACanvasDateTimeTest
	instanceVariableNames: 'data numericData date time data1 data2 msg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:25'!
data1
	^data1! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:26'!
data1: aString
	data1 := aString! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:25'!
data2
	^data2! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:26'!
data2: aString
	data2 := aString! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:22'!
date
	^date! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:23'!
date: aDate 
	date := aDate! !

!WACanvasDateTimeTest methodsFor: 'initialize-release' stamp: 'pmm 7/19/2006 19:48'!
initialize
	super initialize.
	data1 := 'Harry'.
	data2 := 'Covert'.
	data := String new.
	msg := String new.
	numericData := 12.! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:26'!
numericData
	^numericData! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:26'!
numericData: aString
	numericData := aString! !

!WACanvasDateTimeTest methodsFor: 'rendering' stamp: 'mb 2/6/2006 10:44'!
renderContentOn: html

	self renderSubmitFormOn: html.
	self renderDateTimeOn: html.
! !

!WACanvasDateTimeTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:25'!
renderDateTimeOn: html
	html heading: 'Form with #dateInput and #timeInput'.
	html form
		style: 'border: 1px green solid; width: 50%';
		id: 'f2';
		defaultAction: [msg := 'Default action: ' , date displayString , ' ' , time displayString];
		with: [
			html dateInput
				id: 'date-input';
				on: #date of: self.
			html space: 10.
			html timeInput
				id: 'time-input';
				value: time;
				withSeconds;
				on: #time of: self.
			html	
				break;
				text: msg;
				break.
			html submitButton
				callback: [msg := 'Button action: ' , date displayString , ' ' , time displayString]].
! !

!WACanvasDateTimeTest methodsFor: 'rendering' stamp: 'lr 11/16/2006 16:47'!
renderSubmitFormOn: html
	html heading: 'Form with #submitFormNamed:'.
	(html form)
		style: 'border: 1px red solid; width: 50%';
		id: 'f1';
		defaultAction: [data := 'Default action : '
			, data1 printString , ' ' 
			, data2 printString , ' ' 
			, numericData printString];
		with: [
			html textInput
				on: #data1 of: self.
			html textInput
				on: #data2 of: self.
			html textInput
				on: #numericData of: self.
			html break.
			html text: data.
			html break.
			html anchor
				callback: [data := 'Anchor action : '
					, data1 printString , ' ' 
					, data2 printString , ' ' 
					, numericData printString];
				submitFormNamed: 'f1';
				with: 'Click me'].
! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:23'!
time
	^time! !

!WACanvasDateTimeTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:23'!
time: aTime
	time := aTime! !

WAComponent subclass: #WACanvasDefaultFormTest
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WACanvasDefaultFormTest methodsFor: 'rendering' stamp: 'mb 4/5/2006 07:12'!
renderContentOn: html
	html form
		defaultAction: [self inform: 'Default: ', value displayString]; with:
		[
		html submitButton 
				callback: [self inform: 'Before: ', value displayString];
				text: 'Before'.
		html break.
		html textInput
				value: '';
				callback: [:v | value := v].
		html submitButton
				callback: [self inform: 'Go: ', value displayString];
				text: 'Go'.
		html break.
		html submitButton
				callback: [self inform: 'After: ', value displayString];
				text: 'After']! !

WAComponent subclass: #WACanvasHtmlTest
	instanceVariableNames: 'booleanList message number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WACanvasHtmlTest methodsFor: 'accessing' stamp: 'mb 10/12/2006 19:43'!
allSelectors
	^ (self class selectors asSortedCollection select: [:s | s beginsWith: 'render'])
		remove: #renderContentOn:;
		yourself! !

!WACanvasHtmlTest methodsFor: 'accessing' stamp: 'mb 3/8/2006 14:00'!
initialMessage
	^'Hello world!!'.
! !

!WACanvasHtmlTest methodsFor: 'initialize-release' stamp: 'pmm 7/19/2006 19:49'!
initialize
	super initialize.
	message := self initialMessage.
	booleanList := #(a b c d) collect: [:key | key -> ((Array with: true with: false) atRandom)].
	number := 10 atRandom.! !

!WACanvasHtmlTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:33'!
message
	^message! !

!WACanvasHtmlTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:33'!
message: aString
	message := aString! !

!WACanvasHtmlTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:32'!
number
	^number! !

!WACanvasHtmlTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:32'!
number: anInteger
	number := anInteger! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:37'!
renderCheckboxesOn: html
	html text: booleanList.
	html paragraph.
	html form: [
		booleanList do: [:association |
			html text: association key; space.
			html checkbox
				addShortcut: 'Ctrl-' , association key asUppercase;
				on: #value of: association.
			html break].
		html submitButton]! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'mb 1/31/2006 11:32'!
renderContentOn: html
	self allSelectors pairsDo:
		[:selA :selB |
		(html div)
			class: 'row';
			with: 
				[(html div)
					class: 'left';
					with: [self perform: selA with: html].
				(html div)
					class: 'left';
					with: [self perform: selB with: html]]
		]
! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:39'!
renderRadioButtonsOn: html
	html text: booleanList.
	html paragraph.
	html form: [
		booleanList do: [ :association |
			| group |
			group := html radioGroup.
			html text: association key; space.
			html radioButton
				addShortcut: 'Ctrl-' , association key;
				group: group;
				selected: association value;
				callback: [association value: true].
			html radioButton
				addShortcut: 'Alt-' , association key;
				group: group;
				selected: association value not;
				callback: [association value: false].
			html break].
		html submitButton]! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:39'!
renderSelectsOn: html
	html text: number.
	html paragraph.
	html form: [
		html select
			list: (1 to: 10);
			on: #number of: self.
		html submitButton]! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:42'!
renderSubmitButtonsOn: html
	html text: number.
	html paragraph.
	html form: [
		1 to: 10 do: [ :index |
			html submitButton
				addShortcut: 'F' , index asString;
				callback: [number := index];
				text: index.
			html space]]! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'mb 3/27/2007 09:55'!
renderTextAreaOn: html 
	| position |
	position := message = self initialMessage
				ifTrue: [6]
				ifFalse: ['End'].
	html
		form: [html text: message.
			html paragraph.
			html textArea
				 setSelectionFrom: position to: position;
				 on: #message of: self.
			html break.
			html submitButton]! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:34'!
renderTextInputOn: html
	html form: [
		html text: message.
		html paragraph.
		html textInput
			on: #message of: self.
		html submitButton]! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'lr 11/16/2006 15:36'!
renderVFieldSetOn: html
	(html fieldSet)
		legend: 'Various text rendering in a fieldset';
		with:
			[html
				strong: 'Bold';
				break;
				emphasis: 'Italic';
				break;
				underline: 'Underline';
				break.
			(html acronym)
				title: 'United States of America';
				with: 'USA'.
			html
				break;
				emphasis: 'Emphasis';
				break.	

			(html div)
				addStyle: 'color: red';
				addStyle: 'background-color: lightgreen';
				addStyle: 'padding: 1em';
				addStyle: 'border: solid 2px black';
				addStyle: 'font-weight: bold';
				addStyle: 'font-size: 150%';
				addStyle: 'height: 3em';
				addStyle: 'text-align: center';
				with: 'Large bold red in a green div'.
			html
				break]! !

!WACanvasHtmlTest methodsFor: 'rendering' stamp: 'mb 6/12/2006 14:33'!
renderZFieldSetOn: html
	| url1 |
	url1 := html context
				urlForDocument: (ScriptingSystem formAtKey: 'Halo-Debug') 
				mimeType: 'image/jpg' 
				fileName: 'Debug.jpg'.
	(html fieldSet)
		legend: 'Various images in a fieldset';
		with:
			[html image url: url1; altText: 'Halo-Debug'.
			html space.
			html image form: (ScriptingSystem formAtKey: 'Halo-View'); altText: 'Halo-View'.
			html space.
			html image
					fileName: 'Paint.png'; 
					mimeType: 'image/png';
					document: (ScriptingSystem formAtKey: 'Halo-Paint'); 
					altText: 'Halo-Paint'.
			html break.
			html image border: 1; url: 'http://www.netstyle.ch/include/seaside/pics/top.jpg'; width: '80%'; altText: 'Seaside'.
			html break.
			html image border: 2; url: 'http://www.netstyle.ch/include/seaside/pics/top.jpg'; height: '50px'; altText: 'Seaside'.
			html break.
			html image border: 0; url: 'http://www.netstyle.ch/include/seaside/pics/top.jpg'; width: '250px'; height: '60px'; altText: 'Seaside'.

		]
! !

!WACanvasHtmlTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:18'!
style
^ '
	div.row {clear: both}
	div.left {float: left; width: 45%; margin: 1%}
'! !

WAComponent subclass: #WACanvasImageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WACanvasImageTest methodsFor: 'rendering' stamp: 'mb 6/8/2006 15:54'!
renderContentOn: html
	html form: [
		html imageButton 
			callback: [self inform: 'ok'];
			form: (ScriptingSystem formAtKey: 'Halo-Debug')]! !

WAComponent subclass: #WACanvasInputTest
	instanceVariableNames: 'nilString emptyString integer fraction lastName address selection multiSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WACanvasInputTest class methodsFor: 'accessing' stamp: 'mb 2/22/2007 14:42'!
description
	^'Various XHTML form input elements'! !

!WACanvasInputTest class methodsFor: 'accessing' stamp: 'mb 2/22/2007 14:41'!
example

	^ self new! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 10/10/2006 23:21'!
address
	"Answer the value of address"

	^ address! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'pmm 10/12/2006 22:11'!
address: anObject
	"Set the value of address"

	address := anObject! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
emptyString
	"Answer the value of emptyString"

	^ emptyString! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
emptyString: anObject
	"Set the value of emptyString"

	emptyString := anObject! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
fraction
	"Answer the value of fraction"

	^ fraction! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
fraction: anObject
	"Set the value of fraction"

	fraction := anObject! !

!WACanvasInputTest methodsFor: 'initialize-release' stamp: 'mb 11/3/2006 14:34'!
initialize
	super initialize.
	nilString := nil.
	emptyString := ''.
	integer := 42.
	fraction := 1/3.
	selection := nil.
	multiSelection := Set new.! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
integer
	"Answer the value of integer"

	^ integer! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
integer: anObject
	"Set the value of integer"

	integer := anObject! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 10/10/2006 23:04'!
lastName
	"Answer the value of lastName"

	^ lastName! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'pmm 10/12/2006 22:11'!
lastName: anObject
	"Set the value of lastName"

	lastName := anObject! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 11/3/2006 14:50'!
multiSelection
	^ multiSelection! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 11/3/2006 14:50'!
multiSelection: anObject
	multiSelection := anObject! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
nilString
	"Answer the value of nilString"

	^ nilString! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
nilString: anObject
	"Set the value of nilString"

	nilString := anObject! !

!WACanvasInputTest methodsFor: 'rendering' stamp: 'mb 3/28/2007 10:14'!
renderContentOn: html 
	html
		form: [html
				table: [html
						tableRow: [html tableHeading: 'Name'.
							html tableHeading: 'Value'.
							html tableHeading: 'PrintString'].
					html
						tableRow: [html tableData: 'Nil String'.
							html
								tableData: [html textInput on: #nilString of: self].
							html
								tableData: [html text: nilString printString]].
					html
						tableRow: [html tableData: 'Empty String'.
							html
								tableData: [html textInput on: #emptyString of: self].
							html
								tableData: [html text: emptyString printString]].
					html
						tableRow: [html tableData: 'Integer'.
							html
								tableData: [html textInput setFocus; on: #integer of: self].
							html
								tableData: [html text: integer printString]].
					html
						tableRow: [html tableData: 'Fraction'.
							html
								tableData: [html textInput on: #fraction of: self].
							html
								tableData: [html text: fraction printString]].
					html
						tableRow: [html tableData: 'Text input with example'.
							html
								tableData: [html textInput value: self lastName;
										 exampleText: 'Your name';
										
										callback: [:v | self lastName: v]].
							html tableData: ''].
					html
						tableRow: [html tableData: 'Text area with example'.
							html
								tableData: [html textArea value: self address;
										 exampleText: 'Your address';
										
										callback: [:v | self address: v]].
							html tableData: ''].
					html
						tableRow: [html tableData: 'Selection'.
							html
								tableData: [html select list: #(#London #Paris '---' #Bamako #Dakar #London #Paris #Quito #Sydney );
										
										enablementBlock: [:v | v ~= #'---'];
										 on: #selection of: self].
							html
								tableData: [html text: selection]].
					html
						tableRow: [html tableData: 'Multi Selection'.
							html
								tableData: [html select beMultiple; list: #(#Lunch '---' #Breakfast #Dinner );
										enablementBlock: [:v | v ~= #'---'];
										on: #multiSelection of: self].
							html
								tableData: [html text: multiSelection]].
					html tableRow
						with: [html tableData: 'Input elements with no callback'.
							html tableData
								with: [html select size: 10;
										 list: Collection subclasses].
							html tableData
								with: [html unorderedList beMultiple; selected: #(); list: Collection subclasses]]].
			html submitButton]! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 11/3/2006 14:49'!
selection
	^ selection! !

!WACanvasInputTest methodsFor: 'accessing' stamp: 'mb 11/3/2006 14:50'!
selection: anObject
	selection := anObject! !

WAComponent subclass: #WACanvasLinkSubmitTest
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WACanvasLinkSubmitTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:45'!
count
	^count! !

!WACanvasLinkSubmitTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:46'!
count: anInteger
	count := anInteger! !

!WACanvasLinkSubmitTest methodsFor: 'initialize-release' stamp: 'pmm 7/19/2006 19:46'!
initialize
	super initialize.
	count := 0
! !

!WACanvasLinkSubmitTest methodsFor: 'rendering' stamp: 'lr 11/16/2006 16:47'!
renderContentOn: html
	| formId |
	formId := #myform.
	html form
		id: formId;
		with: [
			html textInput
				on: #count of: self.
			html break.
			html anchor
				id: #decreaseLink;
				addShortcut: 'Ctrl-Down';
				callback: [count := count - 1];
				submitFormNamed: formId;
				with: '--'.
			html space.
			html anchor
				id: #increaseLink;
				addShortcut: 'Ctrl-Up';
				callback: [count := count + 1];
				submitFormNamed: formId;
				with: '++'.
			html break; break.
			count = 0 ifFalse:
				[(html checkbox)
					addShortcut: 'Ctrl-Z';
					addShortcut: 'Ctrl-z';
					value: (count = 0);
					callback: [ :value | value ifTrue: [count := 0]];
					submitFormNamed: formId.
				html space.
				html text: 'Reset']].
	html emphasis: 'Handy shortcuts : Ctrl-Up, Ctrl-Down and Ctrl-Z'
! !

WAComponent subclass: #WACanvasModelTest
	instanceVariableNames: 'state user pass test'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WACanvasModelTest methodsFor: 'actions' stamp: 'mb 2/9/2006 15:25'!
logoff
	state := #OFF.
	test ifTrue: [self inform: 'Logged off']! !

!WACanvasModelTest methodsFor: 'actions' stamp: 'mb 2/9/2006 15:26'!
logon
	user isEmptyOrNil
		ifTrue:
			[self inform: 'Nope !!']
		ifFalse:
			[state := #ON.
			test ifTrue: [self inform: 'Logged on']]! !

!WACanvasModelTest methodsFor: 'accessing' stamp: 'mb 2/9/2006 15:04'!
pass
	"Answer the value of pass"

	^ pass! !

!WACanvasModelTest methodsFor: 'accessing' stamp: 'mb 2/9/2006 15:04'!
pass: anObject
	"Set the value of pass"

	pass := anObject! !

!WACanvasModelTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:55'!
renderContentOn: html
	| formId |
	formId := 'myform'.
	(html form)
		id: formId;
		with:
			[(html label)
				for: #userid; with:
					[html text: 'User name'; space.
					(html textInput) id: #userid; on: #user of: self].
			html break.
			(html label)
				for: #pass; with:
					[html text: 'Password'; space.
					(html passwordInput) on: #pass of: self].
			html break.
			(html label)
				for: #test; with:
					[html text: 'With feedback'; space.
					(html checkbox) on: #test of: self].
			html break.
			state == #ON
				ifFalse:
					[(html submitButton)
						callback: [self logon];
						text: 'Logon']
				ifTrue:
					[(html submitButton)
						callback: [self logoff];
						text: 'Logoff']].	! !

!WACanvasModelTest methodsFor: 'accessing' stamp: 'mb 2/9/2006 15:04'!
test
	"Answer the value of test"

	^ test! !

!WACanvasModelTest methodsFor: 'accessing' stamp: 'mb 2/9/2006 15:04'!
test: anObject
	"Set the value of test"

	test := anObject! !

!WACanvasModelTest methodsFor: 'accessing' stamp: 'mb 2/9/2006 15:10'!
user
	"Answer the value of user"

	^ user! !

!WACanvasModelTest methodsFor: 'accessing' stamp: 'mb 2/9/2006 15:10'!
user: anObject
	"Set the value of user"

	user := anObject! !

WAComponent subclass: #WACanvasTest
	instanceVariableNames: 'count selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WACanvasTest methodsFor: 'actions' stamp: 'avi 6/13/2004 01:06'!
decrease
	count := count - 1! !

!WACanvasTest methodsFor: 'actions' stamp: 'avi 6/13/2004 01:06'!
increase
	count := count + 1! !

!WACanvasTest methodsFor: 'initialize-release' stamp: 'pmm 7/19/2006 19:49'!
initialize
	super initialize.
	count := 0.
	selected := Array new.! !

!WACanvasTest methodsFor: 'rendering' stamp: 'mb 11/3/2006 14:54'!
renderContentOn: html
	html div style: 'background-color: lightblue'; with: [
		html text: count; break.
		html anchor callback: [self increase]; with: '++'.
		html space.
		html anchor callback: [self decrease]; with: '--'.
	].

	html table with: [
		html tableRow with: [
			html tableData with: [
				html form: [
					html select
						size: 10; 
						beMultiple; 
						beSubmitOnChange;
						list: Collection subclasses;
						on: #selected of: self ] ].
			html tableData with: [
				html unorderedList
					beMultiple;
					list: Collection subclasses;
					on: #selected of: self ] ] ].

! !

!WACanvasTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 19:59'!
selected
	^selected! !

!WACanvasTest methodsFor: 'accessing' stamp: 'pmm 7/19/2006 20:00'!
selected: aClass
	selected := aClass! !

WAComponent subclass: #WACanvasUploadTest
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WACanvasUploadTest methodsFor: 'rendering' stamp: 'lr 11/16/2006 16:48'!
renderContentOn: html
	html heading: 'Upload File'.

	html form
		multipart;
		with: [
			html fileUpload callback: [ :f | file := f].
			html submitButton text: 'Load'].

	file ifNotNil: [
		html anchor
			document: file contents mimeType: file contentType fileName: file fileName;
			with: file fileName , ' (' , file contentType , ')'.
		html break.
		html anchor
			document: file contents;
			with: file fileName.

		html preformatted: file contents ]! !

WAComponent subclass: #WAChangePassword
	instanceVariableNames: 'username password confirmation authenticator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAChangePassword methodsFor: 'accessing' stamp: 'avi 2/6/2004 22:37'!
authenticator: anAuthenticator
	authenticator := anAuthenticator! !

!WAChangePassword methodsFor: 'actions' stamp: 'avi 2/6/2004 23:10'!
cancel
	self answer: false! !

!WAChangePassword methodsFor: 'actions' stamp: 'avi 2/6/2004 23:09'!
changePassword
	password = confirmation
		ifFalse: [^ self inform: 'Sorry, the password and confirmation did not match.'].
	authenticator setPassword: password forUser: username.
	self answer: true
	! !

!WAChangePassword methodsFor: 'rendering' stamp: 'avi 2/6/2004 23:10'!
renderContentOn: html

	html form: [
		html table: [
			html
				tableRowWithLabel: 'Username'
				column: username.
			html
				tableRowWithLabel: 'Password'
				column: [html passwordInputWithCallback: [:v | password := v]].
			html
				tableRowWithLabel: 'Confirm Password'
				column: [html passwordInputWithCallback: [:v | confirmation := v]].
			html spacerRow.
			html attributes alignCenter.
			html tableRowWith: [
				html submitButtonOn: #changePassword of: self.
				html space.
				html submitButtonOn: #cancel of: self
			] span: 2.
		]
	]! !

!WAChangePassword methodsFor: 'accessing' stamp: 'avi 2/6/2004 22:37'!
username: aString
	username := aString! !

WAComponent subclass: #WAClosureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAClosureTest methodsFor: 'actions' stamp: 'avi 1/23/2004 19:43'!
ensure
	[self go] ensure: [self inform: 'ensure']! !

!WAClosureTest methodsFor: 'actions' stamp: 'mb 10/12/2006 18:58'!
go
	#(a b c) keysAndValuesDo: [:i :each |
		self inform: each displayString, ' ', i displayString]! !

!WAClosureTest methodsFor: 'rendering' stamp: 'avi 1/23/2004 19:47'!
renderContentOn: html
	html anchorWithAction: [self go] text: 'go'.
	html space.
	html anchorWithAction: [self ensure] text: 'go with ensure'.! !

!WAClosureTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 18:57'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

!WAComponent class methodsFor: 'utilities' stamp: 'mb 1/15/2007 15:31'!
applicationClass
	^WAApplication
! !

!WAComponent class methodsFor: 'registration' stamp: 'lr 2/12/2007 20:14'!
applicationNamed: aString
	| application |
	application := WAApplication named: aString.
	application configuration addAncestor: WARenderLoopConfiguration new.
	application preferenceAt: #rootComponent put: self.
	^ application! !

!WAComponent class methodsFor: 'testing' stamp: 'lr 11/29/2004 16:16'!
canBeRoot
	"When returning true, the component can be registered as a standalone application from the config interface."
	
	^ false! !

!WAComponent class methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:15'!
description
	^ self name! !

!WAComponent class methodsFor: 'accessing' stamp: 'mb 2/22/2007 14:27'!
headerForExampleBrowser
	^self name = self description
		ifTrue:
			[self name]
		ifFalse:
			[self description , ' (' , self name , ')']! !

!WAComponent class methodsFor: 'testing' stamp: 'mb 5/26/2006 11:01'!
isDeployed
	"When returning true, the component is to be kept in a deployed system,
	otherwise it is disabled"
	
	^ false

"
	Usage:

	1. 	Implement #isDeployed on the class side of
		the deployed root components

	2.	Evaluate the following

		WADispatcher default trimForDeployment

"! !

!WAComponent class methodsFor: 'instance-creation' stamp: 'avi 9/22/2004 13:57'!
new
	^ self basicNew initializeDecoration initialize! !

!WAComponent class methodsFor: 'registration' stamp: 'lr 2/12/2007 21:40'!
registerAsApplication: aString
	| path dispatcher |
	path := aString findTokens: '/'.
	dispatcher := path allButLast
		inject: WADispatcher default
		into: [ :result :each | 
			result entryPoints at: each ifAbsent: [ 
				result register: (WADispatcher named: each) ] ].
	^ dispatcher register: (self applicationNamed: path last)! !

!WAComponent class methodsFor: 'registration' stamp: 'lr 2/12/2007 21:42'!
registerAsAuthenticatedApplication: aString
	| application user password |
	application := self registerAsApplication: aString.
	application configuration addAncestor: WAAuthConfiguration new.
	user := SeasidePlatformSupport
		request: 'Please choose a username for\the application ' withCRs , aString printString.
	password := SeasidePlatformSupport
		request: 'Please enter a password for ', aString printString.
	application preferenceAt: #login put: user.
	application preferenceAt: #password put: password.
	^ application
	! !

!WAComponent class methodsFor: 'utilities' stamp: 'mb 1/15/2007 15:32'!
renderLoopConfigurationClass
	^WARenderLoopConfiguration! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 5/19/2004 14:18'!
activeComponent
	self visiblePresentersDo: [:ea | ea isDecoration ifFalse: [^ ea]]! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 6/2/2004 22:16'!
addDecoration: newDecoration
	| prev dec |
	prev := nil.
	dec := self decoration.
	[dec ~~ self and: [self decoration: dec shouldWrap: newDecoration]] whileTrue:
		[prev := dec.
		dec := dec owner].
	newDecoration owner: dec.
	prev
		ifNil: [self decoration: newDecoration]
		ifNotNil: [prev owner: newDecoration].
	^ newDecoration! !

!WAComponent methodsFor: 'convenience' stamp: 'RJT 5/8/2007 12:17'!
addMessage: aString
	^self addDecoration: (WAMessageDecoration new message: aString)! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 10/19/2004 15:55'!
allDecorationsDo: aBlock
	| ea |
	ea := self decoration.
	[ea notNil and: [ea ~~ self]] whileTrue:
		[aBlock value: ea.
		ea := ea owner]! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 3/27/2004 00:55'!
answer
	self answer: self! !

!WAComponent methodsFor: 'call/answer' stamp: 'mb 4/23/2007 14:52'!
answer: anObject
	"Give back control to the component from which the receiver was called from. When returning, a component can additionally return anObject to the caller."


	self decorationChainDo: [:ea | ea handleAnswer: anObject]! !

!WAComponent methodsFor: 'convenience' stamp: 'ac 3/22/2006 15:04'!
asComponent
	^ self! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 3/27/2004 00:55'!
authenticateWith: anAuthenticator during: aBlock
	^ self decorateWith: (WABasicAuthentication new authenticator: anAuthenticator) during: aBlock
! !

!WAComponent methodsFor: 'call/answer' stamp: 'mb 4/23/2007 14:52'!
call: aComponent 
	"Pass control from the receiver to aComponent. The receiver will be temporarily replaced with aComponent. Code can return from here later on by sending #answer: to aComponent."


	^ AnswerContinuation
		currentDo: [:cc | 
			self show: aComponent onAnswer: cc.
			WARenderNotification raiseSignal]
! !

!WAComponent methodsFor: 'accessing' stamp: 'mb 4/23/2007 14:21'!
children
	"This method is really important. It should return a collection of all subcomponents of the current component that will be rendered in #renderContentOn:. Components that are displayed using #call: are *not* children.
	
	If the contents returned by this method change over time make sure to register the receiver for backtracking by sending #registerForBacktracking (preferably in the #initialize method), otherwise the back button will fail."

	^ #()! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 6/8/2004 00:57'!
childrenDo: aBlock
	self children do: [:ea | ea ifNotNil: [aBlock value: ea]]! !

!WAComponent methodsFor: 'convenience' stamp: 'RJT 5/8/2007 12:19'!
confirm: aString
	
	^ self call: (WAYesOrNoDialog new addMessage: aString; yourself).! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 3/27/2004 19:53'!
decorateWith: aDecoration during: aBlock
	| val |
	self addDecoration: aDecoration.
	val := aBlock value.
	self removeDecoration: aDecoration.
	^ val! !

!WAComponent methodsFor: 'accessing' stamp: 'avi 4/13/2004 20:36'!
decoration
	decoration ifNil: [decoration := WAStateHolder new contents: self].
	^ decoration contents! !

!WAComponent methodsFor: 'accessing' stamp: 'avi 9/22/2004 13:59'!
decoration: aDecoration
	decoration contents: aDecoration! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 3/28/2004 20:49'!
decoration: oldDecoration shouldWrap: newDecoration
	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isDelegation and: [newDecoration isLocal]]! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 4/22/2004 14:50'!
decorationChainDo: aBlock
	aBlock value: self decoration! !

!WAComponent methodsFor: 'accessing' stamp: 'avi 10/19/2004 15:57'!
delegations
	| delegations |
	delegations := OrderedCollection new.
	self allDecorationsDo: [:ea | ea isDelegation ifTrue: [delegations add: ea]].
	^ delegations! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 6/8/2004 01:13'!
handleAnswer: anObject
	^ false! !

!WAComponent methodsFor: 'accessing' stamp: 'avi 10/19/2004 15:56'!
home
	self delegations do: [:ea | self removeDecoration: ea]! !

!WAComponent methodsFor: 'convenience' stamp: 'RJT 5/8/2007 12:25'!
inform: aString
	self call: (WAFormDialog new addMessage: aString; yourself)
! !

!WAComponent methodsFor: 'initialization' stamp: 'avi 9/22/2004 13:59'!
initializeDecoration
	decoration := WAStateHolder new contents: self! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
isolate: aBlock
	|txn val |
	txn := WATransaction new.
	val := self decorateWith: txn during: aBlock.
	txn close.
	^ val! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 6/8/2004 00:59'!
nextPresentersDo: aBlock
	self childrenDo: [:ea | ea decorationChainDo: aBlock]! !

!WAComponent methodsFor: 'call/answer' stamp: 'mb 4/23/2007 14:52'!
onAnswer: aBlock
	"adds an answer handler"


	^ self addDecoration: (WAAnswerHandler new block: aBlock)! !

!WAComponent methodsFor: 'convenience' stamp: 'pmm 10/8/2006 21:06'!
registerForBacktracking
	self session registerObjectForBacktracking: self! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 7/6/2004 10:40'!
removeDecoration: aDecoration
	| dec |
	dec := self decoration.
	dec = aDecoration ifTrue:
		[self decoration: dec owner.
		^ self].
	
	[dec notNil] whileTrue:
		[dec owner = aDecoration
			ifTrue: [dec owner: aDecoration owner.  ^ self]
			ifFalse: [dec := dec owner]]! !

!WAComponent methodsFor: 'rendering' stamp: 'lr 11/29/2004 16:19'!
renderOn: aRenderer
	"Do not override this methods on your component, override instead #renderContentOn: and in addition to not invoke directly renderContentOn: on subcomponent in such method but use instead html render: subcomponent."

	self decorationChainDo: [ :each | each renderWithContext: aRenderer context ].! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: aString
	^ self request: aString default: ''! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: aString default: initialString
	^ self request: aString label: nil default: initialString! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: requestString label: labelString
	^ self request: requestString label: labelString default: ''! !

!WAComponent methodsFor: 'convenience' stamp: 'RJT 5/8/2007 12:25'!
request: requestString label: labelString default: initialString
	^ self call:
		((WAInputDialog new
			label: labelString;
			default: initialString;
			yourself)
				addMessage: requestString; yourself)! !

!WAComponent methodsFor: 'call/answer' stamp: 'mb 4/23/2007 14:52'!
show: aComponent
	"displays a component on this component
	like #call: but not blocking"


	self 
		show: aComponent
		onAnswer: [:value | ]! !

!WAComponent methodsFor: 'call/answer' stamp: 'mb 4/23/2007 14:52'!
show: aComponent onAnswer: aBlock
	"displays a component on this component
	like #call: but not blocking and with continuation passing style where the continuation is aBlock."


	self 
		show: aComponent 
		onAnswer: aBlock 
		delegation: (WADelegation new 
			delegate: aComponent;
			yourself)! !

!WAComponent methodsFor: 'call/answer' stamp: 'mb 4/7/2007 02:06'!
show: aComponent onAnswer: aBlock delegation: aDelegation 
	| event |
	event := nil.
	event := aComponent
				onAnswer: [:value | 
					aDelegation remove.
					event remove.
					aBlock value: value].
	self addDecoration: aDelegation! !

!WAComponent methodsFor: 'convenience' stamp: 'cds 7/25/2005 10:24'!
validateWith: aBlock
	^self addDecoration: (WAValidationDecoration new validateWith: aBlock)! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 6/8/2004 00:58'!
visiblePresentersDo: aBlock
	self decorationChainDo: [:ea | ea withNextPresentersDo: aBlock]! !

WAComponent subclass: #WAConfigurationEditor
	instanceVariableNames: 'configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

WAConfigurationEditor subclass: #WAApplicationEditor
	instanceVariableNames: 'application library'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAApplicationEditor methodsFor: 'actions' stamp: 'pmm 2/13/2007 19:31'!
addLibrary
	application addLibrary: library! !

!WAApplicationEditor methodsFor: 'accessing' stamp: 'pmm 2/13/2007 19:53'!
allLibraries
	^ (WAStyleLibrary subclasses, WAScriptLibrary subclasses, WAFileLibrary allSubclasses asArray)
		asSortedCollection: [ :a :b | a name <= b name ]! !

!WAApplicationEditor methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:32'!
application: anApplication
	application := anApplication.
	configuration := application configuration.! !

!WAApplicationEditor methodsFor: 'accessing' stamp: 'avi 6/24/2004 00:23'!
libraryOptions
	^ self allLibraries difference: application libraries! !

!WAApplicationEditor methodsFor: 'rendering' stamp: 'lr 2/12/2007 22:19'!
renderContentOn: html
	html heading level1; with: 'Application: ' , application name.
	super renderContentOn: html! !

!WAApplicationEditor methodsFor: 'rendering' stamp: 'lr 2/12/2007 22:18'!
renderFormOn: html
	self renderLibrariesOn: html.
	super renderFormOn: html! !

!WAApplicationEditor methodsFor: 'rendering' stamp: 'pmm 2/13/2007 19:29'!
renderLibrariesOn: html
	html heading level2 with: 'Libraries'.
	self libraryOptions isEmpty ifFalse: [
		html text: 'Add Library: '.
		html select
			list: self libraryOptions;
			selected: nil;
			callback: [ :value | library := value ].
		html space.
		html submitButton
			callback: [ self addLibrary ];
			text: 'Add' ].
	html unorderedList: [
		application libraries do: [ :each |
			html listItem: [
				html text: each.
				html space.
				html anchor
					callback: [ application removeLibrary: each ];
					with: '(remove)' ] ] ]! !

!WAConfigurationEditor methodsFor: 'actions' stamp: 'lr 2/12/2007 22:17'!
close
	self answer! !

!WAConfigurationEditor methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:30'!
configuration
	^ configuration! !

!WAConfigurationEditor methodsFor: 'accessing' stamp: 'avi 1/31/2004 12:02'!
configuration: aConfiguration
	configuration := aConfiguration! !

!WAConfigurationEditor methodsFor: 'initialization' stamp: 'mb 4/23/2006 15:13'!
initialize
	super initialize.
	configuration := WAConfiguration new! !

!WAConfigurationEditor methodsFor: 'rendering-ancestry' stamp: 'lr 2/12/2007 22:23'!
renderAncestryListFor: aConfiguration seen: aSet on: html
	aConfiguration ancestors isEmpty ifTrue: [ ^ self ].
	html unorderedList: [
		aConfiguration ancestors do: [ :each |
			html listItem: [
				self renderParent: each on: html.
				(aSet includes: each) ifFalse: [
					aSet add: each.
					self renderAncestryListFor: each seen: aSet on: html ] ] ] ]! !

!WAConfigurationEditor methodsFor: 'rendering-ancestry' stamp: 'lr 2/12/2007 22:26'!
renderAncestryOn: html
	html heading level2; with: 'Ancestry'.
	configuration potentialAncestors isEmpty ifFalse: [
		html text: 'Add ancestor: '.
		self renderParentSelectorOn: html ].
	self renderAncestryListFor: configuration seen: Set new on: html! !

!WAConfigurationEditor methodsFor: 'rendering-attributes' stamp: 'lr 2/12/2007 22:27'!
renderAttribute: anAttribute on: html
	html tableRow: [
		html tableData: (self labelForSelector: anAttribute key).
		html tableData: [
			(configuration valueForAttribute: anAttribute)
				ifNil: [ self renderUnspecifiedAttribute: anAttribute on: html ]
				ifNotNil: [
					(configuration hasLocalValueForAttribute: anAttribute)
						ifTrue: [ self renderOverridenAttribute: anAttribute on: html ]
						ifFalse: [ self renderInheritedAttribute: anAttribute on: html ] ] ].
		self renderInheritanceForAttribute: anAttribute on: html ]! !

!WAConfigurationEditor methodsFor: 'rendering-attributes' stamp: 'lr 2/12/2007 22:26'!
renderAttributesOn: html
	html heading level2; with: 'Configuration'.
	html table: [
		configuration groupedAttributes do: [ :associaction |
			html tableRow: [
				html tableData
					colSpan: 4; 
					with: [ html heading level3; with: (self labelForSelector: associaction key) ] ].
				associaction value do: [ :attribute |
				self renderAttribute: attribute on: html ] ] ]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'lr 2/12/2007 22:30'!
renderButtonsOn: html
	html break.
	html submitButton on: #save of: self.
	html submitButton on: #close of: self! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'lr 2/12/2007 22:19'!
renderContentOn: html
	html form: [
		self renderFormOn: html.
		self renderButtonsOn: html ]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'mb 2/7/2007 11:44'!
renderFormButtonsOn: html
	html submitButton on: #save of: self.
	html submitButton on: #done of: self.! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'lr 2/12/2007 22:25'!
renderFormOn: html
	self renderAncestryOn: html.
	self renderAttributesOn: html! !

!WAConfigurationEditor methodsFor: 'rendering-attributes' stamp: 'lr 2/12/2007 22:27'!
renderInheritanceForAttribute: anAttribute on: html
	configuration inheritedValueAndSourceAt: anAttribute key do: [:value :source |
		(configuration hasLocalValueForAttribute: anAttribute)
			ifTrue: [
				html tableData: [
					html anchor callback: [configuration clearValueForAttribute: anAttribute]; with: 'revert'.
					html text: ' to: ', value printString].
				html tableData: 'overriden from ', source name ]
			ifFalse: [
				html tableData: [
					html anchor callback: [configuration overrideAttribute: anAttribute]; with: 'override'].
				html tableData: 'inherited from ', source name ].
		^ self ].
	(configuration hasLocalValueForAttribute: anAttribute)
		ifTrue: [
			html tableData: [
				html anchor callback: [configuration clearValueForAttribute: anAttribute]; with: 'clear']]
		ifFalse: [
			html tableData: [
				html span
					style: 'color: #ff0000';
					with: '(unspecified)' ] ].
	html tableData! !

!WAConfigurationEditor methodsFor: 'rendering-attributes' stamp: 'avi 3/23/2004 12:35'!
renderInheritedAttribute: anAttribute on: html
	html text: (configuration valueForAttribute: anAttribute) printString! !

!WAConfigurationEditor methodsFor: 'rendering-attributes' stamp: 'pmm 4/23/2006 20:11'!
renderInheritedValueForAttribute: anAttribute on: html
	| inheritedValue |
	inheritedValue := (configuration lookupValueAt: anAttribute key).
	inheritedValue isNil
		ifTrue: [
			html span
				style: 'color: #ff0000';
				with: '(unspecified)' ]
		ifFalse: [ html text: inheritedValue printString ]! !

!WAConfigurationEditor methodsFor: 'rendering-attributes' stamp: 'pmm 4/23/2006 20:12'!
renderOverrideForAttribute: anAttribute on: html
	html anchor callback: [configuration overrideAttribute: anAttribute]; with: 'edit'! !

!WAConfigurationEditor methodsFor: 'rendering-attributes' stamp: 'avi 3/23/2004 12:34'!
renderOverridenAttribute: anAttribute on: html
	anAttribute accept: self with: html! !

!WAConfigurationEditor methodsFor: 'rendering-ancestry' stamp: 'lr 2/12/2007 22:24'!
renderParent: aConfiguration on: html
	html text: aConfiguration name; space.
	(configuration hasMutableAncestry and: [ configuration ancestors includes: aConfiguration]) ifTrue: [
		html anchor
			callback: [ configuration removeAncestor: aConfiguration ];
			with: '(remove)' ]! !

!WAConfigurationEditor methodsFor: 'rendering-ancestry' stamp: 'lr 2/12/2007 22:23'!
renderParentSelectorOn: html
	| selectedAncestor |
	selectedAncestor := ValueHolder new.
	html select
		list: configuration potentialAncestors;
		selected: nil;
		callback: [ :value | selectedAncestor contents: value ];
		labels: [ :each | each name ].
	html space.
	html submitButton
		callback: [ configuration addAncestor: selectedAncestor contents ];
		text: 'Add'! !

!WAConfigurationEditor methodsFor: 'rendering-attributes' stamp: 'pmm 4/23/2006 20:15'!
renderRevertForAttribute: anAttribute on: html
	html anchor callback: [configuration clearValueForAttribute: anAttribute]; with: 'clear'! !

!WAConfigurationEditor methodsFor: 'rendering-attributes' stamp: 'avi 3/23/2004 12:35'!
renderUnspecifiedAttribute: anAttribute on: html
	anAttribute accept: self with: html! !

!WAConfigurationEditor methodsFor: 'actions' stamp: 'avi 3/23/2004 14:36'!
save! !

!WAConfigurationEditor methodsFor: 'actions' stamp: 'avi 3/23/2004 14:34'!
select: aConfiguration
	self call: (WAConfigurationEditor new configuration: aConfiguration)! !

!WAConfigurationEditor methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:40'!
trailName
	^ configuration name! !

!WAConfigurationEditor methodsFor: 'rendering-visitors' stamp: 'pmm 4/23/2006 20:18'!
visitBooleanAttribute: anAttribute with: html
	html select
		list: (Array with: true with: false);
		selected: (configuration valueForAttribute: anAttribute);
		callback: [:v | configuration takeValue: v forAttribute: anAttribute];
		labels: [ :b | b ifTrue: [ 'true' ] ifFalse: [ 'false' ] ]! !

!WAConfigurationEditor methodsFor: 'rendering-visitors' stamp: 'pmm 4/23/2006 20:19'!
visitListAttribute: anAttribute with: html
	html select
		list: (Array with: nil), anAttribute options asArray;
		selected: (configuration valueForAttribute: anAttribute);
		callback: [ :value | (configuration takeValue: value forAttribute: anAttribute ) ];
		labels: [ :each | each ifNil: ['None'] ifNotNil: [ each displayString] ]! !

!WAConfigurationEditor methodsFor: 'rendering-visitors' stamp: 'pmm 4/23/2006 20:20'!
visitNumberAttribute: anAttribute with: html
	html textInput
		size: 5;
		callback: [ :value | configuration takeValue: value asNumber forAttribute: anAttribute ];
		value: (configuration valueForAttribute: anAttribute)! !

!WAConfigurationEditor methodsFor: 'rendering-visitors' stamp: 'lr 5/3/2006 09:57'!
visitPasswordAttribute: anAttribute with: html
	html passwordInput 
		callback: [ :value | configuration takeValue: (anAttribute valueFromString: value) forAttribute: anAttribute ]! !

!WAConfigurationEditor methodsFor: 'rendering-visitors' stamp: 'lr 5/3/2006 09:58'!
visitStringAttribute: anAttribute with: html
	html textInput
		callback: [ :value | configuration takeValue: (anAttribute valueFromString: value) forAttribute: anAttribute ];
		value: (configuration valueForAttribute: anAttribute)! !

WAComponent subclass: #WACounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WACounter commentStamp: '<historical>' prior: 0!
A WACounter is component that displays a number. Additionally it has two links that allow the user to increase or decrease this number by 1. 

The lesson to learn here is how the Seaside callback mechanism is used, how anchors can be used to trigger actions.

Instance Variables
	count:		<Integer>

count
	- the number to display, default 0
!

!WACounter class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WACounter class methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:16'!
description
	^ 'A very simple Seaside application'! !

!WACounter class methodsFor: 'examples' stamp: 'ab 6/14/2003 19:02'!
example
	^ self new! !

!WACounter class methodsFor: 'initialization' stamp: 'lr 2/12/2007 21:50'!
initialize
	self registerAsApplication: 'examples/counter'! !

!WACounter methodsFor: 'accessing' stamp: 'avi 2/3/2004 00:59'!
count
	^ count! !

!WACounter methodsFor: 'accessing' stamp: 'lr 2/20/2007 12:05'!
count: anInteger
	count := anInteger! !

!WACounter methodsFor: 'actions' stamp: 'pmm 7/19/2006 18:49'!
decrease
	count := count - 1! !

!WACounter methodsFor: 'actions' stamp: 'pmm 7/19/2006 18:49'!
increase
	count := count + 1! !

!WACounter methodsFor: 'initialization' stamp: 'lr 2/20/2007 12:05'!
initialize
	super initialize.
	self registerForBacktracking.
	self count: 0! !

!WACounter methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:11'!
renderContentOn: html
	html heading: count.
	html anchor 
		callback: [ self increase ];
		with: '++'.
	html space.
	html anchor
		callback: [ self decrease ];
		with: '--'! !

WAComponent subclass: #WADateSelector
	instanceVariableNames: 'day month year startYear endYear'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/22/2006 08:02'!
date
	(self privateIsValidDay: day monthNumber: month year: year)
		ifFalse: [self error: 'Invalid date'].
	^ self dateClass year: year month: month day: day! !

!WADateSelector methodsFor: 'accessing' stamp: 'ab 2/17/2003 13:52'!
date: aDate
	day := aDate dayOfMonth.
	month := aDate monthIndex.
	year := aDate year.! !

!WADateSelector methodsFor: 'private' stamp: 'pmm 10/22/2006 07:59'!
dateClass
	^ Date! !

!WADateSelector methodsFor: 'testing' stamp: 'ab 2/17/2003 13:53'!
dateIsValid
	[self date] on: Error do: [:e | ^ false].
	^ true! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
day
	^day! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
day: anObject
	^day := anObject! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:06'!
days
	^ 1 to: 31! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:44'!
endYear
	^ endYear! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:41'!
endYear: anInteger
	endYear := anInteger! !

!WADateSelector methodsFor: 'initialize-release' stamp: 'pmm 10/22/2006 08:00'!
initialize
	super initialize.
	startYear := Date today year - 1.
	endYear := Date today year + 5.
	self date: self dateClass today.! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:34'!
labelForDay: aNumber
	^ aNumber! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:33'!
labelForMonth: aNumber
	^ Date nameOfMonth: aNumber! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:34'!
labelForYear: aNumber
	^ aNumber! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
month
	^month! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
month: anObject
	^month := anObject! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:06'!
months
	^ 1 to: 12! !

!WADateSelector methodsFor: 'private' stamp: 'avi 7/11/2005 12:44'!
privateIsValidDay: theDay monthNumber: theMonth year: theYear
	| maxDay |
	theMonth > 0 & (theMonth <= 12) ifFalse: [^false].
	maxDay := Month daysInMonth: theMonth forYear: theYear.
	^theDay > 0 & (theDay <= maxDay)! !

!WADateSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:05'!
renderContentOn: html
	html select
		list: self months;
		on: #month of: self;
		labels: [ :each | self labelForMonth: each ].
		
	html select
		list: self days;
		on: #day of: self;
		labels: [ :each | self labelForDay: each ].
		
	html select
		list: self yearRange;
		on: #year of: self;
		labels: [ :each | self labelForYear: each ].
	
	self dateIsValid ifFalse: [self renderValidationErrorOn: html].! !

!WADateSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:00'!
renderValidationErrorOn: html
	html span
		class: 'error';
		with: 'invalid date'! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:44'!
startYear
	^ startYear! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:40'!
startYear: anInteger
	startYear := anInteger! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:02'!
year
	^year! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:02'!
year: anObject
	^year := anObject! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:43'!
yearRange
	^ self startYear to: self endYear! !

WAComponent subclass: #WADateSelectorTest
	instanceVariableNames: 'beginDate endDate beginTime endTime beginDAT endDAT'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WADateSelectorTest class methodsFor: 'examples' stamp: 'mb 2/10/2006 13:18'!
example
	^self new.! !

!WADateSelectorTest class methodsFor: 'class initialization' stamp: 'lr 6/13/2006 16:10'!
initialize
	self registerAsApplication: 'tests/dateselector'! !

!WADateSelectorTest methodsFor: 'accessing' stamp: 'mb 4/21/2006 17:13'!
children
	^(OrderedCollection new)
		add: beginDate;
		add: endDate;
		add: beginTime;
		add: endTime;
		add: beginDAT;
		add: endDAT;
		yourself.! !

!WADateSelectorTest methodsFor: 'initialization' stamp: 'pmm 7/19/2006 19:51'!
initialize
	super initialize.
	beginDate := WADateSelector new.
	endDate := WADateSelector new.
	endDate date: (Date today addDays: 1).

	beginTime := WATimeSelector new.
	beginTime time: Time now.
	endTime := WATimeSelector new.
	endTime time: (beginTime time addSeconds: 3600).

	beginDAT := WADateTimeSelector new.
	endDAT := WADateTimeSelector new.
	endDAT dateAndTime: beginDAT dateAndTime + 1 day + 1 hour! !

!WADateSelectorTest methodsFor: 'rendering' stamp: 'dc 7/21/2006 21:11'!
renderContentOn: html

	self renderDateSelectorsOn: html.
	html horizontalRule.
	self renderTimeSelectorsOn: html.
	html horizontalRule.
	self renderDateTimeSelectorsOn: html.
! !

!WADateSelectorTest methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:09'!
renderDateSelectorsOn: html
	html heading level: 3; with: 'Dates'.
	html form: [
		html table: [
			html tableRow: [
				html tableData: 'From'; tableData: beginDate].
			html tableRow: [
				html tableData: 'To'; tableData: endDate]].
		html submitButton
			callback: [self inform: (endDate date - beginDate date) days printString , ' day(s)'];
			text: 'Compute duration'].
! !

!WADateSelectorTest methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:08'!
renderDateTimeSelectorsOn: html
	html heading level: 3; with: 'Dates and Times'.
	html form: [
		html table: [
			html tableRow: [
				html tableData: 'From'; tableData: beginDAT ].
			html tableRow: [
				html tableData: 'To'; tableData: endDAT ] ].
		html submitButton
			callback: [
				| dateDiff |
				dateDiff := (endDAT dateAndTime asDate - beginDAT dateAndTime asDate) days.
				dateDiff isZero 
					ifFalse: [ self inform: dateDiff printString , ' day(s)' ]
					ifTrue: [ self inform: (endDAT dateAndTime asTime
										subtractTime: beginDAT dateAndTime asTime) asSeconds printString ,
										' second(s)']];
			text: 'Compute duration'].
! !

!WADateSelectorTest methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:07'!
renderTimeSelectorsOn: html
	html heading level: 3; with: 'Times'.
	html form: [
		html table: [
			html tableRow: [
				html tableData: 'From'; tableData: beginTime].
			html tableRow: [
				html tableData: 'To'; tableData: endTime ] ].
		html submitButton
			callback: [self inform: (endTime time subtractTime: beginTime time) asSeconds printString , ' seconds(s)'];
			text: 'Compute duration'].
! !

WAComponent subclass: #WADateTable
	instanceVariableNames: 'rows startDate endDate datesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WADateTable methodsFor: 'enumerating' stamp: 'ab 2/18/2003 14:52'!
datesDo: aBlock separatedBy: monthlyBlock
	| month|
	month := datesCache first monthIndex.
	datesCache do:
		[:date |
		date monthIndex = month ifFalse: [month := date monthIndex. monthlyBlock value].
		aBlock value: date].
	monthlyBlock value.! !

!WADateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 20:56'!
endDate: aDate
	endDate := aDate.
	self updateDatesCache.! !

!WADateTable methodsFor: 'enumerating' stamp: 'ab 2/17/2003 16:19'!
monthsAndLengthsDo: aBlock
	|count last|
	count := 0.
	self
		datesDo: [:ea | count := count + 1. last := ea]
		separatedBy: [aBlock value: last month value: count.
						count := 0]! !

!WADateTable methodsFor: 'rendering' stamp: 'ab 2/17/2003 16:59'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	html tableData: [html space]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:17'!
renderContentOn: html
	html table
		class: 'DateTable';
		border: 1;
		with: [
			html tableRow: [ self renderMonthHeadingsOn: html ].
			html tableRow: [ self renderDayHeadingsOn: html ].
			rows withIndexDo: [ :each :index |
				html tableRow: [self renderRow: each index: index on: html ] ] ]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:19'!
renderDayHeadingsOn: html
	self renderHeadingSpacerOn: html.
	self
		datesDo: [:date |
			html tableHeading
				class: 'DayHeading';
				with: date dayOfMonth ]
		separatedBy: [ self renderHeadingSpacerOn: html ]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:20'!
renderHeadingForRow: anObject on: html
	html tableHeading
		class: 'RowHeading';
		with: anObject! !

!WADateTable methodsFor: 'rendering' stamp: 'ab 2/17/2003 16:22'!
renderHeadingSpacerOn: html
	html tableData: []! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:21'!
renderMonthHeadingsOn: html
	self monthsAndLengthsDo: [ :month :length |
		self renderHeadingSpacerOn: html.
		html tableHeading
			colSpan: length;
			class: 'MonthHeading';
			with: [
				html text: month name.
				html space.
				html text: month year ] ]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:22'!
renderRow: anObject index: aNumber on: html
	self renderHeadingForRow: anObject on: html.
	self
		datesDo: [ :date | self renderCellForDate: date row: anObject index: aNumber on: html]	
		separatedBy: [ self renderHeadingSpacerOn: html ]! !

!WADateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 14:11'!
rows: aCollection
	rows := aCollection! !

!WADateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 20:56'!
startDate: aDate
	startDate := aDate.
	self updateDatesCache.! !

!WADateTable methodsFor: 'actions' stamp: 'ab 2/17/2003 20:58'!
updateDatesCache
	| date |
	(startDate isNil or: [endDate isNil]) ifTrue: [^ self].
	
	datesCache := OrderedCollection new.
	date := startDate.
	[date > endDate] whileFalse:
		[datesCache add: date.
		date := date next]! !

WADateTable subclass: #WASelectionDateTable
	instanceVariableNames: 'cellBlock dateSelectionStart dateSelectionEnd rowSelectionStart rowSelectionEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WASelectionDateTable methodsFor: 'selecting' stamp: 'ab 2/17/2003 17:23'!
clearSelection
	dateSelectionStart := dateSelectionEnd := rowSelectionStart := rowSelectionEnd := nil! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:19'!
colorForDate: aDate rowIndex: aNumber
	^ (self hasSelection
		and: [self selectionContainsDate: aDate rowIndex: aNumber])
			ifTrue: ['lightgrey']
			ifFalse: ['white']! !

!WASelectionDateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 19:56'!
endDate: aDate
	self clearSelection.
	super endDate: aDate! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:22'!
endDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart max: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
endRow
	^ rowSelectionStart max: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:27'!
endRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart max: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'testing' stamp: 'ab 2/17/2003 17:02'!
hasSelection
	^ dateSelectionStart notNil! !

!WASelectionDateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:27'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	| text |
	html tableData
		style: 'background-color: ', (self colorForDate: aDate rowIndex: aNumber);
		align: 'center';
		with: [
			text := cellBlock value: anObject value: aDate.
			html anchor callback: [self selectDate: aDate rowIndex: aNumber]; with: text ]! !

!WASelectionDateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 19:56'!
rows: aCollection
	self clearSelection.
	super rows: aCollection! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:48'!
rowsAndDatesDisplay: aBlock
	cellBlock := aBlock! !

!WASelectionDateTable methodsFor: 'editor access' stamp: 'ab 2/17/2003 20:04'!
selectAll
	dateSelectionStart := startDate.
	dateSelectionEnd := endDate.
	rowSelectionStart := 1.
	rowSelectionEnd := rows size.! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:05'!
selectDate: aDate rowIndex: rowIndex
	self hasSelection
		ifFalse: [dateSelectionStart := dateSelectionEnd := aDate. rowSelectionStart := rowSelectionEnd := rowIndex]
		ifTrue: [dateSelectionEnd := aDate. rowSelectionEnd := rowIndex]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
selectedRows
	^ rows copyFrom: self startRow to: self endRow! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:18'!
selectionContainsDate: aDate rowIndex: aNumber
	^ ((aDate between: dateSelectionStart and: dateSelectionEnd) or: [aDate between: dateSelectionEnd and: dateSelectionStart])
		and: [(aNumber between: rowSelectionStart and: rowSelectionEnd) or: [aNumber between: rowSelectionEnd and: rowSelectionStart]]! !

!WASelectionDateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 19:56'!
startDate: aDate
	self clearSelection.
	super startDate: aDate! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:22'!
startDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart min: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
startRow
	^ rowSelectionStart min: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:27'!
startRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart min: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'rendering' stamp: 'ab 2/17/2003 22:43'!
style
	^ 'td a {text-decoration: none}'! !

WAComponent subclass: #WADateTimeSelector
	instanceVariableNames: 'dateSelector timeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WADateTimeSelector methodsFor: 'accessing' stamp: 'jlr 4/5/2006 00:19'!
children

	^ Array with: dateSelector with: timeSelector! !

!WADateTimeSelector methodsFor: 'accessing' stamp: 'jlr 4/5/2006 00:22'!
dateAndTime

	^ DateAndTime date: dateSelector date time: timeSelector time! !

!WADateTimeSelector methodsFor: 'accessing' stamp: 'mb 4/21/2006 17:22'!
dateAndTime: anObject

	dateSelector date: anObject asDate.
	timeSelector time: anObject asTime.! !

!WADateTimeSelector methodsFor: 'initialize-release' stamp: 'mb 5/6/2006 16:07'!
initialize
	super initialize.
	dateSelector := WADateSelector new.
	timeSelector := WATimeSelector new.! !

!WADateTimeSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:29'!
renderContentOn: html

	html span: dateSelector.
	html span: [html strong: ' : '].
	html span: timeSelector.! !

WAComponent subclass: #WADefaultFormTest
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WADefaultFormTest methodsFor: 'rendering' stamp: 'mb 4/5/2006 07:21'!
renderContentOn: html
	html formWithDefaultAction: [self inform: 'Default: ', value displayString] do: 
		[
		html submitButtonWithAction: [self inform: 'Before: ', value displayString] text: 'Before'.
		html break.
		html textInputWithValue: '' callback: [:v | value := v].
		html submitButtonWithAction: [self inform: 'Go: ' , value displayString] text: 'Go'.
		html break.
		html submitButtonWithAction: [self inform: 'After: ', value displayString] text: 'After']! !

!WADefaultFormTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:01'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WADelayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WADelayTest methodsFor: 'actions' stamp: 'avi 3/27/2005 20:39'!
go
	self call: (WAComponent new
				addMessage: '3 seconds';
				addDecoration: (WADelayedAnswerDecoration new delay: 3);
				yourself)! !

!WADelayTest methodsFor: 'rendering' stamp: 'avi 3/27/2005 20:35'!
renderContentOn: html
	html anchorWithAction: [self go] text: 'go'! !

!WADelayTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:02'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WADispatcherComponent
	instanceVariableNames: 'dispatcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WADispatcherComponent class methodsFor: 'instance-creation' stamp: 'lr 1/5/2007 22:14'!
on: aDispatcher
	^ self new dispatcher: aDispatcher! !

!WADispatcherComponent class methodsFor: 'instance-creation' stamp: 'mb 2/14/2007 17:54'!
registerAsApplication: aString
	^(super registerAsApplication: aString)
		addLibrary: WADispatcherFiles;
		yourself.! !

!WADispatcherComponent methodsFor: 'accessing' stamp: 'lr 1/5/2007 19:03'!
dispatcher
	^ dispatcher! !

!WADispatcherComponent methodsFor: 'accessing' stamp: 'lr 1/5/2007 19:03'!
dispatcher: aDispatcher
	dispatcher := aDispatcher! !

!WADispatcherComponent methodsFor: 'accessing' stamp: 'lr 1/5/2007 22:22'!
entryPoints
	"Answer a dictionary with the visible entry points of the dispatcher."
	
	^ self dispatcher entryPoints select: [ :each | each isEntryPoint ]! !

!WADispatcherComponent methodsFor: 'initialization' stamp: 'lr 2/16/2007 15:36'!
initialize
	super initialize.
	self dispatcher: self application parent.
	self session registerObjectForBacktracking: self! !

!WADispatcherComponent methodsFor: 'rendering' stamp: 'lr 1/5/2007 19:17'!
renderContentOn: html
	self renderHeadingOn: html.
	self renderDispatcherOn: html! !

!WADispatcherComponent methodsFor: 'rendering' stamp: 'mb 2/18/2007 01:28'!
renderDispatcherOn: html
	html heading level: 2; with: self dispatcher basePath , '/'.
	html table: [
		self dispatcher isRoot
			ifFalse: [ self renderRow: self dispatcher parent named: '..' on: html ].
		self entryPoints keysSortedSafely
			do: [ :each | self renderRow: (dispatcher entryPoints at: each) named: each on: html ] ]! !

!WADispatcherComponent methodsFor: 'rendering' stamp: 'lr 2/12/2007 23:12'!
renderHeadingOn: html
	html heading level: 1; with: 'Seaside'.
	html div class: 'version'; with: SeasidePlatformSupport versionString! !

!WADispatcherComponent methodsFor: 'rendering-rows' stamp: 'lr 1/5/2007 22:08'!
renderRow: anEntryPoint named: aString on: html
	html tableRow: [
		html tableData: [ self renderRowName: anEntryPoint named: aString on: html ].
		html tableData: [ self renderRowDescription: anEntryPoint named: aString on: html ].
		html tableData: [ self renderRowActions: anEntryPoint named: aString on: html ] ]! !

!WADispatcherComponent methodsFor: 'rendering-rows' stamp: 'lr 1/5/2007 22:08'!
renderRowActions: anEntryPoint named: aString on: html! !

!WADispatcherComponent methodsFor: 'rendering-rows' stamp: 'lr 2/12/2007 23:10'!
renderRowDescription: anEntryPoint named: aString on: html
	aString = self upDirectory 
		ifFalse: [ html render: anEntryPoint description ]
		ifTrue: [ html render: 'Parent Directory' ]! !

!WADispatcherComponent methodsFor: 'rendering-rows' stamp: 'lr 2/12/2007 23:10'!
renderRowName: anEntryPoint named: aString on: html
	anEntryPoint isDispatcher
		ifTrue: [ html anchor callback: [ self dispatcher: anEntryPoint ]; with: aString ]
		ifFalse: [
			anEntryPoint isApplication
				ifTrue: [ html anchor url: anEntryPoint basePath; with: aString ]
				ifFalse: [ html render: aString ] ]! !

!WADispatcherComponent methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:12'!
title
	^ self class description! !

!WADispatcherComponent methodsFor: 'accessing' stamp: 'mb 2/7/2007 11:28'!
upDirectory
	^'..'! !

!WADispatcherComponent methodsFor: 'rendering' stamp: 'mb 2/7/2007 11:59'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: self title! !

WADispatcherComponent subclass: #WADispatcherEditor
	instanceVariableNames: 'name type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

WADispatcherEditor class
	instanceVariableNames: 'plugins'!

WADispatcherEditor class
	instanceVariableNames: 'plugins'!

!WADispatcherEditor class methodsFor: 'plugins' stamp: 'pmm 9/12/2006 19:26'!
actionsFor: anEntryPoint inEditor: anEditor
	| actions |
	"Answer an OrderedCollectionn of associations"
	actions := OrderedCollection new.
	self plugins do: [:each |
		actions addAll: (each editorActionsFor: anEntryPoint inEditor: anEditor)].
	^actions.! !

!WADispatcherEditor class methodsFor: 'plugins' stamp: 'mb 6/18/2006 22:12'!
addPlugin: aClass
	(self plugins includes: aClass) ifFalse:
		[self plugins add: aClass]! !

!WADispatcherEditor class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:56'!
canBeRoot 
	^ true! !

!WADispatcherEditor class methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:16'!
description
	^ 'Dispatcher Editor'! !

!WADispatcherEditor class methodsFor: 'plugins' stamp: 'lr 12/12/2006 11:14'!
editorActionsFor: anEntryPoint inEditor: anEditor
	^ OrderedCollection new
		add: (Dictionary new
			at: #label put: 'configure';
			at: #action put: [ anEditor configure: anEntryPoint ];
			yourself);
		add: (Dictionary new
			at: #label put: 'copy';
			at: #action put: [ anEditor copy: anEntryPoint ];
			yourself);
		add: (Dictionary new
			at: #label put: 'remove';
			at: #action put: [ anEditor remove: anEntryPoint ];
			yourself);
		yourself! !

!WADispatcherEditor class methodsFor: 'initialization' stamp: 'mb 2/18/2007 18:44'!
initialize
	self registerAsAuthenticatedApplication: 'config'! !

!WADispatcherEditor class methodsFor: 'testing' stamp: 'mb 5/26/2006 09:23'!
isDeployed
	^ true! !

!WADispatcherEditor class methodsFor: 'plugins' stamp: 'mb 6/16/2006 18:16'!
plugins
	^plugins ifNil: [plugins := self standardPlugins].! !

!WADispatcherEditor class methodsFor: 'plugins' stamp: 'mb 6/16/2006 18:20'!
standardPlugins
	^OrderedCollection with: self! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'lr 11/16/2006 18:52'!
actionsFor: anEntryPoint
	^ self class actionsFor: anEntryPoint inEditor: self! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'lr 2/12/2007 21:03'!
addEntryPoint
	| handler |
	(name isNil or: [ name isEmpty ]) 
		ifTrue: [ ^ self inform: 'You must enter a path-name.' ].
	handler := type named: name.
	dispatcher register: handler.
	self configure: handler! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'JF 9/22/2003 20:15'!
clearCaches
	WARegistry clearAllHandlers.
	Smalltalk garbageCollect! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'lr 11/16/2006 18:52'!
configure: anEntryPoint
	anEntryPoint configurationComponent
		ifNotNilDo: [ :component | self call: component ]! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'lr 2/12/2007 21:09'!
copy: anEntryPoint
	name := self request: 'Name' label: 'add' default: anEntryPoint name.
	name ifNil: [ ^ self ].
	dispatcher register: (anEntryPoint copy setName: name)! !

!WADispatcherEditor methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:52'!
entryPointClasses
	^ WAEntryPoint concreteSubclasses! !

!WADispatcherEditor methodsFor: 'initialization' stamp: 'lr 2/12/2007 21:01'!
initialize
	super initialize.
	type := WAApplication.
	name := String new! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'lr 2/12/2007 21:09'!
remove: anEntryPoint
	dispatcher unregister: anEntryPoint! !

!WADispatcherEditor methodsFor: 'rendering-parts' stamp: 'lr 2/12/2007 21:05'!
renderAddEntryPointOn: html
	html heading level: 3; with: 'Add entry point'.
	html form: [
		html table: [
			html tableRow: [
				html tableData class: 'label'; with: 'Name: '.
				html tableData: [ 
					html textInput 
						callback: [ :value | name := value ] ] ].
			html tableRow: [
				html tableData class: 'label'; with: 'Type: '.
				html tableData: [
					html select 
						list: self entryPointClasses;
						selected: type;
						callback: [ :value | type := value ];
						labels: [ :each | each description ].
				html space.
				html submitButton
					callback: [ self addEntryPoint ];
					text: 'Add' ] ] ] ]
! !

!WADispatcherEditor methodsFor: 'rendering' stamp: 'lr 1/5/2007 19:20'!
renderContentOn: html
	super renderContentOn: html.
	self renderSettingsOn: html.
	self renderStatisticsOn: html! !

!WADispatcherEditor methodsFor: 'rendering-parts' stamp: 'lr 2/12/2007 21:03'!
renderDefaultEntryPointOn: html
	html heading
		level: 3;
		with: 'Default entry point'.
	html form: [
		html select
			beOptional;
			optionalLabel: '(none)';
			list: self dispatcher entryPoints keysSortedSafely;
			on: #defaultName of: dispatcher.
		html space.
		html submitButton ]! !

!WADispatcherEditor methodsFor: 'rendering-rows' stamp: 'mb 2/7/2007 11:32'!
renderRowActions: anEntryPoint named: aString on: html
	aString = self upDirectory ifTrue: [^nil] .
	(self actionsFor: anEntryPoint)
		do: [ :each | html anchor callback: (each at: #action); with: (each at: #label) ]
		separatedBy: [ html space ]! !

!WADispatcherEditor methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:47'!
renderSettingsOn: html
	html heading level: 2; with: 'Settings'.
	self renderDefaultEntryPointOn: html.
	self renderAddEntryPointOn: html! !

!WADispatcherEditor methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:49'!
renderStatisticsOn: html
	html heading level: 2; with: 'Statistics'.
	html preformatted: SeasidePlatformSupport vmStatisticsReportString.
	html anchor callback: [ self clearCaches ]; with: 'Clear Caches'! !

WADispatcherComponent subclass: #WADispatcherViewer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WADispatcherViewer class methodsFor: 'testing' stamp: 'mb 5/26/2006 11:53'!
canBeRoot 
	^ true! !

!WADispatcherViewer class methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:16'!
description
	^ 'Dispatcher Browser'! !

!WADispatcherViewer class methodsFor: 'initialization' stamp: 'lr 2/12/2007 21:04'!
initialize
	self registerAsApplication: 'browse'.
	WADispatcher default defaultName: 'browse'! !

!WADispatcherViewer class methodsFor: 'testing' stamp: 'mb 5/26/2006 11:54'!
isDeployed
	^ true! !

!WADispatcherViewer methodsFor: 'accessing' stamp: 'lr 1/5/2007 22:21'!
entryPoints
	^ super entryPoints select: [ :each | each isDispatcher or: [ each isApplication ] ]! !

WAComponent subclass: #WADispatcherEditorPlugin
	instanceVariableNames: 'application psuedoAppSession'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WADispatcherEditorPlugin class methodsFor: 'testing' stamp: 'mb 10/7/2006 11:34'!
canBeRoot
	^true! !

!WADispatcherEditorPlugin class methodsFor: 'as yet unclassified' stamp: 'kph 10/11/2006 02:38'!
editorActionsFor: anEntryPoint inEditor: anEditor
	(anEntryPoint isApplication and: 
		[ anEntryPoint hasPreferenceGroup: self showForAppWithGroup]) ifFalse: [ ^ #() ].
 
	^(OrderedCollection new) 
		add: ((Dictionary new)
				at: #label put: self label;
				at: #action put: [ anEditor call: (self launch: anEntryPoint) ];
				yourself);
		yourself.! !

!WADispatcherEditorPlugin class methodsFor: 'initialization' stamp: 'mb 10/7/2006 11:35'!
initialize
 	self registerAsDispatcherEditorPlugin.
 ! !

!WADispatcherEditorPlugin class methodsFor: 'accessing' stamp: 'mb 10/7/2006 11:35'!
label
	^ ''! !

!WADispatcherEditorPlugin class methodsFor: 'as yet unclassified' stamp: 'mb 10/7/2006 11:35'!
launch: anEntryPoint
	| plugin |
	plugin := self new application: anEntryPoint.
	plugin addDecoration: (WAWindowDecoration new title: plugin title; yourself).
	^plugin! !

!WADispatcherEditorPlugin class methodsFor: 'as yet unclassified' stamp: 'mb 10/7/2006 11:35'!
registerAsDispatcherEditorPlugin
	 ^ self label notEmpty ifTrue: [ WADispatcherEditor addPlugin: self ]! !

!WADispatcherEditorPlugin class methodsFor: 'as yet unclassified' stamp: 'mb 10/7/2006 11:35'!
showForAppWithGroup
	" e.g. for all apps return #general "

	^ self label! !

!WADispatcherEditorPlugin methodsFor: 'accessing' stamp: 'mb 10/7/2006 11:30'!
application 
	^application! !

!WADispatcherEditorPlugin methodsFor: 'accessing' stamp: 'mb 10/7/2006 11:30'!
application: app
	application := app! !

!WADispatcherEditorPlugin methodsFor: 'as yet unclassified' stamp: 'mb 10/7/2006 11:34'!
psuedoAppSession
	^psuedoAppSession ifNil: [ 
		psuedoAppSession := application sessionClass application: application ]! !

!WADispatcherEditorPlugin methodsFor: 'rendering' stamp: 'mb 10/7/2006 11:33'!
renderContentOn: html
	"customize"

	html bold: 'Dispatcher Editor Plugin: ', self class label, ' on application ', application name! !

!WADispatcherEditorPlugin methodsFor: 'rendering' stamp: 'mb 10/7/2006 11:33'!
rendererClass
	^ WARenderCanvas ! !

!WADispatcherEditorPlugin methodsFor: 'accessing' stamp: 'mb 10/7/2006 11:33'!
title
	^ self class name, ' - ', application name, ' (', application basePath, ')'! !

!WADispatcherEditorPlugin methodsFor: 'as yet unclassified' stamp: 'mb 10/7/2006 11:38'!
usingAppSession: aBlock
	WACurrentSession use: self psuedoAppSession during: aBlock! !

WAComponent subclass: #WAEmailConfirmation
	instanceVariableNames: 'from to subject body notice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAEmailConfirmation methodsFor: 'accessing' stamp: 'avi 3/10/2004 15:40'!
body: aString
	body := aString! !

!WAEmailConfirmation methodsFor: 'accessing' stamp: 'avi 3/10/2004 15:40'!
from: fromString
	from := fromString! !

!WAEmailConfirmation methodsFor: 'accessing' stamp: 'avi 3/10/2004 15:40'!
notice: aString
	notice := aString! !

!WAEmailConfirmation methodsFor: 'rendering' stamp: 'rdt 5/16/2007 00:22'!
renderContentOn: html
	| url |
	url := html context actionUrl copy.
	url addParameter: (html callbacks registerActionCallback: [ self answer ]).
	self sendMessageWithUrl: url.
	html div id: 'notice'; with: notice.! !

!WAEmailConfirmation methodsFor: 'actions' stamp: 'rdt 5/15/2007 20:48'!
sendMessageWithUrl: urlString
	SeasidePlatformSupport
		deliverMailFrom: from
		to: (Array with: to)
		text: ('Subject: ' , subject , '

' , urlString asString , '
		
' , body)! !

!WAEmailConfirmation methodsFor: 'accessing' stamp: 'avi 3/10/2004 15:40'!
subject: aString
	subject := aString! !

!WAEmailConfirmation methodsFor: 'accessing' stamp: 'avi 3/10/2004 15:40'!
to: toString
	to := toString! !

WAComponent subclass: #WAEncodingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAEncodingTest methodsFor: 'rendering' stamp: 'jf 2/18/2004 15:15'!
renderContentOn: html
	| w allChars r |

	w := WriteStream on: String new.
	32 to: 255 do: [ :c |  w nextPut: c asCharacter ].
	allChars := w contents.

	html code: [ 
		html text: 'Start'; break.
		r := ReadStream on: allChars.

		[ r atEnd ] whileFalse: [ 
			html text: (r next: 14);
			break.
		].
		html text: 'End'; 
			  break.
	].
	html text: 'Characters Encoded: '.
	'Hello World' do: [ :c | html encodeCharacter: c ]. 
	html break.
! !

!WAEncodingTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:05'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAErrorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAErrorTest methodsFor: 'rendering' stamp: 'avi 3/28/2004 21:24'!
renderContentOn: html
	html anchorWithAction: [1/0] text: 'Raise error'.
	html break.
	html anchorWithAction: [self notify: 'Really?'. self inform: 'Ok!!'] text: 'Raise warning'.! !

!WAErrorTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:07'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAExampleBrowser
	instanceVariableNames: 'class selector component hasAnswer answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WAExampleBrowser commentStamp: '<historical>' prior: 0!
I browse all the examples available in the system ie all the results of class methods beginning with #example... 

point your browser to localhost:xxx/seaside/examples

If you want to see these examples

/seaside/config app:
- add a new application named "examples"
- choose WAExampleBrowser as the root component
!

!WAExampleBrowser class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WAExampleBrowser class methodsFor: 'accessing' stamp: 'mb 5/26/2006 12:29'!
description
	^'Browse through Seaside examples'! !

!WAExampleBrowser class methodsFor: 'class initialization' stamp: 'lr 2/12/2007 21:38'!
initialize
	self registerAsApplication: 'examples/examplebrowser'! !

!WAExampleBrowser methodsFor: 'helper' stamp: 'lr 2/20/2007 14:40'!
allClasses
	^ (WAComponent allSubclasses
		select: [ :each |
			each class selectors
				anySatisfy: [ :sel | sel beginsWith: self selectorPrefix ] ])
		asSortedCollection: [ :a :b | a name < b name ]! !

!WAExampleBrowser methodsFor: 'helper' stamp: 'lr 2/20/2007 14:39'!
allSelectors
	^ (class class selectors select: [ :each | each beginsWith: self selectorPrefix ])
		asSortedCollection! !

!WAExampleBrowser methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:21'!
children
	^ Array with: component! !

!WAExampleBrowser methodsFor: 'accessing' stamp: 'pmm 6/23/2005 08:52'!
class: aClass
	class := aClass.
	self selector: self allSelectors first! !

!WAExampleBrowser methodsFor: 'accessing' stamp: 'lr 2/20/2007 14:37'!
component: aComponent
	component := aComponent.
	hasAnswer := false.
	answer := nil.
	component onAnswer: [ :value | hasAnswer := true. answer := value ]! !

!WAExampleBrowser methodsFor: 'initialize' stamp: 'pmm 11/2/2005 22:35'!
initialize
	super initialize.
	self class: self allClasses first! !

!WAExampleBrowser methodsFor: 'rendering' stamp: 'lr 2/20/2007 14:00'!
renderChooserOn: html
	html div class: 'chooser'; with: [
		html form: [
			html select
				beSubmitOnChange;
				list: self allClasses;
				selected: class;
				callback: [ :value | self class: value ] ].
		self allSelectors size > 1 ifTrue: [
			html form: [
				html select
					beSubmitOnChange;
					list: self allSelectors;
					selected: selector;
					callback: [ :value | self selector: value ] ] ] ]! !

!WAExampleBrowser methodsFor: 'rendering' stamp: 'mb 2/22/2007 14:27'!
renderComponentOn: html

	html heading: component class headerForExampleBrowser level: 4.
	html div 
		class: 'component';
		with: component.
	hasAnswer ifTrue: [
		html div
			class: 'answer';
			with: answer printString ]! !

!WAExampleBrowser methodsFor: 'rendering' stamp: 'lr 2/20/2007 13:48'!
renderContentOn: html
	self renderChooserOn: html.
	self renderComponentOn: html! !

!WAExampleBrowser methodsFor: 'accessing' stamp: 'ab 6/14/2003 19:04'!
selector: aSymbol
	selector := aSymbol.
	self component: (class perform: selector)! !

!WAExampleBrowser methodsFor: 'helper' stamp: 'ab 6/14/2003 19:02'!
selectorPrefix
	^ 'example'! !

!WAExampleBrowser methodsFor: 'accessing' stamp: 'lr 2/20/2007 13:58'!
style
	^ '.chooser {
	background-color: #eee;
	padding: 5px;
}
.chooser form,
.chooser form div {
	display: inline;
}
.chooser form select {
	margin-right: 5px;
}
.component {
	padding: 5px;
}
.answer {
	background-color: #eee;
	padding: 5px;
}'! !

WAComponent subclass: #WAExpiryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAExpiryTest class methodsFor: 'services' stamp: 'lr 2/12/2007 21:38'!
install
	(self registerAsApplication: 'tests/expiry') preferenceAt: #sessionClass put: WAExpirySession! !

!WAExpiryTest methodsFor: 'rendering' stamp: 'mb 5/26/2006 09:15'!
renderContentOn: html
	html table: [
		html tableRowWithLabel: 'Live session instances' column: WAExpirySession allInstances size.
		html tableRowWithLabel: 'Live component instances' column: self class allInstances size.
		html tableRowWithLabel: 'Sessions created' column: WAExpirySession created.
		html tableRowWithLabel: 'Sessions unregistered' column: WAExpirySession unregistered.
	].
	html anchorWithUrl: self session newSessionUrl do: 'New Session'.
	html break.
	html anchorWithAction: [self session expire] text: 'Expire'.
	html break.
	html anchorWithAction: [WAExpirySession resetCounters] text: 'Reset Counters'.
	html break.
	html anchorWithAction: [Smalltalk garbageCollect] text: 'Garbage Collect'.
	html break.
	html anchorWithAction: [self session application clearHandlers. Smalltalk garbageCollect] text: 'Clear Handlers'.
	html break.
	html anchorWithAction: [self session application clearHandlers. WAExpirySession resetCounters. 	Smalltalk garbageCollect.
] text: 'Reset All'.
	html form: [
		html text: 'Expiry seconds:'.
		html
			textInputWithValue: self session application sessionExpirySeconds
			callback: [:v | self session application preferenceAt: #sessionExpirySeconds put: v].
		html space.
		html submitButton]
	! !

!WAExpiryTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:09'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAFileHandlerEditor
	instanceVariableNames: 'fileHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAFileHandlerEditor methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:35'!
basePath
	^ self fileHandler basePath! !

!WAFileHandlerEditor methodsFor: 'actions' stamp: 'lr 2/18/2007 12:37'!
configureLibrary: aLibrary
	self call: aLibrary configurationComponent! !

!WAFileHandlerEditor methodsFor: 'accessing' stamp: 'pmm 4/18/2006 21:57'!
fileHandler
	^fileHandler! !

!WAFileHandlerEditor methodsFor: 'accessing' stamp: 'pmm 4/18/2006 21:57'!
fileHandler: aFilehandler 
	fileHandler := aFilehandler! !

!WAFileHandlerEditor methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:34'!
libraries
	^ self fileHandler libraries asSortedCollection: [ :a :b | a name < b name ]! !

!WAFileHandlerEditor methodsFor: 'rendering' stamp: 'lr 2/18/2007 12:24'!
renderContentOn: html
	html heading: WAFileHandler description.
	html table: [
		self libraries do: [ :each |
			html tableRow: [
				html tableData: each name.
				html tableData: [ 
					html anchor
						callback: [ self configureLibrary: each default ];
						with: 'configure' ] ] ] ].
	html form: [
		html submitButton
			callback: [ self answer ]; 
			text: 'close' ] ! !

WAComponent subclass: #WAFileLibraryExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAFileLibraryExample class methodsFor: 'testing' stamp: 'mb 10/17/2006 14:10'!
canBeRoot
	^true! !

!WAFileLibraryExample class methodsFor: 'testing' stamp: 'mb 10/17/2006 14:41'!
description
	^'A component with a static stylesheet and a static background image'! !

!WAFileLibraryExample class methodsFor: 'testing' stamp: 'mb 10/17/2006 14:42'!
example
	^self new! !

!WAFileLibraryExample methodsFor: 'accessing' stamp: 'mb 10/17/2006 14:43'!
basePath
	^WADispatcher default basePath! !

!WAFileLibraryExample methodsFor: 'rendering' stamp: 'mb 10/17/2006 14:38'!
renderContentOn: html
	html div
		class: 'desc';
		with:
			[html heading: 'This page has' level: 3.
			html unorderedList:
				[html listItem: 'a static stylesheet (main.css)'.
				html listItem: 'a static background image (main.jpg) named in a dynamic stylesheet']].! !

!WAFileLibraryExample methodsFor: 'rendering' stamp: 'mb 10/17/2006 14:44'!
style
	^'

body { 
	background: url(' , self basePath , '/files/WAFileLibraryDemo/main.jpg);
}
div.desc {
	padding: 2em;
}
'
! !

!WAFileLibraryExample methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:20'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet 
		url: self basePath , '/files/WAFileLibraryDemo/main.css'.
! !

WAComponent subclass: #WAFormDialog
	instanceVariableNames: 'validationError form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

WAFormDialog subclass: #WAChoiceDialog
	instanceVariableNames: 'options selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAChoiceDialog class methodsFor: 'examples' stamp: 'lr 1/7/2007 17:59'!
example
	^ self options: #('Smalltalk' 'Perl' 'Python' 'Ruby')! !

!WAChoiceDialog class methodsFor: 'instance-creation' stamp: 'avi 3/21/2004 00:59'!
options: aCollection
	^ self new options: aCollection! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'avi 3/21/2004 01:00'!
buttons
	^ #(ok cancel)! !

!WAChoiceDialog methodsFor: 'actions' stamp: 'avi 3/21/2004 01:00'!
cancel
	self answer: nil! !

!WAChoiceDialog methodsFor: 'actions' stamp: 'avi 3/21/2004 01:00'!
ok
	self answer: selection! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'avi 3/21/2004 00:59'!
options
	^ options! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'avi 3/21/2004 00:59'!
options: aCollection
	options := aCollection! !

!WAChoiceDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:01'!
renderContentOn: html
	html select
		list: options;
		selected: nil;
		callback: [ :value | selection := value ]! !

!WAFormDialog methodsFor: 'actions' stamp: 'avi 3/16/2004 13:45'!
addForm
	form := WAFormDecoration new buttons: self buttons.
	self addDecoration: form! !

!WAFormDialog methodsFor: 'testing' stamp: 'avi 3/16/2004 14:05'!
addFormByDefault
	^ true! !

!WAFormDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 16:37'!
buttons
	^ #(ok)! !

!WAFormDialog methodsFor: 'accessing' stamp: 'mb 4/4/2006 13:41'!
defaultButton
	^self buttons first! !

!WAFormDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 20:41'!
divClass
	^ self class name! !

!WAFormDialog methodsFor: 'initialization' stamp: 'pmm 11/2/2005 22:51'!
initialize
	super initialize.
	self addFormByDefault ifTrue: [self addForm]! !

!WAFormDialog methodsFor: 'testing' stamp: 'avi 3/12/2004 16:35'!
isValid
	^ validationError isNil! !

!WAFormDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 16:35'!
model
	^ self! !

!WAFormDialog methodsFor: 'actions' stamp: 'avi 3/12/2004 16:37'!
ok
	self answer! !

!WAFormDialog methodsFor: 'actions' stamp: 'avi 3/27/2004 16:59'!
removeForm
	form ifNotNil: [self removeDecoration: form]! !

!WAFormDialog methodsFor: 'rendering' stamp: 'lr 1/7/2007 17:55'!
renderContentOn: html
	html hiddenInput callback: [ validationError := nil ].
	validationError 
		ifNotNil: [ self renderValidationError: validationError on: html ].
	html div
		class: self divClass;
		with: [ self renderDialogOn: html ]! !

!WAFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:37'!
renderDialogOn: html! !

!WAFormDialog methodsFor: 'rendering' stamp: 'lr 1/7/2007 17:55'!
renderSpacerRowOn: html
	html div class: 'dialog-spacer'; with: [ html space ]! !

!WAFormDialog methodsFor: 'rendering' stamp: 'lr 1/7/2007 17:56'!
renderValidationError: aString on: html
	html span class: 'dialog-validation'; with: aString! !

!WAFormDialog methodsFor: 'validation' stamp: 'avi 3/12/2004 16:35'!
validationError: aString
	validationError := aString! !

WAFormDialog subclass: #WAGridDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAGridDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 16:47'!
columns
	^ #()! !

!WAGridDialog methodsFor: 'accessing' stamp: 'avi 3/17/2004 15:05'!
cssClassForItem: anObject
	^ 'dialog-row'! !

!WAGridDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 16:47'!
items
	^ #()! !

!WAGridDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 16:59'!
renderColumn: aSymbol for: anObject on: html
	| renderSelector |
	renderSelector := self renderingSelectorFor: aSymbol.
	(self respondsTo: renderSelector)
		ifTrue: [self perform: renderSelector with: anObject with: html]
		ifFalse: [self renderDefaultColumn: aSymbol for: anObject on: html]! !

!WAGridDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 17:00'!
renderDefaultColumn: aSymbol for: anObject on: html
	html text: (anObject perform: aSymbol)! !

!WAGridDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:04'!
renderDialogOn: html
	html table: [
		self renderHeadingsOn: html.
		self items do: [ :each | 
			self renderRowForItem: each on: html ] ]! !

!WAGridDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 16:51'!
renderHeadingForSelector: aSymbol on: html
	html text: (self labelForSelector: aSymbol)! !

!WAGridDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:05'!
renderHeadingsOn: html
	self columns do: [ :each |
		html tableHeading
			class: each;
			with: [ self renderHeadingForSelector: each on: html ] ]! !

!WAGridDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:07'!
renderRowForItem: anObject on: html
	html tableRow
		class: (self cssClassForItem: anObject);
		with: [
			self columns do:  [:each |
				html tableData
					class: each;
					with: [self renderColumn: each for: anObject on: html ] ] ]! !

!WAGridDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 16:59'!
renderingSelectorFor: aSymbol
	^ ('render', aSymbol capitalized, 'For:on:') asSymbol! !

!WAGridDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 21:03'!
style
	^ '
	.dialog-buttons {text-align: center}
	'! !

WAFormDialog subclass: #WALabelledFormDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

WALabelledFormDialog subclass: #WAEditDialog
	instanceVariableNames: 'model snapshot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAEditDialog class methodsFor: 'instance creation' stamp: 'avi 3/13/2004 14:21'!
model: anObject
	^ self new model: anObject! !

!WAEditDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 14:10'!
buttons
	^ #(save cancel)! !

!WAEditDialog methodsFor: 'actions' stamp: 'avi 3/12/2004 17:46'!
cancel
	self rollback.
	self answer: false! !

!WAEditDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 17:49'!
model
	^ model! !

!WAEditDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 17:46'!
model: anObject
	model := anObject.
	self snapshot.! !

!WAEditDialog methodsFor: 'actions' stamp: 'avi 3/12/2004 17:49'!
rollback
	model copyFrom: snapshot! !

!WAEditDialog methodsFor: 'actions' stamp: 'avi 3/12/2004 17:46'!
save
	self validate.
	self isValid ifTrue: [self answer: true]! !

!WAEditDialog methodsFor: 'actions' stamp: 'avi 3/12/2004 17:49'!
snapshot
	snapshot := model clone! !

!WAEditDialog methodsFor: 'actions' stamp: 'avi 3/13/2004 14:10'!
validate
	! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:08'!
renderDefaultFieldForSelector: aSymbol on: html
	html textInput
		on: aSymbol of: self model! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:37'!
renderDialogOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]].
! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 21:06'!
renderFieldForSelector: aSymbol on: html
	| renderSelector |
	renderSelector := self renderingSelectorFor: aSymbol.
	(self respondsTo: renderSelector)
		ifTrue: [self perform: renderSelector with: html]
		ifFalse: [self renderDefaultFieldForSelector: aSymbol on: html]! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:41'!
renderLabelForSelector: aSymbol on: html
	html text: (self labelForSelector: aSymbol)! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:09'!
renderRowForSelector: aSymbol on: html
	html div
		id: 'dialog-row-' , aSymbol;
		class: 'dialog-row';
		with: [
			html span 
				class: 'dialog-form-label';
				with: [self renderLabelForSelector: aSymbol on: html].
			html span 
				class: 'dialog-form-field';
				with: [self renderFieldForSelector: aSymbol on: html]].
! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 16:39'!
renderTableRowsOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]].
! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:37'!
renderingSelectorFor: aSymbol
	^ ('render', aSymbol capitalized, 'On:') asSymbol! !

!WALabelledFormDialog methodsFor: 'accessing' stamp: 'avi 3/10/2004 18:00'!
rows
	^ #()! !

!WALabelledFormDialog methodsFor: 'accessing' stamp: 'avi 3/16/2004 16:29'!
style
	^ '
.dialog-row {
	clear: both;
	/*set position: relative to handle the ie disappearing text bug*/
	position: relative;
	margin-top: 3px;
}

.dialog-form-label {
	width: 100px;
	float: left;
	text-align: right;
	padding: 2px 6px;
	margin-right: 4px;
	margin-top: 2px;
}

.dialog-form-field {
	text-align: left;
	padding: 2px;
	margin-top: 2px;
	float: left;
}

.dialog-buttons {
	clear: both;
	padding: 10px;
	text-align: center
}

.dialog-spacer {
	clear: both;
	height: 10px;
}
	'! !

WALabelledFormDialog subclass: #WAStoreAddressEditor
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreAddressEditor commentStamp: 'avi 1/1/2004 09:56' prior: 0!
A component for editing WAStoreAddress instances.  When called, it will create a new address instance, present a form for the user to modify it, and then answer the instance on submit.  Used by WAStoreTask>>getBillingAddress and getShippingAddress.!

!WAStoreAddressEditor methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:55'!
countries
	^ #(Canada USA)! !

!WAStoreAddressEditor methodsFor: 'initialize-release' stamp: 'al 9/7/2006 16:12'!
initialize
	super initialize.
	address := WAStoreAddress new! !

!WAStoreAddressEditor methodsFor: 'accessing' stamp: 'mb 2/17/2005 11:14'!
labelForSelector: aSymbol

	aSymbol == #name ifTrue: [^'Your name'].
	aSymbol == #street ifTrue: [^'The street'].
	aSymbol == #city ifTrue: [^'The city'].
	aSymbol == #ok ifTrue: [^'Continue'].
	^ super labelForSelector: aSymbol! !

!WAStoreAddressEditor methodsFor: 'accessing' stamp: 'avi 5/1/2004 14:38'!
model
	^ address! !

!WAStoreAddressEditor methodsFor: 'actions' stamp: 'avi 12/10/2003 13:04'!
ok
	self answer: address! !

!WAStoreAddressEditor methodsFor: 'rendering' stamp: 'al 9/7/2006 16:11'!
renderCountryOn: html
	html select
		list: self countries;
		on: #country of: address! !

!WAStoreAddressEditor methodsFor: 'accessing' stamp: 'avi 5/1/2004 14:11'!
rows
	^ #(name street city country)
! !

!WAStoreAddressEditor methodsFor: 'path' stamp: 'mb 2/10/2006 12:05'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Seaside Sushi Store : Your address'.! !

WALabelledFormDialog subclass: #WAStorePaymentEditor
	instanceVariableNames: 'name cardType cardNumber month year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStorePaymentEditor commentStamp: 'avi 1/1/2004 09:58' prior: 0!
A component for editing WAStoreCreditCard instances.  When called, it presents a form for the user to choose credit card type, and enter name, number, and expiry date.  On submit, it will create and answer an instance of the appropiate credit card subclass.  Note the difference with WAStoreAddressEditor, where the form modifies the address instance directly.  Used by WAStoreTask>>getPaymentInfo.!

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:14'!
cardNumber
	^cardNumber! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:15'!
cardNumber: aString
	cardNumber := aString! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:17'!
cardType
	^cardType! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:22'!
cardType: aCreditCardClass
	cardType := aCreditCardClass! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'avi 12/10/2003 14:06'!
cardTypes
	^ WAStoreCreditCard subclasses! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'mb 2/10/2006 12:29'!
labelForSelector: aSymbol

	aSymbol == #ok ifTrue: [^'OK to pay'].
	^ super labelForSelector: aSymbol! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:22'!
month
	^month! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:23'!
month: anInteger
	month := anInteger! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'avi 12/10/2003 13:59'!
months
	^ (1 to: 12)! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:25'!
name
	^name! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:25'!
name: aString
	name := aString! !

!WAStorePaymentEditor methodsFor: 'actions' stamp: 'pmm 11/2/2005 23:42'!
ok
	self answer:
		(cardType new
			name: name;
			number: cardNumber;
			expiry: (Date newDay: 1 monthNumber: month year: year);
			yourself)! !

!WAStorePaymentEditor methodsFor: 'rendering' stamp: 'al 9/7/2006 17:10'!
renderCardNumberOn: html
	html textInput on: #cardNumber of: self! !

!WAStorePaymentEditor methodsFor: 'rendering' stamp: 'al 9/7/2006 17:10'!
renderCardTypeOn: html
	html select
		list: self cardTypes;
		on: #cardType of: self;
		labels: [ :each | each abbreviation]! !

!WAStorePaymentEditor methodsFor: 'rendering' stamp: 'al 9/7/2006 16:25'!
renderExpirationDateOn: html 
	html select
		list: self months;
		on: #month of: self.
	html select
		list: self years;
		on: #year of: self! !

!WAStorePaymentEditor methodsFor: 'rendering' stamp: 'al 9/7/2006 16:26'!
renderNameOn: html
	html textInput on: #name of: self! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'avi 5/1/2004 14:14'!
rows
	^ #(cardType name cardNumber expirationDate)! !

!WAStorePaymentEditor methodsFor: 'path' stamp: 'mb 2/10/2006 12:08'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Seaside Sushi Store : Payment'.! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:23'!
year
	^year! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'al 9/7/2006 16:23'!
year: anInteger
	year := anInteger! !

!WAStorePaymentEditor methodsFor: 'accessing' stamp: 'avi 12/10/2003 13:45'!
years
	^ (Date today year to: Date today year + 5)! !

WALabelledFormDialog subclass: #WAViewer
	instanceVariableNames: 'presenter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAViewer class methodsFor: 'instance creation' stamp: 'avi 3/13/2004 01:13'!
on: aPresenter
	^ self new presenter: aPresenter! !

!WAViewer methodsFor: 'accessing' stamp: 'avi 3/13/2004 01:14'!
buttons
	^ #(save)! !

!WAViewer methodsFor: 'accessing' stamp: 'avi 3/13/2004 01:14'!
model
	^ presenter! !

!WAViewer methodsFor: 'accessing' stamp: 'avi 3/13/2004 01:13'!
presenter: aPresenter
	presenter := aPresenter! !

!WAViewer methodsFor: 'rendering' stamp: 'al 9/7/2006 16:30'!
renderContentOn: html
	html heading level: 3; with: presenter displayString.
	super renderContentOn: html! !

!WAViewer methodsFor: 'rendering' stamp: 'al 9/7/2006 15:57'!
renderCssOn: html
	html textArea
		rows: 20;
		columns: 80;
		value: presenter style;
		callback: [ :css |
			presenter class compile: 'style ^ ', css printString]! !

!WAViewer methodsFor: 'accessing' stamp: 'avi 3/13/2004 01:14'!
rows
	^ #(css)! !

!WAViewer methodsFor: 'actions' stamp: 'avi 3/13/2004 01:23'!
save
	! !

!WAViewer methodsFor: 'accessing' stamp: 'avi 3/13/2004 01:22'!
script
	^ 'self.opener.location=self.opener.location'! !

WAFormDialog subclass: #WANoteDialog
	instanceVariableNames: 'note'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WANoteDialog methodsFor: 'accessing' stamp: 'avi 3/16/2004 16:48'!
buttons
	^ #(ok cancel)! !

!WANoteDialog methodsFor: 'actions' stamp: 'avi 3/16/2004 16:48'!
cancel
	self answer: nil! !

!WANoteDialog methodsFor: 'accessing' stamp: 'al 9/7/2006 16:27'!
note
	^note! !

!WANoteDialog methodsFor: 'accessing' stamp: 'al 9/7/2006 16:27'!
note: aString
	note := aString! !

!WANoteDialog methodsFor: 'actions' stamp: 'avi 3/16/2004 16:46'!
ok
	self answer: note! !

!WANoteDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:28'!
renderDialogOn: html
	html textArea
		id: 'dialog-note';
		on: #note of: self! !

!WANoteDialog methodsFor: 'accessing' stamp: 'avi 3/16/2004 16:50'!
style
	^ ' 
	#dialog-note {width: 80%; height: 200px}
	'! !

WAFormDialog subclass: #WAYesOrNoDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAYesOrNoDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 21:40'!
buttons
	^ #(yes no)! !

!WAYesOrNoDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 21:40'!
no
	self answer: false! !

!WAYesOrNoDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 21:40'!
yes
	self answer: true! !

WAComponent subclass: #WAFrameComponent
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Frames'!

WAFrameComponent subclass: #WAAllCanvasTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WAAllCanvasTests class methodsFor: 'testing' stamp: 'mb 1/31/2006 11:07'!
canBeRoot
	^ true! !

!WAAllCanvasTests class methodsFor: 'class initialization' stamp: 'lr 2/12/2007 21:38'!
initialize
	self registerAsApplication: 'tests/allcanvastests'! !

!WAAllCanvasTests methodsFor: 'initialization' stamp: 'mb 5/1/2007 12:40'!
initialize
	super initialize.
	self contents: (WASimpleNavigation new add: WACanvasInputTest new label: 'Input';
			 add: WAInputTest new label: 'Input(2)';
			 add: WACanvasHtmlTest new label: 'Html';
			 add: WACanvasTest new label: 'Canvas';
			 add: WACanvasLinkSubmitTest new label: 'Submit';
			 add: WACanvasDateTimeTest new label: 'More tests';
			 add: WACanvasModelTest new label: 'Model';
			 add: WACanvasUploadTest new label: 'Upload';
			 add: WACanvasDefaultFormTest new label: 'Default Form';
			 add: WACanvasImageTest new label: 'Image';
			 add: WAIframeTest new label: 'Iframe';
			 add: WARubyTest new label: 'Ruby';
			 add: WAPhraseElementsTest new label: 'Phrase';
			 add: WACanvasTableTest new label: 'Table';
			 add: WATableReportTest new label: 'Table Report';
			 add: WASvgTest new label: 'SVG';
			 yourself)! !

!WAAllCanvasTests methodsFor: 'rendering' stamp: 'mb 10/31/2006 16:14'!
renderContentOn: html
	html div
		id: 'all-tests';
		with: [
			html heading: 'Test Canvas Components'.
			html space.
			html render: contents]! !

!WAAllCanvasTests methodsFor: 'path' stamp: 'mb 6/21/2006 13:28'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Seaside Canvas Tests: ', contents selection displayString.
"	anHtmlRoot linkToStyle: 'http://www.netstyle.ch/include/seaside/include/style.css'."
	anHtmlRoot linkWithStyle: 'h1 {color: #efb321} body {font-family: tahoma, arial, helvetica; font-size: 80%}'.
"	anHtmlRoot linkToScript: 'http://www.xxxx.yyy/scripts.js'."
	anHtmlRoot linkWithScript: 'var example = "abc";'.
! !

WAFrameComponent subclass: #WAAllTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAAllTests commentStamp: 'sd 11/28/2004 14:42' prior: 0!
If you want to see these examples:

/seaside/config app:
- add a new application named "tests"
- choose WAAllTests as the root component
!

!WAAllTests class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WAAllTests class methodsFor: 'initialize' stamp: 'lr 2/12/2007 21:39'!
initialize
	self registerAsApplication: 'tests/alltests'! !

!WAAllTests methodsFor: 'initialize-release' stamp: 'mb 5/1/2007 12:40'!
initialize
	super initialize.
	self contents: (WASimpleNavigation new add: WAOldApiInputTest new label: 'Input';
			 add: WAOldApiHtmlTest new label: 'Html';
			 add: WAEncodingTest new label: 'Encoding';
			 add: WAErrorTest new label: 'Error';
			 add: WAExceptionTest new label: 'Exception';
			 add: WAClosureTest new label: 'Closure';
			 add: WATransactionTest new label: 'Transaction';
			 add: WAUploadTest new label: 'Upload';
			 add: (WAParentTest new parent: self) label: 'Parent';
			 add: WAPathTest new label: 'Path';
			 add: WATaskTest new label: 'Task';
			 add: WACookieTest new label: 'Cookies';
			 add: WACallbackTest new label: 'Callbacks';
			 add: WAImageTest new label: 'Images';
			 add: WAHomeTest new label: 'Home';
			 add: WACacheTest new label: 'Cache';
			 add: WADefaultFormTest new label: 'Default Form';
			 add: WALinkSubmitTest new label: 'Submit';
			 add: WAJavascriptTest new label: 'Javascript';
			 add: WADelayTest new label: 'Delay';
			 add: WALotsaLinks new label: 'Lot of links';
			 add: WAPopupTest new label: 'Popup';
			 yourself)! !

!WAAllTests methodsFor: 'rendering' stamp: 'mb 10/31/2006 16:14'!
renderContentOn: html
	html divNamed: 'all-tests'
		with: [
			html heading: 'Test Components'.
			html space.
			html render: contents]! !

!WAAllTests methodsFor: 'updating' stamp: 'mb 10/12/2006 18:54'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

!WAAllTests methodsFor: 'updating' stamp: 'mb 6/21/2006 13:11'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Seaside Tests: ', contents selection displayString.
"	anHtmlRoot linkToStyle: 'http://www.netstyle.ch/include/seaside/include/style.css'."
	anHtmlRoot linkWithStyle: 'h1 {color: #efb321} body {font-family: tahoma, arial, helvetica; font-size: 80%}'.
"	anHtmlRoot linkToScript: 'http://www.xxxx.yyy/scripts.js'."
	anHtmlRoot linkWithScript: 'var example = "abc";'.

! !

!WAFrameComponent class methodsFor: 'instance creation' stamp: 'avi 2/2/2004 20:01'!
on: aComponent
	^ self new contents: aComponent! !

!WAFrameComponent methodsFor: 'accessing' stamp: 'avi 2/2/2004 19:58'!
children
	^ Array with: contents! !

!WAFrameComponent methodsFor: 'accessing' stamp: 'avi 2/2/2004 19:58'!
contents
	^ contents! !

!WAFrameComponent methodsFor: 'accessing' stamp: 'avi 4/14/2004 23:56'!
contents: aComponent
	contents := aComponent! !

!WAFrameComponent methodsFor: 'rendering' stamp: 'avi 2/2/2004 19:58'!
renderContentOn: html
	html render: contents! !

WAFrameComponent subclass: #WAPathTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAPathTest methodsFor: 'initialization' stamp: 'pmm 11/2/2005 22:53'!
initialize
	super initialize.
	self contents: WACounter new! !

!WAPathTest methodsFor: 'rendering' stamp: 'avi 4/15/2004 12:06'!
renderContentOn: html
	html anchorWithName: contents count.
	html render: contents.! !

!WAPathTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:19'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

!WAPathTest methodsFor: 'path' stamp: 'mbany 4/14/2005 11:58'!
updateUrl: aUrl
	aUrl addToPath: contents count displayString.
	aUrl fragment: contents count displayString.! !

WAFrameComponent subclass: #WAToolFrame
	instanceVariableNames: 'showHalos processTime renderTime deprecated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAToolFrame methodsFor: 'accessing' stamp: 'lr 11/20/2006 23:38'!
actions
	^ #( configure toggleHalos )! !

!WAToolFrame methodsFor: 'actions' stamp: 'ab 3/29/2003 00:20'!
configure
	self call: (WAApplicationEditor new application: self session application)! !

!WAToolFrame methodsFor: 'accessing' stamp: 'lr 11/21/2006 00:05'!
deprecated
	^ deprecated! !

!WAToolFrame methodsFor: 'private' stamp: 'lr 1/5/2007 18:51'!
deprecatedApi: aBlock on: html
	aBlock on: WADeprecatedApi do: [ :notification |
		| continuation |
		continuation := Continuation fromContext: notification signalerContext.
		deprecated at: notification messageText put: [
			continuation invoke: [ 
				self halt: notification messageText.
				WARenderNotification raiseSignal ] ].
		notification resume ]! !

!WAToolFrame methodsFor: 'actions' stamp: 'lr 11/21/2006 00:11'!
deprecatedCode
	| result |
	result := self confirm: [ :html | 
		html heading: 'Clear deprecated warnings?'.
		html unorderedList: [
			self deprecated keysAndValuesDo: [ :message :cc |
				html listItem: [
					html anchor
						callback: [ cc value ];
						with: message ] ] ] ].
	result ifTrue: [ deprecated := Dictionary new ]! !

!WAToolFrame methodsFor: 'initialization' stamp: 'lr 11/21/2006 00:05'!
initialize
	super initialize.
	showHalos := WAStateHolder new contents: false.
	deprecated := Dictionary new! !

!WAToolFrame methodsFor: 'actions' stamp: 'lr 11/20/2006 23:35'!
openTool: aToolClass
	self call: (aToolClass new
		root: contents;
		addDecoration: (WAWindowDecoration new 
			title: aToolClass title;
			yourself);
		yourself)! !

!WAToolFrame methodsFor: 'processing' stamp: 'avi 5/5/2005 12:30'!
processCallbackStream: aCallbackStream
	processTime := Time millisecondClockValue.
	super processCallbackStream: aCallbackStream! !

!WAToolFrame methodsFor: 'rendering' stamp: 'pmm 1/25/2007 22:53'!
renderActionsOn: html
	self actions do: [ :each |
		html anchor on: each of: self.
		html space ].! !

!WAToolFrame methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:17'!
renderChildOn: html
	showHalos contents 
		ifTrue: [ html context debugMode ].
	processTime := processTime
		ifNil: [ 0 ] ifNotNil: [ Time millisecondClockValue - processTime ].
	renderTime := Time millisecondsToRun: [
		self 
			deprecatedApi: [ html render: contents ]
			on: html ].
	html context clearMode! !

!WAToolFrame methodsFor: 'rendering' stamp: 'mb 8/10/2006 07:58'!
renderContentOn: html 
	html div
		id: 'frameContent';
		with: [self renderChildOn: html].
	html div: [html space]. "Compensate for Mozilla: bottom of contents hidden by toolbar"
	self renderToolbarOn: html.! !

!WAToolFrame methodsFor: 'rendering' stamp: 'pmm 1/25/2007 22:51'!
renderDeprecationOn: html
	self deprecated isEmpty ifFalse: [
		html space.
		html anchor
			style: 'color: red';
			callback: [ self deprecatedCode ];
			with: 'Deprecated' ].! !

!WAToolFrame methodsFor: 'rendering' stamp: 'pmm 1/25/2007 22:54'!
renderNewSessionOn: html
	html anchor
		callback: [self session expire; redirectTo: self session newSessionUrl];
		with: 'New Session'.! !

!WAToolFrame methodsFor: 'rendering' stamp: 'pmm 1/25/2007 22:52'!
renderTerminateOn: html
	html anchor
		url: (html context actionUrl withParameter: 'terminate' value: '1');
		with: 'Terminate'! !

!WAToolFrame methodsFor: 'rendering' stamp: 'pmm 1/25/2007 22:55'!
renderTimesOn: html
	html span
		title: 'Render Time';
		with: renderTime displayString.
	html text: '/'.
	html span
		title: 'Callback Time';
		with: processTime displayString.
	html text: ' ms'! !

!WAToolFrame methodsFor: 'rendering' stamp: 'pmm 1/25/2007 22:54'!
renderToolbarOn: html
	html paragraph.
	html div id: 'toolbar'; with: [
		self renderNewSessionOn: html.
		html space.
		self renderActionsOn: html.
		self renderToolsOn: html.
		self renderTerminateOn: html.
		html space.
		self renderValidationOn: html.
		self renderDeprecationOn: html.
		html space.
		self renderTimesOn: html ].
	processTime := nil! !

!WAToolFrame methodsFor: 'rendering' stamp: 'pmm 1/25/2007 22:53'!
renderToolsOn: html
	self tools do: [ :each |
		html anchor
			callback: [ self openTool: each ]; 
			with: each title.
		html space ]! !

!WAToolFrame methodsFor: 'rendering' stamp: 'pmm 1/25/2007 22:52'!
renderValidationOn: html
	html anchor
		title: 'Validate XHTML';
		url: 'http://validator.w3.org/check/referer';
		with: 'XHTML'! !

!WAToolFrame methodsFor: 'rendering' stamp: 'lr 12/6/2006 21:55'!
style
	^ '#toolbar { position: fixed; bottom: 0; left: 0; right: 0; margin-top: 40px; padding: 3px; clear: both; background: #d3d3d3; font-size: 10pt; z-index: 20 }
#toolbar-profile { margin-top: 40px; padding: 3px; clear: both; background: #d3d3d3; font-size: 10pt }

.halo { border-style: solid; border-width: 1px; margin: 4px; border-color: #aaaaaa }
.halo-header { font-size: 10pt; background-color: #cccccc }
.halo-mode { float: right }
.halo-mode .active { font-weight: bold }
.halo-icons { float: left }
.halo-icons img { border: 0 }
.halo-contents { clear: both }'
! !

!WAToolFrame methodsFor: 'actions' stamp: 'avi 9/30/2004 16:55'!
toggleHalos
	WAHalo initialize.
	showHalos contents: showHalos contents not.
! !

!WAToolFrame methodsFor: 'accessing' stamp: 'pmm 1/26/2007 21:18'!
tools
	^ WATool allSubclasses! !

WAComponent subclass: #WAHalo
	instanceVariableNames: 'target mode'
	classVariableNames: 'Halos'
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

WAHalo class
	instanceVariableNames: 'plugins'!

WAHalo class
	instanceVariableNames: 'plugins'!

!WAHalo class methodsFor: 'plugins' stamp: 'mb 6/18/2006 22:12'!
addPlugin: aClass
	(self plugins includes: aClass) ifFalse:
		[self plugins add: aClass]! !

!WAHalo class methodsFor: 'instance-creation' stamp: 'avi 9/30/2004 16:46'!
for: aComponent
	^ Halos at: aComponent ifAbsentPut: [self new target: aComponent]! !

!WAHalo class methodsFor: 'plugins' stamp: 'pmm 2/20/2007 17:58'!
haloElementsFor: aTarget inHalo: aHalo
	^OrderedCollection new
		add: ((Dictionary new)
				at: #image put: (WAStandardFiles urlOf: #haloDebugGif);
				at: #action put: [WABrowser fullOnClass: aTarget class];
				at: #title put: 'System Browser';
				yourself);
		add: ((Dictionary new)
				at: #image put: (WAStandardFiles urlOf: #haloViewGif);
				at: #action put: [WAInspector on: aTarget];
				at: #title put: 'Inspector';
				yourself);
		add: ((Dictionary new)
				at: #image put: (WAStandardFiles urlOf: #haloPaintGif);
				at: #action put: [WAViewer on: aTarget];
				at: #title put: 'Style Editor';
				yourself);
		yourself

! !

!WAHalo class methodsFor: 'plugins' stamp: 'mb 6/16/2006 19:13'!
haloImageLinksFor: aTarget inHalo: aHalo
	| actions |
	"Answer an OrderedCollection of dictionaries"
	actions := OrderedCollection new.
	self plugins do:
		[:each | actions addAll: (each haloElementsFor: aTarget inHalo: aHalo)].
	^actions.! !

!WAHalo class methodsFor: 'class initialization' stamp: 'avi 9/30/2004 16:46'!
initialize
	Halos := SeasidePlatformSupport weakDictionaryOfSize: 20.
! !

!WAHalo class methodsFor: 'plugins' stamp: 'mb 6/16/2006 18:38'!
plugins
	^plugins ifNil: [plugins := self standardPlugins].! !

!WAHalo class methodsFor: 'plugins' stamp: 'mb 6/16/2006 18:51'!
standardPlugins
	^OrderedCollection with: self! !

!WAHalo methodsFor: 'plugins' stamp: 'lr 12/6/2006 20:20'!
haloImageLinksFor: aTarget
	^ self class haloImageLinksFor: aTarget inHalo: self! !

!WAHalo methodsFor: 'initialization' stamp: 'lr 12/6/2006 20:26'!
initialize
	super initialize.
	mode := WAStateHolder new 
		contents: self modes first! !

!WAHalo methodsFor: 'accessing' stamp: 'lr 12/6/2006 20:25'!
mode
	^ mode contents! !

!WAHalo methodsFor: 'accessing' stamp: 'lr 12/6/2006 20:24'!
mode: aSymbol
	mode contents: aSymbol! !

!WAHalo methodsFor: 'configuration' stamp: 'lr 12/6/2006 20:23'!
modes
	^ #( render: source: profile: )! !

!WAHalo methodsFor: 'rendering-modes' stamp: 'lr 12/6/2006 21:42'!
profile: html
	| context haloHtml | 
	haloHtml := self rendererClass
		context: html context
		callbacks: html callbacks. 
	context := haloHtml context copy.	
	context clearMode.
	context document: WAProfiledDocument new.
	haloHtml div 
		class: 'halo-source';
		with: [ self target renderWithContext: context ]. 
	haloHtml render: context document; close.
	html context count: context count
	! !

!WAHalo methodsFor: 'rendering-modes' stamp: 'avi 9/30/2004 16:48'!
render: html
	self target renderContentOn: html! !

!WAHalo methodsFor: 'rendering' stamp: 'lr 12/6/2006 21:41'!
renderContentOn: html
	| haloHtml |
	haloHtml := self rendererClass
		context: html context
		callbacks: html callbacks.
	haloHtml div class: 'halo'; with: [
		haloHtml div class: 'halo-header'; with: [
			self renderIconsOn: haloHtml.
			self renderModeOn: haloHtml.
			haloHtml div class: 'halo-contents' ].
		haloHtml div: [
			self perform: mode contents with: html ] ].
	haloHtml close.
	html close! !

!WAHalo methodsFor: 'rendering' stamp: 'pmm 2/20/2007 18:02'!
renderHalo: aString icon: aUrl callback: aBlock on: html
	html anchor
		title: aString;
		callback: aBlock;
		with: [ html image url: aUrl ]
! !

!WAHalo methodsFor: 'rendering' stamp: 'pmm 2/20/2007 18:03'!
renderHalo: aString icon: aUrl window: aComponentBlock on: html
	self 
		renderHalo:	aString
		icon: aUrl
		callback: [
			WARenderLoop new 
				call: (aComponentBlock value
					addDecoration: (WAWindowDecoration new 
						title: aString);
					yourself) ]
		on: html! !

!WAHalo methodsFor: 'rendering' stamp: 'lr 12/6/2006 21:40'!
renderIconsOn: html
	html div class: 'halo-icons'; with: [
		html text: self target class name; text: ' '.
		(self haloImageLinksFor: self target) do: [:each |
			self
				renderHalo: (each at: #title)
				icon: (each at: #image)
				window: (each at: #action)
				on: html ] ]! !

!WAHalo methodsFor: 'rendering' stamp: 'lr 12/6/2006 20:29'!
renderModeOn: html
	html div class: 'halo-mode'; with: [
		html text: '['.
		self modes
			do: [ :each |
				html anchor
					class: 'active' if: self mode = each;
					title: (self labelForSelector: each allButLast);
					callback: [ self mode: each ];
					with: each first asUppercase ]
			separatedBy: [ html text: '|' ].
		html text: ']' ]! !

!WAHalo methodsFor: 'rendering-modes' stamp: 'lr 12/6/2006 20:33'!
source: html
	| context haloHtml | 
	haloHtml := self rendererClass
		context: html context
		callbacks: html callbacks. 
	context := haloHtml context copy.	
	context clearMode.
	context document: (WAPrettyPrintedDocument renderer: haloHtml).
	haloHtml div 
		class: 'halo-source';
		with: [ self target renderWithContext: context ]. 
	haloHtml close. 
	html context count: context count! !

!WAHalo methodsFor: 'accessing' stamp: 'avi 9/30/2004 16:54'!
target
	^ target! !

!WAHalo methodsFor: 'accessing' stamp: 'avi 9/30/2004 16:54'!
target: aComponent
	target := aComponent! !

WAComponent subclass: #WAHomeTest
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAHomeTest methodsFor: 'accessing' stamp: 'avi 10/19/2004 15:53'!
children
	^ Array with: main! !

!WAHomeTest methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 15:23'!
initialize
	super initialize.
	main := WATaskTest new.
	! !

!WAHomeTest methodsFor: 'rendering' stamp: 'avi 10/19/2004 15:53'!
renderContentOn: html
	html anchorWithAction: [main home] text: 'Home'.
	html div: main! !

!WAHomeTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:07'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAIframeTest
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAIframeTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 13:31'!
children
	^ Array with: counter! !

!WAIframeTest methodsFor: 'initialization' stamp: 'lr 3/9/2006 13:31'!
initialize
	super initialize.
	counter := WACounter new! !

!WAIframeTest methodsFor: 'rendering' stamp: 'lr 2/13/2007 00:15'!
renderContentOn: html
	html iframe 
		contents: counter.
	html break; break.
	html iframe 
		url: (WADispatcher default entryPointAt: WAStore entryPointName) basePath.
	html break; break.
	html iframe 
		document: SeasidePlatformSupport seasideBanner
		mimeType: 'image/jpeg'! !

!WAIframeTest methodsFor: 'rendering' stamp: 'lr 8/9/2006 08:38'!
style
	^ 'iframe { 
	border: 1px solid gray;
	width: 100%;
}'! !

WAComponent subclass: #WAImageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAImageTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:11'!
renderContentOn: html
	html form: [
		html 
			submitButtonWithAction: [self inform: 'ok']
			image: (ScriptingSystem formAtKey: 'Halo-Debug')]! !

!WAImageTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:11'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAInputDialog
	instanceVariableNames: 'label value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:32'!
default: aString
	value := aString! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:34'!
label
	^label ifNil: [ label := 'OK' ]! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:32'!
label: aString
	label := aString! !

!WAInputDialog methodsFor: 'rendering' stamp: 'lr 1/7/2007 18:02'!
renderContentOn: html
	html form
		defaultAction: [ self answer: value ];
		with: [
			html textInput on: #value of: self.
			html space.
			html submitButton
				callback: [ self answer: value ];
				text: self label ]! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:34'!
value
	^value! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:34'!
value: aString
	value := aString! !

WAComponent subclass: #WAInputTest
	instanceVariableNames: 'nilString emptyString integer fraction lastName address selection multiSelection option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WAInputTest class methodsFor: 'accessing' stamp: 'mb 2/22/2007 14:42'!
description
	^'Various XHTML form input elements'! !

!WAInputTest class methodsFor: 'accessing' stamp: 'mb 2/22/2007 14:41'!
example

	^ self new! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 10/10/2006 23:21'!
address
	"Answer the value of address"

	^ address! !

!WAInputTest methodsFor: 'accessing' stamp: 'pmm 10/12/2006 22:11'!
address: anObject
	"Set the value of address"

	address := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
emptyString
	"Answer the value of emptyString"

	^ emptyString! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
emptyString: anObject
	"Set the value of emptyString"

	emptyString := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
fraction
	"Answer the value of fraction"

	^ fraction! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
fraction: anObject
	"Set the value of fraction"

	fraction := anObject! !

!WAInputTest methodsFor: 'initialize-release' stamp: 'mb 11/3/2006 14:34'!
initialize
	super initialize.
	nilString := nil.
	emptyString := ''.
	integer := 42.
	fraction := 1/3.
	selection := nil.
	multiSelection := Set new.! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
integer
	"Answer the value of integer"

	^ integer! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
integer: anObject
	"Set the value of integer"

	integer := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'pmm 3/28/2007 10:08'!
label
	^'Input'! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 10/10/2006 23:04'!
lastName
	"Answer the value of lastName"

	^ lastName! !

!WAInputTest methodsFor: 'accessing' stamp: 'pmm 10/12/2006 22:11'!
lastName: anObject
	"Set the value of lastName"

	lastName := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 11/3/2006 14:50'!
multiSelection
	^ multiSelection! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 11/3/2006 14:50'!
multiSelection: anObject
	multiSelection := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
nilString
	"Answer the value of nilString"

	^ nilString! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:03'!
nilString: anObject
	"Set the value of nilString"

	nilString := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'pmm 4/24/2007 11:08'!
option
	^option! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 5/1/2007 11:57'!
option: anObject 
	option := anObject! !

!WAInputTest methodsFor: 'rendering' stamp: 'pmm 4/24/2007 11:05'!
renderContentOn: html
	html form: [
		html table: [
			self renderHeadingsOn: html.
			self renderNilStringOn: html.
			self renderEmptyStringOn: html.
			self renderIntegerOn: html.
			self renderFractionOn: html.
			self renderTextInputWithExampleOn: html.
			self renderTextAreaWithExampleOn: html.
			self renderSingleSelectionOn: html.
			self renderMultiSelectionOn: html.
			self renderInputWithoutCallbackOn: html.
			self renderOptionGroupOn: html ].
		html submitButton ]! !

!WAInputTest methodsFor: 'rendering' stamp: 'pmm 3/27/2007 18:21'!
renderEmptyStringOn: html

	html tableRow: [
		html tableData: 'Empty String'.
		html tableData: [
			html textInput on: #emptyString of: self].
		html tableData: emptyString ]! !

!WAInputTest methodsFor: 'rendering' stamp: 'pmm 3/27/2007 18:20'!
renderFractionOn: html

	html tableRow: [
		html tableData: 'Fraction'.
		html tableData: [
			html textInput on: #fraction of: self].
		html tableData: fraction ]! !

!WAInputTest methodsFor: 'rendering' stamp: 'pmm 3/27/2007 18:23'!
renderHeadingsOn: html

	html tableRow: [
		html tableHeading:  'Name'.
		html tableHeading: 'Value'.
		html tableHeading: 'PrintString']! !

!WAInputTest methodsFor: 'rendering' stamp: 'pmm 3/27/2007 18:15'!
renderInputWithoutCallbackOn: html

	html tableRow with: [
		html tableData: 'Input elements with no callback'.
		html tableData with: [
			html select
				size: 10; 
				list: Collection subclasses].
		html tableData with: [
			html unorderedList
				beMultiple;
				selected: #();
				list: Collection subclasses ] ]! !

!WAInputTest methodsFor: 'rendering' stamp: 'pmm 3/27/2007 18:20'!
renderIntegerOn: html

	html tableRow: [
		html tableData: 'Integer'.
		html tableData: [
			html textInput setFocus; on: #integer of: self].
		html tableData: integer ]! !

!WAInputTest methodsFor: 'rendering' stamp: 'pmm 3/27/2007 18:17'!
renderMultiSelectionOn: html

	html tableRow: [
		html tableData: 'Multi Selection'.
		html tableData: [
			html select
				beMultiple;
				list: #(Breakfast Lunch Dinner);
				on: #multiSelection of: self ].
		html tableData: [
			html text: multiSelection ] ]! !

!WAInputTest methodsFor: 'rendering' stamp: 'pmm 3/27/2007 18:22'!
renderNilStringOn: html

	html tableRow: [
		html tableData: 'Nil String'.
		html tableData: [
			html textInput on: #nilString of: self].
		html tableData: nilString ]! !

!WAInputTest methodsFor: 'rendering' stamp: 'mb 5/1/2007 11:59'!
renderOptionGroupOn: html

	| options |
	options := #(
		('Dataflow' ('Hartmann pipelines'  'G' 'Max'  'Prograph'))
		('Functional' ('Haskell ' 'Lisp' 'ML'))
		('Fourth-generation' ('Today' 'Ubercode' 'Uniface'))).

	html tableRow: [
		html tableData: 'Option Group'.
		html tableData: [
			html select
				on: #option of: self;
				with: [
				options do: [ :list |
					html optionGroup
						label: list first;
						with: [
							list second do: [ :each |
								html option
									selected: self option = each;
									callback: [self option: each];
									with: each ] ] ] ] ].
		html tableData: [
			html text: option ] ]! !

!WAInputTest methodsFor: 'rendering' stamp: 'mb 5/1/2007 10:33'!
renderSingleSelectionOn: html 
	html
		tableRow: [html tableData: 'Selection'.
			html
				tableData: [html select beOptional; list: #(#Quito #Dakar #Sydney #Bamako );
						enablementBlock: [:value | #(nil #Quito #Sydney ) includes: value]; optionalLabel: 'nothing selected'; on: #selection of: self].
			html
				tableData: [html text: selection]]! !

!WAInputTest methodsFor: 'rendering' stamp: 'pmm 3/27/2007 18:17'!
renderTextAreaWithExampleOn: html

	html tableRow: [
		html tableData: 'Text area with example'.
		html tableData: [
			html textArea
				value: self address;
				exampleText: 'Your address';
				callback: [ :value | self address: value ] ].
		html tableData: self address]! !

!WAInputTest methodsFor: 'rendering' stamp: 'pmm 3/27/2007 18:18'!
renderTextInputWithExampleOn: html

	html tableRow: [
		html tableData: 'Text input with example'.
		html tableData: [
			html textInput
				value: self lastName;
				exampleText: 'Your name';
				callback: [:v | self lastName: v]].
		html tableData: self lastName]! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 11/3/2006 14:49'!
selection
	^ selection! !

!WAInputTest methodsFor: 'accessing' stamp: 'mb 11/3/2006 14:50'!
selection: anObject
	selection := anObject! !

WAComponent subclass: #WAInspector
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAInspector class methodsFor: 'instance creation' stamp: 'ab 2/15/2003 00:21'!
on: anObject
	^ self new object: anObject! !

!WAInspector methodsFor: 'testing' stamp: 'pmm 9/12/2006 18:35'!
canInspect: anObject
	^[ anObject isNumber
		or: [ (Array with: nil with: true with: false) includes: anObject ]
	] on: Error do: [ :ex | false ]! !

!WAInspector methodsFor: 'accessing' stamp: 'avi 2/10/2004 16:34'!
children
	^ Array with: path! !

!WAInspector methodsFor: 'actions' stamp: 'ab 5/31/2003 15:13'!
chooseObject: anObject named: aString
	path pushSegment: anObject name: aString! !

!WAInspector methodsFor: 'actions' stamp: 'pmm 7/4/2005 15:37'!
evaluate: aString
	^self object class evaluatorClass new
		evaluate: aString
		in: nil
		to: self object.! !

!WAInspector methodsFor: 'initialize-release' stamp: 'al 9/7/2006 15:22'!
initialize
	super initialize.
	path := WAPath new! !

!WAInspector methodsFor: 'state variables' stamp: 'ab 5/31/2003 15:12'!
object
	^ path currentSegment! !

!WAInspector methodsFor: 'state variables' stamp: 'ab 5/31/2003 15:11'!
object: anObject 
	path pushSegment: anObject name: anObject printString! !

!WAInspector methodsFor: 'rendering' stamp: 'pmm 7/4/2005 15:38'!
renderContentOn: html 
	html render: path.
	html heading: (self object printStringLimitedTo: 50).
	html text: 'Identity Hash: ', self object identityHash displayString; break; break.
	self renderMembersOn: html.
	self renderEditAreaOn: html.! !

!WAInspector methodsFor: 'rendering' stamp: 'al 9/7/2006 15:37'!
renderEditAreaOn: html
	| input |
	input := ValueHolder new.
	html break.
	html form: [
		html textArea
			rows: 6;
			columns: 60;
			callback: [ :value | input contents: value].
		html break.
		html submitButton
			callback: [ self evaluate: input contents ];
			text: 'do it'.
		html submitButton 
			callback: [ self inform: (self evaluate: input contents) ];
			text: 'print it'.
		html submitButton
			callback: [
				WARenderLoop new call:
					((self class on: (self evaluate: input contents))
					addDecoration: (WAWindowDecoration new title: 'Inspector');
					yourself) ];
			text: 'inspect it'. ].! !

!WAInspector methodsFor: 'rendering' stamp: 'al 9/7/2006 15:43'!
renderMembersOn: html 
	| members |
	members := self object inspectorFields.
	members isEmpty ifTrue: [^self].
	html strong: 'Members: '.
	html table
		border: 1;
		with: [
			members associationsDo: [ :association | 
				self
					renderRowForObject: association value
					named: association key
					on: html ] ]! !

!WAInspector methodsFor: 'rendering' stamp: 'pmm 2/20/2007 18:21'!
renderRowForObject: anObject named: aString on: html
	html tableRow: [
		html tableData: [ 
			(self canInspect: anObject)
				ifTrue: [html text: aString]
				ifFalse: [html anchor callback: [self chooseObject: anObject named: aString]; with: aString ] ].
		html tableData: [
			html form
				with: [
					html textArea
						rows: 1;
						columns: 30;
						value: (anObject printStringLimitedTo: 100);
						callback: [ :value |
							self object
								instVarNamed: aString
								put: (self evaluate: value) ].
					html submitButton text: 'accept' ] ] ]! !

WAComponent subclass: #WAJavascriptTest
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAJavascriptTest methodsFor: 'rendering' stamp: 'pmm 9/12/2006 18:36'!
renderContentOn: html
	html form: [
		html cssId: 'F0'.
		html textInputWithValue: value callback: [:v | value := v].
		html cssId: #F1.
		html autofocus: [html textInputWithValue: value callback: [:v | value := v]].
		html submitButton].
	html cssId: #D1.
	html divWithShow: 'Show' hide: 'Hide' do: 'DIV'.
	html cssId: #S1.
	html spanWithShow: 'Show' hide: 'Hide' do: 'SPAN'! !

!WAJavascriptTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:13'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WALibraryBrowser
	instanceVariableNames: 'selector library hits search'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WALibraryBrowser methodsFor: 'actions' stamp: 'avi 7/2/2004 00:50'!
find: aString
	| inst |
	self libraries do:
		[:ea |
		inst := ea new.
		ea selectors do: 
			[:sel |
			((inst perform: sel) includesSubString: aString)
				ifTrue: [(hits at: (Array with: ea with: sel) ifAbsentPut: [SortedCollection new]) add: aString]]]! !

!WALibraryBrowser methodsFor: 'actions' stamp: 'avi 7/2/2004 00:49'!
findAll: aString
	hits := Dictionary new.
	(aString findTokens: ' ') do: [:ea | self find: ea].
	hits isEmpty ifFalse: [self goto: self orderedHits first]! !

!WALibraryBrowser methodsFor: 'actions' stamp: 'avi 7/2/2004 00:51'!
goto: anArray
	library := anArray first.
	selector := anArray second! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'mb 5/6/2006 16:08'!
hits
	^ hits ifNil: [ hits := Dictionary new ]! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 7/2/2004 00:28'!
libraries
	^ (WAStyleLibrary subclasses, WAScriptLibrary subclasses) asSortedCollection: [:a :b | a name <= b name]! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 7/2/2004 00:28'!
library
	^ library! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 7/2/2004 00:28'!
library: aLibraryClass
	library := aLibraryClass.
	selector := nil.! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'lr 5/3/2006 10:05'!
orderedHits
	^ self hits keys asSortedCollection: [:a :b | (hits at: a) size >= (hits at: b) size]! !

!WALibraryBrowser methodsFor: 'rendering' stamp: 'pmm 4/23/2006 21:23'!
renderColumnsOn: html
	html select
		beSubmitOnChange;
		size: 10;
		list: self libraries;
		on: #library of: self.
	html
		select
		beSubmitOnChange;
		size: 10;
		list: self selectors;
		on: #selector of: self.! !

!WALibraryBrowser methodsFor: 'rendering' stamp: 'pmm 4/23/2006 21:17'!
renderContentOn: html
	html div
		class: 'stylebrowser-columns';
		with: [
			html form: [ self renderColumnsOn: html ] ].

	html div
		class: 'stylebrowser-search';
		with: [
			html form: [
				html textInput value: search; callback: [:v | search := v].
				html space.
				html submitButton callback: [self findAll: search]; text: 'Search' ].
		html unorderedList: [
			self orderedHits do: [:pair |
				html listItem: [
					self renderHit: pair on: html ] ] ] ].

	html div
		class: 'stylebrowser-editor';
		with: [
			html form: [
				self renderEditorOn: html.
				html paragraph.
				html submitButton callback: [self save]; text: 'Save' ] ]! !

!WALibraryBrowser methodsFor: 'rendering' stamp: 'pmm 4/23/2006 21:18'!
renderEditorOn: html
	html textArea
		rows: 20;
		columns: 80;
		on: #string of: self.
! !

!WALibraryBrowser methodsFor: 'rendering' stamp: 'pmm 4/23/2006 21:19'!
renderHit: anArray on: html
	| text |
	text := String streamContents: [ :stream |
		stream nextPutAll: anArray first name.
		stream nextPutAll: '>>'.
		stream nextPutAll: anArray second.
		stream space.
		stream nextPutAll: '('.
		(hits at: anArray)
			do: [:each | stream nextPutAll: each ]
			separatedBy: [ stream nextPutAll: ', '].
		stream nextPutAll: ')'].
	html anchor callback: [self goto: anArray]; with: text.
	! !

!WALibraryBrowser methodsFor: 'actions' stamp: 'avi 5/24/2004 14:55'!
save! !

!WALibraryBrowser methodsFor: 'actions' stamp: 'avi 7/2/2004 11:08'!
search: aString
	search := aString.
	self findAll: search! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 5/24/2004 14:46'!
selector
	^ selector! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 7/2/2004 00:32'!
selector: aSymbol
	(library selectors includes: aSymbol) ifTrue: [selector := aSymbol]! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 7/2/2004 00:28'!
selectors
	^ library ifNil: [#()] ifNotNil: [library selectors]! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 7/2/2004 10:58'!
string
	^ self selector ifNotNilDo: [:s | library new perform: s]! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'avi 7/2/2004 10:58'!
string: aString
	self selector ifNotNilDo:
		[:sel |
		library compile: (sel, '
	^ ', aString printString)]! !

!WALibraryBrowser methodsFor: 'accessing' stamp: 'mb 2/17/2005 18:32'!
style
	^ '
	.stylebrowser-search {float: left}
	.stylebrowser-columns {float: left}
	.stylebrowser-columns select {width: 250px}
	.stylebrowser-editor {clear: both}
	'! !

WAComponent subclass: #WALinkSubmitTest
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WALinkSubmitTest methodsFor: 'initialize-release' stamp: 'pmm 7/19/2006 19:52'!
initialize
	super initialize.
	count := 0! !

!WALinkSubmitTest methodsFor: 'rendering' stamp: 'lr 8/3/2006 08:43'!
renderContentOn: html
	html attributes at: 'name' put: #myform.
	html form:
		[html textInputWithValue: count callback: [:v | count := v].
		html break.
		html addShortcut: 'Ctrl-Down'.
		html anchorWithAction: [count := count - 1] text: '--' submitFormNamed: 'myform'.
		html space.
		html addShortcut: 'Ctrl-Up'.
		html anchorWithAction: [count := count + 1] text: '++' submitFormNamed: #myform.
		html break; break.
		html addShortcut: 'Ctrl-Z'.
		html addShortcut: 'Ctrl-z'.
		html checkboxWithValue: (count = 0) callback: [:v | v ifTrue: [count := 0] ] submitFormNamed: 'myform'.
		html space.
		html text: 'Reset'
		].
	html emphasis: 'Handy shortcuts : Ctrl-Up, Ctrl-Down and Ctrl-Z'
! !

!WALinkSubmitTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:15'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WALoginDialog
	instanceVariableNames: 'username password authenticator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WALoginDialog methodsFor: 'accessing' stamp: 'avi 2/6/2004 16:55'!
authenticator: anAuthenticator
	authenticator := anAuthenticator! !

!WALoginDialog methodsFor: 'actions' stamp: 'avi 2/6/2004 16:56'!
cancel
	self answer: nil! !

!WALoginDialog methodsFor: 'actions' stamp: 'avi 2/6/2004 16:56'!
login
	(authenticator verifyPassword: password forUser: username) ifTrue: [self answer: username]! !

!WALoginDialog methodsFor: 'rendering' stamp: 'lr 12/7/2006 08:37'!
renderContentOn: html
	html form: [
		html table: [ 
			html tableRow: [
				html tableHeading: 'Username:'.
				html tableData: [
					html textInput
						value: username;
						callback: [ :value | username := value ] ] ].
			html tableRow: [
				html tableHeading: 'Password:'.
				html tableData: [
					html passwordInput
						callback: [ :value | password := value ] ] ].
			html tableRow: [
				html tableData colSpan: 2; with: [
					html submitButton on: #login of: self.
					html space.
					html submitButton on: #cancel of: self ] ] ] ]! !

WAComponent subclass: #WALotsaLinks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WALotsaLinks methodsFor: 'rendering' stamp: 'avi 5/3/2005 21:27'!
renderContentOn: html
	html list: (1 to: 5000) do:
		[:ea |
		html anchorWithAction: [self inform: ea] text: ea]! !

!WALotsaLinks methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:16'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAMiniCalendar
	instanceVariableNames: 'month date canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAMiniCalendar class methodsFor: 'testing' stamp: 'dc 12/28/2005 14:20'!
canBeRoot
	^ true! !

!WAMiniCalendar class methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:37'!
example
	^self new! !

!WAMiniCalendar methodsFor: 'testing' stamp: 'lr 12/28/2006 22:37'!
canSelect: aDate
	^ canSelectBlock value: aDate! !

!WAMiniCalendar methodsFor: 'accessing' stamp: 'avi 10/23/2003 15:16'!
canSelectBlock: aBlock
	canSelectBlock := aBlock! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 10/23/2003 15:25'!
date
	^ date contents! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 12/12/2004 13:39'!
date: aDate
	date contents: aDate.
	month contents: aDate month! !

!WAMiniCalendar methodsFor: 'initialization' stamp: 'lr 12/28/2006 22:39'!
initialize
	super initialize.
	month := WAStateHolder new contents: Date today month.
	date := WAStateHolder new.
	canSelectBlock := [ :value | true ].
	selectBlock := [ :value | self answer: value ]! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 10/23/2003 22:56'!
month
	^ month contents! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 10/23/2003 22:56'!
month: aMonth
	^ month contents: aMonth! !

!WAMiniCalendar methodsFor: 'private' stamp: 'lr 12/28/2006 22:41'!
monthHeading
	^ self month name , ' ' , self month year displayString! !

!WAMiniCalendar methodsFor: 'private' stamp: 'lr 12/28/2006 22:41'!
months
	^ (1 to: 12) collect: [ :i | Month month: i year: self year ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderCellForDate: aDate on: html 
	html tableData: [
		aDate month = self month ifTrue: [
			html span
				class: (self date = aDate ifTrue: [ 'calendarArchiveDate' ]);
				with: [
					(self canSelect: aDate)
						ifTrue: [
							html anchor
								callback: [ self select: aDate ];
								with: aDate dayOfMonth ]
						ifFalse: [ html text: aDate dayOfMonth ] ] ] ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:03'!
renderContentOn: html
	html div
		class: 'calendar';
		with: [
			html span
				class: 'calendarCaption';
				with: [ self renderMonthHeadingOn: html ].
			html table: [
				html tableRow
					class: 'calendarTitle';
						with: [
						self weekDays do: [ :each |
							html tableData: each ] ].
				self month weeksDo: [ :week |
					self renderRowForWeek: week on: html ] ].
			
			self renderMonthNavigationOn: html.
			html space; space.
			self renderYearNavigationOn: html ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:09'!
renderMonthHeadingOn: html
	html form: [
		html select
			list: self months;
			on: #month of: self;
			labels: [:eachMonth | eachMonth name].
		html textInput
			maxLength: 4;
			on: #year of: self.
		html submitButton text: 'Refresh' ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:23'!
renderMonthNavigationOn: html
	html span
		class: 'calendarPrevious';
		with: [
			html anchor
				callback: [self month: self month previous];
				with: (self month previous name first: 3) ].
	html space.
	html span
		class: 'calendarNext';
		with: [
			html anchor
				callback: [self month: self month next];
				with: (self month next name first: 3) ]
	! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'pmm 9/11/2006 23:28'!
renderRowForWeek: aWeek on: html
	html tableRow: [
		aWeek datesDo: [ :each | self renderCellForDate: each on: html ] ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderYearNavigationOn: html
	html span
		class: 'calendarPrevious';
		with: [
			html anchor
				callback: [self year: self year - 1];
				with: (self year - 1) ].
	html space.
	html span
		class: 'calendarNext';
		with: [
			html anchor
				callback: [self year: self year + 1];
				with: (self year + 1) ]
	! !

!WAMiniCalendar methodsFor: 'action' stamp: 'lr 12/28/2006 22:38'!
select: aDate
	self date: aDate.
	selectBlock value: aDate! !

!WAMiniCalendar methodsFor: 'accessing' stamp: 'avi 10/23/2003 17:39'!
selectBlock: aBlock
	selectBlock := aBlock! !

!WAMiniCalendar methodsFor: 'private' stamp: 'lr 12/28/2006 22:42'!
weekDays
	^ (1 to: 7) collect: [ :i | (Date nameOfDay: i) first: 3 ]! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dc 12/29/2005 11:44'!
year
	^ self month year! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dc 12/29/2005 11:51'!
year: anInteger
	self month: (Month month: self month monthIndex year: anInteger)! !

WAComponent subclass: #WAMultiCounter
	instanceVariableNames: 'counters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAMultiCounter commentStamp: '<historical>' prior: 0!
A WAMultiCounter is a component that consits of several instances of WACounter. Be sure to understand WACounter.

The lesson to learn here is how Seaside components can be composed of other components.

Instance Variables
	counters:		<Collection<WACounter>>

counters
	- a Collection of components (instances of WACounter) 
!

!WAMultiCounter class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^true! !

!WAMultiCounter class methodsFor: 'accessing' stamp: 'mb 5/26/2006 12:30'!
description
	^'Multiple Seaside components on one page'! !

!WAMultiCounter class methodsFor: 'initialization' stamp: 'lr 2/12/2007 21:39'!
initialize
	self registerAsApplication: 'examples/multicounter'! !

!WAMultiCounter methodsFor: 'accessing' stamp: 'avi 4/15/2004 21:50'!
children
	^ counters! !

!WAMultiCounter methodsFor: 'initialization' stamp: 'lr 2/20/2007 12:06'!
initialize
	super initialize.
	counters := (1 to: 5) collect: [ :each | WACounter new ]! !

!WAMultiCounter methodsFor: 'rendering' stamp: 'lr 2/20/2007 12:06'!
renderContentOn: html
	counters 
		do: [ :each | html render: each ]
		separatedBy: [ html horizontalRule ]! !

WAComponent subclass: #WANavigation
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Frames'!

!WANavigation methodsFor: 'initialize' stamp: 'mb 4/23/2006 15:27'!
initialize
	super initialize.
	selection := WAStateHolder new! !

!WANavigation methodsFor: 'query' stamp: 'mbany 4/14/2005 12:12'!
labelForOption: anObject
	^ anObject displayString! !

!WANavigation methodsFor: 'initialize' stamp: 'avi 3/15/2004 16:27'!
options
	^ #()! !

!WANavigation methodsFor: 'rendering' stamp: 'dc 7/25/2006 16:28'!
renderContentOn: html
	html div
		class: 'kalsey';
		with: [
			html div
				class: 'navigation-options';
				with: [self renderOptionsOn: html].
			html div
				class: 'navigation-content';
				with: [self renderSelectionOn: html]]! !

!WANavigation methodsFor: 'rendering' stamp: 'dc 7/25/2006 16:29'!
renderOptionsOn: html
	html unorderedList
		list: self options;
		selected: self selection;
		callback: [:v | self select: v];
		labels: [:ea | self labelForOption: ea]
! !

!WANavigation methodsFor: 'rendering' stamp: 'avi 3/15/2004 16:13'!
renderSelectionOn: html! !

!WANavigation methodsFor: 'selection' stamp: 'avi 3/15/2004 16:28'!
select: anObject
	selection contents: anObject.
	self selectionChanged! !

!WANavigation methodsFor: 'selection' stamp: 'avi 3/15/2004 16:28'!
selection
	^ selection contents! !

!WANavigation methodsFor: 'selection' stamp: 'avi 3/15/2004 16:28'!
selectionChanged
	! !

WANavigation subclass: #WASimpleNavigation
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Frames'!

!WASimpleNavigation commentStamp: 'lr 11/29/2004 16:30' prior: 0!
I'm a simple tab panel, that can be styled with stylesheets. New tabs can be added using #add:label:!

!WASimpleNavigation class methodsFor: 'example' stamp: 'lr 11/29/2004 16:32'!
example
	^self new
		add: WACounter example label: 'Counter'; 
		add: WAPath example label: 'Path';
		select: 'Counter';
		yourself.! !

!WASimpleNavigation methodsFor: 'behavior' stamp: 'avi 3/15/2004 19:24'!
add: aComponent label: aString
	components add: aString -> aComponent! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:27'!
children
	^Array with: self selectedComponent.! !

!WASimpleNavigation methodsFor: 'initialize' stamp: 'avi 3/15/2004 19:25'!
initialize
	super initialize.
	components := OrderedCollection new! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:28'!
labels
	"Return the tabs labels"

	^ self options! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'avi 3/16/2004 19:34'!
options
	^ components collect: [:ea | ea key]! !

!WASimpleNavigation methodsFor: 'rendering' stamp: 'sd 11/28/2004 21:15'!
renderSelectionOn: html
	html render: self selectedComponent! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'avi 3/15/2004 19:25'!
selectedComponent
	^ (components detect: [:ea | ea key = self selection] ifNone: [^ nil]) value! !

WAComponent subclass: #WANavigationBar
	instanceVariableNames: 'actionsSelector owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WANavigationBar methodsFor: 'accessing' stamp: 'ab 5/30/2003 00:15'!
actions
	^ self target perform: actionsSelector! !

!WANavigationBar methodsFor: 'accessing' stamp: 'ab 5/30/2003 00:15'!
actionsSelector: aSymbol
	actionsSelector := aSymbol! !

!WANavigationBar methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 15:27'!
initialize
	super initialize.
	actionsSelector := #actions! !

!WANavigationBar methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:31'!
owner: anObject 
	owner := anObject! !

!WANavigationBar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:32'!
renderContentOn: html
	self actions do: [ :symbol |
		symbol numArgs = 0
			ifTrue: [ self renderLink: symbol on: html ]
			ifFalse: [ self renderInput: symbol on: html ] ]! !

!WANavigationBar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:34'!
renderInput: aSymbol on: html
	html form: [
		html strong: aSymbol capitalized.
		html space.
		html textInput
			callback: [ :value |
				self target perform: aSymbol with: value ] ]! !

!WANavigationBar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:34'!
renderLink: aSymbol on: html
	html anchor
		on: aSymbol of: self target.
	html break! !

!WANavigationBar methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:31'!
target
	^ owner activeComponent! !

WAComponent subclass: #WAOldApiHtmlTest
	instanceVariableNames: 'booleanList message number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAOldApiHtmlTest methodsFor: 'private' stamp: 'mb 5/1/2007 13:18'!
allSelectors
	^ (self class selectors asSortedCollection select: [:s | s beginsWith: 'render'])
		remove: #renderContentOn:;
		remove: #rendererClass;
		yourself! !

!WAOldApiHtmlTest methodsFor: 'accessing' stamp: 'cds 6/24/2004 00:41'!
booleanList
	^booleanList! !

!WAOldApiHtmlTest methodsFor: 'initialize' stamp: 'mb 3/8/2006 14:10'!
initialMessage
	^'Hello world!!'.
! !

!WAOldApiHtmlTest methodsFor: 'initialize' stamp: 'pmm 7/19/2006 19:52'!
initialize
	super initialize.
	message := self initialMessage.
	booleanList := #(a b c d) collect: [:key | key -> ((Array with: true with: false) atRandom)].
	number := 10 atRandom.! !

!WAOldApiHtmlTest methodsFor: 'accessing' stamp: 'cds 6/25/2004 17:18'!
message
	^message! !

!WAOldApiHtmlTest methodsFor: 'accessing' stamp: 'cds 6/25/2004 16:54'!
number
	^number! !

!WAOldApiHtmlTest methodsFor: 'rendering' stamp: 'cds 6/24/2004 10:30'!
renderCheckboxesOn: html 
	html text: booleanList.
	html paragraph.
	html cssId: 'checkbox-form'.
	html
		form: [booleanList
				do: [:assoc | 
					html text: assoc key;
						 space.
					html cssId: 'cb-' , assoc key asString.
					html
						checkboxWithValue: assoc value
						callback: [:b | assoc value: b].
					html break].
			html submitButton]! !

!WAOldApiHtmlTest methodsFor: 'rendering' stamp: 'mb 2/9/2006 17:55'!
renderContentOn: html
	self allSelectors pairsDo:
		[:selA :selB |
		html divClass: 'row' with: [
			html divClass: 'left' with: [self perform: selA with: html].
			html divClass: 'right' with: [self perform: selB with: html]
		]]
! !

!WAOldApiHtmlTest methodsFor: 'rendering' stamp: 'mb 6/21/2006 13:00'!
renderRadioButtonsOn: html 
	html text: booleanList.
	html paragraph.
	html cssId: 'radio-form'.
	html
		form: [booleanList
				do: [:assoc | 
					| group | 
					group _ html radioGroup.
					html text: assoc key;
						 space.
					html cssId: assoc key asString , '-on'.
					html addShortcut: 'Ctrl-' , assoc key.
					html
						radioButtonInGroup: group
						selected: assoc value
						callback: [assoc value: true].
					html cssId: assoc key asString , '-off'.
					html addShortcut: 'Alt-' , assoc key.
					html
						radioButtonInGroup: group
						selected: assoc value not
						callback: [assoc value: false].
					html break].
			html submitButton]! !

!WAOldApiHtmlTest methodsFor: 'rendering' stamp: 'cds 6/25/2004 16:45'!
renderSelectsOn: html 
	html text: number.
	html paragraph.
	html cssId: 'select-form'.
	html
		form: [html cssId: 'select-list'.
			html
				selectFromList: (1 to: 10)
				selected: number
				callback: [:i | number _ i].
			html submitButton]! !

!WAOldApiHtmlTest methodsFor: 'rendering' stamp: 'pmm 7/19/2006 19:41'!
renderSubmitButtonsOn: html 
	html text: number.
	html paragraph.
	html cssId: 'button-form'.
	html form: [
		1 to: 10 do: [ :index | 
			html addShortcut:  'F' , index asString.
			html addShortcut:  'Ctrl-' , index asString.
			html
				submitButtonWithAction: [ number := index ]
				text: index.
			html space]].
	html attributes addStyle: 'font-size: 60%'.
	html attributes addStyle: 'font-style: italic'.
	html span: 'Handy shortcuts : F1..F10, Ctrl-1..Ctrl-9'.
! !

!WAOldApiHtmlTest methodsFor: 'rendering' stamp: 'mb 6/21/2006 12:55'!
renderTextAreaOn: html 
	html cssId: 'textarea-form'.
	html
		form: [html cssId: 'textarea-banner'.
			html span: message.
			html paragraph.
			html cssId: 'textarea-message'.
			html
				textAreaWithValue: message
				callback: [:v | message _ v].
			html break; submitButton]! !

!WAOldApiHtmlTest methodsFor: 'rendering' stamp: 'mb 6/21/2006 12:54'!
renderTextInputOn: html 
	html cssId: 'textInput-form'.
	html
		form: [html cssId: 'textInput-banner'.
			html span: message.
			html paragraph.
			html cssId: 'text-message'.
			html
				textInputWithValue: message
				callback: [:v | message _ v].
			html submitButton]! !

!WAOldApiHtmlTest methodsFor: 'rendering' stamp: 'mb 2/10/2006 11:15'!
renderVFieldSetOn: html
	html fieldsetWithLegend: 'Various text rendering in a fieldset' do:
		[html
			strong: 'Strong';
			break;
			bold: 'Bold';
			break;
			italic: 'Italic';
			break;
			underline: 'Underline';
			break;
			acronym: 'United States of America' do: 'USA';
			break;
			emphasis: 'Emphasis';
			break.

		html attributes
			addStyle: 'color: red';
			backgroundColor: 'lightgreen';
			addStyle: 'padding: 1em';
			border: 2;
			addStyle: 'font-weight: bold';
			addStyle: 'font-size: 150%';
			height: '3em';
			alignCenter.
		html
			div: 'Large bold red in a green div';
			break]! !

!WAOldApiHtmlTest methodsFor: 'rendering' stamp: 'mb 6/12/2006 14:38'!
renderZFieldSetOn: html
	| url1 |
	url1 _ html context
				urlForDocument: (ScriptingSystem formAtKey: 'Halo-Debug') 
				mimeType: 'image/jpg' 
				fileName: 'Debug.jpg'.
	html fieldsetWithLegend: 'Various images in a fieldset' do:
		[html image: url1 altText: 'Halo-Debug'.
		html space.
		html attributeAt: 'alt' put: 'Halo-View'.
		html imageWithForm: (ScriptingSystem formAtKey: 'Halo-View').
		html space.
		html attributeAt: 'alt' put: 'Halo-Paint'.
		html
			imageWithDocument: (ScriptingSystem formAtKey: 'Halo-Paint')
			mimeType: 'image/png'
			fileName: 'Paint.png'.		
		html break.
		html attributes border: 1.
		html image: 'http://www.netstyle.ch/include/seaside/pics/top.jpg' width: '80%' altText: 'Seaside'.
		html break.
		html attributes border: 2.
		html image: 'http://www.netstyle.ch/include/seaside/pics/top.jpg' height: '50px' altText: 'Seaside'.
		html break.
		html attributes noBorder.
		html image: 'http://www.netstyle.ch/include/seaside/pics/top.jpg' width: '250px' height: '60px' altText: 'Seaside']! !

!WAOldApiHtmlTest methodsFor: 'rendering' stamp: 'mb 5/1/2007 12:27'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

!WAOldApiHtmlTest methodsFor: 'rendering' stamp: 'mb 2/10/2006 10:52'!
style
^ '
	div.row {clear: both}
	div.left {float: left; width: 45%; margin: 1%}
	div.right {float: left; width: 45%; margin: 1%}

'! !

WAComponent subclass: #WAOldApiInputTest
	instanceVariableNames: 'nilString integer emptyString fraction selected mSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAOldApiInputTest class methodsFor: 'example' stamp: 'sd 11/28/2004 15:43'!
example

	^ self new! !

!WAOldApiInputTest methodsFor: 'accessing' stamp: 'mb 4/30/2007 09:06'!
emptyString
	"Answer the value of emptyString"


	^emptyString! !

!WAOldApiInputTest methodsFor: 'accessing' stamp: 'mb 4/30/2007 09:06'!
emptyString: anObject
	"Set the value of emptyString"


	emptyString := anObject! !

!WAOldApiInputTest methodsFor: 'accessing' stamp: 'mb 4/30/2007 09:06'!
fraction
	"Answer the value of fraction"


	^fraction! !

!WAOldApiInputTest methodsFor: 'accessing' stamp: 'mb 4/30/2007 09:06'!
fraction: anObject
	"Set the value of fraction"


	fraction := anObject! !

!WAOldApiInputTest methodsFor: 'initialize-release' stamp: 'pmm 7/19/2006 19:52'!
initialize
	super initialize.
	nilString := nil.
	emptyString := ''.
	integer := 42.
	fraction := 1/3.! !

!WAOldApiInputTest methodsFor: 'accessing' stamp: 'mb 4/30/2007 09:06'!
integer
	"Answer the value of integer"


	^integer! !

!WAOldApiInputTest methodsFor: 'accessing' stamp: 'mb 4/30/2007 09:06'!
integer: anObject
	"Set the value of integer"


	integer := anObject! !

!WAOldApiInputTest methodsFor: 'accessing' stamp: 'mb 2/10/2006 12:49'!
labelForSelector: aSymbol

	aSymbol == #nilString ifTrue: [^'Nil string,  ' , self nilString printString].
	aSymbol == #emptyString ifTrue: [^'Empty string, ' , self emptyString printString].
	aSymbol == #integer ifTrue: [^'Integer, ' , self integer printString].
	aSymbol == #fraction ifTrue: [^'Fraction, ' , self fraction printString].
	^ super labelForSelector: aSymbol! !

!WAOldApiInputTest methodsFor: 'accessing' stamp: 'mb 3/28/2007 12:30'!
mSelected
	^mSelected ifNil: [#()]! !

!WAOldApiInputTest methodsFor: 'accessing' stamp: 'mb 3/28/2007 12:50'!
mSelected: anObject 
	mSelected := anObject! !

!WAOldApiInputTest methodsFor: 'accessing' stamp: 'mb 4/30/2007 09:06'!
nilString
	"Answer the value of nilString"


	^nilString! !

!WAOldApiInputTest methodsFor: 'accessing' stamp: 'mb 4/30/2007 09:06'!
nilString: anObject
	"Set the value of nilString"


	nilString := anObject! !

!WAOldApiInputTest methodsFor: 'rendering' stamp: 'mb 2/10/2006 12:39'!
renderContentOn: html
	self renderFormOneOn: html.
	self renderFormTwoOn: html.
! !

!WAOldApiInputTest methodsFor: 'rendering' stamp: 'mb 3/28/2007 12:34'!
renderFormOneOn: html
	html form: [
		html table: [
			html	
				tableHeadings: #(Name Value PrintString);
				tableRowWithLabel: 'Nil String'
					column: [html textInputOn: #nilString of: self]
					column: [html text: nilString printString];
				tableRowWithLabel: 'Empty String'
					column: [html textInputOn: #emptyString of: self]
					column: [html text: emptyString printString];
				tableRowWithLabel: 'Integer'
					column: [html textInputOn: #integer of: self]
					column: [html text: integer printString];
				tableRowWithLabel: 'Fraction'
					column: [html textInputOn: #fraction of: self]
					column: [html text: fraction printString];
				tableRowWithLabel: 'Select'
					column: [html selectInputOn: #selected of: self list: #(a b c) ]
					column: [html text: selected];
				tableRowWithLabel: 'Multi Select'
					column: 
							[html attributeAt: 'multiple' put: true.
							html selectInputOn: #mSelected of: self list: #(1 2 3 4 5) ]
					column: [html text: mSelected].
		].
		html break; submitButton.
	]
! !

!WAOldApiInputTest methodsFor: 'rendering' stamp: 'mb 3/28/2007 12:24'!
renderFormTwoOn: html
	html form: [
		html table: [
			html	
				tableHeadings: #(Name Value);
				labelledRowForTextInputOn: #nilString of: self size: 4;
				labelledRowForTextInputOn: #emptyString of: self size: 8;
				labelledRowForTextInputOn: #integer of: self size: 12;
				labelledRowForTextInputOn: #fraction of: self size: 16.
		].
		html break; submitButton.
	]
! !

!WAOldApiInputTest methodsFor: 'rendering' stamp: 'mb 5/1/2007 12:27'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

!WAOldApiInputTest methodsFor: 'accessing' stamp: 'mb 3/28/2007 12:23'!
selected
	^selected! !

!WAOldApiInputTest methodsFor: 'accessing' stamp: 'mb 3/28/2007 12:23'!
selected: anObject
	selected := anObject! !

!WAOldApiInputTest methodsFor: 'rendering' stamp: 'mb 2/10/2006 12:52'!
style
	^'
form {
	float: left;
	margin: 0 150px 0 0;
}
'! !

WAComponent subclass: #WAParentTest
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAParentTest methodsFor: 'processing' stamp: 'ab 5/12/2003 22:13'!
go
	parent inform: 'foo'! !

!WAParentTest methodsFor: 'accessing' stamp: 'ab 5/12/2003 22:13'!
parent: aComponent
	parent := aComponent! !

!WAParentTest methodsFor: 'rendering' stamp: 'ab 5/12/2003 22:14'!
renderContentOn: html
	html anchorWithAction: [self go] text: 'swap parent' ! !

!WAParentTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:19'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAPath
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAPath commentStamp: '<historical>' prior: 0!
I represent a path navigation such as the one that is displayed on the top of the web inspector when you toggle on the halos.

Here is an example of path:

	xxx >> yyy >> zzz

Useful methods are 
	- #currentSegment returns zzz
	- pushSegment: anObject name: 'lulu'!

!WAPath class methodsFor: 'example' stamp: 'lr 11/29/2004 16:24'!
example
	^self new 
		pushSegment: 123 name: 'xxx'; 
		pushSegment: 456 name: 'yyy';
		pushSegment: 789 name: 'zzz';
		yourself.! !

!WAPath methodsFor: 'behavior' stamp: 'lr 11/29/2004 16:26'!
choose: anAssociation
	"Install a new stack of navigation from the old one and the specified association."
	
	| newStack |
	newStack := Array new writeStream.
	stack do:
		[:ea |
		newStack nextPut: ea.
		ea == anAssociation
			ifTrue: [stack := newStack contents. ^ self]]
! !

!WAPath methodsFor: 'accessing' stamp: 'ab 5/31/2003 15:06'!
currentSegment
	^ stack isEmpty
		ifTrue: [nil]
		ifFalse: [stack last value]! !

!WAPath methodsFor: 'initialize' stamp: 'mb 4/23/2006 15:27'!
initialize
	super initialize.
	stack := #().
	self session registerObjectForBacktracking: self.! !

!WAPath methodsFor: 'behavior' stamp: 'ab 5/31/2003 15:06'!
pushSegment: anObject name: aString
	stack := stack, (Array with: aString -> anObject)! !

!WAPath methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderContentOn: html

	stack isEmpty ifTrue: [^ self].	
		
	html div
		id: 'path';
		with: [
		stack allButLast do:
			[:assoc |
			html anchor callback: [self choose: assoc]; with: assoc key.
			html text: ' >> '].
		
		html strong: stack last key].! !

WAComponent subclass: #WAPhraseElementsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:24'!
renderAbbreviatedOn: html

	html heading level2; with: '<abbr>'.

	html abbreviated
		title: 'World Wide Web';
		with: 'WWW'! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:28'!
renderAcronymOn: html

	html heading level2; with: '<acronym>'.

	html acronym
		title: 'Federal Bureau of Investigation';
		with: 'F.B.I.'! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 10/2/2006 21:26'!
renderAddressOn: html

	html heading level2; with: '<address>'.

	html address: [
		#(
			'Newsletter editor'
			'J.R. Brown'
			'JimquickPost News, Jimquick, CT 01234'
			'Tel (123) 456 7890')
			do: [ :each | html text: each ]
			separatedBy: [ html break ] ]! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:25'!
renderCodeOn: html

	html heading level2; with: '<code>'.

	html text: 'Expressions like '.
	html code: 'a[i++] + b[i++]'.
	html text: ' should not be used, since they cause undefined behavior'! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 10/2/2006 21:29'!
renderContentOn: html
	self renderHarryOn: html.
	self renderAbbreviatedOn: html.
	self renderAcronymOn: html.
	self renderKeyboardInputOn: html.
	self renderVariableOn: html.
	self renderCodeOn: html.
	self renderDefinitionOn: html.
	self renderSampleOn: html.
	self renderAddressOn: html! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:25'!
renderDefinitionOn: html

	html heading level2; with: '<dfn>'.

	html definition: 'Ichthyology'.
	html text: ' is the branch of natural science which
studies fish.'! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:36'!
renderHarryOn: html

	html heading level2; with: '<cite>, <q>, <strong>'.

	html text: 'As '.
	html citation: 'Harry S. Truman'.
	html text: ' said, '.
	html quote: 'The buck stops here.'.
	
	html break.
	
	html text: 'More information can be found in '.
	html citation: '[ISO-0000]'.
	html text: '.'.
	
	html break.
	
	html text: 'Please refer to the following reference number in future correspondence: '.
	html strong: '1-234-55'! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:25'!
renderKeyboardInputOn: html

	html heading level2; with: '<kbd>'.

	html text: 'Finally, type '.
	html keyboardInput: 'logout'.
	html text: ' and press the return key.'! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 10/2/2006 21:28'!
renderSampleOn: html

	html heading level2; with: '<samp>'.

	html text: 'If you select the ''champion'' option, you will receive the message '.
	html sampleOutput: 'The monkey is not a caterpillar'.
	html text: '.'! !

!WAPhraseElementsTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:25'!
renderVariableOn: html

	html heading level2; with: '<var>'.

	html text: 'In the simplest case, the command for deleting a file in Unix is'.
	html break.
	html keyboardInput: 'rm'.
	html space.
	html variable: 'filename'! !

WAComponent subclass: #WAPopupTest
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAPopupTest methodsFor: 'initialize-release' stamp: 'pmm 7/19/2006 19:52'!
initialize
	super initialize.
	url := 'http://www.seaside.st'! !

!WAPopupTest methodsFor: 'rendering' stamp: 'mjr 8/17/2005 17:45'!
renderContentOn: html

	html form: [
		html text: 'URL:'.
		html space.
		html textInputWithValue: url callback: [:v | url := v].
		html submitButtonWithText: 'Update'
	].
	html anchorWithPopupUrl: url
		extent: 400@400
		text: 'popup'.
	html space.
	html text: '(', url, ')'! !

!WAPopupTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:20'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAReport
	instanceVariableNames: 'rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAReport methodsFor: 'initialize' stamp: 'mb 4/23/2006 15:29'!
initialize
	super initialize.
	rows := #().
! !

!WAReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:03'!
rows: anArray
	rows := anArray! !

WAReport subclass: #WATableReport
	instanceVariableNames: 'sortColumn isReversed columns rowPeriod rowColors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

WATableReport subclass: #WACanvasTableReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WACanvasTableReport class methodsFor: 'instance creation' stamp: 'pmm 12/20/2006 12:08'!
new
	self deprecatedApi.
	^super new! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'ab 11/11/2002 19:04'!
chooseRow: aRow column: aColumn	
	aColumn chooseRow: aRow! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:01'!
colorForRowNumber: aNumber
	^ rowColors at: ((aNumber-1 // rowPeriod) \\ rowColors size) + 1 ifAbsent: ['white']! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:29'!
columns: anArray
	columns := anArray! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 2/18/2003 19:06'!
initialize
	super initialize.
	isReversed := false.
	columns := #().
	sortColumn := WAStateHolder new.
	rowColors := #('white' 'lightyellow').
	rowPeriod := 3! !

!WATableReport methodsFor: 'testing' stamp: 'AC 1/31/2003 11:24'!
isReversed
	^ isReversed! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderColumn: aColumn row: aRow on: html
	| text |
	aColumn canRender ifTrue: [
		^html tableData: [aColumn renderValue: aRow on: html]].
	text := aColumn textForRow: aRow.
	text isEmpty ifTrue: [ text := ' ' ].
	html tableData: [
		aColumn canChoose
			ifFalse: [ html text: text ]
			ifTrue: [
				html anchor
					callback: [ self chooseRow: aRow column: aColumn ];
					with: text ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:17'!
renderContentOn: html
	html table: [
		self renderTableHeaderOn: html.
		self renderRowsOn: html.
		self renderTableFooterOn: html ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:47'!
renderFooterForColumn: aColumn on: html
	html tableHeading: (aColumn totalForRows: rows)
! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 11/16/2006 16:46'!
renderHeaderForColumn: aColumn on: html
	html tableHeading:  [
		aColumn canSort
			ifTrue: [
				html anchor
					callback: [self sortColumn: aColumn];
					with: aColumn title]
			ifFalse: [ html text: aColumn title ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:48'!
renderRowNumber: index item: row on: html
	html tableRow
		style: 'background-color: ' , (self colorForRowNumber: index);
		with: [
			columns do: [ :each |
				self renderColumn: each row: row on: html ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'AC 1/31/2003 11:26'!
renderRowsOn: html
	self rows withIndexDo: [:row :i | self renderRowNumber: i item: row on: html ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:38'!
renderTableFooterOn: html
	html tableRow: [
		columns do: [ :each |
			self renderFooterForColumn: each on: html] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:39'!
renderTableHeaderOn: html
	html tableRow: [
			columns do: [ :each |
				self renderHeaderForColumn: each on: html] ]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowColors: colorArray
	rowColors := colorArray! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowPeriod: aNumber
	rowPeriod := aNumber! !

!WATableReport methodsFor: 'accessing' stamp: 'AC 1/31/2003 11:46'!
rows
	| r |
	self sortColumn ifNil: [^ rows].
	r := self sortColumn sortRows: rows.
	^ self isReversed ifTrue: [r reversed] ifFalse: [r]! !

!WATableReport methodsFor: 'state variables' stamp: 'ab 1/16/2003 17:47'!
sortColumn
	^ sortColumn contents! !

!WATableReport methodsFor: 'state variables' stamp: 'mb 4/23/2006 18:35'!
sortColumn: anObject 
	isReversed := anObject = self sortColumn and: [isReversed not ].
	sortColumn contents: anObject! !

WAComponent subclass: #WARubyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WARubyTest commentStamp: 'pmm 9/18/2006 19:11' prior: 0!
Examples taken directly from spec:
http://www.w3.org/TR/2001/REC-ruby-20010531/
!

!WARubyTest methodsFor: 'rendering' stamp: 'pmm 9/18/2006 22:07'!
renderComplexOn: html
	html heading level2; with: 'Complex ruby markup'.
	html ruby: [
		html rubyBaseContainer: [
			html rubyBase: 10.
			html rubyBase: 31.
			html rubyBase: 2002 ].
		html rubyTextContainer: [
			html rubyText: 'Month'.
			html rubyText: 'Day'.
			html rubyText: 'Year' ].
		html rubyTextContainer: [
			html rubyText
				span: 3;
				with: 'Expiration Date' ] ]! !

!WARubyTest methodsFor: 'rendering' stamp: 'pmm 9/18/2006 22:06'!
renderContentOn: html
	self renderSimpleOn: html.
	self renderSimpleParenthesesOn: html.
	self renderComplexOn: html! !

!WARubyTest methodsFor: 'rendering' stamp: 'pmm 9/18/2006 22:07'!
renderSimpleOn: html
	html heading level2; with: 'Simple ruby markup'.
	html ruby: [
		html rubyBase: 'WWW'.
		html rubyText: 'World Wide Web' ]! !

!WARubyTest methodsFor: 'rendering' stamp: 'pmm 9/18/2006 22:08'!
renderSimpleParenthesesOn: html
	html heading level2; with: 'Simple ruby markup with parentheses'.
	html ruby: [
		html rubyBase: 'WWW'.
		html rubyParentheses: '('.
		html rubyText: 'World Wide Web'.
		html rubyParentheses: ')' ]! !

WAComponent subclass: #WAScreenshot
	instanceVariableNames: 'button zoom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAScreenshot class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:57'!
canBeRoot
	^ true! !

!WAScreenshot class methodsFor: 'initialization' stamp: 'lr 2/12/2007 21:53'!
initialize
	self registerAsApplication: 'tools/screenshot'! !

!WAScreenshot methodsFor: 'accessing' stamp: 'pmm 9/20/2006 17:48'!
buttonCode
	^ button = #red
		ifTrue: [ 4 ]
		ifFalse: [
			button = #blue
				ifTrue: [ 2 ]
				ifFalse: [ 1 ] ]! !

!WAScreenshot methodsFor: 'actions' stamp: 'pmm 9/20/2006 17:45'!
click: aPoint
	| event |
	event := Sensor createMouseEvent.
	event at: 3 put: aPoint x.
	event at: 4 put: aPoint y.
	event at: 5 put: self buttonCode.
	Sensor processEvent: event.	
	event at: 5 put: 0.
	Sensor processEvent: event.
	button := #red.! !

!WAScreenshot methodsFor: 'accessing' stamp: 'pmm 9/20/2006 17:48'!
form
	^ zoom
		ifFalse: [ Display copy ]
		ifTrue: [ self topWindow imageForm ]! !

!WAScreenshot methodsFor: 'initialize-release' stamp: 'pmm 9/20/2006 17:45'!
initialize
	super initialize.
	button := #red.
	zoom := false! !

!WAScreenshot methodsFor: 'accessing' stamp: 'pmm 9/20/2006 17:49'!
offset
	^ zoom
		ifTrue: [ self topWindow position ]
		ifFalse: [ 0@0 ]! !

!WAScreenshot methodsFor: 'rendering' stamp: 'pmm 9/20/2006 17:59'!
renderContentOn: html
	html table: [
		html tableRow: [
			html tableData: [ self renderMouseButtonOn: html ].
			html tableData: [ self renderToggleZoomOn: html ].
			html tableData: [ self renderToggleUIProcessOn: html ] ] ].
	self renderMouseClickOn: html.
	html horizontalRule.
	! !

!WAScreenshot methodsFor: 'rendering' stamp: 'pmm 9/20/2006 17:59'!
renderMouseButtonOn: html
	| group |
	html form: [
		html table: [
			html tableRow: [
				html tableData: 'Button: '.
				group := html radioGroup.
				#(red yellow blue) do: [ :each |
					html tableData
						style: 'background-color: ' , each;
						with: [
							html radioButton
								group: group;
								selected: button = each;
								callback: [ button := each] ] ].
				html tableData: [
					html submitButton text: 'Set'] ] ] ]! !

!WAScreenshot methodsFor: 'rendering' stamp: 'pmm 2/9/2007 20:01'!
renderMouseClickOn: html
	html map
		id: #pictureMap;
		title: 'Click here';
		callback: [ :point | self click: point + self offset];
		with: [
			html image
				form: self form ]! !

!WAScreenshot methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderToggleUIProcessOn: html
	html anchor callback: [self toggleUIProcess]; with: self toggleUIText! !

!WAScreenshot methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderToggleZoomOn: html
	html anchor callback: [self toggleZoom]; with: self toggleZoomText! !

!WAScreenshot methodsFor: 'actions' stamp: 'avi 1/21/2004 02:01'!
toggleUIProcess
	Project uiProcess isSuspended
		ifTrue: [Project uiProcess resume]
		ifFalse: [Project uiProcess suspend]! !

!WAScreenshot methodsFor: 'accessing' stamp: 'avi 1/21/2004 02:01'!
toggleUIText
	^ Project uiProcess isSuspended
		ifFalse: ['Suspend UI Process']
		ifTrue: ['Resume UI Process']! !

!WAScreenshot methodsFor: 'actions' stamp: 'pmm 9/20/2006 17:47'!
toggleZoom
	zoom := zoom not! !

!WAScreenshot methodsFor: 'accessing' stamp: 'pmm 9/20/2006 17:47'!
toggleZoomText
	^ zoom
		ifTrue: ['Zoom out']
		ifFalse: ['Zoom in']! !

!WAScreenshot methodsFor: 'accessing' stamp: 'avi 2/5/2004 14:18'!
topWindow
	^ SystemWindow classPool at: #TopWindow! !

WAComponent subclass: #WASelection
	instanceVariableNames: 'items labelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WASelection methodsFor: 'initialization' stamp: 'mb 4/23/2006 15:31'!
initialize
	super initialize.
	items := #().
	labelBlock := [:ea | ea displayString].! !

!WASelection methodsFor: 'accessing' stamp: 'lr 1/7/2007 18:04'!
items
	^ items! !

!WASelection methodsFor: 'accessing' stamp: 'avi 7/5/2004 20:24'!
items: aCollection
	items := aCollection! !

!WASelection methodsFor: 'accessing' stamp: 'lr 1/7/2007 18:06'!
labelBlock
	^ labelBlock! !

!WASelection methodsFor: 'accessing' stamp: 'avi 7/5/2004 20:24'!
labelBlock: aBlock
	labelBlock := aBlock! !

!WASelection methodsFor: 'rendering' stamp: 'lr 1/7/2007 18:05'!
renderContentOn: html
	html unorderedList
		list: self items;
		labels: self labelBlock;
		callback: [ :value | self answer: value ]! !

WAComponent subclass: #WAStore
	instanceVariableNames: 'task'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStore commentStamp: 'avi 1/1/2004 10:06' prior: 0!
This component is the entry point for the store example.  It provides the main stylesheet in its #style method, renders a simple banner at the top, and then embeds an instance of WAStoreTask, which is where the real action happens.!

!WAStore class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WAStore class methodsFor: 'accessing' stamp: 'mb 5/26/2006 12:25'!
description
	^'sushiNet - Fresh, raw fish delivered to your door'! !

!WAStore class methodsFor: 'as yet unclassified' stamp: 'mb 6/14/2006 14:13'!
entryPointName
	^'examples/store'! !

!WAStore class methodsFor: 'class initialization' stamp: 'mb 6/14/2006 14:13'!
initialize
	self registerAsApplication: self entryPointName! !

!WAStore methodsFor: 'accessing' stamp: 'avi 2/10/2004 20:42'!
children
	^ Array with: task! !

!WAStore methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 18:33'!
initialize
	super initialize.
	task := WAStoreTask new.! !

!WAStore methodsFor: 'rendering' stamp: 'pmm 4/19/2006 22:40'!
renderContentOn: html
	html table
		id: 'banner';
		with: [
			html tableRow: [
				html tableData: [
					html div id: 'title'; with: self title.
					html div id: 'subtitle'; with: self subtitle ] ] ].
	html div id: 'body'; with: task! !

!WAStore methodsFor: 'accessing' stamp: 'mb 1/5/2006 14:35'!
style
	^ '
body {
	margin: 0px; 
	font-family: sans-serif
}
#banner {
	width: 100%
}	
#banner tr {
	background-color: lightblue;
	text-align: right;
	padding: 10px;
	vertical-align: bottom
}
#title {
	font-size: 18pt;
	font-weight: bold
}
#subtitle {
	font-size: 9pt;
	font-style: italic
}
#body {
	padding: 5px
}
.validation-error {
	color: red;
	font-size: 15pt; 
	padding: 5px
}
'
! !

!WAStore methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:58'!
subtitle
	^ 'fresh, raw fish delivered to your door'! !

!WAStore methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:58'!
title
	^ 'sushiNet'! !

WAComponent subclass: #WAStoreCartConfirmation
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreCartConfirmation commentStamp: 'avi 1/1/2004 09:58' prior: 0!
A component for confirming the contents of a WAStoreCart.  The caller must provide a cart instance with #cart: .  When called, it will display a summary of the items in the cart, along with two buttons: "Proceed with checkout" and "Modify cart".  Answers true if the user presses the first button, false if the user presses the seecond.  Used by WAStoreTask>>confirmContentsOfCart.!

!WAStoreCartConfirmation methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:35'!
cart: aCart
	cart := aCart! !

!WAStoreCartConfirmation methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:20'!
renderContentOn: html
	| table |
	table := html table.
	table id: 'invoice'; with: [
		html tableHead:
			[#(Item Price Count Total) do:
				[:ea | html tableHeading: ea]].
		cart countsAndItems do:
			[:assoc | |count item|
			count := assoc key.
			item := assoc value.
			html tableRow: [
				html tableData class: 'item-title'; with: item title.
				html tableData class: 'item-price'; with: item price printStringAsCents.
				html tableData class: 'item-count'; with: count displayString.
				html tableData class: 'item-total'; with: (item price * count) printStringAsCents
			]
		].
		html tableRow: [
			html tableData: nil.
			html tableData: nil.
			html tableData: nil.
			html tableData class: 'cart-total'; with:cart totalPrice printStringAsCents
		].
	].
	html paragraph.
	html form: [
		html submitButton callback: [ self answer: true ]; text: 'Proceed with checkout'.
		html break.
		html submitButton callback: [self answer: false]; text: 'Modify my order'.
	]! !

!WAStoreCartConfirmation methodsFor: 'accessing' stamp: 'mb 2/9/2006 19:09'!
style
	^'
.item-title {
	text-align: left;
	width: 15em;
}
.item-count {
	text-align: right;
	width: 5em;
}
.item-price {
	text-align: right;
	width: 5em;
}
.item-total {
	text-align: right;
	width: 5em;
}
.cart-total {
	text-align: right;
	font-weight: bold; 
}
#invoice table {
	border-collapse: collapse;
}
#invoice td {
	padding: 0.3em;
	border: 1px lightblue dotted;
}
#invoice tr {
	background-color: lightyellow;
}
'! !

!WAStoreCartConfirmation methodsFor: 'path' stamp: 'mb 2/10/2006 12:04'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Seaside Sushi Store : Verify your cart'.! !

WAComponent subclass: #WAStoreCartView
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreCartView commentStamp: 'avi 1/1/2004 09:57' prior: 0!
A component for displaying and modifying a WAStoreCart.  Intended to be embedded rather than called.  The parent must provide a cart instance with #cart:.  Displays a list of items in the cart, and allows individual items to be removed.  Used by WAStoreFillCart.!

!WAStoreCartView methodsFor: 'accessing' stamp: 'ab 8/15/2003 17:18'!
cart: aCart
	cart := aCart! !

!WAStoreCartView methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:05'!
renderContentOn: html
	cart hasItems ifFalse: [^ self].
	html div
		id: 'cart';
		with: [
			html small: [ html strong: 'Your cart:' ].
			html table: [
				cart countsAndItems do:
					[:assoc | self renderRowForCount: assoc key of: assoc value on: html ].
				html tableRow: [ html space].
				html tableRow: [
					html tableData: ''.
					html tableData: ''.
					html tableData: [html strong: cart totalPrice printStringAsCents] ] ] ]! !

!WAStoreCartView methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderRowForCount: aNumber of: anItem on: html 
	| countString |
	countString := (aNumber = 1) ifTrue: [''] ifFalse: ['(', aNumber displayString, ') '].
	html tableRow: [
		html tableData: [ html anchor callback: [ cart remove: anItem ]; with: '-'].
		html tableData: countString, anItem title.
		html tableData: (aNumber * anItem price) printStringAsCents ]! !

WAComponent subclass: #WAStoreFillCart
	instanceVariableNames: 'cart cartView main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreFillCart commentStamp: 'avi 1/1/2004 10:10' prior: 0!
This component provides the main UI for browsing the store inventory and filling the cart.  The caller must provide a shopping cart instance with #cart:.  The component presents a navigation bar with options to browse and search on the left, and embeds a WACartView showing the cart contents on the right.  In the middle is initially embedded a WAStoreInfo.  Browsing and searching will replace this with a stock WABatchSelection component for listing items (see #displatItems:), or a WAStoreItemView for displaying individual items.  This answers back to the caller when the user chooses "checkout" from the nav bar.!

!WAStoreFillCart methodsFor: 'actions' stamp: 'avi 12/9/2003 13:13'!
browse
	self displayItems: self inventory allItems! !

!WAStoreFillCart methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:10'!
cart: aCart
	cart := aCart.
	cartView cart: aCart.! !

!WAStoreFillCart methodsFor: 'actions' stamp: 'ab 8/15/2003 17:11'!
checkout
	self answer.! !

!WAStoreFillCart methodsFor: 'accessing' stamp: 'avi 2/10/2004 20:42'!
children
	^ Array with: cartView with: main! !

!WAStoreFillCart methodsFor: 'actions' stamp: 'pmm 11/2/2005 23:44'!
displayItem: anItem
	main call: (WAStoreItemView new item: anItem; cart: cart; yourself)! !

!WAStoreFillCart methodsFor: 'actions' stamp: 'avi 12/9/2003 13:25'!
displayItems: aCollection
	| list |
	aCollection size = 1 ifTrue: [^ self displayItem: aCollection first].
	list := WABatchSelection
			 items: aCollection
			 link: #title
			 text: #subtitle.
	[self displayItem: (main call: list)] repeat
	! !

!WAStoreFillCart methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 18:33'!
initialize
	super initialize.
	main := WAStoreInfo new.
	cartView := WAStoreCartView new! !

!WAStoreFillCart methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:13'!
inventory
	^ WAStoreInventory default! !

!WAStoreFillCart methodsFor: 'rendering' stamp: 'pmm 4/19/2006 20:06'!
renderContentOn: html
	html table: [
"		html tableRow: [ html tableData colSpan: 3; with: trail ]."
		html tableRow: [
			html tableData id: 'nav'; with: [ self renderNavBarOn: html ].
			html tableData id: 'main'; with: main.
			html tableData id: 'side'; with: cartView ] ]! !

!WAStoreFillCart methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderNavBarOn: html
	html form: [
		html strong: 'Search:'.
		html space.
		html textInput callback: [:v | self search: v]; value: '' ].
	html anchor callback: [self browse]; with: 'Browse'.
	cart hasItems ifTrue:  [
		html break.
		html anchor callback: [self checkout]; with: 'Checkout']! !

!WAStoreFillCart methodsFor: 'actions' stamp: 'avi 12/9/2003 13:13'!
search: aString
	| results |
	results := self inventory findItem: aString.
	results isEmpty
		ifTrue: [main inform: 'No items match ', aString printString]
		ifFalse: [self displayItems: results].! !

!WAStoreFillCart methodsFor: 'accessing' stamp: 'avi 12/9/2003 15:33'!
style
^ '
	#search {vertical-align: bottom}
	#main {width: 50%; padding: 10px}
	#side {vertical-align: top; }
	#cart {border-style: dashed; border-width: 1; padding: 5px}
	#nav {background-color: lightgrey; vertical-align: top; padding: 5px; border-width: 1; width: 15%; font-size: 12pt}
	#batch {font-size: 10pt}
'! !

!WAStoreFillCart methodsFor: 'path' stamp: 'mb 2/10/2006 12:03'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Seaside Sushi Store : Fill your cart'.! !

WAComponent subclass: #WAStoreInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreInfo commentStamp: 'avi 1/1/2004 09:57' prior: 0!
A component that displays simple informative text about this example.  Used by WAStoreFillCart.!

!WAStoreInfo methodsFor: 'rendering' stamp: 'mb 4/23/2006 20:25'!
renderContentOn: html
	html withLineBreaks: self text! !

!WAStoreInfo methodsFor: 'accessing' stamp: 'mb 2/9/2006 19:10'!
text
	^
'Welcome to the sushiNet online store.

This is a sample Seaside application.

Use the search box at the top left to find some results.
Good searches to try might be "tuna", "saba", or "fish".
'! !

WAComponent subclass: #WAStoreItemView
	instanceVariableNames: 'item cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreItemView commentStamp: 'avi 1/1/2004 09:58' prior: 0!
A component for viewing an individual WAStoreItem.  The caller must provide #item: and also the current #cart:.  Shows the description and price info for the item, and presents two buttons: "Add to Cart", which will add the item to the cart, once, and "Done", which will answer back to the caller.  Used by WAStoreFillCart>>displayItem: and displayItems:.!

!WAStoreItemView methodsFor: 'actions' stamp: 'avi 12/9/2003 13:11'!
addToCart
	cart add: item! !

!WAStoreItemView methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:11'!
cart: aCart
	cart := aCart! !

!WAStoreItemView methodsFor: 'accessing' stamp: 'ab 5/25/2003 14:47'!
item: anItem
	item := anItem! !

!WAStoreItemView methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:12'!
renderContentOn: html
	html heading: item title.
	html heading level3; with: item subtitle.
	html paragraph: item description.
	html emphasis: item price printStringAsCents.
	html form: [
		html submitButton callback: [self addToCart]; text: 'Add To Cart'.
		html space.
		html submitButton callback: [self answer]; text: 'Done' ]! !

!WAStoreItemView methodsFor: 'updating' stamp: 'mb 11/27/2005 19:31'!
updateUrl: aUrl
	aUrl addToPath: item title
! !

WAComponent subclass: #WAStringLibraryEditor
	instanceVariableNames: 'library'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

WAStringLibraryEditor subclass: #WAFileLibraryEditor
	instanceVariableNames: 'renamingFile newName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAFileLibraryEditor methodsFor: 'rendering' stamp: 'lr 2/18/2007 12:41'!
renderAddFileOn: html
	html form multipart; with: [
		html text: 'Add File: '.
		html fileUpload on: #addFile of: self library.
		html space.
		html submitButton text: 'Add' ]! !

!WAFileLibraryEditor methodsFor: 'rendering' stamp: 'pmm 4/22/2006 00:41'!
renderContentOn: html
	self renderHeadingsOn: html.
	self renderAddFileOn: html.
	self renderFilesOn: html.
	self renderDoneOn: html! !

!WAFileLibraryEditor methodsFor: 'rendering' stamp: 'mb 2/23/2007 09:36'!
renderFile: fileName on: html 
	html tableData: [
		self renderSaveButtonOn: html for: fileName.		
		html anchor
			url: (self urlFor: fileName);
			with: fileName ].
	html tableData: [
		html anchor
			callback: [ self library removeFile: fileName ];
			with: 'remove'.
		html space.
		html anchor
			callback: [ renamingFile := fileName ];
			with: 'rename' ]! !

!WAFileLibraryEditor methodsFor: 'rendering' stamp: 'pmm 2/20/2007 07:25'!
renderFilesOn: html 
	html table: [
		self library filenames asSortedCollection do: [ :each | 
			html tableRow: [			
				renamingFile = each
					ifTrue: [ self renderRenameFormForFile: each on: html ]
					ifFalse: [ self renderFile: each on: html ] ] ] ]! !

!WAFileLibraryEditor methodsFor: 'rendering' stamp: 'pmm 2/20/2007 18:20'!
renderRenameFormForFile: fileName on: html 
	html tableData colSpan: 2; with: [
		html form: [
			html textInput
				value: fileName;
				callback: [ :value | newName := value ].
			html submitButton
				callback: [
					self library renameFile: fileName to: newName.
					renamingFile := nil ];
			 	text: 'rename'.
			html cancelButton
				callback: [ renamingFile := nil ];
				text: 'cancel' ] ]! !

!WAStringLibraryEditor methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:36'!
library
	^ library! !

!WAStringLibraryEditor methodsFor: 'accessing' stamp: 'pmm 4/21/2006 23:01'!
library: aLibrary 
	library := aLibrary! !

!WAStringLibraryEditor methodsFor: 'rendering' stamp: 'pmm 4/22/2006 00:40'!
renderContentOn: html
	self renderHeadingsOn: html.
	self renderFilesOn: html.
	self renderDoneOn: html! !

!WAStringLibraryEditor methodsFor: 'rendering' stamp: 'lr 2/18/2007 12:36'!
renderDoneOn: html
	html form: [
		html submitButton
			callback: [ self answer ];
			text: 'close' ]! !

!WAStringLibraryEditor methodsFor: 'rendering' stamp: 'mb 2/23/2007 09:34'!
renderFilesOn: html 
	html
		unorderedList: [self library filenames
			do: [:each | html listItem: [
					self renderSaveButtonOn: html for: each.
					html anchor
						url: (self urlFor: each);
						with: each]]]! !

!WAStringLibraryEditor methodsFor: 'rendering' stamp: 'lr 2/18/2007 12:37'!
renderHeadingsOn: html
	html heading: self library name! !

!WAStringLibraryEditor methodsFor: 'rendering' stamp: 'mb 2/23/2007 10:22'!
renderSaveButtonOn: html for: fileName
	html anchor
			document:  (self library documentForFile: fileName)
				mimeType:   (self library mimetypeForFile: fileName)
				fileName: fileName;
			with:
				[html image
						class: 'saveButton';
						url: (self resources addToPath: 'floppy.gif');									
						altText: 'Save';
						title: 'Save ' , fileName].
! !

!WAStringLibraryEditor methodsFor: 'accessing' stamp: 'mb 2/23/2007 09:43'!
resources
	^ WAUrl new addToPath: WADispatcher default basePath , '/files/WADispatcherFiles/'! !

!WAStringLibraryEditor methodsFor: 'private' stamp: 'mb 2/22/2007 10:38'!
urlFor: aFilename
	^ (self library urlForFile: aFilename) asString! !

WAComponent subclass: #WASvgTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WASvgTest methodsFor: 'rendering' stamp: 'lr 2/13/2007 00:13'!
renderContentOn: html
	html object
		type: 'image/svg+xml';
		width: 600;
		height: 800;
		standby: 'loading tiger';
		classId: 'http://www.adobe.com/svg/viewer/install/main.html';
		url: 'http://croczilla.com/svg/samples/tiger/tiger.svg';
		with: 'Your browser doesn''t support SVG'! !

WAComponent subclass: #WATableReportTest
	instanceVariableNames: 'widget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

WATableReportTest subclass: #WACanvasTableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Canvas'!

!WACanvasTableTest methodsFor: 'samples' stamp: 'mb 12/8/2006 17:18'!
entities
	^#(
		('non-breaking space' ('&nbsp;' '&#160;' '&#xA0;'))
		('ampersand' ('&amp;' '&#38;' '&#x26;'))
		('less than sign' ('&lt;' '&#60;' '&#x3C;'))
		('greater than sign' ('&gt;' '&#62;' '&#x3E;'))
		('euro sign' ('&euro;' '&#8364;' '&#x20AC;'))
	)
! !

!WACanvasTableTest methodsFor: 'samples' stamp: 'mb 12/8/2006 17:28'!
exchangeRates
	^#(	
		('EUR' 1.70) 
		('USD' 1.30) 
		('DKK' 23.36)
		('SEK' 19.32)
	)
! !

!WACanvasTableTest methodsFor: 'rendering' stamp: 'mb 12/8/2006 16:05'!
renderContentOn: html
	self renderEntityTableOn: html.
	self renderCurrencyTableOn: html! !

!WACanvasTableTest methodsFor: 'rendering' stamp: 'mb 12/8/2006 17:39'!
renderCurrencyTableBodyOn: html
	html tableBody title: 'Table body'; 
		with: [
			self exchangeRates do: [:each |
				html tableRow: [
					html tableHeading: each first.
					html tableData align: 'char'; character: $.; 
						with: each second]]].
! !

!WACanvasTableTest methodsFor: 'rendering' stamp: 'mb 12/8/2006 17:39'!
renderCurrencyTableHeadOn: html
	html tableHead title: 'Table header'; 
		with: [
			html tableRow: [
				html tableHeading: 'Currency'.
				html tableHeading: 'Rate']].
! !

!WACanvasTableTest methodsFor: 'rendering' stamp: 'mb 12/8/2006 17:33'!
renderCurrencyTableOn: html
	html table align: 'center'; border: 1; 
 		summary: 'This table shows exchange rates against the Swiss Franc';
		with: [
			html tableCaption: 'Currencies against Swiss Franc (CHF)'.
			html tableColumnGroup.
			html tableColumnGroup width: 100 px; align: 'char'; character: $..
			self renderCurrencyTableHeadOn: html.
			self renderCurrencyTableBodyOn: html].
! !

!WACanvasTableTest methodsFor: 'rendering' stamp: 'mb 12/8/2006 17:40'!
renderEntityTableBodyOn: html
	html tableBody: [
		self entities do: [:eachEntity |
			html tableRow: [
				html tableData scope: 'row'; 
					with: eachEntity first.
				eachEntity second do: [:ea | 
					html tableData: ea].
				eachEntity second do: [:ea | 
					html tableData align: 'center'; 
						with: [html html: ea]].
				].
			].
		].! !

!WACanvasTableTest methodsFor: 'rendering' stamp: 'mb 12/8/2006 17:23'!
renderEntityTableColumnGroupsOn: html
	html tableColumnGroup.
	html tableColumnGroup span: 3.
	html tableColumnGroup span: 3; align: 'center'.
! !

!WACanvasTableTest methodsFor: 'rendering' stamp: 'mb 12/8/2006 17:40'!
renderEntityTableFootOn: html
	html tableFoot: [
		html tableRow: [
			html tableData align: 'center'; colSpan: 7; 
				with: '5 entities shown']]! !

!WACanvasTableTest methodsFor: 'rendering' stamp: 'mb 12/8/2006 17:40'!
renderEntityTableHeadOn: html
	html tableHead: [
		html tableRow: [
			#('Character' 'Entity' 'Decimal' 'Hex') do: [:each |
				html tableHeading scope: 'col'; rowSpan: 2;
					with: each].
			html tableHeading scope: 'colgroup'; colSpan: 3; 
				with: 'Rendering in Your Browser'
		].
		html tableRow: [
			#('Entity' 'Decimal' 'Hex') do: [:each |
				html tableHeading scope: 'col'; with: each]
		].
	].
! !

!WACanvasTableTest methodsFor: 'rendering' stamp: 'mb 12/8/2006 17:36'!
renderEntityTableOn: html
	html table align: 'center'; border: 1; 
 		summary: 'This table gives the character entity reference,
                decimal character reference, and hexadecimal character
                reference for 8-bit Latin-1 characters, as well as the
                rendering of each in your browser.';
		with: [
			html tableCaption: 'HTML 4.0 entities'.
			self renderEntityTableColumnGroupsOn: html.
			self renderEntityTableHeadOn: html.
			self renderEntityTableFootOn: html.
			self renderEntityTableBodyOn: html].
! !

!WACanvasTableTest methodsFor: 'rendering' stamp: 'mb 12/8/2006 16:03'!
style
	^'
table {
	border-collapse: collapse;
}
caption {
	font-weight: bold;
	padding: 0.5em 0 1em 0;
}
td, th {
	padding: 3px;
}
'! !

!WATableReportTest class methodsFor: 'accessing' stamp: 'mb 2/10/2006 13:11'!
example

	^ self new! !

!WATableReportTest methodsFor: 'accessing' stamp: 'mb 2/10/2006 13:08'!
children
	^Array with: widget.! !

!WATableReportTest methodsFor: 'initialize-release' stamp: 'pmm 2/11/2007 19:51'!
initialize
	| cols rows |
	cols := OrderedCollection new
		add: (WAReportColumn
				selector: #title
				title: 'Title'
				onClick: [:v | self inform: v description]);
		add: (WAReportColumn
				selector: #subtitle
				title: 'Subtitle');
		add: (WAReportColumn
				selector: #price
				title: 'Price');
		add: (WAReportColumn
				renderBlock: [:obj :html | html emphasis: obj description]
				title: 'Description');
		yourself.
	rows := WAStoreInventory default allItems.
	widget := WATableReport new
				columns: cols;
				rows: rows;
				rowPeriod: 1;
				rowColors: #(lightblue lightyellow);
				yourself.! !

!WATableReportTest methodsFor: 'rendering' stamp: 'mb 2/10/2006 13:07'!
renderContentOn: html
	html render: widget.! !

WAComponent subclass: #WATask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WATask commentStamp: '<historical>' prior: 0!
I am a subclass of WAComponent, specialized for defining workflow.  The difference between a task and a component is the following:

Both of them are reusable, embeddable, callable pieces of user interface. A component has state (instance variables), behavior (it may change its state, and it may also choose to display other components with #call:), and appearance (it renders HTML). A Task has only the first two - it doesn't render any HTML directly, but only through the components it calls. This is useful when what you want to encapsulate/embed/call is purely a process (show this component, then this one, then this one).

The key method for WATask is #go - as soon as a task is displayed, this method will get invoked, and will presumably #call: other components.

In terms of implementation, you can think of a WATask in the following way: it is a component which renders two things:
- a link whose callback invokes the #go method
- a header that immediately redirects to the URL of that link

Subclasses must not implement #renderContentOn:
!

WATask subclass: #WACookieTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WACookieTest methodsFor: 'actions' stamp: 'mb 2/27/2006 08:34'!
go
	[self session checkForCookies]
		whileFalse: [self inform: 'You must have cookies enabled to proceed.'].
	self session redirectWithCookies: (Array with:
		"Should get back empty cookie ?"
		(WACookie new
			key: 'nullCookie';
			expireIn: (Duration seconds: 60);
			yourself)
	with:	
		(WACookie new
			key: 'cookietest';
			value: 1000 atRandom displayString;
			expireIn: (Duration seconds: 60);
			yourself)
	with:	
		"Should get back multiple (i.e. a collection of) cookies with same key ?"
		(WACookie new
			key: 'cookietest';
			value: 1000 atRandom displayString;
			expireIn: (Duration seconds: 60);
			yourself)).
	self inform: self session currentRequest cookies displayString.! !

WATask subclass: #WAExceptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAExceptionTest methodsFor: 'processing' stamp: 'mbany 4/14/2005 12:14'!
go
	[(self confirm: 'Raise an exception?')
		ifTrue: [self error: 'foo']]
			on: Error
			do: [:e | self inform: 'Caught: ', e displayString]! !

WATask subclass: #WAStoreTask
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreTask commentStamp: 'avi 1/1/2004 10:19' prior: 0!
This task models the main application flow of the store example.  Most of the other components in the example are called from here.  The flow is defined by the #go method.  After creating a WAStoreCart instance, this calls WAStoreFillCart to allow the user to add items to it.  It then calls WAStoreCartConfirmation, WAStoreAddressEditor, and WAStorePaymentEditor in succession for the checkout process.  Many of the components it calls are wrapped with informative messages (#withMessage:) and validation (#validateWith:).  It also makes use of WASession>>isolate: to ensure that once the checkout process starts, backtracking to modify the cart is forbidden.  Used by WAStore.!

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'RJT 5/8/2007 12:26'!
confirmContentsOfCart
	^ self call:
		((WAStoreCartConfirmation new cart: cart)
			addMessage: 'Please verify your order:'; yourself)! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:28'!
displayConfirmation
	self inform: 'Your fish is on its way.'! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 1/14/2004 22:51'!
fillCart
	self call: (WAStoreFillCart new cart: cart)! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 16:35'!
getAddressWithMessage: aString
	^ self call:
		(WAStoreAddressEditor new
			validateWith: [:a | a validate];
			addMessage: aString;
			yourself)
				! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:43'!
getBillingAddress
	^ self getAddressWithMessage: 'Please enter your billing address:'.! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 18:55'!
getPaymentInfo
	^ self call:
		(WAStorePaymentEditor new
			validateWith: [:p | p validate];
			addMessage: 'Please enter your payment information:';
			yourself)! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 11/6/2005 00:38'!
getShippingAddress
	^ self getAddressWithMessage: 'Please enter your shipping address:'.! !

!WAStoreTask methodsFor: 'actions' stamp: 'avi 2/2/2004 21:58'!
go
	| shipping billing creditCard |
	cart := WAStoreCart new.
	self isolate:
		[[self fillCart.
		self confirmContentsOfCart]
			whileFalse].

	self isolate:
		[shipping := self getShippingAddress.
		billing := (self useAsBillingAddress: shipping)
					ifFalse: [self getBillingAddress]
					ifTrue: [shipping].
		creditCard := self getPaymentInfo.
		self shipTo: shipping billTo: billing payWith: creditCard].

	self displayConfirmation.! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:04'!
shipTo: shippingAddress billTo: billingAddress payWith: aCreditCard
	"no-op"! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:44'!
useAsBillingAddress: anAddress
	^ self confirm: 'Do you wish to use ', anAddress street printString, ' as your billing address?'! !

!WATask methodsFor: 'decorations' stamp: 'avi 3/28/2004 20:50'!
decoration: oldDecoration shouldWrap: newDecoration
	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isLocal and: [newDecoration isDelegation]]! !

!WATask methodsFor: 'processing' stamp: 'jf 11/10/2003 16:13'!
go
	self subclassResponsibility! !

!WATask methodsFor: 'rendering' stamp: 'lr 9/6/2006 11:27'!
renderContentOn: html
	self session redirectTo: (html context actionUrl
		withParameter: (html callbacks 
			registerActionCallback: [ [ self answer: self go ] repeat ])) displayString! !

WATask subclass: #WATransactionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WATransactionTest methodsFor: 'processing' stamp: 'avi 3/22/2004 15:16'!
go
	self inform: 'Before parent txn'.
	self isolate: 
			[self inform: 'Inside parent txn'.
			self isolate: [self inform: 'Inside child txn'].
			self inform: 'Outside child txn'].
	self inform: 'Outside parent txn'! !

WAComponent subclass: #WATaskTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WATaskTest methodsFor: 'rendering' stamp: 'avi 9/22/2004 14:05'!
renderContentOn: html
	html anchorWithAction: [self call: WAExceptionTest new] text: 'go'.
! !

!WATaskTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:27'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WATimeSelector
	instanceVariableNames: 'second hour minute startHour endHour'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:38'!
date: aDate 
	second := aDate dayOfMonth.
	hour := aDate monthIndex.
	minute := aDate year! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:37'!
days
	^ 1 to: 31! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:48'!
endHour
	^endHour! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:48'!
endHour: anInteger 
	endHour := anInteger! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
hour
	^hour! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
hour: anObject
	^hour := anObject! !

!WATimeSelector methodsFor: 'initialize-release' stamp: 'mb 5/6/2006 16:10'!
initialize
	super initialize.
	startHour := 0.
	endHour := 23.
	self time: Time midnight! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
minute
	^minute! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
minute: anObject
	^minute := anObject! !

!WATimeSelector methodsFor: 'private' stamp: 'pmm 10/2/2006 21:13'!
privateIsValidSecond: theSecond hourNumber: theHour minuteNumber: theMinute

	^ (theHour between: 0 and: 23)
		and: [ theMinute between: 0 and: 59 ]
		and: [ theSecond between: 0 and: 59 ]! !

!WATimeSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:25'!
renderContentOn: html 
	html select
		list: (0 to: 23);
		on: #hour of: self.
	html  select
		list: (0 to: 59);
		on: #minute of: self.
	html  select
		list: (0 to: 59);
		on: #second of: self.
		
	self timeIsValid ifFalse: [self renderValidationErrorOn: html]! !

!WATimeSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:23'!
renderValidationErrorOn: html
	html span
		class: 'error';
		with: 'invalid time'! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
second
	^second! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
second: anObject
	^second := anObject! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:48'!
startHour
	^startHour! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:48'!
startHour: anInteger 
	startHour := anInteger! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/22/2006 07:22'!
time
	(self 
		privateIsValidSecond: second
		hourNumber: hour
		minuteNumber: minute) ifFalse: [self error: 'Invalid time'].
	^self timeClass 
		hour: hour
		minute: minute
		second: second! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:47'!
time: aTime 
	second := aTime second.
	hour := aTime hour.
	minute := aTime minute! !

!WATimeSelector methodsFor: 'private' stamp: 'pmm 10/22/2006 07:22'!
timeClass
	^Time! !

!WATimeSelector methodsFor: 'testing' stamp: 'jlr 4/4/2006 23:46'!
timeIsValid
	[self time] on: Error do: [:e | ^ false].
	^ true! !

WAComponent subclass: #WATool
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

WATool subclass: #WAMemory
	instanceVariableNames: 'instances sizes table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAMemory class methodsFor: 'accessing' stamp: 'lr 11/20/2006 23:52'!
title
	^ 'Memory'! !

!WAMemory methodsFor: 'private' stamp: 'lr 11/20/2006 23:44'!
buildTable
	^ WATableReport new
		rowPeriod: 1;
		rowColors: #( 'lightgrey' 'white' );
		rows: sizes keys asSortedCollection;
		columns: (Array 
			with: (WAReportColumn selector: #yourself title: 'Class')
			with: (WAReportColumn new
				title: 'Instances';
				valueBlock: [:ea | instances at: ea];
				yourself)
			with: (WAReportColumn new
				title: 'Total Size';
				valueBlock: [:ea | sizes at: ea];
				yourself));
		yourself! !

!WAMemory methodsFor: 'accessing' stamp: 'avi 2/10/2004 16:15'!
children
	^ Array with: table! !

!WAMemory methodsFor: 'initialization' stamp: 'lr 11/20/2006 23:46'!
initialize
	| segment results |
	super initialize.
	segment := ImageSegment new 
		copyFromRoots: (Array with: self session)
		sizeHint: 100000.
	results := segment doSpaceAnalysis.
	instances := results first.
	sizes := results second.
	table := self buildTable! !

!WAMemory methodsFor: 'rendering' stamp: 'lr 11/20/2006 23:40'!
renderContentOn: html
	html strong: self totalInstances displayString, ' instances in ', self totalSizeString.
	html render: table! !

!WAMemory methodsFor: 'accessing' stamp: 'ab 2/18/2003 20:42'!
totalInstances
	^ instances detectSum: [:ea | ea]! !

!WAMemory methodsFor: 'accessing' stamp: 'ab 2/18/2003 20:41'!
totalSize
	^ sizes detectSum: [:ea | ea]! !

!WAMemory methodsFor: 'accessing' stamp: 'ab 2/18/2003 20:58'!
totalSizeString
	|size unit|
	size := self totalSize.
	unit := 'bytes'.
	size > 1024 ifTrue:
		[size := size / 1024.
		unit := 'kB'.
		size > 1024 ifTrue:
			[size := size / 1024.
			unit := 'MB']].
	^ (size printShowingDecimalPlaces: 1), ' ', unit! !

WATool subclass: #WAProfiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAProfiler class methodsFor: 'accessing' stamp: 'pmm 1/26/2007 21:19'!
title
	^ 'Profiler'! !

!WAProfiler methodsFor: 'rendering' stamp: 'pmm 1/26/2007 21:34'!
children
	^Array with: self root! !

!WAProfiler methodsFor: 'rendering' stamp: 'pmm 1/26/2007 21:17'!
renderContentOn: html
	| profile |
	profile := SeasidePlatformSupport 
		profileSendsDuring: [ html render: self root ].
	html horizontalRule.
	html preformatted: profile! !

WATool subclass: #WASpotProfileReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WASpotProfileReport class methodsFor: 'accessing' stamp: 'lr 11/20/2006 23:53'!
title
	^ 'Spot Profiler'! !

!WASpotProfileReport methodsFor: 'rendering' stamp: 'lr 11/20/2006 23:55'!
renderContentOn: html
	html table: [
		html tableRow: [
			#( 'Selector' 'Total Time' 'Time/Req' 'Readings/Req' 'Time/Reading' )
				do: [ :each | html tableHeading: each ].
			WASpotProfiler profilers keysAndValuesDo: [ :selector :profile |
				html tableHeading: selector.
				profile allReadings isEmpty ifFalse: [
					html tableData: profile totalTime.
					html tableData: profile averageRequestTime.
					html tableData: profile averageReadingsPerRequest.
					html tableData: profile averageReadingTime.
					html tableData: [
						html anchor
							callback: [ profile reset ];
							with: 'reset' ] ] ] ] ]! !

!WATool class methodsFor: 'accessing' stamp: 'ab 7/3/2003 12:43'!
title
	^ self name! !

!WATool methodsFor: 'accessing' stamp: 'lr 11/20/2006 23:35'!
root
	"Answer the root component of the application."
	
	^ root! !

!WATool methodsFor: 'accessing' stamp: 'lr 11/20/2006 23:35'!
root: aComponent
	root := aComponent! !

WAComponent subclass: #WATrail
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WATrail class methodsFor: 'instance creation' stamp: 'ab 8/26/2003 15:27'!
on: anObject
	^ self new root: anObject! !

!WATrail methodsFor: 'rendering' stamp: 'lr 11/16/2006 15:38'!
renderContentOn: html
	| last selected |
	last := nil.
	html unorderedList
		class: 'trail';
		with: [
			root visiblePresentersDo: [ :each |
				(each isDecoration and: [each isDelegation]) ifTrue: [
					(each component respondsTo: #trailName) ifTrue: [
						last := each.
						html listItem: [
							html anchor
								callback: [ each remove ];
								with: each component trailName ] ] ] ].
			selected := last ifNil: [ root ] ifNotNil: [ last delegate ].
			(selected respondsTo: #trailName) ifTrue: [
				html listItem: selected trailName ] ]
! !

!WATrail methodsFor: 'accessing' stamp: 'ab 8/26/2003 15:27'!
root: anObject
	root := anObject! !

!WATrail methodsFor: 'rendering' stamp: 'avi 4/13/2004 22:16'!
style
^'	ul.trail {
		margin-left: 0;
		padding-left: 0;
		display: inline;
		border: none;
	}
	ul.trail li {
        	margin-left: 0;
        	padding-left: 2px;
        	border: none;
        	list-style: none;
        	display: inline;
	}
	
	ul.trail  li:before {
        content: "\0020 \0020 \0020 \00BB \0020";
        }
        
	ul.trail li.first:before {
        content: " ";
        }
'! !

WAComponent subclass: #WATree
	instanceVariableNames: 'root selected expanded childrenBlock labelBlock canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WATree class methodsFor: 'examples' stamp: 'lr 3/27/2006 11:13'!
exampleCollectionClasses
	^ self new
		root: Collection;
		labelBlock: [ :class | class name ];
		childrenBlock: [ :class | class subclasses ];
		yourself! !

!WATree class methodsFor: 'examples' stamp: 'lr 2/20/2007 14:02'!
exampleObjectExplorer
	^ self new
		root: 'dispatcher' -> WADispatcher default;
		labelBlock: [ :assoc | assoc key displayString , ': ' , assoc value printString ];
		childrenBlock: [ :assoc | assoc value inspectorFields ];
		yourself! !

!WATree class methodsFor: 'instance-creation' stamp: 'lr 3/27/2006 11:08'!
root: anObject
	^ self new
		root: anObject;
		yourself! !

!WATree class methodsFor: 'instance-creation' stamp: 'lr 3/27/2006 11:09'!
root: anObject path: anArray
	^ (self root: anObject)
		expandAll: anArray;
		selected: anArray last;
		yourself! !

!WATree methodsFor: 'testing' stamp: 'lr 3/7/2005 17:39'!
canSelect: aNode
	^self selectBlock notNil
		and: [ self canSelectBlock isNil
			or: [ self canSelectBlock value: aNode ] ].! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 12:11'!
canSelectBlock
	^canSelectBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 3/7/2005 17:40'!
canSelectBlock: aBlock
	canSelectBlock := aBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:19'!
childrenBlock
	^childrenBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:20'!
childrenBlock: aBlock
	childrenBlock := aBlock! !

!WATree methodsFor: 'accessing-nodes' stamp: 'lr 3/27/2006 09:12'!
childrenOf: aNode
	| children |
	children := self childrenBlock value: aNode.
	^ children ifNil: [ Array new ]! !

!WATree methodsFor: 'actions' stamp: 'lr 2/19/2005 16:03'!
collapse: aNode
	expanded remove: aNode.! !

!WATree methodsFor: 'actions' stamp: 'lr 2/19/2005 11:20'!
expand: aNode
	expanded add: aNode.! !

!WATree methodsFor: 'actions' stamp: 'lr 3/28/2005 21:15'!
expandAll: aCollection
	expanded addAll: aCollection.! !

!WATree methodsFor: 'testing' stamp: 'lr 2/19/2005 16:25'!
hasChildren: aNode
	^(self childrenOf: aNode) 
		isEmpty not.! !

!WATree methodsFor: 'initialization' stamp: 'lr 3/27/2006 11:25'!
initialize
	super initialize.
	self session registerObjectForBacktracking: (expanded := IdentitySet new).
	self selectBlock: [ :node | self answer: node ].
	self childrenBlock: [ :node | Array new ].
	self labelBlock: [ :node | node displayString ]! !

!WATree methodsFor: 'testing' stamp: 'lr 2/19/2005 11:18'!
isExpanded: aNode
	^expanded includes: aNode.! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:19'!
labelBlock
	^labelBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:20'!
labelBlock: aBlock
	labelBlock := aBlock! !

!WATree methodsFor: 'accessing-nodes' stamp: 'lr 2/19/2005 12:06'!
labelOf: aNode
	^self labelBlock value: aNode.! !

!WATree methodsFor: 'rendering' stamp: 'lr 2/19/2005 11:41'!
renderContentOn: html
	self renderTreeOn: html.! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:27'!
renderNode: aNode on: html
	html listItem: [
		self renderNodeButton: aNode on: html.
		self renderNodeLabel: aNode on: html.
		self renderNodeChildren: aNode on: html ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:23'!
renderNodeButton: aNode on: html
	| isExpanded |
	html span
		class: 'button';
		with: [
			(self hasChildren: aNode) ifTrue: [
				isExpanded := self isExpanded: aNode.
				self 
					renderNodeButtonLink: aNode 
					action: (MessageSend 
						receiver: self 
						selector: (isExpanded
							ifTrue: [ #collapse: ]
							ifFalse: [ #expand: ])
						argument: aNode)
					text: (isExpanded
						ifTrue: [ '-' ]
						ifFalse: [ '+' ])
					on: html ] ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:24'!
renderNodeButtonLink: aNode action: aBlock text: anObject on: html
	html anchor callback: aBlock; with: anObject! !

!WATree methodsFor: 'rendering-nodes' stamp: 'lr 2/19/2005 16:07'!
renderNodeChildren: aNode on: html
	| children |
	children := self childrenOf: aNode.
	children isEmpty ifFalse: [
		(self isExpanded: aNode) ifTrue: [
			html unorderedList: [
				children do: [ :each |
					self renderNode: each on: html ] ] ] ].! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:27'!
renderNodeLabel: aNode on: html
	| label |
	html span
		class: 'label';
		class: (self selected == aNode
			ifTrue: [ 'active' ]
			ifFalse: [ 'inactive' ]);
		with: [
			label := self labelOf: aNode.
			(self canSelect: aNode)
				ifFalse: [ html render: label ]
				ifTrue: [
					self
						renderNodeLabelLink: aNode
						action: (MessageSend
							receiver: self 
							selector: #select:
							argument: aNode)
						text: label on: html ] ].! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:28'!
renderNodeLabelLink: aNode action: aBlock text: anObject on: html
	html anchor callback: aBlock; with: anObject! !

!WATree methodsFor: 'rendering' stamp: 'lr 3/7/2005 16:30'!
renderTreeOn: html
	html unorderedList: [ self renderNode: self root on: html ].! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:18'!
root
	^root! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:18'!
root: aNode
	root := aNode! !

!WATree methodsFor: 'actions' stamp: 'lr 3/28/2005 21:13'!
select: aNode
	(self canSelect: aNode) ifTrue: [
		self selected: aNode.
		self selectBlock isNil
			ifFalse: [ self selectBlock value: aNode ] ].! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:21'!
selectBlock
	^selectBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:21'!
selectBlock: aBlock
	selectBlock := aBlock! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:19'!
selected
	^selected! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:19'!
selected: aNode
	selected := aNode! !

WAComponent subclass: #WAUploadTest
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAUploadTest methodsFor: 'rendering' stamp: 'pmm 9/30/2006 18:18'!
renderContentOn: html
	html heading: 'Upload File'.
	
	html attributeAt: 'enctype' put: 'multipart/form-data'.
	html form: [
		html fileUploadWithCallback: [:f | file := f].
		html submitButton.
	].

	file ifNotNil: [
		html 
			anchorWithDocument: file contents 
			mimeType: file contentType
			fileName: file fileName
			text: file fileName , ' (' , file contentType , ')'. 
		html break. 
		html anchorWithDocument: file contents text:file fileName.
		html preformatted: file contents ]
! !

!WAUploadTest methodsFor: 'rendering' stamp: 'mb 10/12/2006 19:27'!
rendererClass
	"Intentionally using the classic API"
	^WAHtmlRenderer! !

WAComponent subclass: #WAVNCController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAVNCController class methodsFor: 'accessing' stamp: 'lr 2/12/2007 21:53'!
canBeRoot
	^ true! !

!WAVNCController class methodsFor: 'initialization' stamp: 'cb 2/27/2007 15:06'!
initialize
	(Smalltalk hasClassNamed: 'RFBServer')
		ifTrue: [ self registerAsAuthenticatedApplication: 'tools/vnc' ]! !

!WAVNCController methodsFor: 'accessing' stamp: 'pmm 3/6/2007 21:57'!
currentDisplay
	^ self serverInstance displayNumber displayString! !

!WAVNCController methodsFor: 'testing' stamp: 'pmm 3/6/2007 21:54'!
isServerRunning
	^self serverInstance notNil! !

!WAVNCController methodsFor: 'accessing' stamp: 'lr 11/21/2006 00:02'!
project
	^ Smalltalk classNamed: #Project! !

!WAVNCController methodsFor: 'rendering' stamp: 'pmm 3/6/2007 21:54'!
renderContentOn: html
	html heading: 'VNC Server'.
	self isServerRunning
		ifTrue: [ self renderStopOn: html ]
		ifFalse: [ self renderStartOn: html ].
	html heading: 'UI Process'.
	self project uiProcess isSuspended
		ifFalse: [ self renderSuspendOn: html ]
		ifTrue: [ self renderResumeOn: html ]! !

!WAVNCController methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:01'!
renderResumeOn: html
	html form: [
		html text: 'UI Process is suspended. '.
		html submitButton
			callback: [ self resume ];
			text: 'Resume' ]! !

!WAVNCController methodsFor: 'rendering' stamp: 'lr 11/20/2006 23:58'!
renderStartOn: html
	html form: [
		html text: 'Start VNC on display: '.
		html textInput
			value: 0;
			callback: [ :value | self startOn: value asNumber ].
		html submitButton
			text: 'Start' ]! !

!WAVNCController methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:01'!
renderStopOn: html
	html form: [
		html text: 'Stop VNC (running on ', self currentDisplay, ') '.
		html submitButton
			callback: [ self stop ];
			text: 'Stop' ]! !

!WAVNCController methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:01'!
renderSuspendOn: html
	html form: [
		html text: 'UI Process is running. '.
		html submitButton
			callback: [ self suspend ];
			text: 'Suspend' ]! !

!WAVNCController methodsFor: 'actions' stamp: 'lr 11/21/2006 00:02'!
resume
	self project uiProcess resume! !

!WAVNCController methodsFor: 'accessing' stamp: 'lr 11/21/2006 00:00'!
server
	^ Smalltalk classNamed: #RFBServer! !

!WAVNCController methodsFor: 'accessing' stamp: 'pmm 3/6/2007 21:51'!
serverClass
	^ Smalltalk classNamed: #RFBServer! !

!WAVNCController methodsFor: 'accessing' stamp: 'pmm 3/6/2007 21:53'!
serverInstance
	^ self serverClass server! !

!WAVNCController methodsFor: 'actions' stamp: 'pmm 3/6/2007 21:56'!
startOn: aNumber
	self resume.
	self serverClass start: aNumber! !

!WAVNCController methodsFor: 'actions' stamp: 'pmm 3/6/2007 21:56'!
stop
	self serverClass stop! !

!WAVNCController methodsFor: 'actions' stamp: 'lr 11/21/2006 00:02'!
suspend
	self project uiProcess suspend.
	self stop! !

WAComponent subclass: #WAVersionUploader
	instanceVariableNames: 'file url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAVersionUploader class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:57'!
canBeRoot
	^ true! !

!WAVersionUploader class methodsFor: 'initialization' stamp: 'lr 2/12/2007 21:52'!
initialize
	self registerAsApplication: 'tools/versionuploader'! !

!WAVersionUploader methodsFor: 'actions' stamp: 'avi 1/21/2004 18:58'!
loadFile
	| reader version |
	reader := MCVersionReader readerClassForFileNamed: file fileName.
	reader ifNil: [self inform: file fileName, ' is not in a known format'].
	version := reader versionFromStream: file contents asByteArray readStream.
	version load.! !

!WAVersionUploader methodsFor: 'actions' stamp: 'avi 1/21/2004 18:58'!
loadURL
	| stream version |
	stream := url asUrl retrieveContents content asByteArray readStream .
	version := (MCVersionReader readerClassForFileNamed: url) versionFromStream: stream.
	version load.! !

!WAVersionUploader methodsFor: 'rendering' stamp: 'avi 5/10/2005 14:34'!
newVersion: aWorkingCopy
	| version s |
	version := [aWorkingCopy newVersion]
				on: MCVersionNameAndMessageRequest 
				do: [:n | n resume: (Array with: n suggestedName with: '')].
	s := RWBinaryOrTextStream on: String new.
	version fileOutOn: s.
	self session respond:
		[:u |
		u addToPath: version fileName.
		WAResponse redirectTo: u displayString].
	self session returnResponse: (WAResponse new
									contentType: 'application/octet-stream';
									nextPutAll: s contents;
									yourself)! !

!WAVersionUploader methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:05'!
renderContentOn: html
	html strong: 'Loaded versions:'.
	html unorderedList 
		with: [MCWorkingCopy allManagers
				do: [:ea | 
					html listItem: [
						html anchor callback: [self newVersion: ea]; with: 'Save'.
						html space.
						html text: ea description]]].
	
	html form
		multipart;
		with: [
			html strong: 'Load version from file: '.
			html break.
			html fileUpload callback: [:f | file := f].
			html space.
			html submitButton callback: [self loadFile]; text: 'Load'.
	].
	html form
		with: [
			html strong: 'Load version from URL: '.
			html break.
			html textInput size: 60; value: 'http://'; callback: [:u | url := u].
			html space.
			html submitButton callback: [self loadURL]; text: 'Load'.
	].
	html anchor callback: [self saveImage]; with: 'Save Image'. ! !

!WAVersionUploader methodsFor: 'actions' stamp: 'pmm 1/26/2007 22:55'!
saveImage
	SmalltalkImage current snapshot: true andQuit: false! !

WAComponent subclass: #WAWalkback
	instanceVariableNames: 'exception fullstack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAWalkback commentStamp: '<historical>' prior: 0!
A WAWalkback is a component that renders an exeception stack track with the instance and temporary variables. Per default it renders only the top stack frames but it offers the option to render all. It also offers the option to open a debugger in the image.

Instance Variables
	exception:		<Exception>
	fullstack:		<Boolean>

exception
	- the exception to render

fullstack
	- true if all the stack frames shall be rendered, false if only the first #defaultStackFrames shall be rendered, default: false
!

!WAWalkback methodsFor: 'actions' stamp: 'avi 11/10/2003 01:54'!
debug
	self answer! !

!WAWalkback methodsFor: 'accessing' stamp: 'avi 10/26/2004 14:05'!
exception: anException
	exception := anException! !

!WAWalkback methodsFor: 'actions' stamp: 'lr 3/28/2005 17:52'!
fullstack
	fullstack := true
	! !

!WAWalkback methodsFor: 'initialization' stamp: 'lr 3/28/2005 17:55'!
initialize
	super initialize.
	fullstack := false.! !

!WAWalkback methodsFor: 'rendering' stamp: 'lr 9/6/2006 11:13'!
renderContentOn: html
	self renderToolsOn: html.
	self renderWalkbackOn: html! !

!WAWalkback methodsFor: 'rendering' stamp: 'lr 9/6/2006 11:14'!
renderObject: anObject labelled: aString on: html
	| objectString |
	[objectString := (SeasidePlatformSupport isProxy: anObject)
					ifTrue: [anObject printString]
					ifFalse: [anObject printStringLimitedTo: 100]]
		on: Error
		do: [:err | objectString := '<font color="FF0000">&lt;error in printStringLimitedTo:&gt;</font>'].
	html tableRow: [
		html tableData: aString.
		html tableData: [ html html: objectString ] ]! !

!WAWalkback methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:05'!
renderStackFrame: aContext on: html
	| receiver |
	html listItem: [
		html text: aContext fullPrintString.
		html blockquote: [ html table: [
			receiver := aContext receiver.
			self renderObject: receiver labelled: 'self' on: html.
			html tableRow: [ html tableData colSpan: 2; with: [ html strong: 'temps' ]].
			aContext tempNames withIndexDo:
			[:name :index |
			self renderObject: (aContext tempAt: index) labelled: name on: html].
			receiver == nil ifFalse: [
				((SeasidePlatformSupport isProxy: receiver) not and: [receiver class instSize > 0]) ifTrue:
					[html tableRow: [ html tableData colSpan: 2; with: [html strong: 'inst vars']].
					receiver class allInstVarNames withIndexDo:
					[:name :index |
					self renderObject: (receiver instVarAt: index) labelled: name on: html]]].
		]]
	]
! !

!WAWalkback methodsFor: 'rendering' stamp: 'lr 9/6/2006 11:13'!
renderToolsOn: html
	html anchor
		callback: [ self debug ];
		with: 'Debug'.
	html space.
	html anchor
		callback: [ self fullstack ];
		with: 'Full Stack'! !

!WAWalkback methodsFor: 'rendering' stamp: 'lr 3/28/2005 17:56'!
renderWalkbackOn: html
	| context count |
	html heading: exception description.
	html unorderedList: [
		context := thisContext. count := 0.
		[context receiver isKindOf: Exception] whileFalse: [context := context sender].
		[context receiver isKindOf: Exception] whileTrue: [context := context sender].
		[context notNil and: [ fullstack or: [ count < 5 ] ] ] whileTrue: [
			self renderStackFrame: context on: html.
			context := context sender.
			count := count + 1].
	]! !

WAPresenter subclass: #WADecoration
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WADecoration commentStamp: '<historical>' prior: 0!
I am an abstract decoration around instances of WAComponent. I can be added to aComponent by calling #addDecoration: and I change the basic behaviour or look of a component. There are several methods that can be overriden to archive this:

- #renderContentOn: to emit xhtml around the decorated component. Call #renderOwnerOn: to let the owner emit its output.

- #processChildCallbacks: to intercept the callback processing of the owner.

- #handleAnswer: to intercept the answer processing.!

WADecoration subclass: #WAAnswerHandler
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WAAnswerHandler methodsFor: 'accessing' stamp: 'avi 6/2/2004 21:59'!
block: aBlock
	block := aBlock! !

!WAAnswerHandler methodsFor: 'processing' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	block value: anObject! !

WADecoration subclass: #WABasicAuthentication
	instanceVariableNames: 'authenticator realm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WABasicAuthentication methodsFor: 'accessing' stamp: 'avi 2/2/2004 13:03'!
authenticator: anAuthenticator
	authenticator := anAuthenticator! !

!WABasicAuthentication methodsFor: 'testing' stamp: 'avi 3/28/2004 20:51'!
isGlobal
	^ true! !

!WABasicAuthentication methodsFor: 'request processing' stamp: 'avi 6/8/2004 00:56'!
processChildCallbacks: aStream
	(self verifyRequest: self session currentRequest)
		ifTrue: [super processChildCallbacks: aStream]
		ifFalse: [self respondWithChallenge]! !

!WABasicAuthentication methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:04'!
realm
	^ realm ifNil: [self session application basePath]! !

!WABasicAuthentication methodsFor: 'accessing' stamp: 'avi 2/5/2004 13:52'!
realm: aString
	realm := aString! !

!WABasicAuthentication methodsFor: 'rendering' stamp: 'lr 9/6/2006 11:16'!
renderContentOn: html
	(self verifyRequest: self session currentRequest)
		ifTrue: [self renderOwnerOn: html]
		ifFalse: [self respondWithChallenge]! !

!WABasicAuthentication methodsFor: 'request processing' stamp: 'avi 5/19/2004 14:16'!
respondWithChallenge
	self session returnResponse: (WAResponse basicAuthWithRealm: self realm)! !

!WABasicAuthentication methodsFor: 'request processing' stamp: 'avi 4/13/2004 21:42'!
verifyRequest: aRequest
	^ authenticator verifyPassword: aRequest password  forUser: aRequest user! !

!WADecoration methodsFor: 'convenience' stamp: 'ac 3/22/2006 15:04'!
asComponent 
	^ self component! !

!WADecoration methodsFor: 'accessing' stamp: 'avi 3/27/2004 22:13'!
component
	^ self owner isDecoration
		ifTrue: [self owner component]
		ifFalse: [self owner]! !

!WADecoration methodsFor: 'call/answer' stamp: 'avi 6/22/2004 11:02'!
handleAnswer: anObject
	(self owner handleAnswer: anObject) ifFalse:
		[self handleAnswer: anObject continueWith: [^ false]].
	^ true! !

!WADecoration methodsFor: 'processing' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	aBlock value! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/27/2004 19:55'!
isDecoration
	^ true! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/27/2004 22:23'!
isDelegation
	^ false! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/28/2004 20:48'!
isGlobal
	^ false! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/28/2004 20:49'!
isLocal
	^ (self isGlobal or: [self isDelegation]) not! !

!WADecoration methodsFor: 'iterating' stamp: 'avi 6/8/2004 12:43'!
nextPresentersDo: aBlock
	aBlock value: self owner! !

!WADecoration methodsFor: 'accessing' stamp: 'avi 4/13/2004 20:20'!
owner
	^ next ifNotNil: [next contents]! !

!WADecoration methodsFor: 'accessing' stamp: 'avi 4/13/2004 20:20'!
owner: aPresenter
	next ifNil: [next := WAStateHolder new].
	next contents: aPresenter! !

!WADecoration methodsFor: 'actions' stamp: 'avi 3/29/2004 16:10'!
remove
	self component removeDecoration: self! !

!WADecoration methodsFor: 'rendering' stamp: 'avi 3/27/2004 21:07'!
renderOwnerOn: html
	self owner ifNotNilDo: [:owner | owner renderWithContext: html context]! !

!WADecoration methodsFor: 'rendering' stamp: 'lr 2/20/2007 12:08'!
showHalo
	^ false! !

WADecoration subclass: #WADelayedAnswerDecoration
	instanceVariableNames: 'delay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WADelayedAnswerDecoration methodsFor: 'accessing' stamp: 'avi 3/27/2005 20:34'!
delay
	^ delay ifNil: [1]! !

!WADelayedAnswerDecoration methodsFor: 'accessing' stamp: 'avi 3/27/2005 20:34'!
delay: aNumber
	delay := aNumber! !

!WADelayedAnswerDecoration methodsFor: 'path' stamp: 'pmm 10/7/2006 18:41'!
updateRoot: aRoot
	| callbacks url |
	callbacks := WACallbackRegistry context: aRoot context owner: self.
	url := aRoot context actionUrl withParameter: (callbacks registerActionCallback: [self component answer]).
	aRoot meta redirectAfter: self delay to: url asString! !

WADecoration subclass: #WADelegation
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WADelegation methodsFor: 'accessing' stamp: 'avi 3/12/2004 20:18'!
delegate
	^ delegate! !

!WADelegation methodsFor: 'accessing' stamp: 'avi 3/12/2004 20:18'!
delegate: aComponent
	delegate := aComponent! !

!WADelegation methodsFor: 'testing' stamp: 'avi 3/27/2004 22:26'!
isDelegation
	^ true! !

!WADelegation methodsFor: 'iterating' stamp: 'avi 4/22/2004 14:51'!
nextPresentersDo: aBlock
	delegate decorationChainDo: aBlock! !

WADecoration subclass: #WAFormDecoration
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAFormDecoration methodsFor: 'accessing' stamp: 'avi 3/16/2004 13:36'!
buttons
	^ buttons! !

!WAFormDecoration methodsFor: 'accessing' stamp: 'avi 3/16/2004 13:34'!
buttons: selectorArray
	buttons := selectorArray! !

!WAFormDecoration methodsFor: 'actions' stamp: 'mb 4/4/2006 13:42'!
defaultAction
	MessageSend receiver: self owner selector: self owner defaultButton! !

!WAFormDecoration methodsFor: 'rendering' stamp: 'al 9/7/2006 17:09'!
renderButtonForSelector: aSymbol on: html

	html submitButton on: aSymbol of: self owner
! !

!WAFormDecoration methodsFor: 'rendering' stamp: 'al 9/7/2006 15:52'!
renderButtonsOn: html
	html div
		class: 'dialog-buttons';
		with: [
		self buttons do: [ :each |
			"Avoid duplicate cssId, if component used many times in the page"
			html  span
				class: 'dialog-button-' , each;
				with: [self renderButtonForSelector: each on: html ] ] ]! !

!WAFormDecoration methodsFor: 'rendering' stamp: 'al 9/7/2006 15:50'!
renderContentOn: html
	html form
		defaultAction: [ self defaultAction ];
		with: [
			self renderOwnerOn: html.
			self renderButtonsOn: html ]! !

WADecoration subclass: #WAMessageDecoration
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAMessageDecoration methodsFor: 'accessing' stamp: 'avi 3/12/2004 00:43'!
message: aString
	message := aString! !

!WAMessageDecoration methodsFor: 'rendering' stamp: 'avi 3/12/2004 00:49'!
renderContentOn: html
	html heading: message level: 3.
	self renderOwnerOn: html.! !

WADecoration subclass: #WASessionProtector
	instanceVariableNames: 'remoteAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WASessionProtector methodsFor: 'testing' stamp: 'lr 8/31/2004 18:49'!
isGlobal
	^true! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'lr 8/31/2004 19:36'!
processChildCallbacks: aStream
	(self verifyRequest: self session currentRequest)
		ifTrue: [ super processChildCallbacks: aStream ]
		ifFalse: [ self respondNotVerified ]! !

!WASessionProtector methodsFor: 'accessing' stamp: 'lr 8/31/2004 19:32'!
remoteAddressFromRequest: aRequest
	^aRequest 
		headerAt: 'x-forwarded-for'
		ifAbsent: [ aRequest nativeRequest remoteAddress ]! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'lr 9/6/2006 11:16'!
renderContentOn: html
	(self verifyRequest: self session currentRequest)
		ifTrue: [ self renderOwnerOn: html ]
		ifFalse: [ self respondNotVerified ]! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'lr 8/31/2004 19:37'!
respondNotVerified
	self session redirectTo: self session application basePath.! !

!WASessionProtector methodsFor: 'accessing' stamp: 'lr 8/31/2004 19:38'!
storedRemoteAddress
	remoteAddress isNil
		ifTrue: [ remoteAddress := self remoteAddressFromRequest: self session currentRequest ].
	^remoteAddress! !

!WASessionProtector methodsFor: 'testing' stamp: 'lr 8/31/2004 19:31'!
verifyRequest: aRequest
	^(self remoteAddressFromRequest: aRequest) = self storedRemoteAddress! !

WADecoration subclass: #WATransaction
	instanceVariableNames: 'active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WATransaction methodsFor: 'open/close' stamp: 'ab 1/15/2003 21:55'!
close
	active := false! !

!WATransaction methodsFor: 'initialization' stamp: 'mb 4/23/2006 18:36'!
initialize
	super initialize.
	active := true! !

!WATransaction methodsFor: 'testing' stamp: 'avi 3/28/2004 20:51'!
isGlobal
	^ true! !

!WATransaction methodsFor: 'forwarding' stamp: 'avi 6/8/2004 00:56'!
processChildCallbacks: aStream
	^ active
		ifTrue: [super processChildCallbacks: aStream]
		ifFalse: [self session pageExpired].
	! !

!WATransaction methodsFor: 'rendering' stamp: 'avi 9/8/2004 12:18'!
renderContentOn: html
	active
		ifTrue: [ self renderOwnerOn: html ]
		ifFalse: [ self session pageExpired ]! !

WADecoration subclass: #WAValidationDecoration
	instanceVariableNames: 'message validationBlock exceptionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAValidationDecoration methodsFor: 'accessing' stamp: 'cds 6/3/2006 22:40'!
exceptionClass
	^exceptionClass ifNil: [exceptionClass := WAValidationNotification]! !

!WAValidationDecoration methodsFor: 'accessing' stamp: 'cds 7/25/2005 10:19'!
exceptionClass: aClass
	exceptionClass := aClass! !

!WAValidationDecoration methodsFor: 'call/answer' stamp: 'pmm 11/2/2005 23:04'!
handleAnswer: anObject
	^(super handleAnswer: anObject)
		or: [(self validate: anObject) not]! !

!WAValidationDecoration methodsFor: 'request processing' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	(self validate: anObject) ifTrue: [aBlock value]! !

!WAValidationDecoration methodsFor: 'initialization' stamp: 'mb 4/23/2006 18:37'!
initialize
	super initialize.
	message := WAStateHolder new! !

!WAValidationDecoration methodsFor: 'rendering' stamp: 'al 9/7/2006 17:18'!
renderContentOn: html
	message contents ifNotNilDo: [ :msg |
		html div
			class: 'validation-error';
			with: msg].
	self renderOwnerOn: html.! !

!WAValidationDecoration methodsFor: 'request processing' stamp: 'cds 6/3/2006 22:37'!
validate: anObject
	[validationBlock value: anObject.
	message contents: nil.
	^ true]
		on: self exceptionClass
		do: [:e | message contents: e messageText].
	^ false! !

!WAValidationDecoration methodsFor: 'convenience' stamp: 'avi 12/10/2003 12:49'!
validateWith: aBlock
	validationBlock := aBlock! !

WADecoration subclass: #WAWindowDecoration
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAWindowDecoration methodsFor: 'testing' stamp: 'avi 3/28/2004 20:52'!
isGlobal
	^ true! !

!WAWindowDecoration methodsFor: 'rendering' stamp: 'lr 9/6/2006 11:19'!
renderCloseButtonOn: html
	html anchor callback: [self component answer]; with: 'close'! !

!WAWindowDecoration methodsFor: 'rendering' stamp: 'lr 9/6/2006 11:19'!
renderContentOn: html
	html div class: 'window-titlebar'; with: [
		html span class: 'window-close'; with: [self renderCloseButtonOn: html].		
		html span class: 'window-title'; with: title.
	].
	html div class: 'window-content'; with: [self renderOwnerOn: html]! !

!WAWindowDecoration methodsFor: 'accessing' stamp: 'avi 3/28/2004 21:04'!
style
	^ '.window-titlebar {background-color: #aaaaaa; padding: 5px; margin-bottom: 5px}
	    .window-close {float: right}
	   .window-title {}
	    .window-content {clear: both}
	'! !

!WAWindowDecoration methodsFor: 'accessing' stamp: 'ab 6/15/2003 12:51'!
title: aString
	title := aString! !

!WAPresenter class methodsFor: 'instance creation' stamp: 'avi 4/13/2004 20:14'!
new
	^ self basicNew initialize! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 7/16/2006 16:41'!
application
	^ self session application! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/18/2005 22:36'!
classForSection: aSymbol
	^ (aSymbol copyFrom: 7 to: (aSymbol size - 1)) withFirstCharacterDownshifted ! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 11/5/2006 12:45'!
fieldsAt: key
	"Returns the string value associated to the key in the argument given to your webapplication. The argument can have been sent by a form or written at the end of the url (using ...?key=value construction). If key is not found, an error is sent."
	^ self session fieldsAt: key! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 11/5/2006 12:45'!
fieldsAt: key ifAbsent: aBlock
	"Returns the string value associated to the key in the argument given to your webapplication. The argument can have been sent by a form or written at the end of the url (using ...?key=value construction). If key is not found, aBlock is evaluated."
	^ self session fieldsAt: key ifAbsent: aBlock! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 11/5/2006 12:46'!
fieldsAt: key ifPresent: aBlock
	"Returns the string value associated to the key in the argument given to your webapplication. The argument can have been sent by a form or written at the end of the url (using ...?key=value construction). If the key is present, execute the block and give it the value as a parameter. Otherwise, answer nil."
	^ self session fieldsAt: key ifPresent: aBlock! !

!WAPresenter methodsFor: 'call/answer' stamp: 'pmm 11/2/2005 23:50'!
handleAnswer: anObject
	self subclassResponsibility ! !

!WAPresenter methodsFor: 'request processing' stamp: 'mb 4/23/2007 14:20'!
initialRequest: aRequest
	"When a new session is started, all visible presenters (components or tasks) receive this message with the request as argument.
	
	A common usage for this is to initialize their state depending on the URL of the request. This is one building block for bookmarkable URL. The other is updateUrl:.
	
	You can not use #call: in here. Consider using a WATask instead and sending #call: in #go.
	
	See WABrowser for examples."


! !

!WAPresenter methodsFor: 'initialization' stamp: 'ab 2/13/2003 01:10'!
initialize! !

!WAPresenter methodsFor: 'decoration' stamp: 'avi 3/27/2004 19:55'!
isDecoration
	^ false! !

!WAPresenter methodsFor: 'tree' stamp: 'avi 6/8/2004 00:58'!
nextPresentersDo: aBlock
	self subclassResponsibility ! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 7/16/2006 16:48'!
preferenceAt: aSymbol
	^ self application preferenceAt: aSymbol! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 7/16/2006 16:53'!
preferenceAt: aSymbol put: anObject
	^ self application preferenceAt: aSymbol put: anObject! !

!WAPresenter methodsFor: 'request processing' stamp: 'avi 6/8/2004 02:00'!
processCallbackStream: aCallbackStream
	aCallbackStream processCallbacksWithOwner: self.
	self processChildCallbacks: aCallbackStream.
	aCallbackStream processCallbacksWithOwner: self.
! !

!WAPresenter methodsFor: 'request processing' stamp: 'avi 6/8/2004 00:54'!
processChildCallbacks: aStream
	self nextPresentersDo: [:ea | ea processCallbackStream: aStream]! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/27/2004 20:59'!
renderContentOn: aRenderer
	self nextPresentersDo: [:ea | ea renderWithContext: aRenderer context]! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/18/2005 22:11'!
renderWithContext: aRenderingContext
	| html callbacks |
	callbacks := aRenderingContext callbacksFor: self.
	html := (self rendererClass context: aRenderingContext callbacks: callbacks)
				painter: self.
	(self showHalo and: [aRenderingContext isDebugMode])
		ifTrue: [(WAHalo for: self) renderContentOn: html]
		ifFalse: [self renderContentOn: html].
	html close.! !

!WAPresenter methodsFor: 'rendering' stamp: 'mb 4/23/2007 14:20'!
rendererClass
	"Override this method if you want a custom renderer."


	^ WARenderCanvas! !

!WAPresenter methodsFor: 'rendering' stamp: 'mb 4/23/2007 14:20'!
script
	"The same as #style except that it is for JavaScript. This is rarely used, consider using WAFileLibrary or exernal files instead."


	^ nil! !

!WAPresenter methodsFor: 'convenience' stamp: 'avi 4/13/2004 19:48'!
session
	^ WACurrentSession value! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/27/2004 17:27'!
showHalo
	^ true! !

!WAPresenter methodsFor: 'rendering' stamp: 'mb 4/23/2007 14:20'!
style
	"Returns a CSS stylesheet associated with this component. This stylesheet will be added to <head> section of the html document so it will be global and not scoped.
	
	This is done for all visible components (see class comment of WAComponent for what visible means).
	
	Nice for demos but consider using WAFileLibrary or exernal files instead."


	^ nil! !

!WAPresenter methodsFor: 'path' stamp: 'mb 4/23/2007 14:20'!
updateRoot: anHtmlRoot
	"This method allows you customize the <head> section of an HTML document. The API is very similar to the 'Canvas API' for rendering in the <body> section (where you 'draw' in #renderContentOn:).
	
	anHtmlRoot is an instance of WAHtmlRoot
	
	Whenever you override this method don't forget to send super"


	self script ifNotNilDo: [:script | anHtmlRoot addScript: script].
	self style ifNotNilDo: [:style | anHtmlRoot addStyle: style].
	
! !

!WAPresenter methodsFor: 'path' stamp: 'avi 3/22/2004 01:00'!
updateUrl: aUrl
! !

!WAPresenter methodsFor: 'tree' stamp: 'avi 3/27/2004 20:59'!
withNextPresentersDo: aBlock
	aBlock value: self.
	self nextPresentersDo: [:ea | ea withNextPresentersDo: aBlock]! !

Object subclass: #WAProcessMonitor
	instanceVariableNames: 'mutex process responseSem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAProcessMonitor class methodsFor: 'instance creation' stamp: 'pmm 4/18/2006 20:17'!
new
	^ self basicNew initialize! !

!WAProcessMonitor methodsFor: 'mutual exclusion' stamp: 'avi 1/16/2005 00:38'!
critical: aBlock ifError: errorBlock
	|value|
	mutex critical:
		[responseSem := Semaphore new.
		process := [[value := aBlock on: Error do: errorBlock]
			ensure: [responseSem signal]] fork.
		responseSem wait].
	process := nil.
	^ value! !

!WAProcessMonitor methodsFor: 'initialization' stamp: 'mb 4/23/2006 21:39'!
initialize
	mutex := Semaphore forMutualExclusion! !

!WAProcessMonitor methodsFor: 'controlling' stamp: 'avi 1/16/2005 00:38'!
terminate
	process ifNotNil: [process terminate]! !

Object subclass: #WARadioGroup
	instanceVariableNames: 'canvas key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WARadioGroup class methodsFor: 'accessing' stamp: 'ac 7/6/2005 11:30'!
canvas: aRenderCanvas
	^ self basicNew initializeWithCanvas: aRenderCanvas! !

!WARadioGroup methodsFor: 'initialize-release' stamp: 'ac 7/6/2005 11:31'!
initializeWithCanvas: aRenderCanvas
	canvas := aRenderCanvas.
	key := aRenderCanvas callbacks registerDispatchCallback.! !

!WARadioGroup methodsFor: 'accessing' stamp: 'ac 7/6/2005 11:32'!
key
	^ key! !

!WARadioGroup methodsFor: 'public api' stamp: 'ac 7/6/2005 11:31'!
radioButton
	^ canvas radioButton group: self! !

Object subclass: #WAReadWriteLock
	instanceVariableNames: 'sem mutex readers'
	classVariableNames: 'Global'
	poolDictionaries: ''
	category: 'Seaside-Utilities-Squeak'!

!WAReadWriteLock class methodsFor: 'instance creation' stamp: 'avi 11/3/2005 00:38'!
global
	^ Global ifNil: [Global := self new]! !

!WAReadWriteLock class methodsFor: 'instance creation' stamp: 'lr 5/3/2006 09:30'!
new
	^ self basicNew initialize! !

!WAReadWriteLock methodsFor: 'initialization' stamp: 'avi 11/3/2005 00:37'!
initialize
	sem := Semaphore forMutualExclusion.
	mutex := Semaphore forMutualExclusion.
	readers := 0! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:33'!
lockForReading
	mutex critical:
		[readers = 0 ifTrue: [sem wait].
		readers := readers + 1]! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:34'!
lockForWriting
	sem wait! !

!WAReadWriteLock methodsFor: 'model' stamp: 'avi 11/3/2005 00:35'!
read: aBlock
	self lockForReading.
	^ aBlock ensure: [self unlockForReading]! !

!WAReadWriteLock methodsFor: 'accessing' stamp: 'avi 11/3/2005 00:39'!
readers
	^ readers! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:33'!
unlockForReading
	mutex critical:
		[readers := readers - 1.
		readers = 0 ifTrue: [sem signal]]! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:34'!
unlockForWriting
	sem signal! !

!WAReadWriteLock methodsFor: 'filter streaming' stamp: 'avi 11/3/2005 00:35'!
write: aBlock
	self lockForWriting.
	^ aBlock ensure: [self unlockForWriting]! !

Object subclass: #WARender
	instanceVariableNames: 'root context request url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARender methodsFor: 'convenience' stamp: 'avi 11/27/2005 17:29'!
application
	^ self session application! !

!WARender methodsFor: 'rendering' stamp: 'lr 11/22/2006 11:07'!
buildDocRoot
	| docRoot |
	docRoot := WARenderedHtmlRoot context: context.
	docRoot resourceBaseUrl: self application resourceBaseUrl.
	docRoot bodyAttributes at: 'onload' append: 'onLoad()' separator: ';'.
  	self session updateRoot: docRoot.
	root visiblePresentersDo: [:each | each updateRoot: docRoot].
	^ docRoot! !

!WARender methodsFor: 'rendering' stamp: 'mb 8/18/2006 10:28'!
buildResponse
	| response document |
	self updateUrl: url.
	context actionUrl: url. 
	response := self newResponse.
	response headerAt: 'Cache-Control' put: 'No-cache'.
	document := self session outputDocumentClass root: self buildDocRoot.
	document stream: response stream.
	context document: document.
	root decorationChainDo: [:ea | ea renderWithContext: context].		
	self writeOnLoadOn: document.
	document close.
	^ response! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:31'!
go
	self withPageExpiredHandler:
		[self withRenderNowHandler: [self render].
		self shouldRedirect ifTrue: [self redirect]]! !

!WARender methodsFor: 'rendering' stamp: 'avi 1/6/2006 14:02'!
newResponse
	| s |
	s := self session currentRequest ifNotNilDo: [:r | r responseStream].
	^ s
		ifNil: [WAResponse new]
		ifNotNil: [WAStreamResponse new stream: s]! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:48'!
processCallbacks
	| lastPosition callbackStream |
	callbackStream := context callbackStreamForRequest: request.
	lastPosition := nil.
	[callbackStream position = lastPosition] whileFalse:
		[lastPosition := callbackStream position.
		root decorationChainDo: [:ea | ea processCallbackStream: callbackStream]].
	callbackStream atEnd
		ifTrue: [WARenderNotification raiseSignal]
		ifFalse: [self unprocessedCallbacks: callbackStream upToEnd].! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:37'!
redirect	
	self session respond:
		[:u |
		self updateUrl: u.
		WAResponse redirectTo: u displayString]! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:34'!
render
	self session clearJumpTo.
	context := WARenderingContext new request: self session currentRequest.
	request := self session respond: [:u | url := u.  self buildResponse].
	self processCallbacks! !

!WARender methodsFor: 'accessing' stamp: 'avi 11/27/2005 17:30'!
root: aComponent
	root := aComponent! !

!WARender methodsFor: 'convenience' stamp: 'avi 11/27/2005 17:29'!
session
	^ WACurrentSession value! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:38'!
shouldRedirect
	^ request isGet not or: [(request fields includesKey: '_n') not]! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:29'!
unprocessedCallbacks: aCollection
	| owners |
	owners := (aCollection collect: [:ea | ea owner]) asSet asArray.
	self error: 'Components not found while processing callbacks: ', owners displayString! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:29'!
updateUrl: aUrl
	root visiblePresentersDo: [:c | c updateUrl: aUrl]! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:29'!
withPageExpiredHandler: aBlock
	^ aBlock on: WAPageExpired do: [:n |]! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:29'!
withRenderNowHandler: aBlock
	^ aBlock on: WARenderNotification do: [:n | n]! !

!WARender methodsFor: 'rendering' stamp: 'mb 4/7/2007 07:25'!
writeOnLoadOn: anHtmlDocument 
	| attributes |
	attributes := WAHtmlAttributes new.
	attributes at: 'type' put: 'text/javascript'.
	anHtmlDocument openTag: 'script' attributes: attributes.
	anHtmlDocument text: '/*<!![CDATA[*/function onLoad(){'.
	self session onLoadScripts
		do: [:each | anHtmlDocument text: each displayString]
		separatedBy: [anHtmlDocument text: ';'].
	anHtmlDocument text: '}/*]]>*/'.
	anHtmlDocument closeTag: 'script'.
	self session clearLoadScripts! !

Object subclass: #WARenderLoop
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARenderLoop methodsFor: 'convenience' stamp: 'mb 4/23/2007 14:52'!
application
	"Answer the application to which this entry point is associated."


	^ self session application! !

!WARenderLoop methodsFor: 'as yet unclassified' stamp: 'avi 5/8/2004 13:58'!
basicRoot: aComponent
	root := aComponent! !

!WARenderLoop methodsFor: 'call' stamp: 'avi 5/8/2004 14:00'!
call: aComponent
	^ self call: aComponent withToolFrame: true! !

!WARenderLoop methodsFor: 'call' stamp: 'avi 5/8/2004 13:59'!
call: aComponent withToolFrame: aBoolean
	aBoolean ifTrue: [self root: aComponent] ifFalse: [self basicRoot: aComponent].
	aComponent onAnswer: [:v | ^ v].
	self run! !

!WARenderLoop methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:38'!
root: aComponent
	self basicRoot: (self application deploymentMode
		ifFalse: [ WAToolFrame on: aComponent ]
		ifTrue: [ aComponent ])! !

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:37'!
run
	[(WARender new root: root) go] repeat! !

!WARenderLoop methodsFor: 'convenience' stamp: 'mb 4/23/2007 14:52'!
session
	"Answer the session to which this entry point is associated."


	^ WACurrentSession value! !

Object subclass: #WARenderingContext
	instanceVariableNames: 'actionUrl count callbacks document mode request response properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WARenderingContext class methodsFor: 'instance creation' stamp: 'avi 3/25/2004 02:21'!
new
	^ self basicNew initialize! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
actionUrl
	"Answer the value of actionUrl"

	^ actionUrl! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 11/7/2005 13:13'!
actionUrl: anObject
	actionUrl := anObject! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/8/2004 00:42'!
advanceKey
	| key |
	key := self nextKey.
	self increaseKey.
	^ key! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'lr 4/19/2006 08:05'!
callbackAt: aString
	^ callbacks at: aString ifAbsent: [ ]! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/8/2004 02:01'!
callbackStreamForRequest: aRequest
	^ WACallbackStream callbacks: callbacks request: aRequest! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/7/2004 22:17'!
callbacksFor: anObject
	^ WACallbackRegistry context: self owner: anObject! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
clearMode
	mode := nil! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 3/27/2006 10:42'!
count
	^ count! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 3/27/2006 10:42'!
count: anInteger
	count := anInteger! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
debugMode
	mode := #debug! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document
	"Answer the value of document"

	^ document! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document: anObject
	"Set the value of document"

	document := anObject! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'mb 11/27/2005 19:22'!
increaseKey
	count contents: count contents + 1! !

!WARenderingContext methodsFor: 'initialize-release' stamp: 'mb 11/27/2005 19:22'!
initialize
	count := ValueHolder new contents: 1.
	callbacks := Dictionary new
! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:20'!
isDebugMode
	^ mode = #debug! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'mb 3/9/2006 18:07'!
nextKey
	"See discussion on VWNC
	Some VW users have overriden #displayString to answer a Text object.
	#asString works fine here since the count held by the ValueHolder is a Number"
	^ count contents asString
! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
properties
	^ properties ifNil: [properties := Dictionary new]! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
propertyAt: key ifAbsent: aBlock
	^ self properties at: key ifAbsent: aBlock! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
propertyAt: key put: value
	^ self properties at: key put: value! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:52'!
registry
	^ WACurrentSession value application! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:43'!
request
	^ request! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:43'!
request: aRequest
	request := aRequest! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:00'!
response
	^ response! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:00'!
response: aResponse
	response := aResponse! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 9/2/2004 14:46'!
storeCallback: aCallback	
	| key |
	key := self advanceKey.
	callbacks at: (aCallback convertKey: key) put: aCallback.
	^ key! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:04'!
urlForDocument: anObject
	^ self urlForDocument: anObject mimeType: nil
! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:02'!
urlForDocument: anObject mimeType: mimeString
	^ self urlForDocument: anObject mimeType: mimeString fileName: nil! !

!WARenderingContext methodsFor: 'documents' stamp: 'mbany 4/14/2005 12:14'!
urlForDocument: anObject mimeType: mimeType fileName: fileName
	^ (self registry urlForRequestHandler:
		(WADocumentHandler
			document: anObject
			mimeType: mimeType
			fileName: fileName)) displayString! !

Object subclass: #WAReportColumn
	instanceVariableNames: 'clickBlock formatBlock hasTotal title sortBlock valueBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAReportColumn class methodsFor: 'instance creation' stamp: 'pmm 4/18/2006 20:17'!
new
	^ self basicNew initialize! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'mb 5/30/2006 12:13'!
renderBlock: aBlock title: aString
	^ self new
		title: aString;
		valueBlock: aBlock;
		yourself! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol
	^ self selector: aSymbol title: aSymbol capitalized! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol title: aString
	^ self selector: aSymbol title: aString onClick: nil! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'pmm 4/19/2006 17:42'!
selector: aSymbol title: aString onClick: aBlock
	^ self new
		title: aString;
		selector: aSymbol;
		clickBlock: aBlock;
		yourself! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/27/2002 00:05'!
canChoose
	^ clickBlock notNil! !

!WAReportColumn methodsFor: 'rendering' stamp: 'mb 5/30/2006 11:49'!
canRender
	^valueBlock numArgs > 1! !

!WAReportColumn methodsFor: 'public' stamp: 'mb 5/30/2006 12:08'!
canSort
	^self canRender not and: [sortBlock notNil].! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 1/16/2003 16:06'!
chooseRow: row
	^ clickBlock value: row! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/28/2002 14:02'!
clickBlock: aBlock
	clickBlock := aBlock! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:03'!
columnClickBlock: aBlock
	self clickBlock: [:r | aBlock value: (self valueForRow: r)]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
formatBlock: anObject
	formatBlock := anObject! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:29'!
hasTotal: aBoolean
	hasTotal := aBoolean ! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
index: aNumber
	valueBlock := [:row | row at: aNumber]! !

!WAReportColumn methodsFor: 'initialize-release' stamp: 'mbany 4/14/2005 12:15'!
initialize
	formatBlock := [:x | x displayString].
	sortBlock := [:a :b | a <= b].
	valueBlock := [:row | nil].
	clickBlock := nil.
	title := 'Untitled'.
	hasTotal := false.! !

!WAReportColumn methodsFor: 'rendering' stamp: 'mb 5/30/2006 11:47'!
renderValue: anObject on: html
	valueBlock value: anObject value: html! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
selector: aSymbol
	valueBlock := [:row | row perform: aSymbol]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
sortBlock: anObject
	sortBlock := anObject! !

!WAReportColumn methodsFor: 'public' stamp: 'avi 9/18/2003 16:43'!
sortRows: anArray
	|assocs|
	assocs := anArray collect: [:ea | ea -> (self valueForRow: ea)].
	assocs := assocs asSortedCollection: [:a :b | sortBlock value: a value value: b value].
	^ assocs collect: [:ea | ea key]! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
textForRow: row
	^ formatBlock value: (self valueForRow: row)! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:50'!
title
	^title! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
title: aString
	title := aString! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 11/12/2002 14:31'!
totalForRows: aCollection
	^ hasTotal
		ifFalse: ['']
		ifTrue: [formatBlock value: (aCollection detectSum: [:r | self valueForRow: r])]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
valueBlock: aBlock
	valueBlock := aBlock! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
valueForRow: row
	^ valueBlock value: row! !

Object subclass: #WARequest
	instanceVariableNames: 'url fields headers cookies method nativeRequest responseStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WARequest class methodsFor: 'as yet unclassified' stamp: 'avi 8/29/2005 21:19'!
blankRequest
	^ self
			method: 'GET'
			url: ''
			headers: Dictionary new
			fields: Dictionary new
			cookies: Dictionary new! !

!WARequest class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 19:34'!
method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict
	^ self new setMethod: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict! !

!WARequest class methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 10:57'!
method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict nativeRequest: anObject
	^ (self method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict)
		nativeRequest: anObject;
		yourself! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:26'!
accept
	^ self headerAt: 'accept'! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:28'!
acceptCharset
	^ self headerAt: 'accept-charset'! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:27'!
acceptEncoding
	^ self headerAt: 'accept-encoding'! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:27'!
acceptLanguage
	^ self headerAt: 'accept-language'! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 13:37'!
at: key
	^ fields at: key! !

!WARequest methodsFor: 'accessing' stamp: 'JF 5/16/2003 09:40'!
at: key ifAbsent: aBlock
	^ fields at: key ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'ac 11/12/2005 00:46'!
at: key ifPresent: aBlock
	^ fields at: key ifPresent: aBlock! !

!WARequest methodsFor: 'private' stamp: 'ab 1/13/2003 22:40'!
authorization
	^ (self headerAt: 'Authorization' ifAbsent: [self headerAt: 'authorization'])
		ifNotNilDo: [:auth | self decodeAuthorization: auth]! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:15'!
cookies
	^ cookies ifNil: [cookies := Dictionary new]! !

!WARequest methodsFor: 'private' stamp: 'avi 9/21/2003 18:28'!
decodeAuthorization: aString
	^ SeasidePlatformSupport base64Decode: (aString findTokens: ' ') last! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 12:51'!
fields
	^ fields! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey
	^ self headerAt: aKey ifAbsent: []! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey ifAbsent: aBlock
	^ headers at: aKey ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:16'!
headers
	^ headers! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/29/2006 07:28'!
host
	^ self headerAt: 'host'! !

!WARequest methodsFor: 'testing' stamp: 'mb 3/31/2006 09:41'!
includesKey: key
	^ fields includesKey: key! !

!WARequest methodsFor: 'testing' stamp: 'pmm 9/12/2006 18:42'!
isFromIE
	"this is extremely unreliable"
	| tokens |
	tokens := (headers at: 'user-agent') findTokens: ' '.
	^(tokens includes: 'MSIE') and: [ (tokens includes: 'Opera') not ]! !

!WARequest methodsFor: 'testing' stamp: 'avi 3/22/2004 12:58'!
isGet
	^ self method asUppercase = 'GET'! !

!WARequest methodsFor: 'testing' stamp: 'avi 5/9/2005 13:13'!
isPrefetch
	^ (self headerAt: 'HTTP_X_MOZ') = 'prefetch'! !

!WARequest methodsFor: 'testing' stamp: 'lr 7/3/2006 09:25'!
isXmlHttpRequest
	^ (self headerAt: 'x-requested-with') = 'XMLHttpRequest'! !

!WARequest methodsFor: 'accessing' stamp: 'ab 8/26/2003 19:33'!
method
	^ method! !

!WARequest methodsFor: 'accessing' stamp: 'avi 4/28/2004 13:43'!
nativeRequest
	^ nativeRequest! !

!WARequest methodsFor: 'accessing' stamp: 'avi 4/28/2004 13:43'!
nativeRequest: aRequest
	nativeRequest := aRequest! !

!WARequest methodsFor: 'accessing' stamp: 'ab 12/30/2002 17:42'!
password
	^ self authorization ifNotNilDo: [:auth | auth copyAfter: $:]! !

!WARequest methodsFor: 'accessing-headers' stamp: 'ac 6/17/2006 16:28'!
referer
	^ self headerAt: 'referer'! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:23'!
responseStream
	^ responseStream! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:23'!
responseStream: aStream
	responseStream := aStream! !

!WARequest methodsFor: 'private' stamp: 'avi 3/19/2004 13:52'!
setMethod: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict
	method := methodString.
	url := urlString.
	headers := headDict.
	fields := fieldDict.
	cookies := cookieDict! !

!WARequest methodsFor: 'accessing' stamp: 'ab 5/26/2003 00:54'!
url
	^ url! !

!WARequest methodsFor: 'accessing' stamp: 'ab 12/30/2002 17:42'!
user
	^ self authorization ifNotNilDo: [:auth | auth copyUpTo: $:]! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:26'!
userAgent
	^ self headerAt: 'user-agent'! !

Object subclass: #WARequestHandler
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WARequestHandler subclass: #WADocumentHandler
	instanceVariableNames: 'document mimeDocument mimeType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

!WADocumentHandler class methodsFor: 'public api' stamp: 'avi 11/3/2003 12:23'!
document: anObject mimeType: mimeString fileName: fileString
	^ self basicNew initializeWithDocument: anObject mimeType: mimeString fileName: fileString! !

!WADocumentHandler methodsFor: 'comparing' stamp: 'lr 2/12/2007 19:38'!
= other
	^ other species = self species
		and: [ other document = self document
		and: [ other mimeType = self mimeType ] ]! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'ab 2/12/2003 13:41'!
document
	^ document! !

!WADocumentHandler methodsFor: 'actions' stamp: 'ab 8/17/2003 12:43'!
handleRequest: aRequest
	^ self response! !

!WADocumentHandler methodsFor: 'comparing' stamp: 'ab 8/17/2003 12:42'!
hash
	^ self document hash bitXor: self mimeType hash! !

!WADocumentHandler methodsFor: 'initialization' stamp: 'lr 2/12/2007 19:38'!
initializeWithDocument: anObject mimeType: mimeString fileName: fileString
	document := anObject.
	mimeType := mimeString.
	fileName := fileString! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:37'!
mimeDocument
	^ mimeDocument ifNil: [ mimeDocument := document asMIMEDocumentType: mimeType ]! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'ab 8/24/2003 18:48'!
mimeType
	^ mimeType! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:37'!
response
	| response |
	response := WAResponse new.
	response contents: self mimeDocument contentStream text.
	response contentType: (mimeType ifNil: [self mimeDocument contentType]).
	response headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT'.
	fileName ifNotNil: [ response attachmentWithFileName: fileName ].
	^ response! !

WARequestHandler subclass: #WAEntryPoint
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WAEntryPoint subclass: #WADispatcher
	instanceVariableNames: 'entryPoints defaultName lastUpdate version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WADispatcher class
	instanceVariableNames: 'default'!

WADispatcher class
	instanceVariableNames: 'default'!

!WADispatcher class methodsFor: 'accessing' stamp: 'mb 2/22/2007 09:40'!
default
	^ default
		ifNil: [default := self named: SeasidePlatformSupport defaultDispatcherName]! !

!WADispatcher class methodsFor: 'accessing' stamp: 'lr 11/16/2006 18:39'!
description
	^ 'Directory'! !

!WADispatcher class methodsFor: 'initialization' stamp: 'mb 2/22/2007 09:35'!
resetAll
	"To have this todo list somewhere, 
	May be used in the WADispatcher tests"
	default := nil.
	WAFileHandler initialize.
	WAFileHandler default.
	WAComponent allSubclasses do: [:ea | ea initialize].
! !

!WADispatcher methodsFor: 'private' stamp: 'mb 2/21/2007 18:48'!
beAwareOfChangeOf: anAspectSymbol with: aParameter from: anEntryPoint 
	(anEntryPoint == self 
		and: [anAspectSymbol == #name]) ifTrue: [^ self].
	"Here when anything has changed but the name in the
	receiver"
	version := self version + 1.
	lastUpdate := TimeStamp now.
	self changed! !

!WADispatcher methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:53'!
configurationComponent
	^ WADispatcherEditor new dispatcher: self! !

!WADispatcher methodsFor: 'accessing' stamp: 'lr 2/12/2007 20:07'!
defaultName
	^ defaultName! !

!WADispatcher methodsFor: 'accessing' stamp: 'mb 2/17/2007 23:44'!
defaultName: aString
	defaultName := aString.
	self announceChangeOf: #defaultName with: aString! !

!WADispatcher methodsFor: 'accessing' stamp: 'lr 2/12/2007 21:44'!
entryPointAt: aString
	^ (aString findTokens: '/') inject: self into: [ :dispatcher :token | dispatcher entryPoints at: token ]! !

!WADispatcher methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:35'!
entryPoints
	^ entryPoints! !

!WADispatcher methodsFor: 'processing' stamp: 'lr 2/12/2007 20:38'!
handleRequest: aRequest
	aRequest isPrefetch 
		ifTrue: [ ^ WAResponse forbidden: aRequest url ].
	^ (self handlerForRequest: aRequest)
		handleRequest: aRequest! !

!WADispatcher methodsFor: 'processing' stamp: 'lr 2/12/2007 20:02'!
handlerForRequest: aRequest
	^ self handlerForRequest: aRequest relativeTo: self basePath! !

!WADispatcher methodsFor: 'processing' stamp: 'lr 2/12/2007 23:31'!
handlerForRequest: aRequest relativeTo: aString
	| fullUrl relativeUrl handlerName |
	fullUrl := aRequest url.
	(aString isEmpty or: [ fullUrl beginsWith: aString ]) ifTrue: [
		relativeUrl := fullUrl allButFirst: aString size.
		handlerName := (relativeUrl notEmpty and: [ relativeUrl first = $/ ]) 
			ifTrue: [ (relativeUrl findTokens: '/') at: 1 ifAbsent: [ self defaultName ] ]
			ifFalse: [ self defaultName ].
		^ self entryPoints at: handlerName ifAbsent: [
			self entryPoints 
				at: self defaultName 
				ifAbsent: [ WANotFoundHandler new ] ] ].
       ^ WANotFoundHandler new! !

!WADispatcher methodsFor: 'initialization' stamp: 'mb 2/18/2007 00:03'!
initialize
	super initialize.
	entryPoints := Dictionary new.
	version := 0.! !

!WADispatcher methodsFor: 'testing' stamp: 'lr 2/12/2007 20:09'!
isDeployed
	^ self entryPoints anySatisfy: [ :each | each isDeployed ]! !

!WADispatcher methodsFor: 'testing' stamp: 'mb 5/26/2006 08:51'!
isDispatcher
	^ true! !

!WADispatcher methodsFor: 'testing' stamp: 'lr 2/12/2007 20:59'!
isRoot
	^ self parent isNil! !

!WADispatcher methodsFor: 'accessing' stamp: 'mb 2/17/2007 23:39'!
lastUpdate
	^ lastUpdate! !

!WADispatcher methodsFor: 'copying' stamp: 'mb 2/17/2007 01:31'!
postCopy
	super postCopy.
	entryPoints := entryPoints valuesCollect: [ :each | each copy setParent: self ]! !

!WADispatcher methodsFor: 'registration' stamp: 'mb 2/17/2007 23:45'!
register: anEntryPoint
	anEntryPoint name
		ifNil: [ self error: 'Unable to add unnamed entry point.' ].
	entryPoints 
		at: anEntryPoint name 
		put: (anEntryPoint setParent: self).
	self announceChangeOf: #entryPoint with: #add->anEntryPoint.
	^anEntryPoint.! !

!WADispatcher methodsFor: 'private' stamp: 'lr 2/19/2007 12:21'!
trimForDeployment
	(self entryPoints reject: [ :each | each isDeployed ])
		do: [ :each | self unregister: each ].
	(self entryPoints select: [ :each | each isDispatcher ])
		do: [ :each | each trimForDeployment ]! !

!WADispatcher methodsFor: 'registration' stamp: 'mb 2/17/2007 23:45'!
unregister: anEntryPoint
	entryPoints removeKey: anEntryPoint name ifAbsent: [ ^ nil ].
	self announceChangeOf: #entryPoint with: #add->anEntryPoint.
	^ anEntryPoint unregistered.! !

!WADispatcher methodsFor: 'accessing' stamp: 'mb 2/21/2007 18:48'!
version
	^ version ifNil: [ version := 0 ]! !

!WAEntryPoint class methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:54'!
concreteSubclasses
	^ self allSubclasses reject: [ :each | each isAbstract ]! !

!WAEntryPoint class methodsFor: 'accessing' stamp: 'ab 8/27/2003 00:14'!
description
	^ nil! !

!WAEntryPoint class methodsFor: 'testing' stamp: 'ab 8/27/2003 00:14'!
isAbstract
	^ self description isNil! !

!WAEntryPoint class methodsFor: 'instance-creation' stamp: 'lr 2/12/2007 19:56'!
named: aString
	^ self new setName: aString! !

!WAEntryPoint methodsFor: 'private' stamp: 'mb 2/17/2007 23:42'!
announceChangeOf: anAspectSymbol with: aParameter
	"Short-circuit the dependency mechanics"
	self rootDispatcher isNil ifTrue: [^nil "Discard this change"].
	self rootDispatcher beAwareOfChangeOf: anAspectSymbol with: aParameter from: self! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'mb 2/18/2007 01:30'!
basePath
	^ self parent isNil
		ifTrue: [self name isEmpty
				ifTrue: ['']
				ifFalse: ['/' , self name]]
		ifFalse: [self parent basePath , '/' , self name]! !

!WAEntryPoint methodsFor: 'public' stamp: 'lr 2/12/2007 20:53'!
baseUrl
	^ WAUrl new
		addToPath: self basePath;
		yourself! !

!WAEntryPoint methodsFor: 'public' stamp: 'ab 8/26/2003 21:48'!
configurationComponent
	^ nil! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:21'!
description
	^ self class description! !

!WAEntryPoint methodsFor: 'testing' stamp: 'mb 5/26/2006 08:50'!
isEntryPoint
	^ true! !

!WAEntryPoint methodsFor: 'testing' stamp: 'mb 2/17/2007 23:42'!
isRoot
	^false! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:50'!
name
	^ name! !

!WAEntryPoint methodsFor: 'printing' stamp: 'lr 2/12/2007 21:48'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' named: '; print: self name! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'mb 2/17/2007 23:41'!
rootDispatcher
	self isRoot ifTrue: [^self].
	self parent isNil ifTrue: [^nil].
	^self parent rootDispatcher.! !

!WAEntryPoint methodsFor: 'initialization' stamp: 'mb 2/17/2007 23:46'!
setName: aString
	name := aString.
	self announceChangeOf: #name with: aString! !

WAEntryPoint subclass: #WAFileHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WAFileHandler class
	instanceVariableNames: 'default'!

WAFileHandler class
	instanceVariableNames: 'default'!

!WAFileHandler class methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:47'!
default
	^ default ifNil: [ default := self registerAsHandler: 'files' ]! !

!WAFileHandler class methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:25'!
description
	^ 'Files'! !

!WAFileHandler class methodsFor: 'class initialization' stamp: 'mb 2/15/2007 02:24'!
initialize
	"This is just for the 2.7 version, can be removed later"
	
	default := nil! !

!WAFileHandler class methodsFor: 'testing' stamp: 'pmm 4/18/2006 21:15'!
isAbstract
	^ false! !

!WAFileHandler class methodsFor: 'initialization' stamp: 'lr 2/18/2007 12:47'!
registerAsHandler: aString
	^ WADispatcher default register: (self named: aString)! !

!WAFileHandler methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:18'!
configurationComponent
	^ WAFileHandlerEditor new fileHandler: self! !

!WAFileHandler methodsFor: 'processing' stamp: 'lr 2/18/2007 12:16'!
handleRequest: aRequest
	^ self
		responseAt: (aRequest url findTokens: $/)
		ifAbsent: [ self notFound: aRequest url ]! !

!WAFileHandler methodsFor: 'testing' stamp: 'lr 2/18/2007 12:16'!
isDeployed
	^ true! !

!WAFileHandler methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:15'!
libraries
	^ self libraryRootClasses gather: [ :each | each allSubclasses ]! !

!WAFileHandler methodsFor: 'private' stamp: 'lr 2/18/2007 12:16'!
librariesDo: aOneArgumentBlock
	self libraryRootClasses do: [ :each | each allSubclassesDo: aOneArgumentBlock ]! !

!WAFileHandler methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:18'!
libraryAt: aSymbol ifAbsent: aBlock
	self librariesDo: [ :each |
		each name = aSymbol
			ifTrue: [ ^ each ] ].
	^ aBlock value! !

!WAFileHandler methodsFor: 'private' stamp: 'lr 2/18/2007 12:16'!
libraryRootClasses
	^ Array
		with: WAFileLibrary
		with: WAScriptLibrary
		with: WAStyleLibrary! !

!WAFileHandler methodsFor: 'private' stamp: 'lr 2/18/2007 12:17'!
notFound: aString
	^ WAResponse notFound: aString! !

!WAFileHandler methodsFor: 'private' stamp: 'lr 2/18/2007 12:18'!
responseAt: aPath ifAbsent: aBlock
	| libraryName fileName library |
	libraryName := aPath at: aPath size - 1.
	fileName := aPath last.
	library := self
		libraryAt: libraryName asSymbol
		ifAbsent: [ ^ aBlock value ].
	^ library default
		documentAt: fileName
		ifAbsent: aBlock! !

WAEntryPoint subclass: #WARegistry
	instanceVariableNames: 'keysByHandler handlersByKey mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WARegistry subclass: #WAApplication
	instanceVariableNames: 'configuration libraries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAApplication class methodsFor: 'accessing' stamp: 'lr 11/16/2006 18:38'!
description
	^ 'Application'! !

!WAApplication methodsFor: 'adding' stamp: 'mb 3/9/2007 12:23'!
addLibrary: aClass
	aClass isNil ifTrue: [^aClass].
	self libraries add: aClass.
	self announceChangeOf: #library with: #add->aClass.
	^aClass! !

!WAApplication methodsFor: 'accessing' stamp: 'lr 2/12/2007 22:14'!
baseUrl
	| serverPath |
	serverPath := self serverPath.
	^ (serverPath isNil
		ifTrue: [ super baseUrl ]
		ifFalse: [ WAUrl new addToPath: serverPath ])
			scheme: self serverProtocol;
			hostname: self serverHostname;
			port: self serverPort;
			yourself! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 11/16/2005 23:45'!
configuration
	^ configuration ifNil: [configuration := WAUserConfiguration new addAncestor: self defaultAncestor] ! !

!WAApplication methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:34'!
configurationComponent
	^ WAApplicationEditor new application: self! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 11/16/2005 23:32'!
defaultAncestor
	"yes, breaking layering"
	^ WARenderLoopConfiguration new! !

!WAApplication methodsFor: 'accessing' stamp: 'pmm 2/14/2007 09:32'!
defaultLibraries
	^ Array with: WAStandardFiles! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:02'!
deploymentMode
	^ self preferenceAt: #deploymentMode! !

!WAApplication methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:21'!
description
	^ self rootComponent description! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
errorHandler
	^ self preferenceAt: #errorHandler! !

!WAApplication methodsFor: 'request handling' stamp: 'lr 2/12/2007 20:47'!
handleDefaultRequest: aRequest
	^ (self sessionClass new setParent: self) handleRequest: aRequest! !

!WAApplication methodsFor: 'request handling' stamp: 'lr 1/30/2007 23:21'!
handleExpiredRequest: aRequest
	| response |
	response := super handleExpiredRequest: aRequest.
	self useSessionCookie 
		ifTrue: [ response deleteCookieAt: self name ].
	^ response! !

!WAApplication methodsFor: 'request handling' stamp: 'pmm 9/12/2006 18:09'!
handleRequest: aRequest
	self useSessionCookie ifTrue: [
		aRequest cookies at: self name ifPresent: [ :value |
			aRequest fields at: self handlerField ifAbsentPut: [ value ] ] ].
	^ super handleRequest: aRequest! !

!WAApplication methodsFor: 'preferences' stamp: 'kph 9/30/2006 01:47'!
hasPreferenceGroup: aSymbol
	^ self configuration hasGroupNamed: aSymbol! !

!WAApplication methodsFor: 'testing' stamp: 'mb 4/5/2006 20:26'!
isApplication
	^true! !

!WAApplication methodsFor: 'testing' stamp: 'lr 2/18/2007 12:16'!
isDeployed
	^ self rootComponent isDeployed! !

!WAApplication methodsFor: 'accessing' stamp: 'avi 6/24/2004 00:29'!
libraries
	^ libraries ifNil: [libraries := OrderedCollection withAll: self defaultLibraries]! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
login
	^ self preferenceAt: #login! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
mainClass
	^ self preferenceAt: #mainClass! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
password
	^ self preferenceAt: #password! !

!WAApplication methodsFor: 'copying' stamp: 'lr 12/12/2006 11:18'!
postCopy
	super postCopy.
	configuration := configuration copy.
	libraries := libraries copy! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 1/31/2004 12:34'!
preferenceAt: aSymbol
	^ self configuration valueAt: aSymbol! !

!WAApplication methodsFor: 'preferences' stamp: 'mb 2/17/2007 23:43'!
preferenceAt: aSymbol put: anObject
	self configuration valueAt: aSymbol put: anObject.
	self announceChangeOf: #preference with: aSymbol->anObject.
	^anObject! !

!WAApplication methodsFor: 'removing' stamp: 'mb 3/9/2007 12:22'!
removeLibrary: aClass
	self libraries remove: aClass ifAbsent: [^aClass].
	self announceChangeOf: #library with: #remove->aClass.
	^aClass
! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:02'!
resourceBaseUrl
	^ self preferenceAt: #resourceBaseUrl! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
rootComponent
	^ self preferenceAt: #rootComponent! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
serverHostname
	^ self preferenceAt: #serverHostname! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:01'!
serverPath
	^ self preferenceAt: #serverPath! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
serverPort
	^ self preferenceAt: #serverPort! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
serverProtocol
	^ self preferenceAt: #serverProtocol! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:02'!
sessionClass
	^ self preferenceAt: #sessionClass
! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
sessionExpirySeconds
	^ self preferenceAt: #sessionExpirySeconds! !

!WAApplication methodsFor: 'request handling' stamp: 'lr 2/18/2007 12:33'!
updateRoot: anHtmlRoot
	anHtmlRoot title isEmpty 
		ifTrue: [ anHtmlRoot title: self basePath ].
	self libraries do: [ :each | each default updateRoot: anHtmlRoot ]! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:02'!
useSessionCookie
	^ self preferenceAt: #useSessionCookie! !

!WARegistry class methodsFor: 'initialization' stamp: 'JF 9/22/2003 20:15'!
clearAllHandlers
	self allSubInstances do: [:ea | ea clearHandlers]! !

!WARegistry methodsFor: 'private' stamp: 'mb 4/7/2007 01:53'!
clearHandlers
	| handlers |
	self mutex
		critical: [handlers := handlersByKey.
			handlersByKey := Dictionary new.
			keysByHandler := Dictionary new].
	(handlers notNil and: [handlers notEmpty])
		ifTrue:		
			[ [handlers
				do: [:ea | ea unregistered]] fixTemps fork ]! !

!WARegistry methodsFor: 'public' stamp: 'lr 2/12/2007 20:40'!
ensureKeyForHandler: anObject
	^ (self keyOrNilForHandler: anObject) ifNil: [ self registerRequestHandler: anObject ]! !

!WARegistry methodsFor: 'private' stamp: 'lr 2/22/2006 08:41'!
expiryPathFor: aRequest
	^ aRequest url! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:29'!
handleDefaultRequest: aRequest
	self subclassResponsibility! !

!WARegistry methodsFor: 'private' stamp: 'lr 2/3/2007 21:38'!
handleExpiredRequest: aRequest
	| url |
	aRequest isXmlHttpRequest
		ifTrue: [ ^ WAResponse new forbidden ].
	url := WAUrl new.
	url addToPath: (self expiryPathFor: aRequest).
	url takeServerParametersFromRequest: aRequest.
	aRequest isGet ifTrue: [
		aRequest fields keysAndValuesDo: [ :key :value |
			(url isSeasideField: key)
				ifFalse: [ url addParameter: key value: value ] ] ]. 
	^ WAResponse redirectTo: url displayString! !

!WARegistry methodsFor: 'private' stamp: 'mb 1/27/2006 15:52'!
handleKeyRequest: aRequest
	| key handler keyString |
	"Under some circumstances, HTTP fields are collections of values"
	key :=	[keyString := aRequest at: self handlerField.
			(keyString isKindOf: OrderedCollection) ifTrue: [keyString := keyString first].
			WAExternalID fromString: keyString] on: Error do: [:e | nil].
	handler := handlersByKey at: key ifAbsent: [nil].
	^ (handler notNil and: [handler isActive])
		ifTrue: [handler handleRequest: aRequest]
		ifFalse: [self handleExpiredRequest: aRequest]! !

!WARegistry methodsFor: 'public' stamp: 'lr 2/12/2007 20:40'!
handleRequest: aRequest
	^ (aRequest fields includesKey: self handlerField)
		ifTrue: [ self handleKeyRequest: aRequest ]
		ifFalse: [ self handleDefaultRequest: aRequest ]
! !

!WARegistry methodsFor: 'private' stamp: 'avi 3/22/2004 13:04'!
handlerField
	^ '_s'! !

!WARegistry methodsFor: 'private' stamp: 'pmm 11/2/2005 22:39'!
initialize
	super initialize.
	self clearHandlers.! !

!WARegistry methodsFor: 'private' stamp: 'pmm 2/13/2007 07:21'!
isSeasideField: aString
	^ aString notEmpty
		and: [ aString first = $_ ]! !

!WARegistry methodsFor: 'private' stamp: 'lr 2/12/2007 20:43'!
keyOrNilForHandler: anObject
	^ self mutex critical: [ keysByHandler at: anObject ifAbsent: [ nil ] ]! !

!WARegistry methodsFor: 'private' stamp: 'jf 3/4/2004 14:48'!
mutex
	^ mutex ifNil: [mutex := Semaphore forMutualExclusion]! !

!WARegistry methodsFor: 'copying' stamp: 'lr 2/16/2007 15:07'!
postCopy
	super postCopy.
	mutex := nil.
	self clearHandlers.! !

!WARegistry methodsFor: 'private' stamp: 'lr 2/12/2007 20:44'!
registerRequestHandler: anObject
	| key |
	key := WAExternalID new: 16.
	self shouldCollectHandlers 
		ifTrue: [ self unregisterExpiredHandlers ].
	self mutex critical: [
		handlersByKey at: key put: anObject.
		keysByHandler at: anObject put: key ].
	^ key! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:26'!
shouldCollectHandlers
	^ 10 atRandom = 1! !

!WARegistry methodsFor: 'private' stamp: 'mb 4/7/2007 01:46'!
unregisterExpiredHandlers
	| expired newHandlersByKey newKeysByHandler |
	expired := OrderedCollection new.
	newHandlersByKey := Dictionary new.
	newKeysByHandler := Dictionary new.
	self mutex
		critical: [handlersByKey
				keysAndValuesDo: [:key :value | value isActive
						ifTrue: [newHandlersByKey at: key put: value.
							newKeysByHandler at: value put: key]
						ifFalse: [expired add: value]].
			handlersByKey := newHandlersByKey.
			keysByHandler := newKeysByHandler].
	[expired
		do: [:ea | ea unregistered]] fixTemps fork! !

!WARegistry methodsFor: 'private' stamp: 'lr 2/12/2007 19:37'!
unregistered
	super unregistered.
	self clearHandlers ! !

!WARegistry methodsFor: 'public' stamp: 'lr 2/12/2007 20:46'!
urlForRequestHandler: anObject
	| key url |
	key := self ensureKeyForHandler: anObject.
	url := self baseUrl.
	url addParameter: self handlerField value: key displayString.
	^ url! !

WARequestHandler subclass: #WAExpiringHandler
	instanceVariableNames: 'lastAccess expired timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

!WAExpiringHandler methodsFor: 'defaults' stamp: 'avi 1/23/2004 12:20'!
defaultTimeoutSeconds
	^ 600! !

!WAExpiringHandler methodsFor: 'actions' stamp: 'avi 1/23/2004 12:18'!
expire
	expired := true! !

!WAExpiringHandler methodsFor: 'testing' stamp: 'lr 2/12/2007 19:41'!
expired
	^ expired! !

!WAExpiringHandler methodsFor: 'processing' stamp: 'avi 1/23/2004 14:08'!
handleRequest: aRequest
	lastAccess := Time totalSeconds.
	^ self incomingRequest: aRequest! !

!WAExpiringHandler methodsFor: 'processing' stamp: 'avi 1/23/2004 14:08'!
incomingRequest: aRequest
	self subclassResponsibility ! !

!WAExpiringHandler methodsFor: 'initialization' stamp: 'mb 4/23/2006 18:39'!
initialize
	super initialize.
	expired := false! !

!WAExpiringHandler methodsFor: 'testing' stamp: 'lr 2/12/2007 19:42'!
isActive
	^ self expired not and: [ self secondsSinceLastAccess < self timeoutSeconds ]! !

!WAExpiringHandler methodsFor: 'accessing' stamp: 'avi 1/23/2004 12:19'!
lastAccess
	^ lastAccess ifNil: [lastAccess := Time totalSeconds]! !

!WAExpiringHandler methodsFor: 'accessing' stamp: 'avi 1/23/2004 12:19'!
secondsSinceLastAccess
	^ Time totalSeconds - self lastAccess! !

!WAExpiringHandler methodsFor: 'accessing' stamp: 'avi 1/23/2004 12:20'!
timeoutSeconds
	^ timeout ifNil: [self defaultTimeoutSeconds]! !

!WAExpiringHandler methodsFor: 'accessing' stamp: 'avi 1/23/2004 12:20'!
timeoutSeconds: aNumber
	timeout := aNumber! !

WAExpiringHandler subclass: #WASession
	instanceVariableNames: 'continuations escapeContinuation monitor state currentRequest scripts jumpTo internalError cookiesEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WASession commentStamp: '<historical>' prior: 0!
I am a Seaside session. A new instance of me gets created when an user accesses an application for the first time and is persistent as long as the user is interacting with it.

This class is intended to be subclasses by applications that need custom state (like user). Custom state can be added by creating instance variables and storing it there. The session can be retrieved by #session if inside a component or task or by evaluating:
WACurrentSession value
See also WACurrentSession.

If the session has not been used for #defaultTimeoutSeconds, it is garbage collected by the system. To manually expire a session call #expire.

A good way to clear all sessions is the following code:

WARegistry clearAllHandlers.
Smalltalk garbageCollect!

WASession subclass: #WAExpirySession
	instanceVariableNames: ''
	classVariableNames: 'Created Unregistered'
	poolDictionaries: ''
	category: 'Seaside-Tests-Previous'!

!WAExpirySession class methodsFor: 'accessing' stamp: 'avi 9/30/2004 16:30'!
created
	^ Created! !

!WAExpirySession class methodsFor: 'class initialization' stamp: 'avi 9/30/2004 16:24'!
initialize
	self resetCounters! !

!WAExpirySession class methodsFor: 'actions' stamp: 'avi 9/30/2004 16:24'!
resetCounters
	Unregistered := 0.
	Created := 0.! !

!WAExpirySession class methodsFor: 'accessing' stamp: 'avi 9/30/2004 16:30'!
unregistered
	^ Unregistered! !

!WAExpirySession methodsFor: 'initialize-release' stamp: 'avi 9/30/2004 16:24'!
initialize
	super initialize.
	Created := Created + 1! !

!WAExpirySession methodsFor: 'subclass responsibilities' stamp: 'lr 2/12/2007 19:37'!
unregistered
	super unregistered.
	Unregistered := Unregistered + 1! !

!WASession methodsFor: 'accessing' stamp: 'avi 3/22/2004 13:04'!
actionField
	^ '_k'! !

!WASession methodsFor: 'responding' stamp: 'avi 2/3/2004 00:43'!
actionUrlForContinuation: aContinuation
	^ self actionUrlForKey: (continuations store: aContinuation)! !

!WASession methodsFor: 'responding' stamp: 'lr 2/12/2007 20:54'!
actionUrlForKey: aString 
	| url |
	url := self useSessionCookie
		ifTrue: [ self baseUrl ]
		ifFalse: [ self application urlForRequestHandler: self ].
	url takeServerParametersFromRequest: currentRequest.
	url addParameter: self actionField value: aString.
	jumpTo ifNotNil: [ url fragment: jumpTo ].
	^ url! !

!WASession methodsFor: 'scripts' stamp: 'avi 9/24/2005 18:42'!
addLoadScript: aString
	^ (scripts ifNil: [scripts := OrderedCollection new]) add: aString! !

!WASession methodsFor: 'accessing' stamp: 'lr 2/12/2007 20:50'!
application
	^ parent! !

!WASession methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:43'!
baseUrl
	^ self parent baseUrl! !

!WASession methodsFor: 'accessing' stamp: 'mb 12/22/2006 10:36'!
checkCookiesField
	^ '_ck'! !

!WASession methodsFor: 'cookies' stamp: 'mb 12/22/2006 10:46'!
checkForCookies
	| check |
	check := WAExternalID new displayString.
	self redirectWithCookie: ((WACookie new)
			key: check;
			value: 'yes';
			expireIn: (Duration seconds: 2);
			yourself).
	^ currentRequest cookies includesKey: check! !

!WASession methodsFor: 'scripts' stamp: 'avi 9/24/2005 21:09'!
clearJumpTo
	jumpTo := nil! !

!WASession methodsFor: 'scripts' stamp: 'avi 9/24/2005 20:00'!
clearLoadScripts
	scripts := nil! !

!WASession methodsFor: 'responding' stamp: 'ac 12/23/2004 04:09'!
closePopup
	^ self respond:
		[:url |
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: 'self.opener.location=self.opener.location';
			nextPutAll: '</script></html>';
			yourself]! !

!WASession methodsFor: 'responding' stamp: 'mbany 4/14/2005 11:55'!
closePopupAndContinue
	^ self respond:
		[:url |
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: 'self.opener.location=',url displayString printString;
			nextPutAll: '</script></html>';
			yourself]! !

!WASession methodsFor: 'responding' stamp: 'ac 9/27/2005 19:40'!
closePopupWithoutReloadingOpener
	^ self respond:
		[:url |
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: '</script></html>';
			yourself]! !

!WASession methodsFor: 'http' stamp: 'mb 1/12/2006 10:15'!
contentType
	^WAResponse defaultValueForContentType. "text/html; charset=utf-8"! !

!WASession methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:47'!
currentRequest
	^ currentRequest! !

!WASession methodsFor: 'expiring' stamp: 'mb 4/7/2007 01:20'!
defaultTimeoutSeconds
	^ (self application notNil
			and: [self application sessionExpirySeconds notNil])
		ifTrue: [self application sessionExpirySeconds]
		ifFalse: [super defaultTimeoutSeconds]
! !

!WASession methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:43'!
errorHandler
	^ self application errorHandler! !

!WASession methodsFor: 'request handling' stamp: 'dc 11/5/2006 12:29'!
fieldsAt: key
	^ self currentRequest at: key! !

!WASession methodsFor: 'request handling' stamp: 'dc 11/5/2006 12:29'!
fieldsAt: key ifAbsent: aBlock
	^ self currentRequest at: key ifAbsent: aBlock! !

!WASession methodsFor: 'request handling' stamp: 'dc 11/5/2006 12:29'!
fieldsAt: key ifPresent: aBlock
	^ self currentRequest at: key ifPresent: aBlock! !

!WASession methodsFor: 'cookies' stamp: 'pmm 9/12/2006 19:05'!
hasSessionCookie
	^currentRequest cookies includesKey: self sessionCookieName
	! !

!WASession methodsFor: 'request handling' stamp: 'lr 2/12/2007 20:47'!
incomingRequest: aRequest
	((aRequest fields includesKey: 'terminate')
		and: [self application deploymentMode not])
			ifTrue: [
				monitor terminate.
				^ WAResponse new nextPutAll: 'Process terminated'].
			
	^ (monitor
		critical: [ self responseForRequest: aRequest ]
		ifError: [ :error | internalError := WAResponse internalError: error ])
	ifNil:
		[ | resp |	
		resp := internalError.
		internalError := nil.
		resp ]! !

!WASession methodsFor: 'initializing' stamp: 'lr 2/12/2007 19:44'!
initialize
	super initialize.
	continuations := WALRUCache new.
	monitor := WAProcessMonitor new.
	state := WAStateRegistry new.
	cookiesEnabled := true! !

!WASession methodsFor: 'scripts' stamp: 'avi 9/24/2005 21:08'!
jumpToAnchor: aString
	jumpTo := aString! !

!WASession methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:44'!
mainClass
	^ self application mainClass! !

!WASession methodsFor: 'responding' stamp: 'lr 2/12/2007 22:08'!
newSessionUrl
	^ (self baseUrl takeServerParametersFromRequest: currentRequest) displayString! !

!WASession methodsFor: 'scripts' stamp: 'avi 9/24/2005 20:00'!
onLoadScripts
	^ scripts ifNil: [#()]! !

!WASession methodsFor: 'accessing' stamp: 'mb 8/18/2006 10:23'!
outputDocumentClass
	"To be subclassed as needed"
	^WAHtmlStreamDocument! !

!WASession methodsFor: 'expiring' stamp: 'avi 9/2/2004 16:28'!
pageExpired
	state restoreLastSnapshot.
	self redirectWithMessage: 'That page has expired.' delay: 3.
	WAPageExpired raiseSignal.
! !

!WASession methodsFor: 'responding' stamp: 'avi 5/18/2004 16:16'!
pageIntentionallyLeftBlank
	self returnResponse: WAResponse new! !

!WASession methodsFor: 'request handling' stamp: 'mb 12/22/2006 10:37'!
performRequest: aRequest
	| key continuation |
	key := aRequest fields at: self actionField
			ifAbsent: [^ self start: aRequest].
	((aRequest fields includesKey: self checkCookiesField) and: [aRequest cookies isEmpty]) 
		ifTrue: [cookiesEnabled := false].

	"Under some circumstances, HTTP fields are collections of values"
	(key isKindOf: OrderedCollection) ifTrue: [key := key first].
	continuation := continuations at: key 
			ifAbsent: [^ self unknownRequest: aRequest].
	continuation value: aRequest! !

!WASession methodsFor: 'responding' stamp: 'mbany 4/14/2005 11:55'!
redirect
	^ self respond: [:url | WAResponse redirectTo: url displayString]! !

!WASession methodsFor: 'responding' stamp: 'avi 5/18/2004 16:16'!
redirectTo: urlString
	self returnResponse: (WAResponse redirectTo: urlString)! !

!WASession methodsFor: 'cookies' stamp: 'avi 5/18/2004 22:57'!
redirectWithCookie: aCookie
	self redirectWithCookies: (Array with: aCookie)! !

!WASession methodsFor: 'cookies' stamp: 'mb 12/22/2006 15:21'!
redirectWithCookies: aCollection
	| response |
	self respond:
			[:url |
			url addParameter: self checkCookiesField value: 'y'.
			response := WAResponse redirectTo: url displayString.
			aCollection do: [:ea | response addCookie: ea].
			response]
! !

!WASession methodsFor: 'responding' stamp: 'mbany 4/14/2005 11:56'!
redirectWithMessage: aString delay: aNumber
	self respond:
		[:url |
		WAResponse
			refreshWithMessage: aString
			location: url displayString
			delay: aNumber].
! !

!WASession methodsFor: 'state' stamp: 'mb 4/23/2007 14:20'!
registerObjectForBacktracking: anObject
	"registers anObject for backtracking
	
	This means when you hit the back button the state of all the objects that are registered for backtracking will be reverted to the state they had when the page displayed was rendered.
	
	In general this should only be done for UI state and not model state.
	An example usage is a selection index of a report table.
	An other usage for this when the contents returned by #children change over time because your  store components in instance variables and change their content during the lifetime of a session."


	state registerObject: anObject! !

!WASession methodsFor: 'responding' stamp: 'mb 2/27/2006 13:08'!
respond: responseBlock
	|request snapshotHolder response oldEscape |
	snapshotHolder := ValueHolder new.
	oldEscape := escapeContinuation.
	escapeContinuation :=
		[:v |
		snapshotHolder contents: state snapshot.
		oldEscape value: v].
	request := 
	ResponseContinuation currentDo:
		[:cc ||url|
		url := self actionUrlForContinuation: cc.
		response := responseBlock value: url.
		self useSessionCookie
			ifTrue: 
				[response addCookie: self sessionCookie]
			ifFalse:
				[self hasSessionCookie ifTrue:
					[response deleteCookieAt: self sessionCookieName]].
		self returnResponse: response].
	state restoreSnapshot: snapshotHolder contents.
	^ request 
	! !

!WASession methodsFor: 'request handling' stamp: 'pmm 9/12/2006 19:06'!
responseForRequest: aRequest
	currentRequest := aRequest.
	^ self withEscapeContinuation: [
		WACurrentSession
			use: self
			during: [
				self withErrorHandler: [
					self performRequest: aRequest ] ] ]! !

!WASession methodsFor: 'responding' stamp: 'ab 6/15/2003 19:25'!
returnResponse: aResponse
	escapeContinuation value: aResponse! !

!WASession methodsFor: 'responding' stamp: 'avi 3/13/2004 01:21'!
script: aString
	self redirectWithMessage: '<script>', aString, '</script>' delay: 0! !

!WASession methodsFor: 'responding' stamp: 'mb 2/27/2006 13:00'!
sessionCookie
	^WACookie
		key: self sessionCookieName
		value: (self application ensureKeyForHandler: self) displayString! !

!WASession methodsFor: 'responding' stamp: 'mb 2/27/2006 13:00'!
sessionCookieName
	^self application name! !

!WASession methodsFor: 'request handling' stamp: 'avi 11/12/2005 21:37'!
start: aRequest
	self useSessionCookie ifTrue: [self redirectWithCookie: self sessionCookie].
	self mainClass new start: aRequest! !

!WASession methodsFor: 'request handling' stamp: 'avi 1/20/2006 01:41'!
unknownRequest: aRequest
	self start: aRequest! !

!WASession methodsFor: 'expiring' stamp: 'mb 4/7/2007 01:23'!
unregistered
	super unregistered.
	self expire
! !

!WASession methodsFor: 'responding' stamp: 'mb 4/23/2007 14:20'!
updateRoot: anHtmlRoot
	"This method is very similar to its brother in WAPresenter. It is suited for application wide settings like doctype and CSS or JS files that are always needed.
	
	Whenever you override this method don't forget to send super"


	self application updateRoot: anHtmlRoot! !

!WASession methodsFor: 'cookies' stamp: 'pmm 1/8/2007 12:16'!
useSessionCookie
	^cookiesEnabled and: [ self application useSessionCookie ]! !

!WASession methodsFor: 'request handling' stamp: 'avi 4/27/2004 14:25'!
withErrorHandler: aBlock
	^ [aBlock
		on: Error
		do: [:e | self errorHandler handleError: e. WAPageExpired raiseSignal]]
		on: Warning
		do: [:w | self errorHandler handleWarning: w. WAPageExpired raiseSignal]! !

!WASession methodsFor: 'request handling' stamp: 'avi 10/26/2004 15:40'!
withEscapeContinuation: aBlock
	^ EscapeContinuation currentDo:
			[:cc |
			escapeContinuation := cc.
			aBlock value.
			self pageIntentionallyLeftBlank]! !

WARequestHandler subclass: #WANotFoundHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

!WANotFoundHandler methodsFor: 'actions' stamp: 'avi 5/18/2004 16:16'!
handleRequest: aRequest
	^ WAResponse notFound: aRequest url! !

!WARequestHandler class methodsFor: 'instance-creation' stamp: 'pmm 4/19/2006 18:00'!
new
	^ self basicNew initialize! !

!WARequestHandler methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:33'!
description
	"Answer a descriptive text of the receiver."

	^ String new! !

!WARequestHandler methodsFor: 'processing' stamp: 'lr 2/12/2007 19:46'!
handleRequest: aRequest
	"Handle aRequest and answer a response."
	
	self subclassResponsibility! !

!WARequestHandler methodsFor: 'initialization' stamp: 'pmm 11/2/2005 23:17'!
initialize! !

!WARequestHandler methodsFor: 'testing' stamp: 'avi 7/23/2004 15:11'!
isActive
	^ true! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:49'!
isApplication
	^ false! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:49'!
isDispatcher
	^ false! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:48'!
isEntryPoint
	^ false! !

!WARequestHandler methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:33'!
parent
	"Answer the parent request handler of the receiver."
	
	^ parent! !

!WARequestHandler methodsFor: 'copying' stamp: 'lr 2/16/2007 15:06'!
postCopy
	super postCopy.
	parent := nil! !

!WARequestHandler methodsFor: 'initialization' stamp: 'lr 2/12/2007 20:50'!
setParent: aRequestHandler
	parent := aRequestHandler! !

!WARequestHandler methodsFor: 'processing' stamp: 'lr 2/12/2007 21:12'!
unregistered! !

Object subclass: #WAResponse
	instanceVariableNames: 'contentType headers cookies status stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 5/18/2004 16:14'!
basicAuthWithRealm: aString
	^ self new basicAuthenticationRealm: aString! !

!WAResponse class methodsFor: 'defaults' stamp: 'mb 3/12/2007 13:49'!
defaultHttpVersion
	^'HTTP/1.0'! !

!WAResponse class methodsFor: 'defaults' stamp: 'mb 1/12/2006 10:13'!
defaultValueForContentType
	^'text/html; charset=utf-8'! !

!WAResponse class methodsFor: 'instance creation' stamp: 'mb 6/1/2006 09:05'!
document: anObject mimeType: mimeType
	|doc|
	doc := anObject asMIMEDocumentType: mimeType.
	^ self new
		contentType: (mimeType ifNil: [doc contentType]);
		headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT';
		nextPutAll: doc content;
		yourself! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 9/22/2004 21:02'!
document: anObject mimeType: mimeString fileName: fileString
	^ (self document: anObject mimeType: mimeString)
		attachmentWithFileName: fileString;
		yourself! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 5/9/2005 13:14'!
forbidden: locationString
	^ self new
		forbidden;
		nextPutAll: '<h1> Error: you are forbidden to access "', locationString, '". </h1>';
		yourself! !

!WAResponse class methodsFor: 'instance creation' stamp: 'mb 3/23/2006 08:12'!
internalError: anError
	| response |
	response := self new internalError.
	response
		nextPutAll: '<h1> Internal Error</h1>';
		nextPutAll: '<h2>';
		nextPutAll: anError displayString;
		nextPutAll: '</h2>'.
	(SeasidePlatformSupport walkbackStringsFor: anError) do:
		[:eachLine | 
		response 
			nextPutAll: '<br>'; 
			nextPutAll: eachLine].
	^ response! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 5/18/2004 16:14'!
new
	^ self basicNew initialize! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 5/18/2004 16:15'!
notFound: locationString
	^ self new
		notFound;
		nextPutAll: '<h1> Error: "', locationString, '" not found. </h1>';
		yourself! !

!WAResponse class methodsFor: 'responding' stamp: 'avi 5/18/2004 16:15'!
redirectTo: locationString
	^ self new redirectTo: locationString! !

!WAResponse class methodsFor: 'instance creation' stamp: 'mbany 4/14/2005 12:50'!
refreshWithMessage: aString location: locationString delay: aNumber
	^ self new nextPutAll:
		 ('<html>
			<head>
			<meta http-equiv="refresh" content="',aNumber displayString,';URL=',locationString,'">
			<title>',aString,'</title>
			</head>
			<body>
			<h1>',aString,'</h1>
			You are being redirected to <a href="',locationString,'">',locationString,'</a>
			</body>
		</html>');
		yourself
	! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 9/10/2005 17:31'!
root: anHtmlRoot render: renderBlock
	| canvas |
	canvas := WAStaticHtmlCanvas root: anHtmlRoot.
	renderBlock value: canvas.
	^ self new nextPutAll: canvas document stream contents! !

!WAResponse class methodsFor: 'public api' stamp: 'avi 9/10/2005 17:32'!
updateRoot: rootBlock render: renderBlock
	| root |
	root := WAHtmlRoot new.
	rootBlock value: root.
	^ self root: root render: renderBlock! !

!WAResponse methodsFor: 'accessing' stamp: 'pmm 10/12/2006 16:55'!
addCookie: aCookie
	cookies ifNil: [cookies := Set new].
	cookies add: aCookie! !

!WAResponse methodsFor: 'convenience' stamp: 'pmm 4/19/2006 09:30'!
attachmentWithFileName: aString
	self headerAt: 'Content-Disposition' put: 'attachment; filename="', aString, '"'! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:25'!
authenticationFailed
	self status: 401! !

!WAResponse methodsFor: 'convenience' stamp: 'avi 5/18/2004 14:25'!
basicAuthenticationRealm: aString
	self headerAt: 'WWW-Authenticate' put: ('Basic realm="',aString,'"').
	self authenticationFailed! !

!WAResponse methodsFor: 'convenience' stamp: 'mb 1/19/2006 19:30'!
beXML
	contentType := contentType copyReplaceAll: '/html' with: '/xml'.! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:58'!
contentType
	^ contentType! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:58'!
contentType: mimeTypeString
	contentType := mimeTypeString! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:21'!
contents
	^ stream reset! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:21'!
contents: aStream
	stream := aStream! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:23'!
cookieAt: key put: value
	self addCookie: (WACookie key: key value: value)! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:28'!
cookies
	^ cookies ifNil: [#()]! !

!WAResponse methodsFor: 'accessing' stamp: 'mb 2/9/2006 09:29'!
deleteCookieAt: key
	"Delete the cookie in the browser"
	self addCookie: ((WACookie key: key value: '') 
						expireIn: (Duration days: -10000); 
						yourself)! !

!WAResponse methodsFor: 'convenience' stamp: 'ac 9/11/2005 12:46'!
doNotCache
	self headerAt: 'Cache-Control' put: 'no-cache'.! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/9/2005 13:14'!
forbidden
	self status: 403! !

!WAResponse methodsFor: 'accessing' stamp: 'mb 2/17/2005 18:13'!
headerAt: key put: value
	headers ifNil: [headers := OrderedCollection new].
	headers add: (Association key: key value: value).! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:28'!
headers
	^ headers ifNil: [#()]! !

!WAResponse methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 10:53'!
initialize
	| session |
	stream := SeasidePlatformSupport readWriteStream.
	status := '200'.
	session := WACurrentSession value.
	contentType := session isNil 
				ifFalse: [session contentType]
				ifTrue: [self class defaultValueForContentType]
! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 15:57'!
internalError
	self status: 500! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/7/2003 11:12'!
nextPut: aCharacter
	stream nextPut: aCharacter asCharacter! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/7/2003 11:12'!
nextPutAll: aString
	aString do: [:ea | self nextPut: ea]! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:25'!
notFound
	self status: 404! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:26'!
redirect
	self status: 302! !

!WAResponse methodsFor: 'convenience' stamp: 'avi 11/27/2005 15:19'!
redirectTo: aString
	self headerAt: 'Location' put: aString.
	self redirect.! !

!WAResponse methodsFor: 'accessing' stamp: 'tbn 7/20/2006 17:31'!
release
	stream := cookies := headers := nil.
	super release! !

!WAResponse methodsFor: 'accessing' stamp: 'ac 3/22/2006 12:06'!
space
	stream space.! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:50'!
status
	^ status! !

!WAResponse methodsFor: 'accessing' stamp: 'mbany 4/14/2005 12:51'!
status: statusString
	status := statusString displayString! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 2/6/2004 15:28'!
stream
	^ stream! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:28'!
stream: aStream
	stream := aStream! !

!WAResponse methodsFor: 'writing' stamp: 'avi 1/6/2006 12:53'!
writeHeadersOn: aStream
	self headers associationsDo:
		[:assoc |
		aStream nextPutAll: assoc key; nextPutAll: ': '; nextPutAll: assoc value asString.
		aStream crlf].
	aStream nextPutAll: 'Content-Type: ', self contentType.
	aStream crlf! !

!WAResponse methodsFor: 'writing' stamp: 'avi 1/6/2006 12:52'!
writeOn: aStream
	self writeStatusOn: aStream.
	self writeHeadersOn: aStream.
	aStream crlf.
	aStream nextPutAll: stream contents! !

!WAResponse methodsFor: 'writing' stamp: 'mb 3/12/2007 13:50'!
writeStatusOn: aStream
	aStream
		nextPutAll: self class defaultHttpVersion; 
		space; 
		nextPutAll: self status asString;
		crlf! !

WAResponse subclass: #WAStreamResponse
	instanceVariableNames: 'writtenHeaders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WAStreamResponse methodsFor: 'accessing' stamp: 'pmm 4/19/2006 17:32'!
hasWrittenHeaders
	^ writtenHeaders! !

!WAStreamResponse methodsFor: 'initialize-release' stamp: 'mb 9/22/2006 12:26'!
initialize
	super initialize.
	writtenHeaders := false! !

!WAStreamResponse methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:31'!
stream
	self writeOn: stream.
	^ stream! !

!WAStreamResponse methodsFor: 'private' stamp: 'pmm 9/30/2006 18:18'!
writeOn: aStream
	self hasWrittenHeaders ifFalse: [
		self writeStatusOn: aStream.
		self writeHeadersOn: aStream.
		aStream crlf.
		writtenHeaders := true ]! !

Object subclass: #WASpotProfiler
	instanceVariableNames: 'readings'
	classVariableNames: 'Profilers'
	poolDictionaries: ''
	category: 'Seaside-Utilities-Squeak'!

!WASpotProfiler class methodsFor: 'initialization' stamp: 'avi 11/7/2005 13:01'!
initialize
	Profilers := Dictionary new! !

!WASpotProfiler class methodsFor: 'instance creation' stamp: 'lr 5/3/2006 09:38'!
new
	^ self basicNew initialize! !

!WASpotProfiler class methodsFor: 'vm profiling' stamp: 'avi 11/7/2005 12:51'!
profile: aBlock
	| profiler |
	profiler := Profilers at: thisContext sender selector ifAbsentPut: [self new].
	^ profiler profile: aBlock! !

!WASpotProfiler class methodsFor: 'accessing' stamp: 'avi 11/7/2005 12:59'!
profilers
	^ Profilers! !

!WASpotProfiler methodsFor: 'private' stamp: 'avi 11/7/2005 12:56'!
allReadings
	^ readings gather: [:ea | ea]! !

!WASpotProfiler methodsFor: 'accessing' stamp: 'avi 11/7/2005 12:54'!
averageReadingTime
	^ self allReadings average! !

!WASpotProfiler methodsFor: 'accessing' stamp: 'avi 11/7/2005 12:55'!
averageReadingsPerRequest
	^ (readings collect: [:ea | ea size]) average! !

!WASpotProfiler methodsFor: 'accessing' stamp: 'avi 11/7/2005 12:53'!
averageRequestTime
	^ self requestTimes average! !

!WASpotProfiler methodsFor: 'private' stamp: 'avi 11/7/2005 12:51'!
initialize
	self reset! !

!WASpotProfiler methodsFor: 'vm profiling' stamp: 'avi 11/7/2005 12:50'!
profile: aBlock
	| time value |
	time := Time millisecondsToRun: [value := aBlock value].
	(readings at: Processor activeProcess ifAbsentPut: [OrderedCollection new]) add: time.
	^ value! !

!WASpotProfiler methodsFor: 'accessing' stamp: 'avi 11/7/2005 12:54'!
readingCount
	^ self allReadings size! !

!WASpotProfiler methodsFor: 'accessing' stamp: 'avi 11/7/2005 12:54'!
requestCount
	^ self requestTimes size! !

!WASpotProfiler methodsFor: 'private' stamp: 'avi 11/7/2005 12:53'!
requestTimes
	^ readings collect: [:ea | ea sum]! !

!WASpotProfiler methodsFor: 'actions' stamp: 'avi 11/7/2005 12:52'!
reset
	readings := Dictionary new! !

!WASpotProfiler methodsFor: 'accessing' stamp: 'avi 11/7/2005 12:54'!
totalTime
	^ self requestTimes sum! !

Object subclass: #WAStateHolder
	instanceVariableNames: 'hash contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-StateRegistry'!

!WAStateHolder commentStamp: '<historical>' prior: 0!
I am a ValueHolder whose contents will properly track the user's use of the back button.  Use me to wrap any values that you wish to backtrack when the back button is used.

Sometimes it might be more convenient to register your business object directly:

	WACurrentSession value registerObjectForBacktracking: businessObject.

or even to register a component for backtracking, as seen in WACounter:

	WACounter>>initialize
		self session registerObjectForBacktracking: self.!

!WAStateHolder class methodsFor: 'instance creation' stamp: 'avi 4/13/2004 19:48'!
new
	|inst|
	inst := super new.
	WACurrentSession value registerObjectForBacktracking: inst.
	^ inst! !

!WAStateHolder methodsFor: 'accessing' stamp: 'ab 2/20/2003 01:04'!
contents
	^ contents! !

!WAStateHolder methodsFor: 'accessing' stamp: 'ab 2/20/2003 01:04'!
contents: anObject
	contents := anObject! !

!WAStateHolder methodsFor: 'comparing' stamp: 'pmm 9/12/2006 19:08'!
hash
	"this is a workaround for the indentityHash limit in Squeak (4096) and VW (16384)
	this is no longer needed in Squeak 3.9"
	^ hash ifNil: [ hash := SmallInteger maxVal atRandom ]! !

!WAStateHolder methodsFor: 'printing' stamp: 'ab 2/20/2003 01:05'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	contents printOn: aStream.
	aStream nextPut: $).! !

Object subclass: #WAStateRegistry
	instanceVariableNames: 'lastSnapshot objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-StateRegistry'!

!WAStateRegistry class methodsFor: 'instance creation' stamp: 'pmm 4/18/2006 20:17'!
new
	^ self basicNew initialize! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:55'!
calculateFootprint
	^ (objects detectSum: [:ea | 2 + ea class instSize + (ea class isVariable ifTrue: [ea size + 1] ifFalse: [0])]) * 4! !

!WAStateRegistry methodsFor: 'initialize-release' stamp: 'mb 5/6/2006 16:09'!
initialize
	objects := SeasidePlatformSupport weakDictionaryOfSize: 10.! !

!WAStateRegistry methodsFor: 'testing' stamp: 'pmm 4/21/2006 23:26'!
isEmpty
	^self size = 0! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'avi 9/1/2004 21:17'!
registerObject: anObject
	objects at: anObject put: anObject snapshotCopy! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 17:28'!
restoreLastSnapshot
	lastSnapshot ifNotNil: [self restoreSnapshot: lastSnapshot]! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'avi 9/1/2004 21:18'!
restoreObject: object fromSnapshot: copy
	object restoreFromSnapshot: copy.
	objects at: object put: copy.! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:03'!
restoreSnapshot: aDictionary
	aDictionary keysAndValuesDo:
		[:k :v |
		self restoreObject: k fromSnapshot: v]! !

!WAStateRegistry methodsFor: 'accessing' stamp: 'ab 7/3/2003 12:03'!
size
	^ objects size! !

!WAStateRegistry methodsFor: 'accessing' stamp: 'avi 9/1/2004 21:21'!
snapshot
	lastSnapshot := SeasidePlatformSupport weakDictionaryOfSize: objects size.
	objects keysAndValuesDo:
		[:obj :copy|
		(obj isIdenticalToSnapshot: copy)
			ifTrue: [lastSnapshot at: obj put: copy]
			ifFalse: [lastSnapshot at: obj put: obj snapshotCopy]].
	^ lastSnapshot
! !

Object subclass: #WAStoreAddress
	instanceVariableNames: 'name street city country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreAddress commentStamp: 'avi 1/1/2004 07:36' prior: 0!
A simple model of a billing or shipping address.  Stores strings for a person's name, street, city, and country.  Apart from accessors for these, the only behavior this provides is a #validate method which will throw errors if street, city, or country is nil.!

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:53'!
city
	^ city! !

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:52'!
city: aString
	city := aString! !

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:53'!
country
	^ country! !

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:53'!
country: aString
	country := aString! !

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:53'!
name
	^ name! !

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:52'!
name: aString
	name := aString! !

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:53'!
street
	^ street! !

!WAStoreAddress methodsFor: 'accessing' stamp: 'avi 12/8/2003 13:52'!
street: aString
	street := aString! !

!WAStoreAddress methodsFor: 'actions' stamp: 'cds 7/25/2005 10:20'!
validate
	street ifNil: [self validationError: 'You must provide a street address.'].
	city ifNil: [self validationError: 'You must provide a city.'].
	country ifNil: [self validationError: 'You must provide a country.'].! !

Object subclass: #WAStoreCart
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreCart commentStamp: 'avi 1/1/2004 07:44' prior: 0!
A shopping cart.  This is essentially a specialized Bag: you can #add: or #remove: WAStoreItems to it, and calculate their #totalPrice.  You can also use #countsAndItems to get a collection of associations between the items and the number of times they appear in the cart, useful for summary displays.!

!WAStoreCart methodsFor: 'adding' stamp: 'ab 8/15/2003 17:36'!
add: anObject
	items ifNil: [items := Bag new].
	items add: anObject! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:40'!
countsAndItems
	^ items sortedCounts! !

!WAStoreCart methodsFor: 'testing' stamp: 'avi 12/8/2003 14:01'!
hasItems
	^ items notNil and: [items isEmpty not]! !

!WAStoreCart methodsFor: 'accessing' stamp: 'ab 8/15/2003 17:21'!
items
	^ items! !

!WAStoreCart methodsFor: 'removing' stamp: 'ab 8/15/2003 17:40'!
remove: anObject
	items remove: anObject ifAbsent: []! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:41'!
totalPrice
	^ items detectSum: [:ea | ea price]! !

Object subclass: #WAStoreCreditCard
	instanceVariableNames: 'name number expiry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreCreditCard commentStamp: 'avi 1/1/2004 07:47' prior: 0!
Models credit card information - it has accessors for #name and #number (both strings), and #expiry date.  #validate throws an error if anything is missing, or if the expiry date is in the past.

This is intended to be an abstract class - the subclasses WAStoreMasterCard and WAStoreVisaCard provide further validation.!

!WAStoreCreditCard methodsFor: 'accessing' stamp: 'avi 12/9/2003 14:02'!
expiry
	! !

!WAStoreCreditCard methodsFor: 'accessing' stamp: 'avi 12/9/2003 14:03'!
expiry: aDate
	expiry := aDate! !

!WAStoreCreditCard methodsFor: 'accessing' stamp: 'avi 12/9/2003 14:02'!
name
	^ name! !

!WAStoreCreditCard methodsFor: 'accessing' stamp: 'avi 12/9/2003 14:01'!
name: aString
	name := aString! !

!WAStoreCreditCard methodsFor: 'accessing' stamp: 'avi 12/9/2003 14:02'!
number
	^ number! !

!WAStoreCreditCard methodsFor: 'accessing' stamp: 'avi 12/9/2003 14:02'!
number: aString
	number := aString! !

!WAStoreCreditCard methodsFor: 'actions' stamp: 'cds 7/25/2005 10:20'!
validate
	name ifNil: [self validationError: 'You must provide the name of the credit card owner.'].
	number ifNil: [self validationError: 'You must provide a credit card number.'].
	expiry ifNil: [self validationError: 'You must provide an expiry date.'].
	expiry < Date today ifTrue: [self validationError: 'The expiry date must not be in the past'].
	! !

WAStoreCreditCard subclass: #WAStoreMasterCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreMasterCard commentStamp: 'avi 1/1/2004 09:35' prior: 0!
Adds MasterCard-specific validation to WAStoreCreditCard.!

!WAStoreMasterCard class methodsFor: 'accessing' stamp: 'avi 12/10/2003 14:04'!
abbreviation
	^ 'MC'! !

!WAStoreMasterCard methodsFor: 'actions' stamp: 'RJT 5/8/2007 12:33'!
validate
	super validate.
	(number notEmpty and: [number first = $5]) ifFalse: [self validationError: 'Mastercard numbers must start with "5"'].
! !

WAStoreCreditCard subclass: #WAStoreVisaCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreVisaCard commentStamp: 'avi 1/1/2004 09:35' prior: 0!
Adds VISA-specific validation to WAStoreCreditCard.!

!WAStoreVisaCard class methodsFor: 'accessing' stamp: 'avi 12/10/2003 14:04'!
abbreviation
	^ 'VISA'! !

!WAStoreVisaCard methodsFor: 'actions' stamp: 'RJT 5/8/2007 12:34'!
validate
	super validate.
	(number notEmpty and: [number first = $4]) ifFalse: [self validationError: 'Visa card numbers must start with "4"'].
! !

Object subclass: #WAStoreInventory
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

WAStoreInventory class
	instanceVariableNames: 'default'!

!WAStoreInventory commentStamp: 'avi 1/1/2004 09:33' prior: 0!
The list of inventory items.  In a real application, this would probably have to deal with persistence, maintaining inventory counts, etc.  In this example, it just builds a collection of WAStoreItems from a hardcoded data set, and provides #allItems and #findItem: for accessing these.!

WAStoreInventory class
	instanceVariableNames: 'default'!

!WAStoreInventory class methodsFor: 'defaults' stamp: 'avi 12/8/2003 14:26'!
default
	^ default ifNil: [default := self new]! !

!WAStoreInventory class methodsFor: 'instance creation' stamp: 'avi 12/8/2003 14:17'!
new
	^ self basicNew initialize! !

!WAStoreInventory methodsFor: 'accessing' stamp: 'ab 8/15/2003 17:19'!
allItems
	^ items! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
findItem: searchString
	^ items select: [:ea | ea matches: searchString]! !

!WAStoreInventory methodsFor: 'initialize-release' stamp: 'ab 8/15/2003 17:19'!
initialize
	items := OrderedCollection new.
	self itemSpecs do:
		[:row |
		items add: (self itemFromSpec: row)]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'pmm 11/2/2005 23:45'!
itemFromSpec: anArray
	^ WAStoreItem new
		title: anArray first;
		subtitle: anArray second;
		description: anArray third;
		price: anArray fourth;
		yourself! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'avi 9/18/2003 16:43'!
itemSpecs
"adapted from http://www.thaddeus.com/ftp/database/sushi.zip"
	^ #(
#('Akami Maguro' 'Red Tuna' 'The lean meat near the spine of the tuna fish.  It comes in various shades of red--with the lighter, shinier varieties being the best.  For dieters, however, the redder the better.  Easy on the palatte.  The least expensive of the three types of maguro.' 150)
#('Chutoro Maguro' 'Fatty Tuna' 'The moderately fatty part of the tuna belly.  It''s pink, but not the faint pink of ohtoro.  Soft, butter-like texture.  Moderately expensive.' 275)
#('Geso Ika' 'Cuttlefish Tentacles' 'White in color, geso is boiled and brushed with thick teriyaki sauce before serving as sushi.  Its texture is chewy, and its mild flavor is complemented by the sweet-salty teriyaki.' 200)
#('Himo Akagai' 'Ark Shell Filaments' 'This is the thread-like edges which connect the flesh to the shell.  A delicious, soft texture and mild taste.' 200)
#('Hotategai' 'Scallop' 'The part of the scallop that is eaten is the edible adductor muscle that opens the animal''s shell.  It''s pale beige-yellow in color with a brown, crusty edging.  The taste is delicate, and melts in your mouth. ' 250)
#('Iwashi' 'Sardine' 'Shiny, slippery, and ''fishy,'' the taste of sardine sushi is slightly oily.  Sardine must be eaten shortly after it has been caught if it''s to be used in Sushi.  Often eaten with soy sauce mixed with ginger and onion.' 175)
#('Kazunoko' 'Herring Roe' 'An expensive delicacy which is also known as ''yellow diamonds'' (because of the color and expense).  Revered in Japan, it''s usually eaten on special occasions.  An acquired taste for Westerners.' 475)
#('Kisu' 'Sillago' 'A fresh Sillago has bright-gold skin. The taste is mild and delicate.' 225)
#('Ohtoro Maguro' 'Fattiest Tuna' 'Fattiest part of the fatty tuna belly.  It is light pink in color and melts in your mouth.  Mild with a rich texture.  This is the most expensive of the three types of Maguro sushi.' 325)
#('Shima-Aji' 'Yellow Jack' 'A slice of white silvery shima-aji eaten with beef-steak plant and fresh ginger is delicious.  The flavor is delicate and the texture of good, fresh yellow jack is smooth and slides down easily.' 180)
#('Aji' 'Horse Mackerel' 'This fish is pink-grey and shiny.  When it''s fresh, the flesh is almost transparent.  The texture is slippery and easy on the tongue--it should melt in your mouth.  Aji is often eaten with soy sauce containing onion, ginger and garlic.' 250)
#('Inarizushi' 'Stuffed Bean Curd Rolls' '' 200)
#('Kappa Maki' 'Cucumber Rolls' '' 150)
#('Sakura Denbu' 'Shredded Cod Fish' 'Seasoned shredded cod fish.' 200)
#('California Roll' '' 'Rice, cucumber, crab meat, & avacado.' 250)
#('Futo-Maki' 'Fat Rolls' 'Kampyo gourd, oboro or denbu pink powder, tamago omelet, and shiitake mushrooms. May also include bamboo shoots, cucumbers, cooked eel, cooked carrots, and cooked spinach or other greens.' 275)
#('Tekkamaki' 'Tuna Roll' 'Tuna wrapped in rice and nori.' 225)
#('Chakinzushi' 'Omelet-wrapped Sushi' 'Sushi rice in a thin omelet wrapper shaped and tied like a lady''s drawstring purse.  Sometimes a single pea or small shrimp decorates the ruffled part of the wrapper.' 300)
#('Shiro Maguro' 'Albacore Tuna' '' 300)
#('Hamachi' 'Yellowtail' '' 325)
#('Kohada' 'Gizzard Shad' 'This Japanese shad is a member of the herring family, and is a small silver-grey fish, with a black spotted back.  Marinated in vinegar and cross- hatched before serving.  The taste is strong, and a favorite for herring fans.' 275)
#('Katsuo' 'Bonito' '' 275)
#('Saba' 'Mackerel' '' 200)
#('Sake' 'Salmon' '' 250)
#('Tai' 'Red Snapper' '' 250)
#('Hirame' 'Flounder' 'Good hirame is a sushi gourmet''s delight.  Since it''s cut from such a small part of the fish, it''s scarce and expensive.  In appearance, it''s pale pink and smooth, with no markings.  The taste is delicate and buttery.' 350)
#('Suzuki' 'Sea Bass' '' 300)
#('Unagi' 'Freshwater Eel' '' 300)
#('Ika' 'Cuttlefish' 'When fresh, cuttlefish is almost transparent.  It''s butter-like and melts in your mouth.  The texture is sticky.  Cuttlefish is smoky white and glistens. Also popular grilled and mixed with ginger soy sauce.  Also good with lemon for Western palettes.' 325)
#('Awabi' 'Abalone' 'Abalone or ''sea snail'' is another sushi favorite.  The color ranges from beige-grey to pinkish yellow.  Fresh abalone is not too rubbery, and is very subtle in flavor.' 300)
#('Mirugai' 'Horse Clam' 'Also known as Geoduck.  This is a large, hard-shelled clam which is yellowish-white in color.  It has a slight ''shellfish'' taste and an elastic type texture. The part used in sushi is the long muscular siphon which projects from the shell.' 350)
#('Akagai' 'Ark Shell Clam' 'The softest texture of any shellfish. Akagai has an attractive pink-orange color.  The taste is delicate and slightly sweet.' 300)
#('Kobashira' 'Trough Shell (Small) Scallop' 'The edible adductor muscle that opens the shell of the aoyagi.  More prized than the aoyagi itself.' 500)
#('Kani' 'Crab' '' 250)
#('Ebi' 'Cooked Prawn' '' 225)
#('Ikura' 'Salmon Roe' 'Appealing to the eye with its bright red color.  Very appetizing with a delicate taste.' 325)
#('Tobiko ' 'Flying-Fish Roe' '' 350)
#('Masago ' 'Capelin Roe' '' 350)
#('Anago' 'Conger Eel' 'Anago is one of the few pre-cooked sushi.  It is grilled and basted with a thick teriyaki sauce.  The soft, slighty warm eel, the sweet soy sauce, and the vinegared rice make a particularly delicious sushi.' 300)
#('Uni' 'Sea Urchin Roe' 'A prized delicacy with its oily, rich texture.  Mustard color, paste-like topping is held in place by a band of nori seaweed.' 400)
) asSortedCollection: [:a :b | a first <= b first]! !

Object subclass: #WAStoreItem
	instanceVariableNames: 'title subtitle description price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreItem commentStamp: 'avi 1/1/2004 09:34' prior: 0!
Models a single item of inventory - stores a title, subtitle, fill description, and price.  The only real behavior is #matches:, which is used for search.!

!WAStoreItem methodsFor: 'accessing' stamp: 'ab 5/25/2003 13:27'!
description
	^ description! !

!WAStoreItem methodsFor: 'accessing' stamp: 'ab 5/25/2003 13:27'!
description: aString
	description := aString! !

!WAStoreItem methodsFor: 'private' stamp: 'ab 5/25/2003 13:30'!
matches: aString
	^ (title includesSubstring: aString caseSensitive: false)
		or: [description includesSubstring: aString caseSensitive: false]! !

!WAStoreItem methodsFor: 'accessing' stamp: 'ab 5/25/2003 13:28'!
price
	^ price! !

!WAStoreItem methodsFor: 'accessing' stamp: 'ab 5/25/2003 13:28'!
price: cents
	price := cents! !

!WAStoreItem methodsFor: 'printing' stamp: 'avi 12/9/2003 13:17'!
printString
	^ self title! !

!WAStoreItem methodsFor: 'accessing' stamp: 'ab 5/31/2003 23:17'!
subtitle
	^ subtitle! !

!WAStoreItem methodsFor: 'accessing' stamp: 'avi 8/29/2004 14:12'!
subtitle: aString
	subtitle := aString! !

!WAStoreItem methodsFor: 'accessing' stamp: 'ab 5/25/2003 13:27'!
title
	^ title! !

!WAStoreItem methodsFor: 'accessing' stamp: 'ab 5/25/2003 13:27'!
title: aString
	title := aString! !

Object subclass: #WAUrl
	instanceVariableNames: 'host port scheme path params fragment parameterString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WAUrl class methodsFor: 'instance creation' stamp: 'avi 3/18/2004 16:07'!
new
	^ self basicNew initialize! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:45'!
addParameter: aString
	self addParameter: aString value: nil
! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 11/7/2005 13:09'!
addParameter: keyString value: valueString
	params at: keyString put: valueString.
	parameterString := nil! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:45'!
addToPath: aString
	path addAll: (aString findTokens: '/')! !

!WAUrl methodsFor: 'printing' stamp: 'avi 3/22/2004 00:42'!
asString
	^ self urlWithQueryString! !

!WAUrl methodsFor: 'copying' stamp: 'avi 4/15/2004 11:35'!
copy
	| copy |
	copy := self class new.
	copy hostname: host; port: port; scheme: scheme; fragment: fragment.
	copy addToPath: self pathString.
	params keysAndValuesDo: [:k :v | copy addParameter: k value: v].
	^ copy! !

!WAUrl methodsFor: 'private' stamp: 'avi 3/22/2004 00:47'!
defaultPortForScheme: aSymbol
	^ aSymbol = #http
		ifTrue: [80]
		ifFalse: [aSymbol = #https
					ifTrue: [443]]! !

!WAUrl methodsFor: 'printing' stamp: 'mbany 4/14/2005 13:02'!
displayString
	^ self urlWithQueryString! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 4/15/2004 11:35'!
fragment
	^ fragment! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 4/15/2004 11:35'!
fragment: aString
	fragment := aString! !

!WAUrl methodsFor: 'printing' stamp: 'avi 4/15/2004 11:35'!
fragmentString
	^ fragment ifNil: [''] ifNotNil: ['#', fragment]! !

!WAUrl methodsFor: 'requesting' stamp: 'mb 3/24/2006 18:03'!
getDocument
	^ SeasidePlatformSupport getDocumentWithUrl: self! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/19/2004 14:37'!
hostname
	^ host! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/19/2004 14:37'!
hostname: aString
	host := aString! !

!WAUrl methodsFor: 'initialize-release' stamp: 'avi 3/22/2004 00:48'!
initialize
	path := OrderedCollection new.
	params := Dictionary new.
	scheme := #http! !

!WAUrl methodsFor: 'printing' stamp: 'pmm 2/13/2007 07:19'!
isSeasideField: aString
       ^ aString notEmpty
		and: [ aString first = $_
			or: [ aString allSatisfy: [ :each | each isDigit ] ] ]! !

!WAUrl methodsFor: 'private' stamp: 'avi 11/7/2005 12:26'!
orderedParameterKeys 
	| keys |
	keys := OrderedCollection new.
	params keys do: [:ea | (self isSeasideField: ea) ifTrue: [keys addLast: ea] ifFalse: [keys addFirst: ea]].
	^ keys! !

!WAUrl methodsFor: 'printing' stamp: 'avi 11/7/2005 13:08'!
parameterString
	| v |
	^ parameterString ifNil: [parameterString := String streamContents:
		[:s |
		params isEmpty ifFalse:
			[s nextPut: $?.
			self orderedParameterKeys do:
				[:k |
				v := params at: k.
				s nextPutAll: k encodeForHTTP.
				v ifNotNil: [s nextPut: $=; nextPutAll: v encodeForHTTP].
				s nextPut: $&].
			s skip: -1]]]! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/19/2004 13:11'!
parameters
	^ params! !

!WAUrl methodsFor: 'accessing' stamp: 'pmm 9/12/2006 19:22'!
parametersForHttpSocket
	"ugly dictionary should support some form of #collect: that creates a Dictionary, maybe #map: or so"
	| dictionary |
	dictionary := Dictionary new.
	self parameters keysAndValuesDo: [ :key :value |
		dictionary at: key put: (Array with: value) ].
	^ dictionary! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:46'!
path
	^ path! !

!WAUrl methodsFor: 'printing' stamp: 'lr 2/15/2007 17:45'!
pathString
	^ String streamContents: [ :stream | 
		stream nextPut: $/.
		path 
			do: [ :each | stream nextPutAll: each ]
			separatedBy: [ stream nextPut: $/ ] ]! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:47'!
port
	^ port ifNil: [self defaultPortForScheme: scheme]! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/18/2004 16:07'!
port: aNumber
	port := aNumber! !

!WAUrl methodsFor: 'printing' stamp: 'avi 11/7/2005 12:31'!
queryString
	^ self parameterString, self fragmentString! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:47'!
scheme
	^ scheme! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:47'!
scheme: aSymbol
	scheme := aSymbol! !

!WAUrl methodsFor: 'printing' stamp: 'avi 11/28/2005 16:07'!
serverString
	host ifNil: [^ ''].
	
	^ String streamContents:
		[:stream |
		stream nextPutAll: scheme.
		stream nextPutAll: '://'.
		stream nextPutAll: host.
		
		((self defaultPortForScheme: scheme) = self port)
			ifFalse: [stream nextPutAll: ':', port displayString]]! !

!WAUrl methodsFor: 'private' stamp: 'avi 11/7/2005 13:07'!
setParameterString: aString
	parameterString := aString! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 2/3/2007 22:53'!
takeServerParametersFromRequest: aRequest
	| httpHost |
	host ifNil: [
		httpHost := aRequest
			headerAt: 'host' 
			ifAbsent: [ ^ self ].
		host := httpHost copyUpTo: $:.
		(httpHost includes: $:) 
			ifTrue: [ port := (httpHost copyAfter: $:) asNumber ] ]! !

!WAUrl methodsFor: 'printing' stamp: 'lr 2/3/2007 22:58'!
urlString
	^ self serverString , self pathString , self fragmentString! !

!WAUrl methodsFor: 'printing' stamp: 'avi 10/6/2005 10:00'!
urlWithQueryString
	^ String streamContents:
		[:s |
		s nextPutAll: self serverString.
		s nextPutAll: self pathString.
		s nextPutAll: self queryString]! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:52'!
with: pathString
	^ self copy
		addToPath: pathString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'avi 11/7/2005 13:08'!
withParameter: aString
	^ self copy
		addParameter: aString;
		setParameterString: (self parameterString, '&', aString);
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:51'!
withParameter: aString value: valueString
	^ self copy
		addParameter: aString value: valueString;
		yourself! !

Object subclass: #WAUtf8EncodingStream
	instanceVariableNames: 'stream encoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!WAUtf8EncodingStream commentStamp: 'pmm 10/14/2006 14:37' prior: 0!
I wrap a SocketStream and encode the input to utf-8.
Unfortunately such hacks are needed because of the Squeak Stream hierarchy.!

!WAUtf8EncodingStream class methodsFor: 'instance creation' stamp: 'pmm 10/14/2006 04:03'!
on: aStream
	^self new
		setStream: aStream;
		yourself! !

!WAUtf8EncodingStream methodsFor: 'accessing' stamp: 'pmm 10/14/2006 11:12'!
basicNextPut: aCharacter
	stream nextPut: aCharacter! !

!WAUtf8EncodingStream methodsFor: 'accessing' stamp: 'pmm 10/14/2006 04:09'!
crlf
	stream crlf! !

!WAUtf8EncodingStream methodsFor: 'initialize-release' stamp: 'pmm 10/14/2006 14:15'!
initialize
	super initialize.
	encoder := TextConverter newForEncoding: 'utf8'! !

!WAUtf8EncodingStream methodsFor: 'accessing' stamp: 'pmm 10/14/2006 11:14'!
isBinary
	^false! !

!WAUtf8EncodingStream methodsFor: 'accessing' stamp: 'pmm 10/14/2006 11:13'!
nextPut: aCharacter
	encoder nextPut: aCharacter toStream: self ! !

!WAUtf8EncodingStream methodsFor: 'accessing' stamp: 'pmm 10/14/2006 04:02'!
nextPutAll: aColllection
	aColllection do: [ :each |
		self nextPut: each ]! !

!WAUtf8EncodingStream methodsFor: 'initialize-release' stamp: 'pmm 10/14/2006 04:02'!
setStream: aStream
	stream := aStream! !

!WAUtf8EncodingStream methodsFor: 'accessing' stamp: 'pmm 10/14/2006 11:16'!
socket
	^stream socket! !

!Form methodsFor: '*seaside2-squeak' stamp: 'mb 6/12/2006 14:01'!
asMIMEDocument 
	^self asMIMEDocumentType: self defaultMimeType.! !

!Form methodsFor: '*seaside2-squeak' stamp: 'mb 6/2/2006 11:05'!
asMIMEDocumentType: mimeType
	| aStream |
	aStream _ (RWBinaryOrTextStream on: '').
	(self writerForMimeType: mimeType)
		putForm: (self asFormOfDepth: 32) onStream: aStream.
	^MIMEDocument contentType: mimeType content: aStream contents
! !

!Form methodsFor: '*seaside2-squeak' stamp: 'mb 6/12/2006 14:00'!
defaultMimeType
	^'image/gif'! !

!Form methodsFor: '*seaside2-squeak' stamp: 'mb 6/12/2006 14:01'!
mimeType
	^ self defaultMimeType! !

!Form methodsFor: '*seaside2-squeak' stamp: 'mb 6/12/2006 14:02'!
writerForMimeType: mimeTypeString
	| mimeType tokens type |
	mimeType _ mimeTypeString isString
		ifTrue: [mimeTypeString]
		ifFalse: [self mimeType].
	[tokens _ mimeType findTokens: '/'.
	tokens size < 2] whileTrue: [mimeType _ self defaultMimeType].
	"First token is assumed to be 'image'"
	type _ tokens second.
	type = 'jpg' ifTrue: [^JPEGReadWriter2].
	type = 'jpeg' ifTrue: [^JPEGReadWriter2].
	type = 'png' ifTrue: [^PNGReadWriter].
	type = 'pcx' ifTrue: [^PCXReadWriter].
	type = 'bmp' ifTrue: [^BMPReadWriter].
	type = 'gif' ifTrue: [^GIFReadWriter].
	^nil! !

PackageInfo subclass: #Seaside2Info
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!Seaside2Info class methodsFor: 'initialization' stamp: 'avi 3/24/2004 12:19'!
initialize
	[self new register] on: MessageNotUnderstood do: ["must be an old version of PackageInfo"]! !

!Seaside2Info methodsFor: 'naming' stamp: 'ab 10/26/2002 15:41'!
packageName
	^ 'Seaside2'! !

!Seaside2Info methodsFor: 'naming' stamp: 'cwp 4/25/2004 18:40'!
systemCategoryPrefix
	^ 'Seaside'! !

PackageInfo subclass: #SeasideAddonVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!SeasideAddonVWInfo class methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:30'!
addonName
	self subclassResponsibility! !

!SeasideAddonVWInfo class methodsFor: 'actions' stamp: 'mb 10/6/2006 19:30'!
fileOutVW5
	(Smalltalk classNamed: #VW5PackageExporter)
		ifNotNilDo: [ :class | 
			class 
				fileOutPackage: self default 
				on: (FileStream forceNewFileNamed: self addonName , 'VW5.st') ]! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:31'!
addonName
	^self class addonName! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:31'!
externalName
	^ self addonName! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:31'!
ignoredCategories
	^ #('Platform')! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:32'!
includesSystemCategory: aString
	^ (aString beginsWith: self addonName , '-') 
		and: [(self ignoredCategories includes: (aString copyAfter: $-)) not]! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:32'!
isYourClassExtension: aString
	^ (self category: aString asLowercase matches: '*' , self addonName asLowercase)
		and: [(aString endsWith: 'squeak') not]! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:33'!
name
	^ self addonName! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:33'!
namespace
	^ 'Seaside'! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:33'!
needsNamespace
	^false! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:33'!
packageName
	^ self addonName , 'VW'! !

!SeasideAddonVWInfo methodsFor: 'accessing' stamp: 'mb 10/6/2006 19:34'!
versionString
	| ancestor |
	ancestor := (MCPackage named: self name) workingCopy ancestry ancestors first.
	^ancestor name , '.mcz      ' , ancestor date printString, ' ', ancestor time printString ! !

PackageInfo subclass: #SeasideVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!SeasideVWInfo class methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:00'!
fileOutVW3
	VW3PackageExporter fileOutPackage: self default on: (FileStream forceNewFileNamed: 'SeasideVW3.st')! !

!SeasideVWInfo class methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:00'!
fileOutVW5
	VW5PackageExporter fileOutPackage: self default on: (FileStream forceNewFileNamed: 'SeasideVW5.st')! !

!SeasideVWInfo methodsFor: 'naming' stamp: 'ab 6/14/2003 17:46'!
externalName
	^ 'Seaside'! !

!SeasideVWInfo methodsFor: 'accessing' stamp: 'mb 3/21/2006 17:40'!
ignoredCategories
	^ #('Platform' 'Base-Connections' 'Rendering-Buttons' 'Components-Tools-Squeak' 'Utilities-Squeak')! !

!SeasideVWInfo methodsFor: 'testing' stamp: 'avi 3/20/2004 17:55'!
includesSystemCategory: aString
	^ (aString beginsWith: 'Seaside-') and: [(self ignoredCategories includes: (aString copyAfter: $-)) not]! !

!SeasideVWInfo methodsFor: 'testing' stamp: 'kph 5/23/2007 07:55'!
isYourClassExtension: aString
	^ (self category: aString asLowercase matches: '*seaside2')
		and: [(aString includes: '-squeak') not]! !

!SeasideVWInfo methodsFor: 'naming' stamp: 'mb 5/30/2006 13:52'!
name
	^ 'Seaside2'! !

!SeasideVWInfo methodsFor: 'testing' stamp: 'mb 11/27/2005 10:17'!
needsNamespace
	^true
! !

!SeasideVWInfo methodsFor: 'naming' stamp: 'mb 5/30/2006 13:52'!
packageName
	^ 'SeasideVW'! !

!SeasideVWInfo methodsFor: 'accessing' stamp: 'mb 5/30/2006 13:59'!
versionString
	| ancestor |
	ancestor := (MCPackage named: self name) workingCopy ancestry ancestors first.
	^ancestor name , '.mcz      ' , ancestor date printString, ' ', ancestor time printString ! !

!Fraction methodsFor: '*seaside2' stamp: 'mb 11/27/2005 10:11'!
asSeasideString
	^ self asFloat displayString
! !

!Fraction methodsFor: '*seaside2' stamp: 'mb 3/23/2006 07:37'!
convertSeasideString: aString
	^ aString = self asSeasideString ifTrue: [self] ifFalse:[ aString asNumber]
! !

!True methodsFor: '*seaside2' stamp: 'ac 3/22/2005 20:23'!
yesNoString
	^ 'Yes'! !

!Date class methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:29'!
newDay: dayNumber monthNumber: monthNumber year: yearNumber
	^ self newDay: dayNumber month: monthNumber year: yearNumber! !

!Integer methodsFor: '*seaside2' stamp: 'mbany 4/14/2005 12:09'!
printStringAsCents
	^ '$', (self // 100) displayString, '.', (self \\ 100) asTwoCharacterString! !

!XMLElement methodsFor: '*seaside2-squeak' stamp: 'mb 3/29/2007 10:03'!
elementsExcludingContent
	^elements! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 5/22/2004 12:57'!
homeReceiver
	^ self home receiver! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 4/24/2004 12:27'!
localAt: aNumber
	^ self at: aNumber! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 4/24/2004 12:27'!
localAt: aNumber put: anObject
	^ self at: aNumber put: anObject! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 4/24/2004 12:27'!
localSize
	^ self size! !

!False methodsFor: '*seaside2' stamp: 'ac 3/22/2005 20:23'!
yesNoString
	^ 'No'! !

TcpService subclass: #WAModLisp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!WAModLisp methodsFor: 'accessing' stamp: 'avi 5/5/2005 13:45'!
entryPoint
	^ WADispatcher default! !

!WAModLisp methodsFor: 'actions' stamp: 'avi 5/5/2005 13:45'!
handleRequest: aRequest
	^ (self entryPoint handlerForRequest: aRequest) handleRequest: aRequest! !

!WAModLisp methodsFor: 'actions' stamp: 'avi 5/5/2005 13:38'!
parseFields: aString
	| dict key value start end eqSignPos more |
	dict := Dictionary new.
	aString isEmptyOrNil ifTrue: [^dict].
	more := true.
	start := 1.
	[end := aString indexOf: $& startingAt: start.
	end == 0
		ifTrue: [end := aString size. more := false]
		ifFalse: [end := end - 1].
	eqSignPos := aString indexOf: $= startingAt: start.
	(eqSignPos > end or: [eqSignPos == 0])
		ifTrue: [key := (key := aString copyFrom: start to: end) unescapePercents.
			value := '']
		ifFalse: [key := (key := aString copyFrom: start to: eqSignPos-1) unescapePercents.
			value := (value := aString copyFrom: eqSignPos+1 to: end) unescapePercents].
	dict at: key put: value.
	start := end + 2.
	more] whileTrue.

	^dict! !

!WAModLisp methodsFor: 'actions' stamp: 'avi 5/5/2005 13:04'!
readHeadersFrom: aStream
	| headers key |
	headers := Dictionary new.
	[(key := (aStream upTo: Character lf)) = 'end'] whileFalse:
		[headers at: key put: (aStream upTo: Character lf)].
	^ headers! !

!WAModLisp methodsFor: 'conversation' stamp: 'avi 5/5/2005 13:25'!
serve: aSocket
	| stream |
	stream := SocketStream on: aSocket.
	[aSocket isConnected] whileTrue: [self serveOn: stream]! !

!WAModLisp methodsFor: 'actions' stamp: 'pmm 10/2/2006 21:10'!
serveOn: aStream
	| headers request response content method url query fields |
	headers := self readHeadersFrom: aStream.
	
	headers at: 'Content-Length' ifPresent:
		[:cl |
		content := aStream next: cl asInteger].	
	method := headers at: 'method'.
	url := (headers at: 'url') copyUpTo: $?.
	query := (headers at: 'url') copyAfter: $?.
	
	fields := method asLowercase = 'get'
		ifTrue: [ self parseFields: query ]
		ifFalse: [ self parseFields: content ].
		
	request := WARequest
				method: method
				url: url
				headers: headers
				fields: fields
				cookies: Dictionary new.

	response := self handleRequest: request.
	self writeResponse: response on: aStream.
	aStream flush! !

!WAModLisp methodsFor: 'printing' stamp: 'avi 5/10/2005 14:33'!
writeKey: keyString value: valueString on: aStream
	aStream nextPutAll: keyString displayString; nextPut: Character lf.
	aStream nextPutAll: valueString displayString; nextPut: Character lf! !

!WAModLisp methodsFor: 'actions' stamp: 'avi 5/5/2005 13:30'!
writeResponse: aResponse on: aStream
	self writeKey: 'Status' value: aResponse status on: aStream.
	self writeKey: 'Content-Type' value: aResponse contentType on: aStream.
	aResponse headers keysAndValuesDo:
		[:k :v |
		self writeKey: k value: v on: aStream].
	self writeKey: 'Content-Length' value: aResponse contents size on: aStream.
	self writeKey: 'Keep-Socket' value: 1 on: aStream.
	aStream nextPutAll: 'end'; nextPut: Character lf.
	aStream nextPutAll: aResponse contents contents! !

!Parser methodsFor: '*seaside2-squeak-override' stamp: 'ab 2/21/2003 02:00'!
interactive

	^ (requestor == nil or: [requestor isKindOf: SyntaxError] or: [requestor isKindOf: WAMethodEditor]) not! !

!Exception class methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:42'!
raiseSignal
	^ self signal! !

!Exception class methodsFor: '*seaside2-squeak' stamp: 'mb 3/23/2006 17:53'!
raiseSignal: aString
	^ self signal: aString! !

!Exception methodsFor: '*seaside2-squeak' stamp: 'ab 3/28/2003 17:36'!
reactivateHandler 
  handlerContext ifNotNil: [handlerContext tempAt: 3 put: true].
! !

!Morph methodsFor: '*seaside2-squeak' stamp: 'mb 6/2/2006 10:47'!
asMIMEDocument
	^self imageForm asMIMEDocument! !

!Morph methodsFor: '*seaside2-squeak' stamp: 'mb 6/2/2006 10:53'!
asMIMEDocumentType: mimeType
	^self imageForm asMIMEDocumentType: mimeType! !
WAExternalID initialize!
WAAbstractHtmlBuilder initialize!
WACachedDocument initialize!
WAGlobalConfiguration initialize!
WAUserConfiguration initialize!
WAKom initialize!
WAFileLibrary initialize!
WAListener initialize!
WABrowser initialize!
WACounter initialize!
WADateSelectorTest initialize!
WADispatcherEditor initialize!
WADispatcherViewer initialize!
WADispatcherEditorPlugin initialize!
WAExampleBrowser initialize!
WAAllCanvasTests initialize!
WAAllTests initialize!
WAHalo initialize!
WAMultiCounter initialize!
WAScreenshot initialize!
WAStore initialize!
WAVNCController initialize!
WAVersionUploader initialize!
WAFileHandler initialize!
WAExpirySession initialize!
WASpotProfiler initialize!
Seaside2Info initialize!
